var Application = {
    xhr: null,
    userName: "",
    userPassword: "",
    userEmail: "",
    userJoinedAt: "",
    authToken: "",
    loggedIn: false,
    isValidAccount: 0,
    platformVersion: "4.0",
    appVersion: "1.012",
    firmwareVersion: "T-INFOLINK2010-1000", //for testing only
	devMode: false  //enable to show debug
};

Application.checkAccount = function (id, pw, fnCallback) {
    Application.login(id, pw, fnCallback);
};

Application.getUniqueID = function () {
    var netplugin = document.getElementById('pluginObjectNetwork');
    var naviplugin = document.getElementById('pluginObjectNNavi');
    var MAC = netplugin.GetMAC();
    var DUID = naviplugin.GetDUID(MAC);
    return DUID.toString().toLowerCase();
};

Application.login = function (id, pw, fnCallback)  //only needed for manual login with name and password
{
    Application.userName = id;
    Application.userPassword = pw;

    var bURL = "https://plex.tv/users/sign_in.xml";
    var auth = window.btoa(id + ":" + pw);
    var xhrTimeout = null;

    if (Application.xhr !== null) {
        if (Application.xhr.destroy) {
            Application.xhr.destroy(); // Save memory
        }
        Application.xhr = null;
    }

    if (Application.xhr === null) {
        Application.xhr = new XMLHttpRequest();
    }

    if (Application.xhr !== null) {
        Application.xhr.onreadystatechange = function () {
            if (Application.xhr.readyState == 4) {
                clearTimeout(xhrTimeout);
                if (Application.xhr.status == 200 || Application.xhr.status == 201) {
                    Application.receivebrowserXHRResponse(Application.xhr, fnCallback);
                } else {
                    fnCallback("FALSE");
                }
            }
        };

        Application.xhr.open("POST", bURL, true);

        if (Application.xhr.overrideMimeType) { // needed for 2012
            Application.xhr.overrideMimeType('text/xml');
        }

        Application.xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
        Application.xhr.setRequestHeader("Authorization", "Basic " + auth);
        Application.xhr.setRequestHeader("X-Plex-Product", "Plex for Samsung");
        Application.xhr.setRequestHeader("X-Plex-Platform", "Samsung");
        Application.xhr.setRequestHeader("X-Plex-Client-Platform", "Samsung");
        Application.xhr.setRequestHeader("X-Plex-Platform-Version", Application.platformVersion);
        Application.xhr.setRequestHeader("X-Plex-Version", Application.appVersion);
        Application.xhr.setRequestHeader("X-Plex-Provides", "client");
        Application.xhr.setRequestHeader("X-Plex-Client-Identifier", Application.getUniqueID());

        Application.xhr.send();

        // Timeout to abort in 10 seconds
        xhrTimeout = setTimeout(function () {
            if (Application.xhr.abort) {
                Application.xhr.abort();
            }
            if (Application.xhr.destroy) {
                Application.xhr.destroy();
            }
            fnCallback("FALSE");
        }, 10000);
    }
};

Application.receivebrowserXHRResponse = function (xhr, fnCallback) {
    var xmlElement = xhr.responseXML.documentElement;

    if (!xmlElement) {
        Application.isValidAccount = 0;
        Application.loggedIn = false;
    } else {
        Application.userName = $(xmlElement).find('username').text();
        Application.userEmail = $(xmlElement).find('email').text();
        Application.userJoinedAt = $(xmlElement).find('joined-at').text();
        Application.authToken = $(xmlElement).find('authentication-token').text();
        Application.isValidAccount = 1;
        Application.loggedIn = true;
    }

    if (Application.isValidAccount === 1) {
        fnCallback("TRUE");
    } else {
        fnCallback("FALSE");
    }
};