var AjaxManager = {
    xhrQueue: [],
    postHTTP: function (url, callback, params, timeout, id, data) {
        var xhr = {};
        xhr.url = url;
        xhr.callback = callback;
        xhr.params = params;
        xhr.timeout = timeout;
        xhr.timer = 0;
        xhr.id = id;
        xhr.data = data;
        xhr.dataType = "text";
        xhr.method = "POST";
        this.enqueue(xhr);
    },
    getHTTP: function (url, callback, params, timeout, id, data) {
        var xhr = {};
        xhr.url = url;
        xhr.callback = callback;
        xhr.params = params;
        xhr.timeout = timeout;
        xhr.timer = 0;
        xhr.id = id;
        xhr.data = data;
        xhr.dataType = "text";
        xhr.method = "GET";
        this.enqueue(xhr);
    },
    deleteHTTP: function (url, callback, params, timeout, id) {
        var xhr = {};
        xhr.url = url;
        xhr.callback = callback;
        xhr.params = params;
        xhr.timeout = timeout;
        xhr.timer = 0;
        xhr.id = id;
        xhr.dataType = "text";
        xhr.method = "DELETE";
        this.enqueue(xhr);
    },
    parseHTTP: function (url, callback, params, timeout, id, data) {
        var xhr = {};
        xhr.url = url;
        xhr.callback = callback;
        xhr.params = params;
        xhr.timeout = timeout;
        xhr.timer = 0;
        xhr.id = id;
        xhr.data = data;
        xhr.dataType = "xml";
        xhr.method = "GET";
        this.enqueue(xhr);
    },
    enqueue: function (xhr) {
        AjaxManager.xhrQueue.push(xhr);
        if (AjaxManager.xhrQueue.length === 1) {
            AjaxManager.dequeue();
        }
    },
    dequeue: function () {
        //Main.debug("[AjaxManager.js] - xhrQueue Lenght: " + AjaxManager.xhrQueue.length);
        if (AjaxManager.xhrQueue.length > 0) {
            var xhr = AjaxManager.xhrQueue.shift();

            if (xhr.timeout === 0) {
                xhr.timeout = Number(prefs.general.timeout || 10) * 1000;
            }

            AjaxManager.working = 1;

            xhr.xml = $.ajax({
                url: xhr.url,
                type: xhr.method,
                timeout: xhr.timeout,
                dataType: xhr.dataType,
                beforeSend: function (xmlObj) {
                    xmlObj.id = xhr.id;
                    xmlObj.url = xhr.url;
                    xmlObj.callback = xhr.callback;
                    xmlObj.setRequestHeader("Connection", "Keep-Alive");
                },
                success: function (xml, textStatus, xmlObj) {

                    Main.debug("[AjaxManager.js] - success: " + xmlObj.url);
                    var tree = null;
                    var xmlElement = null;

                    //Main.debug("[AjaxManager.js] - xmlObj.responseText: " + xmlObj.responseText);

                    //var headers = xmlObj.getAllResponseHeaders().toLowerCase();
                    // Main.debug("[AjaxManager.js] - xmlObj.getAllResponseHeaders: " +headers);

                    if (xmlObj.responseXML) {
                        xmlElement = xmlObj.responseXML.documentElement;
                        tree = ObjTree.parseDOM(xmlElement); //build the object from the xml
                    }

                    if (!isEmpty(xmlElement)) {
                        if (tree) {
                            xmlObj.callback(tree, xmlObj, xmlObj.id);
                        } else {
                            xmlObj.callback(null, xmlObj, xmlObj.id);
                        }
                    } else {
                        if (xmlObj.callback) {
                            if (!xmlObj) {
                                xmlObj.callback(null, null, xmlObj.id);
                            } else {
                                xmlObj.callback(null, xmlObj, xmlObj.id);
                            }
                        }
                    }

                    if (xhr.xml.destroy)
                        xhr.xml.destroy();

                    AjaxManager.dequeue();
                },
                error: function (xmlObj, status, error) {

                    Main.debug("[AjaxManager.js] - failed: " + xmlObj.url);
                    Main.debug("[AjaxManager.js] - status: " + status);
                    Main.debug("[AjaxManager.js] - error: " + error);

                    if (xmlObj.callback) {
                        if (!xmlObj) {
                            xmlObj.callback(null, null, xmlObj.id);
                        } else {
                            xmlObj.callback(null, xmlObj, xmlObj.id);
                        }
                    }

                    if (xhr.xml.destroy)
                        xhr.xml.destroy();

                    AjaxManager.dequeue();
                }
            });
        }
    }
};