var Audio = {
    plugin: null,
    audioIndex: 0,
    timer: 0,
    timerID: 0,
    mute: 0,
    NMUTE: 0,
    YMUTE: 1,
    output: "Stereo",
    channels: "2.0"
};

Audio.init = function () {
    var success = true;

    Audio.plugin = document.getElementById("pluginAudio");

    if (!Audio.plugin) {
        success = false;
    }

    Main.debug("[Audio.js] - Audio Plugin initialize success: [" + success + "]");
    Main.debug("[Audio.js] - Audio auto change: [" + ((prefs.audio.autoChange || "off") === "on") + "]");

    //Audio.setMuteSymbol(); //hide this we use the default mute

    return success;
};

/*
 ###############################
 #
 #       AUDIO OUTPUT FORMAT
 #
 ###############################
 */

/*
 0 - PL_AUDIO_AUDIO_OUT_MODE_PCM //* The PCM mode
 1 - PL_AUDIO_AUDIO_OUT_MODE_DOLBY //* The Dolby mode
 2 - PL_AUDIO_AUDIO_OUT_MODE_DTS //* The DTS mode
 */

Audio.setAudioOutput = function (codec) {
    if ((prefs.audio.autoChange || "off") === "on") {
        var currentMode = Audio.plugin.GetExternalOutMode();
        var mode;

        Main.debug("[Audio.js] - setAudioOutput codec: " + codec);

        if (codec === 'ac3' || codec === 'eac3' || codec === 'aac') {
            mode = 1;
        } else if (codec === 'dca' || codec === "dts") {
            mode = 2;
        } else {
            mode = 0;
        }

        if (currentMode < 0) {
            currentMode = 0;
        }

        Main.debug("[Audio.js] - Current mode: " + currentMode + ", New mode: " + mode);

        if (mode !== currentMode) {
            if (Audio.plugin.SetExternalOutMode(mode) === 1) {
                Main.debug("[Audio.js] - Forced output to " + codec);
            } else {
                Main.debug("[Audio.js] - Forced audio output to " + codec + " failed!");
            }
        }
    }
    else
        Main.debug("[Audio.js] - Auto change audio output is disabled");
};

/*
 ###############################
 #
 #       VOLUME
 #
 ###############################
 */

/*
 0 - PL_AUDIO_OUTPUT_DEVICE_MAIN_SPEAKER
 1 - PL_AUDIO_OUTPUT_DEVICE_EARPHONE
 2 - PL_AUDIO_OUTPUT_DEVICE_SUBWOOFER
 3 - PL_AUDIO_OUTPUT_DEVICE_EXTERNAL for example, Component audio, Composite audio
 4 - PL_AUDIO_OUTPUT_DEVICE_RECEIVER for example, HDMI, SPDIF
 */

//Audio.setVolume = function (delta) {
//    keyLock.state = keyLock.VOLUMELOCK;
//    window.clearTimeout(Audio.timerID);

//    if (Audio.plugin.GetOutputDevice() === 3 || getProductType() === "BD-Player") {
//        return;
//    } else {
//        Audio.noMuteMode();
//        Audio.plugin.SetVolumeWithKey(delta);
//        if (Audio.plugin.GetOutputDevice() === 4) {
//            return;
//        } else {
//            // Draw Volume UI and change volume value
//            if (Audio.timer === 1)
//                window.clearTimeout(Audio.timerID); // if you push vol button more than once the old timeout will be deleted
//            Audio.timer = 1;
//            Audio.plugin.SetVolumeWithKey(delta);
//            Audio.getVolume();
//        }
//    }
//    Audio.timerID = window.setTimeout(function () {//save id from the timeout
//        Audio.hide();
//    }, 1000);
//};

//Audio.getVolume = function () {
//    var vol = Audio.plugin.GetVolume();
//    Main.debug("[Audio.js] - Volume: [" + vol + "]");

//    document.getElementById("audio").style.display = "block";
//    document.getElementById("audioVolume").style.display = "block";
//    widgetAPI.putInnerHTML(document.getElementById("audioVolume"), vol);
//    return vol;
//};

//Audio.hide = function () {
//    Audio.timer = 0;
//    document.getElementById("audio").style.display = "none";
//    document.getElementById("audioVolume").style.display = "none";
//    keyLock.state = keyLock.NONE;
//};

//Audio.setAutoChange = function () {
//    if ((prefs.audio.autoChange || "on") === "on")
//        prefs.audio.autoChange = "off";
//    else
//        prefs.audio.autoChange = "on";
//
//    Audio.init(); //reinit to update the status
//};

/*
 ###############################
 #
 #       MUTE
 #
 ###############################
 */

//Audio.setMuteSymbol = function () {
//    if (Audio.plugin.GetUserMute()) {
//        Audio.mute = Audio.YMUTE;
//        document.getElementById("audioMute").style.display = "block";
//    }
//    else {
//        Audio.mute = Audio.NMUTE;
//        document.getElementById("audioMute").style.display = "none";
//    }
//};

//Audio.noMuteMode = function () {
//    if (Audio.mute === Audio.YMUTE) {
//        document.getElementById("audioMute").style.display = "none";
//        Audio.plugin.SetUserMute(0);
//        Audio.mute = Audio.NMUTE;
//        Main.debug("[Audio.js] - MUTE OFF [" + Audio.plugin.GetUserMute() + "]");
//    }
//};

//Audio.muteMode = function () {
//    Audio.hide();
//    switch (Audio.mute) {
//        case Audio.NMUTE:
//            Audio.setMuteMode();
//            break;
//
//        case Audio.YMUTE:
//            Audio.noMuteMode();
//            break;
//
//        default:
//            Main.debug("[Audio.js] - ERROR: unexpected mode in muteMode", 1);
//            break;
//    }
//};
