var Content =
{
    urlcallback: "",
    dataReceivedCallback: null,
    cat: "",
    section: "",
    start: 0,
    id: "",
    update: true
};

Content.init = function () {
    return true;
};

Content.fetchContentList = function (cat, section, start, size, noUpdate) {
    this.cat = cat;
    this.section = section;
    this.update = true;
    this.start = 0;
    var url = "";
    var timeout = 0;

    if (noUpdate) {
        this.update = false;
    }

    if (section)
        url = cat + "/" + section;
    else
        url = cat;

    Main.currentUrl = url; //save for reference

    if (start !== null) {
        this.start = start;
        if (url.contains("?"))
            url += "&X-Plex-Container-Start=" + start + "&X-Plex-Container-Size=" + size;
        else
            url += "?X-Plex-Container-Start=" + start + "&X-Plex-Container-Size=" + size;
    }

    url = Main.server.resolveUrl(url, false, true);

    //Main.debug("[Content.js] - Content URL: [" + url + "]");
    AjaxManager.parseHTTP(url, Content.createContentList, null, timeout, Content.id, null);
};

Content.createContentList = function (tree, xhrObj, id) {

    //Main.debug("[Content.js] - Content.createContentList");
    if (id !== Content.id) {
        Main.debug("[Content.js] - Callback aborted, destination has changed");
        if (xhrObj.destroy) {
            xhrObj.destroy();
        }
        return false;
    }

    if (xhrObj === null) //timeout occured
    {
        Content.handleError(null, id);
        return false;
    }

    if (xhrObj.status !== 200) {
        Main.debug("[Content.js] - Media XML Server Error " + xhrObj.status);
        if (xhrObj.status !== 0) //skip 0, this is due to the object being destroyed before it got back, like in fast scrolling.
        {
            Content.handleError(xhrObj, id);
        }
    } else {
        if (tree) {
            var idx;
            var i;
            var parent;
            Data.contentCount = 0;

            if (tree.MediaContainer) {

                parent = tree.MediaContainer;

                //if (Content.section === "onDeck") {
                //    Data.contentTree = $.extend(true, {}, tree);
                //} else {
                //    Data.contentTree = {};
                //    Data.contentTree = $.extend(true, {}, tree);
                //}

                //var strPrefs = JSON.stringify(Data.contentTree, null, 4);
                //Main.writeFile("media.json", strPrefs);

                Data.contentTitle1 = (parent["-title1"] || "").replaceHtml();
                Data.contentTitle2 = (parent["-title2"] || "").replaceHtml();
                Data.contentViewGroup = (parent["-viewGroup"] || "").replaceHtml();
                Data.contentIdentifier = (parent["-identifier"] || "");
                Data.contentUserAgent = (parent["-userAgent"] || "");
                Data.contentContent = (parent["-content"] || "");
                Data.contentHttpCookies = (parent["-httpCookies"] || "");
                Data.contentHttpHeaders = (parent["-httpHeaders"] || "");
                Data.contentCount = parseInt(parent["-totalSize"] || parent["-size"] || 0, 10);

                //don't show owned servers in shared section, they are already visible in the main categories with their remote addresses
                if (Data.contentIdentifier === "com.plexapp.plugins.myplex") {
                    var owned = Main.server.getLocalMachIDs();
                    if (tree.MediaContainer.Directory) {
                        tree.MediaContainer.Directory = _.filter(tree.MediaContainer.Directory, function (dir) {
                            if (dir["-owned"] === "1") {
                                return false;
                            } else {
                                return (owned.indexOf(dir["-machineIdentifier"]) === -1);
                            }
                        });
                        if (tree.MediaContainer.Directory.length > 0) {
                            Data.contentCount = tree.MediaContainer.Directory.length;
                        }
                    }
                }

                Main.debug("[Content.js] - Data.contentCount: " + Data.contentCount);

                idx = 0;
                if (Main.view === Main.CATEGORIE)
                    idx = Data.categorieODCount;
                else
                    idx = Content.start;


                var containers = ('Directory|Video|Track|Photo|Artist|Album|Playlist|Genre|Podcast');

                //keep the same sorting as the xml
                $.each(parent, function (name) {
                    var container = (name.match(containers) !== null) ? name : "";
                    if (container !== "") {
                        Main.debug("[Content.js] - Loading Container: " + container);
                        idx = Content.loadJSON(parent, name, idx);
                    }
                    //alert(name + ": " + value);
                });

                if (tree.MediaContainer["-message"]) {
                    var msg = {};
                    msg.message = tree.MediaContainer["-message"];
                    msg.code = tree.MediaContainer["-code"];
                    msg.header = tree.MediaContainer["-header"];
                    msg.status = tree.MediaContainer["-status"];
                    Content.handleError(xhrObj, id, msg);
                    return false;
                }

            } else if (tree.ASContainer) {
                Data.clearContent();

                Data.contentCount = parseInt(tree.ASContainer["-totalSize"] || tree.ASContainer["-size"] || 0, 10);
                Data.sectionArt = (tree.ASContainer["-art"] || "");
                Data.contentTitle1 = (tree.ASContainer["-title1"] || "").replaceHtml();
                Data.contentTitle2 = (tree.ASContainer["-title2"] || "").replaceHtml();
                Data.contentIdentifier = (tree.ASContainer["-identifier"] || "");
                Data.contentUserAgent = (tree.ASContainer["-userAgent"] || "");
                Data.contentContent = (tree.ASContainer["-content"] || "");

                if (tree.ASContainer.Directory) {
                    idx = 0;
                    for (i = 0; i < tree.ASContainer.Directory.length; i++) {
                        Data.contentContainerType[idx] = "Directory";
                        Data.contentKeys[idx] = tree.ASContainer.Directory[i]["-key"] || "";
                        Data.contentTitles[idx] = (tree.ASContainer.Directory[i]["-title"] || tree.ASContainer.Directory[i]["-name"] || "").replaceHtml();
                        Data.contentThumbs[idx] = tree.ASContainer.Directory[i]["-thumb"] || "";
                        Data.contentArts[idx] = tree.ASContainer.Directory[i]["-art"] || tree.ASContainer["-art"] || "";
                        Data.contentSummarys[idx] = (tree.ASContainer.Directory[i]["-summary"] || "").replaceHtml();
                        Data.contentSettings[idx] = (tree.ASContainer.Directory[i]["-settings"] || "");
                        Data.contentPrompts[idx] = (tree.ASContainer.Directory[i]["-prompt"] || "").replaceHtml();
                        Data.contentSearch[idx] = Number(tree.ASContainer.Directory[i]["-search"] || "0");

                        Data.contentTextureVideoResolutions[idx] = "";
                        Data.contentTextureVideoARs[idx] = "";
                        Data.contentTextureVideoCodecs[idx] = "";
                        Data.contentTextureVideoFramerates[idx] = "";
                        Data.contentTextureAudioCodecs[idx] = "";
                        Data.contentTextureAudioChannels[idx] = "";
                        Data.contentRatings[idx] = "";
                        Data.contentContentRatings[idx] = "";
                        Data.contentStudios[idx] = "";

                        if (tree.ASContainer.Directory[i]["-popup"]) {
                            if (tree.ASContainer.Directory[i]["-popup"] === "1")
                                Data.contentTypes[idx] = "popup";
                            else
                                Data.contentTypes[idx] = "";
                        }

                        idx++;
                    }
                }
            } else {
                Main.debug("[Content.js] - JSON Parse failed");
            }
        }

        if (Data.contentCount === 0) {
            Data.categorieODCount = 0;
            Data.categorieRACount = 0;
            Data.contentCount = 1;
            Data.contentTitles[0] = text.noData;
        }

        //Main.debug("[Content.js] - Content Count: [" + Data.contentRatingKeys.length + "]");

        if (Main.view === Main.CATEGORIE) {
            Data.categorieRACount = Data.contentRatingKeys.length - Data.categorieODCount;
            Data.categorieRealRACount = Data.contentRatingKeys.length;

            if (buttonCategorie.dataReceivedCallback2) {
                buttonCategorie.dataReceivedCallback2(id);
            }
        }
        else {
            if (Content.update === false) { //set update to false , to use an alternative callback
                if (Content.callback !== "") {
                    Main.debug("[Content.js] - Callback to: " + Content.callback);
                    fireEvent(Content.callback, id);
                }
                else {
                    return false;
                }
            }
            else if (Content.dataReceivedCallback) {
                Content.dataReceivedCallback(id);
            }
        }
    }
};

Content.concatTags = function (obj) {
    var result = "";
    if (obj) {
        for (var i = 0; i < obj.length; i++) {
            if (i === 0)
                result = obj[i]["-tag"];
            else
                result = result + ", " + obj[i]["-tag"];
        }
    }
    return result.replaceHtml();
};

Content.loadJSON = function (parent, container, idx) {

    var mediaTagVersion = (parent["-mediaTagVersion"] || "");
    var mediaTagPrefix = (parent["-mediaTagPrefix"] || "");

    if (Content.section === "onDeck") {
        Data.categorieODCount = parent[container].length;
    }

    function Metatag(node, tag) {
        if (mediaTagPrefix !== "" && mediaTagVersion !== "") {
            if (node) {
                if (node["-" + tag]) {
                    return mediaTagPrefix + tag + "/" + node["-" + tag] + "/?t=" + mediaTagVersion
                }
            }
        }
        return null;
    }

    $.each(parent[container], function () {

        var thumb = (this.Thumb) ? this.Thumb[0]["-key"] : null;

        Data.contentContainerType[idx] = container;
        Data.contentArts[idx] = (this["-art"] || parent["-art"] || "");
        Data.contentAspectRatios[idx] = (this.Media) ? (this.Media[0]["-aspectRatio"] || this["-aspectRatio"] || "") : (this["-aspectRatio"] || "");
        Data.contentAudios[idx] = (this["-audioCodec"] || "");
        Data.contentBanner[idx] = (this.Media) ? (this.Media[0]["-banner"]) : "";
        Data.contentBitrates[idx] = (this.Media) ? (this.Media[0]["-bitrate"]) : "";
        Data.contentCasts[idx] = Content.concatTags(this.Role);
        Data.contentCollections[idx] = Content.concatTags(this.Collection);
        Data.contentContentRatings[idx] = (Metatag(this, "contentRating") || Metatag(this, "grandparentContentRating") || "");
        Data.contentDeleteds[idx] = (this["-deletedAt"] || "");
        Data.contentDirectors[idx] = Content.concatTags(this.Director);
        Data.contentDurations[idx] = Number((this.Media) ? (this.Media[0].Part[0]["-duration"] || this.Media[0]["-duration"] || "0") : (this["-duration"] || "0"));
        Data.contentFiles[idx] = (this["-file"] || "");
        Data.contentGenres[idx] = Content.concatTags(this.Genre);
        Data.contentGrandParentTitles[idx] = (this["-grandparentTitle"] || parent["-grandparentTitle"] || this["-artist"] || "").replaceHtml();
        Data.contentGrandParentThumbs[idx] = (this["-grandparentThumb"] || parent["-grandparentThumb"] || "");
        Data.contentHeights[idx] = (this.Media) ? (this.Media[0]["-height"] || this["-height"] || "") : (this["-height"] || "");
        Data.contentIds[idx] = (this["-id"] || "");
        Data.contentIndexs[idx] = (this["-index"] || "");
        Data.contentKeys[idx] = (this.Media) ? (this.Media[0].Part[0]["-key"] || this["-key"] || "") : (this["-key"] || parent["-key"] || "");
        Data.contentLeafCounts[idx] = Number((this["-leafCount"] || "0"));
        Data.contentMetadataUrls[idx] = (this["-key"] || "");
        Data.contentOffsets[idx] = Number((this["-viewOffset"] || "0"));
        Data.contentOriginallyAvailableAt[idx] = (this["-originallyAvailableAt"] || "");
        Data.contentParentIndexs[idx] = (this["-parentIndex"] || "");
        Data.contentParentKey[idx] = (this["-parentKey"] || "");
        Data.contentParentRatingKey[idx] = (this["-parentRatingKey"] || "");
        Data.contentParentTitles[idx] = (this["-parentTitle"] || this["-album"] || parent["-parentTitle"] || parent["-title1"] || "").replaceHtml();
        Data.contentPrompts[idx] = (this["-prompt"] || "").replaceHtml();
        Data.contentRatingKeys[idx] = (this["-ratingKey"] || "");
        Data.contentRatings[idx] = (this["-rating"] || "");
        Data.contentSearch[idx] = Number(this["-search"] || "0");
        Data.contentSourceTitles[idx] = (this["-sourceTitle"] || "").replaceHtml();
        Data.contentStudios[idx] = (Metatag(this, "studio") || Metatag(this, "grandparentStudio") || "");
        Data.contentTextureAudioChannels[idx] = (this.Media) ? (Metatag(this.Media[0], "audioChannels") || "") : "";
        Data.contentTextureAudioCodecs[idx] = (this.Media) ? (Metatag(this.Media[0], "audioCodec") || "") : "";
        Data.contentTextureVideoARs[idx] = (this.Media) ? (Metatag(this.Media[0], "aspectRatio") || "") : "";
        Data.contentTextureVideoCodecs[idx] = (this.Media) ? (Metatag(this.Media[0], "videoCodec") || "") : "";
        Data.contentTextureVideoFramerates[idx] = (this.Media) ? (Metatag(this.Media[0], "videoFrameRate") || "") : "";
        Data.contentTextureVideoResolutions[idx] = (this.Media) ? (Metatag(this.Media[0], "videoResolution") || "") : "";
        Data.contentSummarys[idx] = (this["-summary"] || parent["-summary"] || "").replaceHtml();
        Data.contentTaglines[idx] = (this["-tagline"] || "").replaceHtml();
        Data.contentTitles[idx] = (this["-title"] || this["-name"] || this["-track"] || this["-album"] || this["-artist"] || this["-genre"] || parent["-title"] || text.untitled).replaceHtml();
        Data.contentThemes[idx] = (this["-theme"] || parent["-theme"] || parent["-grandparentTheme"] || "");
        Data.contentThumbs[idx] = (this["-thumb"] || parent["-thumb"] || parent["-grandparentThumb"] || thumb || "");
        Data.contentTypes[idx] = (this["-type"] || parent["-type"] || container.toLowerCase());
        Data.contentUnViewedLeafCounts[idx] = Number((this["-leafCount"] || "0") - (this["-viewedLeafCount"] || "0"));
        Data.contentViewCounts[idx] = Number((this["-viewCount"] || "0"));
        Data.contentViewedLeafCounts[idx] = Number((this["-viewedLeafCount"] || "0"));
        Data.contentWidths[idx] = (this.Media) ? (this.Media[0]["-width"] || this["-width"] || "") : (this["-width"] || "");
        Data.contentWriters[idx] = Content.concatTags(this.Writer);
        Data.contentYears[idx] = (this["-year"] || "");

        if (this.Media) {
            var j = JSON.stringify(this.Media, null, 4);
            Data.contentMedias[idx] = JSON.parse(j);
        } else {
            Data.contentMedias[idx] = "";
        }

        if (this["-popup"]) {
            if (this["-popup"] === "1") {
                Data.contentTypes[idx] = "popup";
            }
        }

        //get the remote server
        Data.contentServerNames[idx] = (this["-serverName"] || "");
        Data.contentServerAddresses[idx] = (this["-address"] || "");
        Data.contentServerHosts[idx] = (this["-host"] || "");
        Data.contentServerPorts[idx] = (this["-port"] || "");
        Data.contentServerVersions[idx] = (this["-serverVersion"] || "");
        Data.contentMachineIndentifiers[idx] = (this["-machineIdentifier"] || "");
        Data.contentAccessTokens[idx] = (this["-accessToken"] || "");
        Data.contentServerOwned[idx] = Number((this["-owned"] || "1"));
        Data.contentServerLocal[idx] = Number((this["-local"] || "1"));
        Data.contentSettings[idx] = (this["-settings"] || "");

        idx++;

    });
    return idx;
};

Content.handleError = function (xhrObj, id, msg) {

    Main.debug("[Content.js] - an error occured");
    $("#selectedContentText").text(text.errorReturn);

    if (msg) {
        var message = (msg.message !== "") ? msg.message : "";
        message = message.replace('.', '.<br>');
        //var status = (msg.status == "") ? msg.status.replace('.', '.<br>') : "";
        var header = (msg.header == "") ? "warning" : msg.header;
        Popup.showMessage(Popup.INFO, header, message, text.close);
        return false;
    }

    if (xhrObj) {
        if (xhrObj.status === 401) {
            Main.showInfo(text.errorPMS401);
            Main.debug("[Content.js] - Couldn't connect to PMS, Status: Unauthorized");
        } else {
            Main.showInfo(text.errorPMS);
            Main.debug("[Content.js] - Couldn't connect to server");
        }
    } else {
        Main.debug("[Content.js] - XHR = null, Couldn't connect to [" + Main.currentUrl + "]");
        if (Main.view === Main.SECTIONS) {
            if (id) {
                if (Content.callback !== "") {
                    Main.debug("[Content.js] - Callback to: " + Content.callback);
                    Data.categorieODCount = 0;
                    Data.categorieRACount = 0;
                    Data.contentCount = 1;
                    Data.contentTitles[0] = text.noData;
                    fireEvent(Content.callback, id);
                }
            } else {
                if (Popup.status === 0) {
                    Main.showInfo(text.errorTimeout);
                }
            }
        } else {
            Main.showInfo(text.errorTimeout);
        }
    }

    Main.error = 0;
    loadbar.hide();
};