var Display =
{
    FSX: 960, // fullscreen x variable
    FSY: 540, // fullscreen y variable

    episodeFilter: 0,

    preloadImages: [],
    preloadUrls: [],

    displayTimer: 0,
    updateTimer: 0,
    descriptionTimer: 0,
    slideIndex: 0,

    listPosition: 0,
    selectedItem: 0,
    lastDirection: null,
    scrollSpeed: 150,
    currentView: "",
    pageLock: 0,
    firstInList: -1,

    videoPlayerVisible: 0,
    audioPlayerVisible: 0,
    audioPlayerTimeout: 0
};

/*
 ###############################
 #
 #       INIT
 #
 ###############################
 */

Display.hide = function () {
    Main.debug("[Display.js] - Player Hide Display and bring up loading gif");
    if ($("#main").length !== 0)
        document.getElementById("main").style.display = "none";

    if ($("#mainEpisode").length !== 0)
        document.getElementById("mainEpisode").style.display = "none";

    $("#popup-overlay").hide();
    Display.videoPlayerVisible = 1;
    scrollText.stop(); //save CPU
};

Display.show = function () {
    Main.debug("[Display.js] - Player Show Display");
    Player.media = null;
    Main.selectedMedia = 0;
    Player.selectedPart = 0;
    loading.hide();
    Display.videoPlayerVisible = 0;

    if ($("#main").length !== 0)
        document.getElementById("main").style.display = "block";

    if ($("#mainEpisode").length !== 0)
        document.getElementById("mainEpisode").style.display = "block";

    $("#background").show();

    window.setTimeout(loading.hide, 1000); //just in case if the player was buffering, it may have triggered the loader again
    keyLock.status = keyLock.NONE;
};

/*
 ###############################
 #
 #       SETTIME
 #
 ###############################
 */

Display.setTime = function (time) {

    loading.hide();

    var realTime = Main.getLocalTime().getTime();
    var endTime = parseInt(realTime, 10) + parseInt(Player.totalTime - time, 10);

    if (Main.getTimeType() === "12")
        widgetAPI.putInnerHTML(document.getElementById("osdEndTime"), "End Time " + new Date(endTime).format("hh:mm a"));
    else
        widgetAPI.putInnerHTML(document.getElementById("osdEndTime"), "End Time " + new Date(endTime).format("HH:mm"));

    if (Player.SEARCHING === false) {

        var timePercent = (100 * time) / Player.totalTime;

        if (timePercent > 100) {
            timePercent = 100;
        }
        var breit = 886 / 100 * timePercent;

        breit = breit + 37;
        document.getElementById("progress_pic").style.width = timePercent + "%";
        document.getElementById("osdProgressBarRight").style.left = breit + "px";
    }

    var leftTime = Player.totalTime - time;
    var totalTimeHour = Math.floor(Player.totalTime / 3600000);
    var leftTimeHour = Math.floor(leftTime / 3600000);
    var timeHour = Math.floor(time / 3600000);
    var totalTimeMinute = Math.floor((Player.totalTime % 3600000) / 60000);
    var leftTimeMinute = Math.floor((leftTime % 3600000) / 60000);
    var timeMinute = Math.floor((time % 3600000) / 60000);
    var totalTimeSecond = Math.floor((Player.totalTime % 60000) / 1000);
    var leftTimeSecond = Math.floor((leftTime % 60000) / 1000);
    var timeSecond = Math.floor((time % 60000) / 1000);

    /*#######################
     ##
     ##      Current Time
     ##
     ########################*/

    var timeHTML = timeHour + ":";

    if (timeMinute === 0)
        timeHTML += "00:";
    else if (timeMinute < 10)
        timeHTML += "0" + timeMinute + ":";
    else
        timeHTML += timeMinute + ":";

    if (timeSecond === 0)
        timeHTML += "00";
    else if (timeSecond < 10)
        timeHTML += "0" + timeSecond;
    else
        timeHTML += timeSecond;

    widgetAPI.putInnerHTML(document.getElementById("osdCurrentTime"), timeHTML);
    Player.frontPanelSetTime(timeHour, timeMinute, timeSecond);

    /*#######################
     ##
     ##      Total Time
     ##
     ########################*/

    timeHTML = totalTimeHour + ":";

    if (totalTimeMinute === 0)
        timeHTML += "00";
    else if (totalTimeMinute < 10)
        timeHTML += "0" + totalTimeMinute;
    else
        timeHTML += totalTimeMinute;

    if (totalTimeSecond === 0)
        timeHTML += ":00";
    else if (totalTimeSecond < 10)
        timeHTML += ":0" + totalTimeSecond;
    else
        timeHTML += ":" + totalTimeSecond;

    /*#######################
     ##
     ##      Left Time
     ##
     ########################*/

    var leftTimeHTML = leftTimeHour + ":";

    if (leftTimeMinute === 0)
        leftTimeHTML += "00";
    else if (leftTimeMinute < 10)
        leftTimeHTML += "0" + leftTimeMinute;
    else
        leftTimeHTML += leftTimeMinute;

    if (leftTimeSecond === 0)
        leftTimeHTML += ":00";
    else if (leftTimeSecond < 10)
        leftTimeHTML += ":0" + leftTimeSecond;
    else
        leftTimeHTML += ":" + leftTimeSecond;


    if (leftTime > 0) {
        $("#osdTotalTime").text(leftTimeHTML + " / " + timeHTML);
        $("#songProgress").text(leftTimeHTML + " / " + timeHTML);
    } else {
        $("#osdTotalTime").text(text.streaming + "...");
        $("#songProgress").text(text.streaming + "...");
    }

};

/*
 ###############################
 #
 #       CATEGORY
 #
 ###############################
 */

Display.setCategorieList = function () {
    var i;

    loadbar.show();
    if (Main.selectedCat > Data.getCategorieCount())
        Main.selectedCat = 0;

    //clear all previous li's
    var menu = $('#carousel_ul');

    $(menu).find('li').remove();

    for (i = 0; i < Data.category.length; i++) {
        $(menu).append($('<li>').attr('id', i).attr('class', '#carousel_ul li').html(Data.category[i].name + "<br><span>" + Data.category[i].serverName + "</span>"));
    }

    $(menu).find('li:first').before($(menu).find('li:last'));
    $(menu).find('li:first').before($(menu).find('li:last'));
    $(menu).find('li:first').before($(menu).find('li:last'));
    $(menu).find('li:first').before($(menu).find('li:last'));
    $(menu).find('li:first').before($(menu).find('li:last'));

    for (i = 0; i < Main.selectedCat; i++) {
        $(menu).find('li:last').after($(menu).find('li:first'));
    }

    if (Data.category[Main.selectedCat].serverName !== "") {
        $('#' + Main.selectedCat).css({
            color: '#FD9800',
            fontSize: '30px',
            height: '50px',
            paddingTop: '2px'
        });
        $('#' + Main.selectedCat).closest('li').find('span').css('display', 'block');
    } else {
        $('#' + Main.selectedCat).css({
            color: '#FD9800',
            fontSize: '30px',
            height: '35px',
            paddingTop: '11px'
        });
    }

    Main.pageLoaded = 1;
    loadbar.hide();
};

/*
 ###############################
 #
 #       CATEGORY MOVIE
 #
 ###############################
 */

Display.setCategorieMovieList = function (divName) {
    var count = 0;
    var j = 0;

    if (divName === "singleBg")
        count = Data.contentKeys.length;
    else if (divName === "doubleBgOD")
        count = Data.categorieODCount;
    else if (divName === "doubleBgRA") {
        count = Data.categorieRACount;
        j = Data.categorieODCount;
    }

    $("#" + divName + "Carousel_ul li img").each(function () { //free memory
        $('img', this).attr('src', 'Images/blank.png');
    });

    $("#" + divName + "Carousel_ul li").remove();//empty th upperlist

    var carousel = document.getElementById(divName + "Carousel_ul");
    var fragment = document.createDocumentFragment();
    var link;
    var imgsrc;
    var watched;

    widgetAPI.putInnerHTML(carousel, "");
    for (var i = 0; i < count; i++) {
        link = document.createElement('li');
        imgsrc = Main.getPhoto(Data.contentThumbs[j], 92 * 2, 134 * 2, 'poster');
        watched = Display.getWatchedImage(j);

        link.setAttribute('id', divName + "ID" + j);
        link.insertAdjacentHTML('beforeend', "<img src='" + imgsrc + "' width='92px' height='134px' id='" + divName + "ContentID" + j + "' class='poster' />");
        link.insertAdjacentHTML('beforeend', "<div class='showSeasonEpisodeNumberBg'><div>");
        link.insertAdjacentHTML('beforeend', "<div class='showText' id=" + divName + "ContentSeasonNumber" + j + ">" + Data.contentTitles[j] + "</div>");
        link.insertAdjacentHTML('beforeend', "<div class='black' id='" + divName + "ID" + j + "Black'></div>");
        link.insertAdjacentHTML('beforeend', "<div class='offset'><img src='" + watched + "' height='26px'/></div>");
        fragment.appendChild(link);
        j++;
    }
	if(carousel){
		carousel.appendChild(fragment);
	}
};

/*
 ###############################
 #
 #       CATEGORY EPISODE
 #
 ###############################
 */

Display.setCategorieEpisodeList = function (divName) {
    var count = 0;
    var j = 0;

    if (divName === "singleBg")
        count = Data.contentCount;
    else if (divName === "doubleBgOD")
        count = Data.categorieODCount;
    else if (divName === "doubleBgRA") {
        count = Data.categorieRACount;
        j = Data.categorieODCount;
    }

    $("#" + divName + "Carousel_ul li img").each(function () { //free memory
        $('img', this).attr('src', 'Images/blank.png');
    });

    $("#" + divName + "Carousel_ul li").remove();//empty th upperlist

    var carousel = document.getElementById(divName + "Carousel_ul");
    if (carousel) {
        var fragment = document.createDocumentFragment();
        widgetAPI.putInnerHTML(carousel, "");

        for (var i = 0; i < count; i++) {

            var link = document.createElement('li');
            var imgsrc = Main.getPhoto(Data.contentGrandParentThumbs[j], 92 * 2, 134 * 2, 'poster');
            var watched = Display.getWatchedImage(j);

            link.setAttribute('id', divName + "ID" + j);
            link.insertAdjacentHTML('beforeend', "<img src='" + imgsrc + "' width='92px' height='134px' id='" + divName + "ContentID" + j + "' class='poster' />");
            link.insertAdjacentHTML('beforeend', "<div class='showSeasonEpisodeNumberBg'></div>");
            link.insertAdjacentHTML('beforeend', "<div class='showText' id=" + divName + "ContentSeasonNumber" + j + ">S" + Data.contentParentIndexs[j] + " <span style='color:#FD9800;'>• </span>E" + Data.contentIndexs[j] + "</div>");
            link.insertAdjacentHTML('beforeend', "<div class='black' id='" + divName + "ID" + j + "Black'></div>");
            link.insertAdjacentHTML('beforeend', "<div class='offset'><img src='" + watched + "' height='26px'/></div>");
            fragment.appendChild(link);
            j++;
        }
        carousel.appendChild(fragment);
    }
};

/*
 #################################################################
 #
 #    CHANNEL-PLUGINS/QUEUE/SHARED/RECOMMENDED/ARTIST/PHOTOS
 #
 #################################################################
 */
Display.setCategorieGeneralList = function (divName, id) {
    Main.debug("[Display.js] - Start Function: Display.setCategorieGeneralList id: " + id);

    if (id !== Main.selectedCat)
        return false;

    var contentThumb = "";
    var contentType = "";
    var count = 0;
    var j = 0;
    var h = 92;
    var w = 92;
    var z = 2;

    switch (Main.mediaContent) {
        case Main.PLUGIN:
            w = 92;
            h = 92;
            z = 1;
            break;
        case Main.ARTIST:
            w = 76;
            h = 76;
            z = 2;
            break;
        case Main.QUEUE:
        case Main.RECOMMENDED:
            w = 92;
            h = 72;
            z = 2;
            break;
        case Main.SHARED:
            w = 80;
            h = 80;
            z = 2;
            break;
        case Main.PHOTO:
            w = 92;
            h = 65;
            z = 1;
            break;
        default:
            w = 92;
            h = 92;
            z = 2;
    }

    if (divName === "singleBg")
        count = Data.contentKeys.length;
    else if (divName === "doubleBgOD")
        count = Data.categorieODCount;
    else if (divName === "doubleBgRA") {
        count = Data.categorieRACount;
        j = Data.categorieODCount;
    }

    $("#" + divName + "Carousel_ul li img").each(function () { //free memory
        $('img', this).attr('src', 'Images/blank.png');
    });

    $("#" + divName + "Carousel_ul li").remove();//empty th upperlist

    var carousel = document.getElementById(divName + "Carousel_ul");
    var fragment = document.createDocumentFragment();
    widgetAPI.putInnerHTML(carousel, "");

    for (var i = 0; i < count; i++) {
        contentThumb = Data.contentThumbs[j];
        contentType = Data.contentTypes[j];

        var link = document.createElement('li');
        link.setAttribute('id', divName + "ID" + j);

        var centerDiv = document.createElement('div');
        centerDiv.className = 'centerContent';
        centerDiv.setAttribute('id', divName + 'IDimg' + j);
        $(link).append(centerDiv);

        $(centerDiv).append(
            $('<img>')
                .attr('src', Main.getPhoto(contentThumb, w * z, h * z, contentType))
                .attr('id', divName + "ContentID" + j)
                .attr('class', "poster")
                .css({ 'height': h, 'max-width': w })
        );

        $(link).append("<div class='black' id='" + divName + "ID" + j + "Black'></div>");

        if (Main.mediaContent === Main.ARTIST || Main.mediaContent === Main.PHOTO) {
            $(link).append("<div class='showQueueText showText' id=" + divName + "ID" + j + ">" + Data.contentTitles[j] + "</div>");
            $(link).append("<div class='showSourceText showText' id=" + divName + "ID" + j + "><p>" + Data.contentParentTitles[j] + "</p></div>");
        }
        else if (Main.mediaContent === Main.SHARED) {
            $(link).append("<div class='showQueueText showText' id=" + divName + "ID" + j + ">" + Data.contentTitles[j] + "</div>");
            if (Data.contentSourceTitles[j] !== "") {
                $(link).append("<div class='showSourceText showText' id=" + divName + "ID" + j + "><p>" + Data.contentSourceTitles[j] + "</p></div>");
            }
            else {
                $(link).append("<div class='showSourceText showText' id=" + divName + "ID" + j + "><p>" + (prefs.myplex.username || "") + "</p></div>");
            }
        } else if (Main.mediaContent === Main.QUEUE || Main.mediaContent === Main.RECOMMENDED) {
            $(link).append("<div class='showQueueText showText' id=" + divName + "ID" + j + ">" + Data.contentTitles[j] + "</div>");
            if (Data.contentSourceTitles[j] !== "") {
                $(link).append("<div class='showSourceText showText' id=" + divName + "ID" + j + "><p>" + Data.contentSourceTitles[j] + "</p></div>");
            }
            else {
                $(link).append("<div class='showSourceText showText' id=" + divName + "ID" + j + "><p>" + Display.friendlyUrl(Data.contentRatingKeys[j]) + "</p></div>");
            }
        }
        else {
            $(link).append("<div class='showChannelText showText' id=" + divName + "ID" + j + ">" + Data.contentTitles[j] + "</div>");
        }
        fragment.appendChild(link);
        j++;
    }

    carousel.appendChild(fragment);
};

/*
 ###############################
 #
 #       MEDIA PREVIEW
 #
 ###############################
 */

Display.setContentList = function () {
    Main.debug("[Display.js] - Data.contentCount: [" + Data.contentCount + "]");
    $('#contentList').find('li').css("outline", "none");
    loadbar.show();

    if (Main.selectedContent > Data.contentCount - 1) {
        Main.selectedContent = Main.selectedContent.mod(Data.contentCount - 1);
    } else if (Main.selectedContent < 0) {
        Main.selectedContent = Main.selectedContent.mod(Data.contentCount - 1);
    }

    if (isEmpty(Main.selectedContent)) {
        Main.selectedContent = 0;
    }

    Data.clearContent();
    Content.callback = "Display.ContentLoaded1";

    var i = (Main.selectedContent - 4).mod(Data.contentCount);
    Content.id = "mediaPreviewUpdate";
    Content.fetchContentList(Content.cat, Content.section, i, 10, "noUpdate");

};

Display.ContentLoaded1 = function () {

    if (Data.contentCount === 0) {
        Main.showInfo(text.errorContent, "info");
        Main.debug("[Display.js] - No content in Display section");
        Content.section = "all";
        Main.onLoadMovie();
    }
    else {
        Content.callback = "Display.ContentLoaded2";
        if ((Main.selectedContent < (Data.contentCount + 4)) || (Main.selectedContent > Data.contentCount)) {
            //start at 0
            Content.id = "ContentLoaded1";
            Content.fetchContentList(Content.cat, Content.section, 0, 50, "noUpdate");
        }
        else {
            Content.id = "ContentLoaded1";
            Content.fetchContentList(Content.cat, Content.section, Main.selectedContent, 10, "noUpdate");
        }
    }
};

Display.ContentLoaded2 = function () {
    var x;
    var y;
    var i;
    var list;
    var item;
    Content.callback = ""; //stop updating
    if (Data.contentCount > 8) {
        x = -4;
        for (y = 0; y < 10; y++) {
            i = ((Main.selectedContent + x).mod(Data.contentCount));
            list = document.getElementById("contentList");
            item = list.getElementsByTagName('li')[y];
            Display.setMediaPreviewSlideImage(item, i);
            x++;
        }
    }
    else {
        x = -4;
        for (y = 0; y < 11; y++) {
            i = (Main.selectedContent + x).mod(Data.contentCount);
            $('#contentList').find('li:last').after($('#contentList').find('li:first'));
            list = document.getElementById("contentList");
            item = list.getElementsByTagName('li')[0];
            if (y < 10) {
                Display.setMediaPreviewSlideImage(item, i);
            }
            x++;
        }
    }

    $('#contentList').find('li:nth-child(5)').css("outline", "2px solid #FD9800");
    Display.setMediaPreviewPosition(Main.selectedContent);
    if (keyLock.status !== keyLock.CHOICELOCK) {
        keyLock.status = keyLock.NONE;
    }
    Main.pageLoaded = 1;
};

Display.setMediaPreviewSlideImage = function (item, id) {
    var img;
    img = item.getElementsByTagName('img')[0];
    img.src = Main.getPhoto(Data.contentThumbs[id], 92 * 2, 140 * 2, "poster");
    img = item.getElementsByTagName('img')[1];
    img.src = Display.getWatchedImage([id]);
    if (Main.view === Main.SHOW) {
        img = item.getElementsByTagName('p')[0];
        Display.addEpisodeWatched(img, id);
    }
};

Display.getWatchedImage = function (id) {
    if (Main.view === Main.SHOW)
        return "Images/blank.png";

    if (Data.contentOffsets[id] > 0) // time for in progress
        return "Images/episode/halfWatched.png";
    else if (Data.contentOffsets[id] === 0 && Data.contentViewCounts[id] === 0) //no time for in progress and not watched yet
        return "Images/episode/unwatched.png";
    else
        return "Images/blank.png";
};

Display.addEpisodeWatched = function (element, id) {
    var all = Data.contentLeafCounts[id];
    var seen = Data.contentViewedLeafCounts[id];
    if (all - seen > 0) {
        element.style.display = "block";
        widgetAPI.putInnerHTML(element, all - seen);
    }
    else {
        element.style.display = "none";
    }
};

Display.UpdateSlideRight = function () {
    var t = 100;
    var list;
    var item;
    var cnt = $('#contentList');
    $(cnt).find('li').css("outline", "none");
    setTimeout(function () {
        $(cnt).find("ul").stop(true, true).animate({ "left": -140 }, t, "linear", function () {
            $(cnt).find("ul").css({ "left": -5 });
            $(cnt).find('li:last').after($(cnt).find('li:first'));

            list = document.getElementById("contentList");
            if (list) {
                item = list.getElementsByTagName('li')[9];
                Display.setMediaPreviewSlideImage(item, Display.slideIndex);

                item = list.getElementsByTagName('li')[4];
                item.style.outline = "2px solid #FD9800";
            }

            Display.setMediaPreviewPosition(Main.selectedContent);
            Main.lock = 0; // free the lock
        });
    }, 0);
};

Display.UpdateSlideLeft = function () {
    var t = 100;
    var item;
    var list;
    var cnt = $('#contentList');
    $(cnt).find('li').css("outline", "none");
    setTimeout(function () {
        $(cnt).find("ul").stop(true, true).animate({ "left": 131 }, t, "linear", function () {
            $(cnt).find("ul").css({ "left": -5 });
            $(cnt).find('li:first').before($(cnt).find('li:last'));


            list = document.getElementById("contentList");
            if (list) {
                item = list.getElementsByTagName('li')[0];
                Display.setMediaPreviewSlideImage(item, Display.slideIndex);

                item = list.getElementsByTagName('li')[4];
                item.style.outline = "2px solid #FD9800";
            }

            Display.setMediaPreviewPosition(Main.selectedContent);
            Main.lock = 0; // free the lock

        });
    }, 0);

};

Display.setMediaPreviewPosition = function (pos) {
    Main.debug("[Display.js] - Media Preview Position: [" + pos + "]");

    Display.stopAnimation("contentInfoSummary", "top");

    if (Data.contentTitle2)
        widgetAPI.putInnerHTML(document.getElementById("topMiddle"), "<span style='color:#FD9800;'>• </span>" + Data.contentTitle1 + " : " + Data.contentTitle2);
    else
        widgetAPI.putInnerHTML(document.getElementById("topMiddle"), "<span style='color:#FD9800;'>• </span>" + Data.contentTitle1);

    if (Main.view === Main.MOVIE) {
        widgetAPI.putInnerHTML(document.getElementById("topRight"), "<span style='color:#FD9800;'>• </span>" + text.movies + ": <span style='color:#FD9800;'>" + (pos + 1) + " / " + Data.contentCount + "</span>");
    } else if (Main.view === Main.SHOW) {
        widgetAPI.putInnerHTML(document.getElementById("topRight"), "<span style='color:#FD9800;'>• </span>" + text.shows + ": <span style='color:#FD9800;'>" + (pos + 1) + " / " + Data.contentCount + "</span>");
    } else {
        widgetAPI.putInnerHTML(document.getElementById("topRight"), "<span style='color:#FD9800;'>• </span>" + text.objects + ": <span style='color:#FD9800;'>" + (pos + 1) + " / " + Data.contentCount + "</span>");
    }

    window.clearTimeout(Display.displayTimer); //stop updating
    var t = 400;
    if((prefs.general.animations || "on") === "off"){
        t = 800;
    }
    Display.scrollSpeed = 200;
    Display.displayTimer = window.setTimeout(Display.setMediaDetails, t, pos);
};

Display.setMediaDetails = function (pos) {
    //$("#contentListOverlay").fadeOut(150);
    var str = "";
    if (Data.contentYears[pos])
        str = Data.contentYears[pos];
    if (Data.contentDurations[pos] && Data.contentYears[pos])
        str = str + " • " + Main.timeConvert(Data.contentDurations[pos]);
    else if (Data.contentDurations[pos])
        str = Main.timeConvert(Data.contentDurations[pos]);
    if (Data.contentGenres[pos] && (Data.contentDurations[pos] || Data.contentYears[pos]))
        str = str + " • " + Data.contentGenres[pos];
    else if (Data.contentGenres[pos])
        str = Data.contentGenres[pos];

    $("#contentInfoName").text(Data.contentTitles[pos]);
    $("#contentInfoYearGenre").text(str);
    $("#contentInfoSummary").text(Data.contentSummarys[pos]);

    // Movie specific
    if (Main.view === Main.MOVIE) {
        if (Data.contentDirectors[pos]) {
            $("#movieDirector").show();
            $("#contentInfoDirectorData").show().text(Data.contentDirectors[pos]);
        }
        else {
            $("#movieDirector").hide();
            $("#contentInfoDirectorData").hide();
        }
        if (Data.contentWriters[pos]) {
            $("#movieWriter").show();
            $("#contentInfoWriterData").show().text(Data.contentWriters[pos]);
        }
        else {
            $("#movieWriter").hide();
            $("#contentInfoWriterData").hide();
        }
        if (Data.contentCasts[pos]) {
            $("#movieCast").show();
            $("#contentInfoCastData").show().text(Data.contentCasts[pos]);
        }
        else {
            $("#movieCast").hide();
            $("#contentInfoCastData").hide();
        }
    }

    //show specific
    if (Main.view === Main.SHOW) {
        if (Data.contentOriginallyAvailableAt[pos]) {
            $("#showAired").show();
            $("#showInfoFirstAiredData").show().text(Date.convert(Data.contentOriginallyAvailableAt[pos]));
        }
        else {
            $("#showAired").hide();
            $("#showInfoFirstAiredData").hide();
        }

        if (Data.contentGenres[pos]) {
            $("#showGenre").show();
            $("#showInfoGenreData").show().text(Data.contentGenres[pos]);
        }
        else {
            $("#showGenre").hide();
            $("#showInfoGenreData").hide();
        }

        if (Data.contentDurations[pos]) {
            $("#showDuration").show();
            $("#showInfoDurationData").show().text(Math.round(Data.contentDurations[pos] / 1000 / 60) + " min");
        }
        else {
            $("#showDuration").hide();
            $("#showInfoDurationData").hide();
        }

        if (Data.contentLeafCounts[pos]) {
            $("#showEpisodes").show();
            $("#showInfoEpisodeData").show().text(Data.contentLeafCounts[pos]);
        }
        else {
            $("#showEpisodes").hide();
            $("#showInfoEpisodeData").hide();
        }

        if (Data.contentViewedLeafCounts[pos]) {
            $("#showWatched").show();
            $("#showInfoWatchedData").show().text(Data.contentViewedLeafCounts[pos]);
        }
        else {
            $("#showWatched").hide();
            $("#showInfoWatchedData").hide();
        }

        if (Data.contentUnViewedLeafCounts[pos]) {
            $("#showUnwatched").show();
            $("#showInfoUnwatchedData").show().text(Data.contentUnViewedLeafCounts[pos]);
        }
        else {
            $("#showUnwatched").hide();
            $("#showInfoUnwatchedData").hide();
        }
    }

    $('#contentInfoPoster').css('background-image', 'none');
    $('#contentInfoPoster').find('img').attr('src', 'Images/blank.png').attr('src', Main.getPhoto(Data.contentThumbs[pos], 188 * 2, 280 * 2, 'posterBig')).css({ width: 188 });
    window.setTimeout(Main.updateBackGroundArt, 200, null, pos);

    Display.setContentImages("content", pos);
    Display.slideDescription("contentInfoSummary");
    Display.setCategorieBottomButtons(pos);
    loadbar.hide();
    Display.pageLock = 0;

};

Display.setContentImages = function (view, pos) {

    if (Data.contentTextureVideoResolutions[pos] !== "") {
        $('#' + view + 'VideoResPic').show().attr('src', Main.getPhoto(Data.contentTextureVideoResolutions[pos], 100, 20, "blank", "png"));
    } else {
        $('#' + view + 'VideoResPic').hide();
    }
    if (Data.contentTextureVideoARs[pos] !== "") {
        $('#' + view + 'VideoARPic').show().attr('src', Main.getPhoto(Data.contentTextureVideoARs[pos], 100, 20, "blank", "png"));
    } else {
        $('#' + view + 'VideoARPic').hide();
    }
    if (Data.contentTextureVideoCodecs[pos] !== "") {
        $('#' + view + 'VideoCodecPic').show().attr('src', Main.getPhoto(Data.contentTextureVideoCodecs[pos], 100, 20, "blank", "png"));
    } else {
        $('#' + view + 'VideoCodecPic').hide();
    }
    if (Data.contentTextureVideoFramerates[pos] !== "") {
        $('#' + view + 'VideoFrameratePic').show().attr('src', Main.getPhoto(Data.contentTextureVideoFramerates[pos], 100, 20, "blank", "png"));
    } else {
        $('#' + view + 'VideoFrameratePic').hide();
    }
    if (Data.contentTextureAudioCodecs[pos] !== "") {
        $('#' + view + 'AudioCodecPic').show().attr('src', Main.getPhoto(Data.contentTextureAudioCodecs[pos], 100, 20, "blank", "png"));
    } else {
        $('#' + view + 'AudioCodecPic').hide();
    }
    if (Data.contentTextureAudioChannels[pos] !== "") {
        $('#' + view + 'AudioChannelPic').show().attr('src', Main.getPhoto(Data.contentTextureAudioChannels[pos], 100, 20, "blank", "png"));
    } else {
        $('#' + view + 'AudioChannelPic').hide();
    }
    if (Data.contentRatings[pos] !== "") {
        $('#' + view + 'RatingPic').show().attr('src', 'Images/rating/rating' + Math.round(Data.contentRatings[pos]) + '.png');
    } else {
        $('#' + view + 'RatingPic').hide();
    }
    if (Data.contentContentRatings[pos] !== "") {
        $('#' + view + 'ContentRatingPic').show().attr('src', Main.getPhoto(Data.contentContentRatings[pos], 100, 20, "blank", "png"));
    } else {
        $('#' + view + 'ContentRatingPic').hide();
    }
    if (Data.contentStudios[pos] !== "") {
        var w = $('#' + view + 'Studio').width();
        var h = $('#' + view + 'Studio').height();
        $('#' + view + 'Studio').css('background-image', 'url(' + Main.getPhoto(Data.contentStudios[pos], w, h, "blank", "png")+ ')');
    } else {
        $('#' + view + 'Studio').hide();
    }
};

/*
 #################################
 #
 #       CATEGORY SECTION RESULT
 #
 #################################
 */

Display.setCategorieSectionList = function () {

    Main.debug("[Display.js] - Start Function: Display.setCategorieSectionList");
    Main.debug("[Display.js] - Section Count: [" + Data.contentCount + "]");

    if (Display.audioPlayerVisible === 1) {
        Display.showAudioPlayer();
    }

    if (Data.contentTitle2 !== "") {
        widgetAPI.putInnerHTML(document.getElementById("topMiddle"), "<span style='color:#FD9800;'>• </span>" + Data.contentTitle1 + " : " + Data.contentTitle2);
    }
    else {
        widgetAPI.putInnerHTML(document.getElementById("topMiddle"), "<span style='color:#FD9800;'>• </span>" + Data.contentTitle1);
    }

    if (Data.contentTitles[0] === "..") {
        widgetAPI.putInnerHTML(document.getElementById("topRight"), "<span style='color:#FD9800;'>• </span>" + text.objects + "<span style='color:#FD9800;'>0</span>");
    }
    else {
        widgetAPI.putInnerHTML(document.getElementById("topRight"), "<span style='color:#FD9800;'>• </span>" + text.objects + "<span style='color:#FD9800;'>" + Data.contentCount + "</span>");
    }

    if (Main.selectedSection < 0)
        Main.selectedSection = 0;
    else if (Main.selectedSection > Data.contentCount - 1)
        Main.selectedSection = 0;

    Display.listPosition = buttonCatSection.listPosition;
    Display.selectedItem = (Main.selectedSection || 0);
    Display.lastDirection = null;
    Display.currentView = "section";
    Display.initList();
};

/*
 ###############################
 #
 #       SEASON
 #
 ###############################
 */

Display.setSeasonList = function () {

    Main.debug("[Display.js] - Start Function: Display.setSeasonList");
    Main.debug("[Display.js] - Season Count: [" + Data.contentCount + "]");

    if (Display.audioPlayerVisible === 1) {
        Display.showAudioPlayer();
    }

    widgetAPI.putInnerHTML(document.getElementById("topMiddle"), "<span style='color:#FD9800;'>• </span>" + Data.contentTitle1 + " : " + Data.contentTitle2);
    widgetAPI.putInnerHTML(document.getElementById("topRight"), "<span style='color:#FD9800;'>• </span>" + text.seasons + "<span style='color:#FD9800;'>" + Data.contentCount + "</span>");


    if (Main.selectedSeason < 0)
        Main.selectedSeason = 0;
    else if (Main.selectedSeason > Data.contentCount - 1)
        Main.selectedSeason = 0;

    if ((prefs.player.playTheme || "off") === "on") {
        if (Data.contentThemes[0] && Player.state === Player.STOPPED) {
            Player.setURL(Main.server.resolveUrl(Data.contentThemes[0] + ".mp3", false, true));
            Main.debug("[Display.js] - Theme Url: " + Player.url);
            Player.playMusic(true);
        }
    }

    Display.listPosition = buttonSeason.listPosition;
    Display.selectedItem = (Main.selectedSeason || 0);
    Display.lastDirection = null;
    Display.currentView = "season";
    Display.initList();
};


/*
 ###############################
 #
 #       EPISODE
 #
 ###############################
 */

Display.setEpisodeList = function () {
    Main.debug("[Display.js] - Start Function: Display.setEpisodeList");
    Main.debug("[Display.js] - Data.contentCount: " + Data.contentCount);

    if (Display.audioPlayerVisible === 1) {
        Display.showAudioPlayer();
    }

    widgetAPI.putInnerHTML(document.getElementById("topMiddle"), "<span style='color:#FD9800;'>• </span>" + Data.contentTitle1 + " : " + Data.contentTitle2);
    widgetAPI.putInnerHTML(document.getElementById("topRight"), "<span style='color:#FD9800;'>• </span>" + text.episodes + ": <span style='color:#FD9800;'>" + Data.contentCount + "</span>");

    if (Main.selectedEpisode < 0)
        Main.selectedEpisode = Data.contentCount - 1;
    else if (Main.selectedEpisode > Data.contentCount - 1)
        Main.selectedEpisode = 0;

    Display.listPosition = buttonEpisode.listPosition;
    Display.selectedItem = (Main.selectedEpisode || 0);
    Display.lastDirection = null;
    Display.currentView = "episode";
    Display.initList();
};

/*
 ###############################
 #
 #       LISTVIEW
 #
 ###############################
 */

Display.initList = function () {
    var s;

    Display.firstInList = -1; //reset trigger to load list

    if (isEmpty(Data.contentKeys[Display.selectedItem])) {  //the selection is not within the loaded range. Reload so we can see it
        if (Display.selectedItem - 10 > 0)
            s = Display.selectedItem - 10;
        else
            s = 0;
        loadbar.show();
        Content.callback = "Display.updateListContent";
        Content.id = "displayInitlist";
        Content.fetchContentList(Content.cat, Content.section, s, 20, "noUpdate");
    }
    else {
        Display.updateList(Display.currentView, Display.selectedItem);
    }
};

Display.slideList = function (view, id, direction) {

    Display.selectedItem = id;
    Display.lastDirection = direction;
    Display.currentView = view;

    var i;
    var load = false;
    var pos = id.mod(10);
    var first = id - pos;
    var last = first + 9;

    if (last > (Data.contentCount - 1)) {
        last = (Data.contentCount - 1);
    }

    //Main.debug("[Display.js] - Position in list " + pos);
    //Main.debug("[Display.js] - First Id in list " + first);
    //Main.debug("[Display.js] - Last Id in list " + last);
    //Main.debug("[Display.js] - selectedItem " + Display.selectedItem);

    Main.debug("[Display.js] - Data.contentCount " + Data.contentCount);

    for (i = first; i <= last; i++) {
        if (isEmpty(Data.contentKeys[i])) {
            Main.debug("[Display.js] - id triggered load: " + i);
            load = true;
            break;
        }
    }

    if (load) {
        keyLock.status = keyLock.LOADING;
        loadbar.show();
        Content.callback = "Display.updateListContent";
        Content.id = id;
        Content.fetchContentList(Content.cat, Content.section, first, 10, "noUpdate");
    }
    else {
        Display.updateList(view, id, direction);
    }

};

Display.updateListContent = function () {
    if (!isEmpty(Data.contentTitles[Display.selectedItem])) {
        Display.updateList(Display.currentView, Display.selectedItem, Display.lastDirection);
    }
    else {
        keyLock.status = keyLock.NONE;
        Main.lock = 0;
    }
};

Display.updateList = function (view, id, direction) {
    var i;
    var x;
    var pos = id.mod(10);
    var first = id - pos;
    //var last = first + 9;
    var diff = (Display.listPosition >= pos) ? Display.listPosition - pos : pos - Display.listPosition;
    var jump = (diff > 1) ? true : false;

    //Main.debug("[Display.js] - First Id in list " + first);
    //Main.debug("[Display.js] - Last Id in list " + last);
    //Main.debug("[Display.js] - Requested Id " + id);
    //Main.debug("[Display.js] - selectedItem " + Display.selectedItem);
    Main.debug("[Display.js] - view " + view);
    $("#selectedContentText").text("");

    Display.verticalScroll(id, Data.contentCount, "scroll"); //update scroll bar

    x = first;
    Display.listPosition = pos;

    if (Display.firstInList !== first) {
        Main.debug("[Display.js] - refreshing list");
        for (i = 0; i < 10; i++) {
            Display.setListItem(view, i, x, false, Main.DOWN);
            x++;
        }
    }

    Display.setListItem(view, pos, id, true, Main.DOWN, jump);

    if (view === "season") {
        widgetAPI.putInnerHTML(document.getElementById("topRight"), "<span style='color:#FD9800;'>• </span>" + text.seasons + "<span style='color:#FD9800;'> " + (id + 1) + "/" + Data.contentCount + "</span>");
    }
    else if (view === "episode") {
        widgetAPI.putInnerHTML(document.getElementById("topRight"), "<span style='color:#FD9800;'>• </span>" + text.showEpisodes + "<span style='color:#FD9800;'> " + (id + 1) + "/" + Data.contentCount + "</span>");
    }
    else if (view === "section") {
        widgetAPI.putInnerHTML(document.getElementById("topRight"), "<span style='color:#FD9800;'>• </span>" + text.objects + "<span style='color:#FD9800;'> " + (id + 1) + "/" + Data.contentCount + "</span>");
    }

    window.clearTimeout(Display.displayTimer);
    var t = 400;
    if((prefs.general.animations || "on") === "off"){
        t = 800;
    }
    Display.scrollSpeed = 0;
    Display.firstInList = first; //set the trigger to watch for changes to the list
    Display.displayTimer = window.setTimeout(Display.updateListDetails, t, view, id, direction); //stop updating
};

Display.setListItem = function (view, index, id, active, direction, noAnimation) {

    //    Main.debug("[Display.js] - id: " + id);
    //    Main.debug("[Display.js] - index: " + index);
    //    Main.debug("[Display.js] - active: " + active);

    var list = document.getElementById(view + "List"); //jQuery doesn't work well on created items, do this the old fashioned way

    if (isEmpty(list)) { //can happen after deleting the last item
        //Main.debug("[Display.js] - oops! list was empty");
        return false;
    }

    var item = list.getElementsByTagName('li')[index];
    var div0 = item.getElementsByTagName('div')[0];
    var div1 = item.getElementsByTagName('div')[1];

    if (Data.contentTitles[id]) {

        if (active) {
            var top = 180 + (index * 32);
            var time = Display.scrollSpeed;
            if (noAnimation)
                time = 0; //we animated the list, this is not moving

            //div0 = document.getElementById('selectedContentText');
            div1 = document.getElementById('selectedContentImage');

            //$("#selectedContentText").stop().fadeOut(time / 2);
            //$("#selectedContentImage").stop().fadeOut(time / 2);

            $('#selectedContent').stop(true, true).animate({ 'top': top }, time, function () {
                $("#selectedContentText").putInnerHTML(Display.getListText(view, id));
                //$("#selectedContentText").fadeIn(time / 2);
                div1.style.display = "block";
                Display.setListImage(div1, view, id, true);
                Main.lock = 0;
            });
        }
        else {
            widgetAPI.putInnerHTML(div0, Display.getListText(view, id));
            div1.style.display = "block";
            Display.setListImage(div1, view, id, active);
        }
        document.getElementById("infoListBg" + (index)).style.display = "block";
    }
    else {
        widgetAPI.putInnerHTML(div0, "");
        div1.style.backgroundImage = "url('')";
        div1.style.display = "none";
        document.getElementById("infoListBg" + (index)).style.display = "none";
    }
};

Display.getListText = function (view, id) {

    var ep;
    if (isEmpty(Data.contentIndexs[id])) {
        ep = -1;
    } else {
        ep = Data.contentIndexs[id];
    }

    if (view === "season") {
        return Data.contentTitles[id];
    }
    else if (view === "section") {
        if (Data.contentTypes[id] === "track" && !isEmpty(ep)) {
            if (ep === -1)
                return Data.contentTitles[id];
            else if (ep < 10)
                return "&nbsp;" + Data.contentIndexs[id] + "&nbsp;: " + Data.contentTitles[id];
            else
                return Data.contentIndexs[id] + ": " + Data.contentTitles[id];
        }
        else if (Data.contentSourceTitles[id]) {
            if (Data.contentServerNames[id]) {
                return Data.contentTitles[id] + "<span style='color:#FD9800;'> • " + Data.contentSourceTitles[id] + " • <span>" + Data.contentServerNames[id];
            }
            else {
                return Data.contentTitles[id] + "<span style='color:#FD9800;'> • " + Data.contentSourceTitles[id];
            }
        }
        else if (Data.contentServerNames[id]) {
            return Data.contentTitles[id] + "<span style='color:#FD9800;'> • " + Data.contentServerNames[id];
        }
        else {
            return Data.contentTitles[id];
        }
    }
    else if (view === "episode") {

        if (Display.episodeFilter === 1)
            if (ep === -1)
                return Data.contentTitles[id];
            else if (ep < 10)
                return "&nbsp;" + Data.contentIndexs[id] + "&nbsp;: " + Data.contentGrandParentTitles[id] + ": " + Data.contentTitles[id];
            else
                return Data.contentIndexs[id] + ": " + Data.contentGrandParentTitles[id] + ": " + Data.contentTitles[id];
        else {
            if (ep === -1)
                return Data.contentTitles[id];
            else if (ep < 10)
                return "&nbsp;" + Data.contentIndexs[id] + "&nbsp;: " + Data.contentTitles[id];
            else
                return Data.contentIndexs[id] + ": " + Data.contentTitles[id];
        }
    }
};

Display.setListImage = function (div, view, id, active) {
    if (view === "season" || Data.contentViewGroup === "season" || Data.contentViewGroup === "show") {
        if (Data.contentUnViewedLeafCounts[id] > 0 && active) {
            widgetAPI.putInnerHTML(div, Data.contentUnViewedLeafCounts[id]);
            div.style.backgroundImage = "url('Images/episode/unwatchedCountFocused.png')";
            div.style.display = "block";
        }
        else if (Data.contentUnViewedLeafCounts[id] > 0 && !active) {
            widgetAPI.putInnerHTML(div, Data.contentUnViewedLeafCounts[id]);
            div.style.backgroundImage = "url('Images/episode/unwatchedCountUnfocused.png')";
            div.style.display = "block";
        }
        else {
            widgetAPI.putInnerHTML(div, "");
            div.style.backgroundImage = "url('')";
            div.style.display = "none";
        }
    }
    else if (view === "episode" || Data.contentViewGroup === "movie" || Data.contentViewGroup === "episode") {
        var key = (Data.contentKeys[id]) ? Data.contentKeys[id] : "";
        if (key.contains("/folder?") || key.contains("/children")) {
            if (active) {
                widgetAPI.putInnerHTML(div, "");
                div.style.backgroundImage = "url('Images/episode/folderFocused.png')";
                div.style.display = "block";
            }
            else {
                widgetAPI.putInnerHTML(div, "");
                div.style.backgroundImage = "url('Images/episode/folderUnfocused.png')";
                div.style.display = "block";
            }
        } else if (Data.contentOffsets[id] > 0) { // time for in progress
            div.style.backgroundImage = "url('Images/episode/halfWatched.png')";
            div.style.backgroundPosition = "5px, 2px";
            div.style.display = "block";
        }
        else if (Data.contentOffsets[id] === 0 && Data.contentViewCounts[id] === 0) { //no time for in progress and not watched yet
            div.style.backgroundImage = "url('Images/episode/unwatched.png')";
            div.style.backgroundPosition = "5px, 2px";
            div.style.display = "block";
        }
        else {
            widgetAPI.putInnerHTML(div, "");
            div.style.backgroundImage = "url('')";
            div.style.display = "none";
        }
    }
    else if (view === "section") {
        if (Data.contentDurations[id] > 0) {
            if (active) {
                widgetAPI.putInnerHTML(div, Data.contentDurations[id].toTimeString());
                div.style.backgroundImage = "url('Images/episode/unwatchedCountFocused.png')";
                div.style.display = "block";
            }
            else {
                widgetAPI.putInnerHTML(div, Data.contentDurations[id].toTimeString());
                div.style.backgroundImage = "url('Images/episode/unwatchedCountUnfocused.png')";
                div.style.display = "block";
            }
        }
        else if (!isEmpty(Data.contentKeys[id])) {
            if (Data.contentKeys[id].contains("/folder?") || Data.contentKeys[id].contains("/children")) {
                if (active) {
                    widgetAPI.putInnerHTML(div, "");
                    div.style.backgroundImage = "url('Images/episode/folderFocused.png')";
                    div.style.display = "block";
                }
                else {
                    widgetAPI.putInnerHTML(div, "");
                    div.style.backgroundImage = "url('Images/episode/folderUnfocused.png')";
                    div.style.display = "block";
                }
            }
        }
        else {
            widgetAPI.putInnerHTML(div, "");
            div.style.backgroundImage = "url('')";
            div.style.display = "none";
        }
    }
    else {
        widgetAPI.putInnerHTML(div, "");
        div.style.backgroundImage = "url('')";
        div.style.display = "none";
    }

};

Display.updateListDetails = function (view, id) {

    //Main.debug("[Display.js] - updateListDetails");
    Display.stopAnimation(view + "Description", "top");
    loadbar.show();

    if (Data.contentTitles[0] === text.noData) {
        Main.debug("[Display.js] - Data.contentTitles returned no data");
        keyLock.status = keyLock.NONE;
        loadbar.hide();
        return false;
    }

    if (isEmpty(Data.contentTitles[id])) {
        Main.debug("[Display.js] - Data.contentTitles is null");
        keyLock.status = keyLock.NONE;
        loadbar.hide();
        return false;
    }

    if (Data.contentTitles[id] === "..") {
        Main.debug("[Display.js] - Data.contentTitles returned no data");
        keyLock.status = keyLock.NONE;
        loadbar.hide();
        return false;
    }

    if (Data.contentMedias[id] !== "") {
        Player.resumeTime = Data.contentOffsets[id];
    }

    //images
    window.setTimeout(Main.updateBackGroundArt, 200, null, id);
    var w = $('#' + view + 'Poster').width();
    var h = $('#' + view + 'Poster').height();

    //text
    window.clearTimeout(Display.descriptionTimer);
    $("#" + view + "Description").html("");
    Display.setDescriptionText(view, Data.contentSummarys[id].substring(0, 350), false); //load the first part of the description, loading evrything at once slows down the ui
    Display.descriptionTimer = window.setTimeout(Display.setDescriptionText, 2000, view, Data.contentSummarys[id].substring(350), true); //load the rest before we start scrolling

    $("#" + view + "Name").text(Data.contentTitles[id]);

    // view specific settings
    if (view === "season") {
        $("#" + view + "Poster img").attr("src", Main.getPhoto(Data.contentThumbs[id], w * 2, h * 2, "poster")).show();

        if (Data.contentUnViewedLeafCounts[id] > 0)
            $("#" + view + "EpCount").text(Data.contentLeafCounts[id] + text.episodes + " / " + Data.contentUnViewedLeafCounts[id] + text.unwatched);
        else
            $("#" + view + "EpCount").text(Data.contentLeafCounts[id] + text.episodes);

        if (Data.contentKeys[id].contains("/allLeaves")) {
            document.getElementById("bottomInfoText").style.display = "none";
            document.getElementById("bottomInfoPic").style.display = "none";
        }
        else {
            document.getElementById("bottomInfoText").style.display = "block";
            document.getElementById("bottomInfoPic").style.display = "block";
        }
        Display.setContentImages(view, id);
    }
    else if (view === "episode") {
        $("#" + view + "Poster img").attr("src", Main.getPhoto(Data.contentThumbs[id], w * 2, h * 2, "poster")).show();
        $("#" + view + "ShowName").text(Data.contentGrandParentTitles[id]);
        $("#" + view + "FirstAired").text(Data.contentOriginallyAvailableAt[id]);
        $("#" + view + "Duration").html("Duration: <span style='color:white;'>" + Data.contentDurations[id].toTimeString() + "</span>");

        // Season Number Episode Number
        if (!(Data.contentParentIndexs[id])) {
            widgetAPI.putInnerHTML(document.getElementById("episodeName"), "<span style='color:#FD9800;'>" + Data.contentTitle2 + ", Episode " + Data.contentIndexs[id] + ": </span>" + Data.contentTitles[id]);
            widgetAPI.putInnerHTML(document.getElementById("osdEpisodeNumber"), Data.contentTitle2 + ", Episode " + Data.contentIndexs[id] + ": " + Data.contentTitles[id]);
        }
        else {
            widgetAPI.putInnerHTML(document.getElementById("episodeName"), "<span style='color:#FD9800;'>Season " + Data.contentParentIndexs[id] + ", Episode " + Data.contentIndexs[id] + ": </span>" + Data.contentTitles[id]);
            widgetAPI.putInnerHTML(document.getElementById("osdEpisodeNumber"), "Season " + Data.contentParentIndexs[id] + ", Episode " + Data.contentIndexs[id] + ": " + Data.contentTitles[id]);
        }

        Display.setContentImages(view, id);
    }
    else if (view === "section") {
        var contentThumb = Data.contentThumbs[id];
        var contentType = Data.contentTypes[id];

        if (contentThumb.contains("movie-fanart.")) {
            contentThumb = "Images/categorie/movie.png";
            contentType = "movie";
        } else if (contentThumb.contains("show-fanart.")) {
            contentThumb = "Images/categorie/show.png";
            contentType = "show";
        } else if (contentThumb.contains("artist-fanart.")) {
            contentThumb = "Images/categorie/artist.png";
            contentType = "track";
        } else if (contentThumb.contains("photo-fanart.")) {
            contentThumb = "Images/categorie/photo.png";
            contentType = "photo";
        }


        if (Data.contentSummarys[id] !== "") {
            $("#" + view + "Poster").hide();
            $("#" + view + "PosterSmall img").attr("src", "Images/preloader.gif");
            $("#" + view + "PosterSmall").show();
            $("#" + view + "PosterSmall img").attr("src", Main.getPhoto(contentThumb, 250, 150, contentType)).css({ 'height': 150, 'max-width': 250 });
            $("#" + view + "TexturesAll").removeClass("large").addClass("small");
            $("#" + view + "Description").show();

            if (!isEmpty(Data.contentOriginallyAvailableAt[id]) && Data.contentOriginallyAvailableAt[id] !== "")
                $("#" + view + "FirstAired").text(Data.contentOriginallyAvailableAt[id]).show();

            if (Data.contentDurations[id] > 0)
                $("#" + view + "Duration").putInnerHTML(text.duration + " <span style='color:white;'>" + Data.contentDurations[id].toTimeString() + "</span>").show();
        }
        else {
            $("#" + view + "Description").hide();
            $("#" + view + "FirstAired").hide();
            $("#" + view + "Duration").hide();
            $("#" + view + "PosterSmall").hide();
            $("#" + view + "TexturesAll").removeClass("small").addClass("large");
            $("#" + view + "Poster img").attr("src", "Images/categorie/plexlogo.png");
            $("#" + view + "Poster").show();
            $("#" + view + "Poster img").attr("src", Main.getPhoto(contentThumb, w, h, contentType)).css({ height: h });
        }
        Display.setContentImages(view, id);

        if (Data.contentViewGroup === "artist") {
            $("#bottomAllDircImg").attr("src", "Images/navi/allDirections.png");
        } else {
            $("#bottomAllDircImg").attr("src", "Images/navi/ud.png");
        }
    }

    Display.setCategorieBottomButtons(id);
    keyLock.status = keyLock.NONE;
    loadbar.hide();
    Main.lock = 0;
};

Display.hideDescription = function () {
    $("#" + Display.currentView + "Description").html('');
};


Display.setDescriptionText = function (view, descr, start) {
    if (start) {
        $("#" + view + "Description").append(descr);
        Display.slideDescription(view + "Description");
    } else {
        $("#" + view + "Description").html(descr);
    }
};

Display.setCategorieBottomButtons = function (id) {

    var allowed = Main.checkDeleteItemAllowed(id);

    //Main.debug("[Display.js] - Deletion Allowed: " + allowed.toString());
    if (allowed) {
        $("#bottomDelete").show();
        $("#bottomDeletePic").show();
        if (Main.mediaContent !== Main.QUEUE || Main.mediaContent !== Main.RECOMMENDED) {
            if (Data.contentRatingKeys[id] !== "") {
                $("#bottomInfoText").text(text.info).show();
                $("#bottomInfoPic").show();
            } else {
                $("#bottomInfoText").text(text.info).hide();
                $("#bottomInfoPic").hide();
            }
        }
        Player.setAutoPlay(); //call without argument will set the current status
    }
    else {
        $("#bottomDelete").hide();
        $("#bottomDeletePic").hide();
        Player.setAutoPlay(Player.NOT); //will just hide the status
    }

    var cVisible = false;
    var cPic = "listview.png";

    if (Main.view === Main.SECTIONS && Data.contentViewGroup === "movie") {
        cVisible = true;
        cPic = "carousel.png";
    } else if (Main.view === Main.SECTIONS && Data.contentViewGroup === "show") {
        cVisible = true;
        cPic = "carousel.png";
    } else if (Main.view === Main.MOVIE)
        cVisible = true;
    else if (Main.view === Main.SHOW)
        cVisible = true;

    $("#bottomView").attr('src', 'Images/navi/' + cPic);

    if (cVisible) {
        $("#bottomView").show();
        $("#bottomViewPic").show();
    } else {
        $("#bottomView").hide();
        $("#bottomViewPic").hide();
    }

};

/*
 ###############################
 #
 #       HELPER FUNCTIONS
 #
 ###############################
 */

Display.slideDescription = function (divID) {
    try {

        var maxHeight = parseInt($("#" + divID + "View").css("height").replace("px", ""), 10);
        var itemHeigth = parseInt($("#" + divID + "").outerScrollHeight(), 10);
        $("#" + divID + "View").show();

        //Main.debug("[Display.js] - Summary Item height: [" + itemHeigth + "]");

        if (itemHeigth > maxHeight) {
            //Main.debug("[Display.js] - Overflow detected");
            var st = scrollText;
            st.init({
                ID: divID + "View",             // the unique ID name of the parent DIV.                                    (string)
                Mode: 'Vertical',               //(optional) the mode of execution, 'Vertical' or 'Horizontal'.             (string, default = 'Vertical')
                StartDelay: 10000,              //(optional) the auto start delay in milli seconds'.                        (number, default = no auto start)
                StartDirection: -1              //(optional) the auto start scroll direction'.                              (number, default = -1)
            }, itemHeigth + maxHeight - 22);    //(optional) the height of the section before the first line reappears'.    (number, default = 0)
        }
        else {
            //no scrolling needed
            //Main.debug("[Display.js] - No Overflow detected");
        }
    }
    catch (err) {
        //just to be safe
    }
};

Display.verticalScroll = function (position, count) { //slide scrollbar
    var height = $(".scrollbar").height();
    if (count > 10) {
        var x = height / count;
        var y = position * x;
        y = Math.ceil(y);

        if (x < 5)
            x = 5;
        $(".scroll").css("height", x);
        $(".scroll").css("top", y);
    }
    else {
        $(".scroll").css("top", 0);
        $(".scroll").css("height", height);
    }
};

Display.stopAnimation = function (divID, what) {
    scrollText.stop();
    $("#" + divID + "").height("0px"); //reset the div's height, scrolling makes it bigger all the time
    if (what === "top")
        $("#" + divID + "").css('top', '0px');
    else if (what === "left")
        $("#" + divID + "").css('left', '0px');
};

Display.friendlyUrl = function (url) {
    var s = "";
    if (url.length > 10) {
        if (url.contains("://www.")) {
            s = url.between("://www.", "."); //will return the same string is not exists
        } else {
            s = url.between("://", ".");
        }
    }

    if (s == "") {
        s = text.unknown;
    }

    return s.capitalize();
};

/*
 ###############################
 #
 #       PLAYER
 #
 ###############################
 */

Display.showAudioPlayer = function () {
    window.clearTimeout(Display.audioPlayerTimeout);
    $("#albumImage").find("img").attr('src', Player.albumImage).attr('width', 70).attr('height', 70);
    $("#artistName").text(Player.aristName);
    $("#albumName").text(Player.albumName);
    $("#songName").text(Player.songName);
    $("#songProgress").text(text.loading);
    $("#songIndex").text(Player.songIndex);
    $("#audioPlayer").stop(true, true).fadeIn("slow");
    Display.audioPlayerVisible = 1;
};

Display.hideAudioPlayer = function () {
    Display.audioPlayerVisible = 0;
    window.clearTimeout(Display.audioPlayerTimeout);
    Display.audioPlayerTimeout = window.setTimeout(function () {
        $("#audioPlayer").fadeOut("slow");
    }, 2000);
};


Display.setOSDText = function (id) {
    if (Main.mediaContent === Main.EPISODE) {
        if (!Data.contentParentIndexs[id]) {
            $("#osdContentTitle").text(Data.contentGrandParentTitles[id] + ", " + Data.contentTitle2 + ", Episode " + Data.contentIndexs[id]);
            $("#osdContentYear").text(Data.contentTitles[id]);
        } else {
            $("#osdContentTitle").text(Data.contentGrandParentTitles[id] + ", Season " + Data.contentParentIndexs[id] + ", Episode " + Data.contentIndexs[id]);
            $("#osdContentYear").text(Data.contentTitles[id]);
        }
    } else {
        $("#osdContentTitle").text(Player.contentTitle);
        $("#osdContentYear").text(Player.contentYear);
    }
};