﻿var IME_Input = function (id, callback, numpad) {

    var imeObject = new IMEShell(id, function () {
        widgetAPI.putInnerHTML(document.getElementById(id), "");
        loadbar.hide();
        installFocusKeyCallbacks();
        installStatusCallbacks();
    }, 'en');

    var installFocusKeyCallbacks = function () {
        imeObject.setKeyFunc(tvKey.KEY_ENTER, keyDown);
        imeObject.setKeyFunc(tvKey.KEY_PANEL_ENTER, keyDown);
        imeObject.setKeyFunc(tvKey.KEY_JOYSTICK_OK, keyDown);
        imeObject.setKeyFunc(tvKey.KEY_RETURN, keyDown);
        imeObject.setKeyFunc(tvKey.KEY_PANEL_RETURN, keyDown);
        imeObject.setKeyFunc(tvKey.KEY_EXIT, keyDown);
        imeObject.setKeyFunc(tvKey.KEY_UP, keyDown);
        imeObject.setKeyFunc(tvKey.KEY_DOWN, keyDown);
        imeObject.setKeyFunc(tvKey.KEY_LEFT, keyDown);
        imeObject.setKeyFunc(tvKey.KEY_RIGHT, keyDown);
        imeObject.setKeyFunc(tvKey.KEY_TTX_MIX, keyDown);
        imeObject.setKeyFunc(35, keyDown);
    };

    var installStatusCallbacks = function () {
        if (numpad) {
            if (getModel(2010)) {
                imeObject.setKeypadPos(660, 100, 9);
            } else {
                imeObject.setKeypadPos(660, 100, 9);
                imeObject.setQWERTYPos(432, 100, 9);
            }
        } else {
            imeObject.setString("");
            if (getModel(2010)) {
                imeObject.setKeypadPos(580, 128, 9);
            } else {
                imeObject.setKeypadPos(580, 140, 9);
                imeObject.setQWERTYPos(432, 140, 9);
            }
        }

        if (Popup.status === 0) {
            imeObject.setEnterFunc(callback);
        }

        loadbar.show();
        document.getElementById(id).focus();
        document.getElementById("loadbar").focus(); //dummy to trigger the build

        if (numpad) {
            if (getModel(2010)) { //ime2.js
                imeObject._inputModeChange();//set mode to num
                imeObject._inputModeChange();
                imeObject._inputModeChange();
            } else if (getModel(2011)) { //ime.js
                imeObject.setKeySetFunc('12key');
                imeObject.setMode("_num");
            } else { //ime.js
                _g_ime.keySet = '12key';
                imeObject.setMode("_num");
            }
        } else {
            if (getModel(2010)) {
                imeObject._inputModeChange(); //set mode to abc
            } else if (getModel(2011)) {
                imeObject.setKeySetFunc('qwerty');
            } else if (getModel(2012)) {
                imeObject.setKeySetFunc('qwerty');
                if (_g_ime.pluginMouse_use_YN) {
                    imeobj._focus();
                }
            } else {
                imeObject.setKeySetFunc('qwerty');
            }
        }

        document.getElementById(id).focus();
        loadbar.hide();

    };

    var keyDown = function (keyCode) {
        Main.debug("[IME_Input.js] - Pushed:" + keyCode);
        switch (keyCode) {
            case tvKey.KEY_TTX_MIX:
            case tvKey.KEY_PLUS100:
            case 35:
                Main.debug("[IME_Input.js] - TTX_MIX");
                return true;
            case tvKey.KEY_RETURN:
            case tvKey.KEY_PANEL_RETURN:
                widgetAPI.blockNavigation(event);
                Main.debug("[IME_Input.js] - RETURN");
                if (Popup.status > 0) {
                    Popup.keyDown(tvKey.KEY_RETURN);
                    return false;
                } else {
                    callback("");
                    return false;
                }
            case tvKey.KEY_EXIT:
                Main.debug("[IME_Input.js] - EXIT");
                widgetAPI.blockNavigation(event);
                Player.deinit();
                widgetAPI.sendExitEvent();
                return false;
            case tvKey.KEY_ENTER:
            case tvKey.KEY_PANEL_ENTER:
            case 29443: //tvKey.KEY_JOYSTICK_OK:
                Main.debug("[IME_Input.js] - ENTER");
                if (Popup.status > 0) {
                    Popup.keyDown(tvKey.KEY_ENTER);
                    return true;
                } else {
                    Main.debug("Enter key pressed in " + id + ", key code is " + keyCode + ", text is " + document.getElementById(id).value);
                    return true;
                }
            case tvKey.KEY_UP:
                Main.debug("[IME_Input.js] - UP");
                if (Popup.status > 0) {
                    Popup.keyDown(keyCode);
                    return false;
                } else {
                    return true;
                }
            case tvKey.KEY_DOWN:
                Main.debug("[IME_Input.js] - DOWN");
                if (Popup.status > 0) {
                    Popup.keyDown(keyCode);
                    return false;
                } else {
                    return true;
                }
            case tvKey.KEY_LEFT:
                Main.debug("[IME_Input.js] - LEFT");
                if (Popup.status > 0) {
                    Popup.keyDown(keyCode);
                    return false;
                } else {
                    return true;
                }
            case tvKey.KEY_RIGHT:
                Main.debug("[IME_Input.js] - RIGHT");
                if (Popup.status > 0) {
                    Popup.keyDown(keyCode);
                    return false;
                } else {
                    return true;
                }
            default:
                Main.debug("[IME_Input.js] - Unhandeled keycode: " + keyCode);
                return false;
        }
    };
};