var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();
var pluginAPI = new Common.API.Plugin();
var text = {};  //holds translations
var profile = {}; //holds supported codecs and containers

var keyLock =
{
    NONE: 0,
    PLAYERSTART: 1,
    INFOLOCK: 2,
    CHOICELOCK: 3,
    VOLUMELOCK: 4,
    LOADING: 5,
    BLOCKALL: 10,

    status: 0
};

var loading = {
    timer: 0,
    count: -1,
    show: function () {
        window.clearInterval(loading.timer);
        var div = document.getElementById("loading");
        div.style.display = "block";
        $("#loading").find("img").attr('src', "Images/loader/loading_00.png");
        loading.timer = window.setInterval(loading.animate, 500);
    },
    animate: function () {
        var url;
        loading.count++;
        if (loading.count > 9) {
            url = "Images/loader/loading_" + loading.count + ".png";
        }
        else {
            url = "Images/loader/loading_0" + loading.count + ".png";
        }
        $("#loading").find("img").attr('src', url);

        if (loading.count > 10)
            loading.count = -1;
    },
    hide: function () {
        window.clearInterval(loading.timer);
        var div = document.getElementById("loading");
        div.style.top = loading.top + "px";
        div.style.display = "none";
    }
};

var loadbar = {
    timer: 0,
    count: -1,
    show: function () {
        window.clearInterval(loadbar.timer);
        var div = document.getElementById("loadbar");
        div.style.display = "block";
        $("#loadbar").find("img").attr('src', "Images/loader/loadbar_0.png");
        loadbar.timer = window.setInterval(loadbar.animate, 500);
    },
    animate: function () {
        var url;
        loadbar.count++;
        url = "Images/loader/loadbar_" + loadbar.count + ".png";
        $("#loadbar").find("img").attr('src', url);

        if (loadbar.count > 2)
            loadbar.count = -1;
    },
    hide: function () {
        window.clearInterval(loadbar.timer);
        var div = document.getElementById("loadbar");
        div.style.display = "none";
    }
};

var Main =
{
    server: null,
    sectionValue: "",
    selectedCat: 0,
    selectedCatID: 0,
    selectedRA: 0,
    selectedOD: 0,
    selectedCategorie: 0,
    selectedSection: 0,
    selectedContent: 0,
    selectedShow: 0,
    selectedSeason: 0,
    selectedEpisode: 0,
    selectedMedia: 0,
    selectedID: 0,
    nextPageUrl: "",

    categoryNumber: 0,

    lock: 0,
    screenlock: 0,
    osd: 0,
    rightOSD: 0,
    rightOSDChanged: 0,
    selectedRightOSD: 0,
    selectedRightOSDTop: 95,
    selectedRightOSDArrow: 1,
    startup: true,

    waitTimer: 0,
    wait: 0,

    view: 0,
    mediaContent: 0,

    deleteAllowed: 0,
    serverAdd: 0,

    debugging: "off",
    intervalID: 0,

    serverPref: null,

    error: 0,
    pageLoaded: 0,

    WINDOW: 0,
    FULLSCREEN: 1,

    MOVIE: 1,
    EPISODE: 2,
    CATEGORIE: 3,
    SHOW: 4,
    SEASON: 5,
    SETTINGS: 6,
    QUEUE: 7,
    SHARED: 8,
    RECOMMENDED: 9,
    PLUGIN: 10,
    PLEXONLINE: 11,
    ARTIST: 12,
    PHOTO: 13,
    SECTIONS: 14,
    PLAY: 15,

    UP: 0,
    DOWN: 1,
    RIGHT: 2,
    LEFT: 3,
    PAGE_UP: 4,
    PAGE_DOWN: 5,

    NEXT: 20,
    PREV: 30,

    WATCHED: 0,
    UNWATCHED: 1,

    ON: "on",
    OFF: "off",

    NETWORKERROR: 4,
    CONNECTERROR: 5,
    FIRSTSTART: 6,

    WIZARDACTION: 0,

    direction: "",
    history: [],

    alphabet: 0,
    alphabetSelected: 0,
    alphabetTimer: 0,
    alphabetChars: [],

    language: ""
};

keyLock.checkKey = function (keyCode) {

    if (keyCode == tvKey.KEY_INFOLINK || tvKey.KEY_WLINK || tvKey.KEY_CONTENT || keyCode === tvKey.KEY_EXIT || keyCode === 246) { //should always work
        return true;
    }

    if (Main.WIZARDACTION == 1) {
        return false;
    }

    var result;
    switch (keyLock.status) {
        case keyLock.NONE:
            result = true;
            break;
        case keyLock.BLOCKALL:
            result = false;
            break;
        case keyLock.VOLUMELOCK:
            if (keyCode === tvKey.KEY_RETURN || tvKey.KEY_PANEL_VOL_UP || tvKey.KEY_VOL_UP || tvKey.KEY_VOL_DOWN || tvKey.KEY_PANEL_VOL_DOWN)
                result = true;
            else
                result = false;
            break;
        case keyLock.LOADING:
            if (keyCode === tvKey.KEY_RETURN)
                result = true;
            else
                result = false;
            break;
        case keyLock.PLAYERSTART:
            if (keyCode === tvKey.KEY_STOP || keyCode === tvKey.KEY_RETURN)
                result = true;
            else
                result = false;
            break;
        case keyLock.INFOLOCK:
            if (keyCode === tvKey.KEY_RED || keyCode === tvKey.KEY_ENTER || keyCode === tvKey.KEY_PANEL_ENTER || keyCode === tvKey.KEY_RETURN)
                result = true;
            else
                result = false;
            break;
        case keyLock.CHOICELOCK:
            if (keyCode === tvKey.KEY_UP || keyCode === tvKey.KEY_DOWN || keyCode === tvKey.KEY_ENTER || keyCode === tvKey.KEY_PANEL_ENTER || keyCode === tvKey.KEY_RETURN)
                result = true;
            else
                result = false;
            break;
        case keyLock.LEFTRIGHTLOCK:
            if (keyCode === tvKey.KEY_LEFT || keyCode === tvKey.KEY_RIGHT || keyCode === tvKey.KEY_ENTER || keyCode === tvKey.KEY_PANEL_ENTER || keyCode === tvKey.KEY_RETURN)
                result = true;
            else
                result = false;
            break;
        default:
            result = true;  //if not defined return true
    }
    return result;
};

Main.registerKeys = function () {
    var pluginAPP = document.getElementById("pluginObjectAppCommon");

    pluginAPP.RegisterKey(309); // register ENTER PANEL key
	pluginAPP.RegisterKey(246); // register HISTORY key

    pluginAPP.UnregisterKey(76); // unregister POWER key
    pluginAPP.UnregisterKey(222); // unregister SOURCE key
    pluginAPP.UnregisterKey(262); // unregister MENU key
    pluginAPP.UnregisterKey(84); // unregister Channel List key
    pluginAPP.UnregisterKey(612); // unregister SOURCE PANEL key
    pluginAPP.UnregisterKey(613); // unregister MENU PANEL key
    pluginAPP.UnregisterKey(614); // unregister POWER PANEL key
    pluginAPP.UnregisterKey(1063); // unregister E-Manual  key
    pluginAPP.UnregisterKey(261); // unregister SmartHub  key
    pluginAPP.UnregisterKey(77); // unregister TV key

    if (getModel(2010)) {
        pluginAPP.RegisterKey(1219); // register 3D key
    } else {
        pluginAPP.UnregisterKey(1219); // unregister 3D key
    }

    setTimeout(Main.enableVolumeOSD, 1000); //needs a delay to work
};

Main.enableVolumeOSD = function () {
    var pluginAPP = document.getElementById("pluginObjectAppCommon");
    pluginAPI.SetBannerState(1);
    pluginAPP.UnregisterKey(7); //unregister volume up button
    pluginAPP.UnregisterKey(11); //unregister volume down button
    pluginAPP.UnregisterKey(27); //unregister mute button
};

Main.init = function () {
    Main.insertTextAll();
    Main.intervalID = window.setInterval("Main.setClock()", 10000);
    Main.myPlexLogin();
    window.setTimeout(Main.setClock, 0);
    loading.hide();
    return true;
};

/*
 ###############################
 #
 #       LOADER
 #
 ###############################
 */
Main.onLoad = function () { //start of app
    //$.support.cors = true;
    //Main.debug("[Main.js] - jQuery version: " + jQuery.fn.jquery);

    Main.loadPrefs();
    Main.debugging = (prefs.general.debug || "off");
    Main.getLanguage(); //get the stored value if any
    Main.setLanguage(); //init the selected language
    Main.setSubtitlePrefs();
    Main.loadProfile(); // get direct play profiles
    $.fx.off = ((prefs.general.animations || "on") === "off") ? true : false;

    //only load this once for the whole app
    Player.init();
    Audio.init();
    Network.init();
    Main.getIME(); //set the proper IME object

    Main.selectedCat = parseInt(prefs.categorie.selectedCategorie || "0", 10); //try to set the same as we left

    Main.debug("[Main.js] - ################# Starting Plex App v " + Application.appVersion + " #################");
    if (prefs.general.animations === "") { //never set before = new installation
        //disable transitions by default for older bluray players
        if (getProductType() !== "TV" && getModelYear() < 2013) {
            $.fx.off = true;
            prefs.general.animations = "off";
            Main.debug("[Main.js] - Slower hardware detected, disabling animations");
        } else {
            $.fx.off = false;
            prefs.general.animations = "on";
        }
    }

    var id = getQueryString("id");
    var pw = getQueryString("pw");

    if (!isEmpty(id) && !isEmpty(pw)) {
        if ($('#splash').is(':visible')) {
            $("#loadingProgress").putInnerHTML(text.loginAccount + "<br>" + id).show();
        }

        Main.debug("[Main.js] - Log in with SSO");

        MyPlex.login(id, pw, function (result) {

            if (result === "OFFLINE") {
                Main.debug("[Main.js] - Plex website is offline");
                Main.showInfo(text.errorMyPlexConnect, "warning", text.continue1, function () {
                    Main.LoadHome();
                });
            } else if (result === "FALSE") {
                Main.debug("[Main.js] - Plex Account login with existing token failed");
                Main.showInfo(text.errorMyPlexLogin, "warning", text.continue1, function () {
                    Main.LoadHome();
                });
            } else {
                var autoupdate = ((prefs.myplex.autoserverlist || "off") === "on");
                MyPlex.getServerList(function () {
                    Main.LoadHome();
                }, autoupdate);
            }
        });

    } else if (((prefs.myplex.autoLogin || "off") === "on") && ((prefs.myplex.authToken || "") !== "")) {
        if ($('#splash').is(':visible')) {
            $("#loadingProgress").putInnerHTML(text.loginAccount + "<br>" + prefs.myplex.username).show();
        }
        Main.debug("[Main.js] - Log in with Token");

        MyPlex.authToken = prefs.myplex.authToken;
        MyPlex.loginWithToken(function (result) {
            if (result === "OFFLINE") {
                Main.debug("[Main.js] - Plex website is offline");
                Main.showInfo(text.errorMyPlexConnect, "warning", text.continue1, function () {
                    Main.LoadHome();
                });
            } else if (result === "FALSE") {
                Main.debug("[Main.js] - Plex Account login with existing token failed");
                Main.showInfo(text.errorMyPlexLogin, "warning", text.continue1, function () {
                    Main.LoadHome();
                });
            } else {
                var autoupdate = ((prefs.myplex.autoserverlist || "off") === "on") ? true : false;
                MyPlex.getServerList(function () {
                    Main.LoadHome();
                }, autoupdate);
            }
        });
    } else {
        Main.LoadHome();
    }

};

Main.LoadHome = function () {
    Main.loadPage("main", "back");
    widgetAPI.sendReadyEvent(); //this will register all keys needed for a full screen app if <fullwidget> = Y
    Main.registerKeys(); //register keyevents and start accepting input
};

Main.onUnload = function () {
    prefs.categorie.selectedCategorie = Main.selectedCat;
    Main.savePrefs();
    Player.plugin.Stop();
    Main.debug("[Main.js] - Application was closed");
};

Main.hideSplashScreen = function () {
    $("#loadingProgress").text("").hide();
    $("#splash").fadeOut('slow');
    if (Main.error === Main.FIRSTSTART) {
        window.setTimeout(Main.showWizard, 1000);
    }
};

Main.showWizard = function () {
    var buttons = [];
    buttons.push(text.wizardButtonConnect);
    buttons.push(text.wizardButtonManual);
    Popup.showWizard(text.welcome, text.wizardPageOne, buttons, function (result) {

        if (result === text.wizardButtonManual) {
            Main.WIZARDACTION = 1; //disable keys
            buttonCategorie.hideCategories();
            Main.loadPage("setting", "forward");

            setTimeout(function () {
                buttonSetting.selectNextSetting();
            }, 500);
            setTimeout(function () {
                buttonSetting.selectNextSetting();
            }, 1000);
            setTimeout(function () {
                buttonSetting.handleEnter();
            }, 1500);
            setTimeout(function () {
                Popup.showIPAddress(text.connectToLocalServer, text.enterIPAddress, "", function () {
                    buttonSetting.updatePMS();
                });
                Main.WIZARDACTION = 0;
            }, 3500);

        } else if (result === text.wizardButtonConnect) {
            Main.WIZARDACTION = 1;
            buttonCategorie.hideCategories();
            Main.loadPage("setting", "forward");

            setTimeout(function () {
                buttonSetting.selectNextSetting();
            }, 500);
            setTimeout(function () {
                buttonSetting.selectNextSetting();
            }, 1000);
            setTimeout(function () {
                buttonSetting.selectNextSetting();
            }, 1500);
            setTimeout(function () {
                buttonSetting.selectNextSetting();
            }, 2000);
            setTimeout(function () {
                buttonSetting.handleEnter();
            }, 2500);
            setTimeout(function () {
                buttonSetting.setLogin();
                Main.WIZARDACTION = 0;
            }, 4000);
        }
    });
};

Main.loadPage = function (view, direction) {

    Main.debug("[Main.js] - Main.loadPage: " + view + ", " + direction);

    if (!Main.server) {
        Main.server = new Server();
    }

    keyLock.status = keyLock.LOADING;

    var listPosition = 0;
    var selectedItem = 0;

    if (direction)
        Main.direction = direction;

    if (Main.direction === "forward") {
        var h = {
            view: view,
            url: Main.nextPageUrl,
            selectedItem: 0,
            listPosition: 0
        };

        Main.history.push(h);
        Main.debug("[Main.js] - Saved View: " + view + ", Forward url: " + Main.nextPageUrl);
    } else if (Main.direction === "back") {

        if (Main.history.length > 0) {
            Main.history.pop();
            if (Main.history.length > 0) {
                var pos = Main.history[Main.history.length - 1];
                Main.nextPageUrl = pos.url;
                view = pos.view;
                selectedItem = pos.selectedItem;
                listPosition = pos.listPosition;
                Main.debug("[Main.js] - Restored View: " + pos.view + ", Selected item: " + selectedItem + ", Position: " + listPosition + ", Back url: " + Main.nextPageUrl);
            }
        } else { //something went wrong, send to main page
            Main.debug("[Main.js] - History is empty");
            Main.direction = "forward";
            var m = {
                view: "main",
                url: "",
                selectedItem: 0,
                listPosition: 0
            };
            Main.history.push(m);
        }
    } else { //something went wrong, send to main page
        Main.debug("[Main.js] - Direction is empty");
        Main.direction = "forward";
        var k = {
            view: "main",
            url: "",
            selectedItem: 0,
            listPosition: 0
        };
        Main.history.push(k);
    }

    Main.debug("[Main.js] - Main.nextPageUrl: " + Main.nextPageUrl);
    Main.debug("[Main.js] - Main.direction: " + Main.direction);

    if (Main.nextPageUrl.contains("library/sections/")) {
        Main.categoryNumber = Main.nextPageUrl.between("library/sections/", "/");
    }

    $('#container').html(''); //release references

    $('#container').load('partials/' + view + '.html #container', function () {

        Main.init();
        if (view === "main") {
            Main.server.shared = false;// falback to default pms
            Main.selectedContent = 0;
            Main.view = Main.CATEGORIE;
            Main.selectedCategorie = selectedItem;
            Main.onLoadCategorie();
        }
        else if (view === "catSection") {
            Main.view = Main.SECTIONS;
            Main.selectedSection = selectedItem;
            buttonCatSection.listPosition = listPosition;
            Main.onLoadCatSection();
        }
        else if (view === "movie") {
            Main.view = Main.MOVIE;
            Main.selectedContent = selectedItem;
            buttonMovie.listPosition = listPosition;
            Main.onLoadMovie();
        }
        else if (view === "show") {
            Main.view = Main.SHOW;
            Main.selectedContent = selectedItem;
            buttonShow.listPosition = listPosition;
            Main.onLoadShow();
        }
        else if (view === "season") {
            Main.view = Main.SEASON;
            Main.selectedSeason = selectedItem;
            buttonSeason.listPosition = listPosition;
            Main.onLoadSeason();
        }
        else if (view === "episode") {
            Main.view = Main.EPISODE;
            Main.selectedEpisode = selectedItem;
            buttonEpisode.listPosition = listPosition;
            Main.onLoadEpisode();
        }
        else if (view === "setting") {
            Main.view = Main.SETTINGS;
            Main.onLoadSetting();
        }
        else if (view === "slideshow") {
            Main.view = Main.PHOTO;
            Main.onLoadSlideShow();
        }

        Main.debug("[Main.js] - view: " + view + ' load completed.');
    });
};

Main.updateHistoryPosition = function (selectedItem, position) {
    // update the position always before you jump to another view
    if (Main.history.length > 0) {
        var pos = Main.history[Main.history.length - 1];
        pos.selectedItem = selectedItem;
        if (position)
            pos.listPosition = position;
        else {
            pos.listPosition = 0;
        }
        //Main.debug("[Main.js] - Updated position: " + pos.view + ", SelectedItem: " + pos.selectedItem + ", Position: " + pos.listPosition + ", Back url: " + pos.url);
        //Main.debug("[Main.js] - Main.history: " + JSON.stringify(Main.history, null, 4));
    }
};

/*
 ###############################
 #
 #       HOME / MAIN
 #
 ###############################
 */

Main.onLoadCategorie = function () {

    Main.debug("[Main.js] - ################# Starting Main page #################");
    Main.error = 0;
    Main.insertTextPlayer();
    Main.insertTextIndex();
    if (Data.category[Main.selectedCat]) {
        Main.server = new Server(Data.category[Main.selectedCat].machineIdentifier);
    } else {
        Main.server = new Server();
    }

    if ($('#leftAll').offset().left <= 0) {
        $('#leftAll').stop(true, true).animate({ 'left': 0 }, 300, function () {
        });
    }

    Categorie.dataReceivedCallback = function () {
        if (Main.selectedCat > Data.category.length - 1)
            Main.selectedCat = 0;

        Main.debug("[Main.js] - Categorie new Position: [" + Main.selectedCat + "]");

        Display.setCategorieList();
        window.setTimeout(Main.hideSplashScreen, 1000);
        buttonCategorie.updateCurrentCat();

        if (Display.audioPlayerVisible === 1) {
            Display.showAudioPlayer();
        }
    };

    //Main.debug("[Main.js] - servercount: " + prefs.servers.length);

    if (Data.category.length > 10 && Main.startup === false) {
        Categorie.dataReceivedCallback();
    } else if (prefs.servers.length > 0) {
        Categorie.loadAllCategories();
    } else { // first start of app
        Categorie.loadAllCategories();
        Main.error = Main.FIRSTSTART;
    }

    // Enable key event processing
    buttonCategorie.enableKeys();
    //start initial timeout for screensaver
    Main.enableScreenSaver();
};

/*
 ###############################
 #
 #       CATSECTION
 #
 ###############################
 */

Main.onLoadCatSection = function () {
    Main.debug("[Main.js] - ################# Starting Category Section #################");
    Main.insertTextListview();

    Main.debug("[Main.js] - LOADING [Main.onLoadCatSection]");
    loadbar.show();

    Main.view = Main.SECTIONS;

    Content.cat = Main.nextPageUrl;
    Content.section = null;

    //Main.debug("[Main.js] - Section Cat Number: [" + Content.cat + "]");
    //Main.debug("[Main.js] - Section section: [" + Content.section + "]");

    $("#selectedContentText").text(text.loading + ", " + text.wait);

    Data.clearContent();
    Content.id = Main.SECTIONS + Main.mediaContent;
    Content.callback = "Display.setCategorieSectionList";

    if (Main.mediaContent === Main.MOVIE) {
        Main.selectedContent = Number(prefs.categorie.selectedMovie || "0");
    }

    if (Main.mediaContent === Main.MOVIE ||
        Main.mediaContent === Main.EPISODE ||
        Main.mediaContent === Main.SHOW ||
        Main.mediaContent === Main.SEASON ||
        Main.mediaContent === Main.ARTIST ||
        Main.mediaContent === Main.PHOTO) {
        Content.fetchContentList(Content.cat, Content.section, 0, 20, "noUpdate");
    }
    else {
        Content.fetchContentList(Content.cat, Content.section, null, null, "noUpdate");
    }

    buttonCatSection.enableKeys(); // Enable key event processing
};

/*
 ###############################
 #
 #       MOVIE
 #
 ###############################
 */

Main.onLoadMovie = function () {
    Main.debug("[Main.js] - ################# Starting Movie View #################");

    Main.insertTextMovie();
    Main.insertTextPlayer();

    Main.resetAlphabet();

    Main.debug("[Main.js] - LOADING [Main.onLoadMovie]");
    loadbar.show();

    Main.view = Main.MOVIE;

    Content.cat = Main.nextPageUrl;
    Content.section = null;

    Main.debug("[Main.js] - Movie Cat Number: [" + Content.cat + "]");
    Main.debug("[Main.js] - Movie section: [" + Content.section + "]");

    Main.selectedContent = Number(prefs.categorie.selectedMovie || "0");

    Data.clearContent();
    Content.callback = "Display.setContentList";
    Content.id = "onLoadMovie";
    Content.fetchContentList(Content.cat, Content.section, 0, 1, "noUpdate");

    // Enable key event processing
    buttonMovie.enableKeys();
};

/*
 ###############################
 #
 #       SHOW
 #
 ###############################
 */

Main.onLoadShow = function () {
    Main.debug("[Main.js] - ################# Starting Show View #################");

    Main.insertTextShow();
    Main.resetAlphabet();

    Main.debug("[Main.js] - LOADING [Main.onLoadShow]");
    loadbar.show();

    Main.view = Main.SHOW;

    Content.cat = Main.nextPageUrl;
    Content.section = null;

    Main.debug("[Main.js] - Show Cat Number: [" + Content.cat + "]");
    Main.debug("[Main.js] - Show section: [" + Content.section + "]");

    Main.selectedContent = Number(prefs.categorie.selectedShow || "0");

    Data.clearContent();
    Content.callback = "Display.setContentList";
    Content.id = "onLoadShow";
    Content.fetchContentList(Content.cat, Content.section, 0, 1, "noUpdate");

    // Enable key event processing
    buttonShow.enableKeys();
};

/*
 ###############################
 #
 #       SEASON
 #
 ###############################
 */

Main.onLoadSeason = function () {
    Main.debug("[Main.js] - ################# Starting Season View #################");

    Main.insertTextSeason();
    Main.view = Main.SEASON;

    Content.cat = Main.nextPageUrl;
    Content.section = null;

    Main.debug("[Main.js] - Season Cat Number: [" + Content.cat + "]");

    Data.clearContent();
    Content.callback = "Display.setSeasonList";
    Content.id = "onLoadSeason";
    Content.fetchContentList(Content.cat, Content.section, null, null, "noUpdate");

    //Enable key event processing
    buttonSeason.enableKeys();
};

/*
 ###############################
 #
 #       EPISODE
 #
 ###############################
 */

Main.onLoadEpisode = function () {
    Main.debug("[Main.js] - ################# Starting Episode View #################");

    Main.insertTextEpisode();
    Main.insertTextPlayer();

    Main.view = Main.EPISODE;

    Content.cat = Main.nextPageUrl;
    Content.section = null;

    Data.clearContent();
    Content.callback = "Display.setEpisodeList";
    Content.id = "onLoadEpisode";
    Content.fetchContentList(Content.cat, Content.section, null, null, "noUpdate");

    // Enable key event processing
    buttonEpisode.enableKeys();
};

/*
 ###############################
 #
 #       PREFERENCES
 #
 ###############################
 */

Main.onLoadSetting = function () {
    Main.debug("[Main.js] - ################# Starting Preferences View #################");
    Main.insertTextPreferences();
    Main.view = Main.SETTINGS;
    buttonSetting.selectedSetting = 0;
    buttonSetting.selectedSettingTop = 212;

    buttonSetting.updateGS();
    buttonSetting.updatePLA();
    buttonSetting.updateSUBS();
    buttonSetting.updateSYSTEM();
    buttonSetting.updateADV();
    buttonSetting.updateABOUT();

    setTimeout(function () {
        $('#leftAll').stop(true, true).animate({ 'left': 0 }, 300, function () {
            $('#settingCatBg').stop(true, true).animate({ 'left': 34 }, 400, function () {
                buttonSetting.updatePMS();
            });
        });
    }, 400);

    // Enable key event processing
    buttonSetting.enableKeys();
    keyLock.status = keyLock.NONE;
};

/*
 ###############################
 #
 #       MyPlex
 #
 ###############################
 */

Main.myPlexLogin = function () {
    //if (((prefs.myplex.autoLogin || "off") === "on") && ((prefs.myplex.authToken || "") !== "")) {
    if (MyPlex.loggedIn) {
        Main.handleLogin("TRUE");
    }
    else {
        Main.handleLogin("FALSE");
    }
};

Main.handleLogin = function (result) {
    //Main.debug("[Main.js] - MyPlex login result: " + result);
    if (result === "TRUE") {
        widgetAPI.putInnerHTML(document.getElementById("bottomLoginText"), prefs.myplex.username || "");
        widgetAPI.putInnerHTML(document.getElementById("bottomLoginImg"), "<img src='Images/navi/login.png'/>");
    }
    else {
        widgetAPI.putInnerHTML(document.getElementById("bottomLoginText"), "");
        widgetAPI.putInnerHTML(document.getElementById("bottomLoginImg"), "");
    }
};

/*
 ###############################
 #
 #  SET WATCHED / DELETE / STREAM
 #
 ###############################
 */

Main.setWatched = function (id, watched, identifier, server, callback) {
    // try {
    var url = "";
    var prefix = "";

    if (isEmpty(id)) {
        callback();
    }

    if (isEmpty(identifier)) {
        identifier = Data.contentIdentifier;
    }

    var params = {
        'key': id,
        'identifier': identifier
    };

    if (Main.mediaContent === Main.QUEUE || Main.mediaContent === Main.RECOMMENDED) {
        prefix = "https://plex.tv/pms";
    }

    if (watched === Main.WATCHED) {
        url = server.resolveUrl(prefix + "/:/scrobble?" + $.param(params), false, true);
        Main.debug("[Main.js] - Setting item " + id + " as watched: " + url);
    }
    else if (watched === Main.UNWATCHED) {
        url = server.resolveUrl(prefix + "/:/unscrobble?" + $.param(params), false, true);
        Main.debug("[Main.js] - Setting item " + id + " as unwatched");
    }

    AjaxManager.getHTTP(url, callback, null, 3000, id, null);
    //  } catch (e) {
    //      callback();
    // }
};

Main.setProgress = function (key, ratingKey, time, duration, identifier, server, state, callback) {
    try {

        if (time > duration) { //we are streaming content, no update needed
            callback();
            return false;
        }

        var prefix = "";

        if (isEmpty(identifier)) {
            identifier = Data.contentIdentifier;
        }
        var params = {
            'containerKey': key,
            'key': key,
            'ratingKey': ratingKey,
            'time': time,
            'duration': duration,
            'state': state,
            'identifier': identifier
        };

        if (Main.mediaContent === Main.QUEUE || Main.mediaContent === Main.RECOMMENDED) {
            prefix = "https://plex.tv/pms";
        }

        $.extend(params, server.getHeaders());

        var url = server.resolveUrl(prefix + "/:/timeline?" + $.param(params), false, true);

        Main.debug("[Main.js] - Setting progress for item " + ratingKey + " to: " + time);

        AjaxManager.getHTTP(url, function (tree, xhrObj, id) {
            if (!isEmpty(xhrObj)) {
                if ((xhrObj.status !== 200) && (xhrObj.status !== 401)) {
                    Main.debug("[Main.js] - Set Progress Error [" + xhrObj.status + "]", 1);
                }
            }
            if (callback) {
                callback();
            }
        }, null, 0, "setProgress");
    } catch (e) {
        callback();
    }
};

Main.deleteContentFile = function (id, callback) {
    var url;
    var params;

    Main.deleteAllowed = 0; //reset the value

    if (Main.mediaContent === Main.QUEUE) {
        url = Main.server.resolveUrl("https://plex.tv/pms/playlists/queue/items/" + encodeURIComponent(id), false, true);
        params = $.param({ "key": encodeURIComponent(id), "identifier": "com.plexapp.plugins.library" });
        AjaxManager.deleteHTTP(url, callback, params, 0, id);
        Main.deleteAllowed = 0;
        return true;
    }

    if (Main.mediaContent === Main.RECOMMENDED) {
        url = Main.server.resolveUrl("https://plex.tv/pms/playlists/recommendations/items/" + encodeURIComponent(id), false, true);
        params = $.param({ "key": encodeURIComponent(id), "identifier": "com.plexapp.plugins.library" });
        AjaxManager.deleteHTTP(url, callback, params, 0, id);
        Main.deleteAllowed = 0;
        return true;
    }

    url = Main.server.resolveUrl("/library/metadata/" + encodeURIComponent(id), false, true);
    params = $.param({ "key": encodeURIComponent(id), "identifier": "com.plexapp.plugins.library" });
    AjaxManager.deleteHTTP(url, callback, params, 0, id);
    return true;

};

Main.updatePMSValue = function (part, parameter, value) {
    //Main.debug("[Main.js] - updatePMSValue:" + parameter + ":" + id);
    var url = Main.server.resolveUrl("/library/parts/" + part + "?" + parameter + "=" + value, false, true);

    AjaxManager.postHTTP(url, function (tree, xhr, id) {
        if (xhr) {
            if (xhr.status !== 200) {
                Main.debug("[Main.js] - Failed to send " + parameter + " update to PMS!");
            } else {
                if (id === "") {
                    Main.debug("[Main.js] - PMS default " + parameter + " for part: " + part + ", is now: None");
                } else {
                    Main.debug("[Main.js] - PMS default " + parameter + " for part: " + part + ", is now: " + id);
                }
            }
        } else {
            Main.debug("[Main.js] - Failed to send update for part: " + part + " to: " + parameter + " to PMS!");
        }
    }, null, 0, value);
};

Main.checkDeleteItemAllowed = function (id) {

    widgetAPI.putInnerHTML(document.getElementById("bottomEnterText"), text.categoryBottomEnterCat);

    if (Main.mediaContent === Main.PLUGIN) { //channels have no deleteable items
        Main.deleteAllowed = 0;
        return false;
    }

    if (!isEmpty(Data.contentServerLocal[id])) {
        if (Data.contentServerLocal[id] === 0) { // only delete on local servers
            Main.deleteAllowed = 0;
            return false;
        }
    } else {
        Main.deleteAllowed = 0;
        return false;
    }

    if (!isEmpty(Data.contentServerOwned[id])) {
        if (Data.contentServerOwned[id] === 0) { // this is not our server
            Main.deleteAllowed = 0;
            return false;
        }
    } else {
        Main.deleteAllowed = 0;
        return false;
    }

    if (!Main.server.owned) {// this is not our server
        if (!(Main.mediaContent === Main.QUEUE || Main.mediaContent === Main.RECOMMENDED)) {
            Main.deleteAllowed = 0;
            return false;
        }
    }

    if (!isEmpty(Data.contentKeys[id])) {
        if ((Data.contentKeys[id].contains("/folder?")) || (Data.contentKeys[id].contains("/children"))) { //we don't allow deleting folders
            Main.deleteAllowed = 0;
            return false;
        }
    }

    if (!isEmpty(Data.contentTypes[id])) {
        switch (Data.contentTypes[id]) {
            //only the correct content type can be deleted
            case "track":
            case "episode":
            case "movie":
            case "clip":
            case "photo":
                widgetAPI.putInnerHTML(document.getElementById("bottomEnterText"), text.categoryBottomPlaySel);
                Main.deleteAllowed = 1;
                return true;
            default:
                Main.deleteAllowed = 0;
                return false;
        }
    } else {
        Main.deleteAllowed = 0;
        return false;
    }
};

/*
 ###############################
 #
 #       UNLOAD
 #
 ###############################
 */

window.onbeforeunload = function () {
    Main.onUnload();
};

/*
 ###############################
 #
 #       SLIDE OSD
 #
 ###############################
 */

Main.slideOSD = function (move) {
    var where = 0;
    if (move === "up") {

        if (Main.rightOSD === 1 && Player.state === Player.PAUSED && Main.selectedRightOSD >= 3 && Main.selectedRightOSD <= 6) {
            //skip
        }
        else {
            if (Main.rightOSD === 1)
                Main.slideRightOSD("right");
            where = 392;
            Main.osd = 1;
            document.getElementById("osd").style.display = "block";
        }
    }
    else if (move === "down") {
        where = 541;
        Main.osd = 0;
    }

    var slidetime = 500;
    if (getProductType() !== "TV")
        slidetime = 50; //kill the animation effect on the slower devices, don't set to zero!

    $('#osd').stop(true, true).animate({ 'top': where }, slidetime, function () {
        if (Main.osd === 0) {
            document.getElementById("osd").style.display = "none";
        }
    });
};

/*
 ###############################
 #
 #       RIGHT OSD
 #
 ###############################
 */

Main.setSubtitlePrefs = function () {

    // SUBTITLE SIZE

    Player.subSize = parseInt((prefs.subtitles.size || "22"), 10);
    document.getElementById("srtSubtitle").style.fontSize = Player.subSize + "px";
    insertText("rightOSDSubtitleSizeData", Player.subSize + "px");

    // SUBTITLE COLOR

    Player.subColor = (prefs.subtitles.color || "white");
    document.getElementById("srtSubtitle").style.color = Player.subColor;

    if (Player.subColor !== "white") {
        for (var i = 0; i < 7; i++) {
            if (Player.subColorArray[i] === Player.subColor)
                Player.selectedSubColor = i;
        }
    }
    $("#rightOSDSubtitleColorData").css("background-color", Player.subColor);

    // SUBTITLE POS

    Player.subPos = parseInt((prefs.subtitles.position || "450"), 10);
    $("#srtSubtitle").css('top', Player.subPos);
    $("#srtSubtitle").css("height", (540 - Player.subPos)); // setting the correct height so we have no problems when pushing ARROW DOWN

    // SUBTITLE OFFSET

    Player.subOffset = Number(prefs.subtitles.offset || "0");

    if (Player.subOffset === 0) {
        insertText("rightOSDSubtitleOffsetData", Player.subOffset + "ms");
    }
    if (Player.subOffset > 0) {
        insertText("rightOSDSubtitleOffsetData", text.rightOSDSubAhead + " " + Player.subOffset + "ms");
    }
    else if (Player.subOffset < 0) {
        var resultO = Player.subOffset + ""; // convert to string
        resultO = resultO.replace(/-/g, "");
        insertText("rightOSDSubtitleOffsetData", text.rightOSDSubDelayed + " " + resultO + "ms");
    }
    Subtitle.subSyncOffset = (Player.subOffset / 1000);

    Main.resetRightOSD();
    //Main.rightOSDResetArrow();

    Main.debug("[Main.js] - Player Subtitles set Offset to: [" + Player.subOffset + "ms] - Font Size to: [" + Player.subSize + "] - Color to: [" + Player.subColor + "] - Position to: [" + Player.subPos + "]");
};

Main.slideRightOSD = function (move) {
    var where = 0;
    if (move === "left") {
        $("#playerStatus").hide();
        if (Main.osd === 1)
            Main.slideOSD("down");
        where = 600;
        Main.rightOSD = 1;
        document.getElementById("rightOSD").style.display = "block";
    }
    else if (move === "right") {
        where = 961;
        Main.rightOSD = 0;
        if ($("#srtSubtitle").text() === "<br><br>" + text.rightOSDSubtitleTest)
            insertText("srtSubtitle", "");
    }

    var slidetime = 250;
    if (getProductType() !== "TV")
        slidetime = 50; //kill the fading effect on the slower devices, don't set to zero!

    $('#rightOSD').stop(true, true).animate({ 'left': where }, slidetime, function () {
        if (Main.rightOSD === 0) {
            document.getElementById("rightOSD").style.display = "none";
        }
    });

    if (move === "left") {
        Main.rightOSDChanged = 0; //reset changes
    } else if (move === "right") {
        if (Main.rightOSDChanged === 1) {
            //Main.showInfo(text.rightOSDAudioRestart, "info");
            Main.debug("[Main.js] - Restarting Transcode session");
            Player.restartTranscodePlayback();
        }
    }
};

Main.selectNextRightOSD = function () {
    Main.lock = 1;
    $("#rightOSDTable").find("tr:nth-child(" + (this.selectedRightOSD + 1) + ")").children().css("color", "grey");
    Main.rightOSDResetArrow();

    this.selectedRightOSD += 1;
    if (this.selectedRightOSD >= $("#rightOSDTable").find("tr").length) {
        this.selectedRightOSD = 0;
        this.selectedRightOSDTop = 95;
    }
    else
        this.selectedRightOSDTop = this.selectedRightOSDTop + 37;

    if (!Subtitle.canBeDisplayed(Subtitle.subtitleIndex)) { //skip disabled items
        if (this.selectedRightOSD === 2) {
            this.selectedRightOSD = 2;
            this.selectedRightOSDTop = 95 + (2 * 37);
        } else if (this.selectedRightOSD === 2 || this.selectedRightOSD === 3) {
            this.selectedRightOSD = 8;
            this.selectedRightOSDTop = 95 + (8 * 37);
        }
    }

    Main.slideSelectedRightOSD(this.selectedRightOSDTop);
    Main.debug("[Main.js] - selected RightOSD: [" + this.selectedRightOSD + "]");
};

Main.selectPrevRightOSD = function () {
    Main.lock = 1;
    $("#rightOSDTable").find("tr:nth-child(" + (this.selectedRightOSD + 1) + ")").children().css("color", "grey");
    Main.rightOSDResetArrow();

    this.selectedRightOSD -= 1;
    if (this.selectedRightOSD < 0) {
        this.selectedRightOSD = $("#rightOSDTable").find("tr").length - 1;
        this.selectedRightOSDTop = 95 + (($("#rightOSDTable").find("tr").length - 1) * 37);
    } else {
        this.selectedRightOSDTop = this.selectedRightOSDTop - 37;
    }

    if (!Subtitle.canBeDisplayed(Subtitle.subtitleIndex)) {
        if (this.selectedRightOSD === 7) {
            this.selectedRightOSD = 2;
            this.selectedRightOSDTop = 95 + (2 * 37);
        } else if (this.selectedRightOSD === 7) {
            this.selectedRightOSD = 1;
            this.selectedRightOSDTop = 95 + (37);
        }
    }

    Main.slideSelectedRightOSD(this.selectedRightOSDTop);
    Main.debug("[Main.js] - selected RightOSD: [" + this.selectedRightOSD + "]");
};

Main.selectNextRightOSDArrow = function (direction) {
    Main.debug("[Main.js] - selectNextRightOSDArrow: [" + this.selectedRightOSDArrow + "]");
    if (this.selectedRightOSD === 0 || this.selectedRightOSD === 1) {
        Main.handleRightOSD(direction);
    } else if (this.selectedRightOSD >= 3 && this.selectedRightOSD <= 6) {
        if (this.selectedRightOSDArrow === Main.DOWN) {
            insertText("rightOSDTableRightTD" + this.selectedRightOSD + this.selectedRightOSDArrow, "<img src='Images/osd/osdArrowDownFO.png' />");
            this.selectedRightOSDArrow = Main.UP;
            insertText("rightOSDTableRightTD" + this.selectedRightOSD + this.selectedRightOSDArrow, "<img src='Images/osd/osdArrowUpUF.png' />");
        }
        else if (this.selectedRightOSDArrow === Main.UP) {
            insertText("rightOSDTableRightTD" + this.selectedRightOSD + this.selectedRightOSDArrow, "<img src='Images/osd/osdArrowUpFO.png' />");
            this.selectedRightOSDArrow = Main.DOWN;
            insertText("rightOSDTableRightTD" + this.selectedRightOSD + this.selectedRightOSDArrow, "<img src='Images/osd/osdArrowDownUF.png' />");
        }
    }
};

Main.slideSelectedRightOSD = function (where) {
    //disable animation on large jumps
    var top = $("#selectedRightOSD").offset().top;
    var t = 150;
    if (Math.abs(top - where) > 37) {
        t = 1;
    }

    $("#selectedRightOSD").stop(true, true).animate({ 'top': where }, t, function () {
        $("#rightOSDTable").find("tr:nth-child(" + (Main.selectedRightOSD + 1) + ")").children().css("color", "white");
        Main.lock = 0;
        Main.rightOSDUpdateArrow();
    });
};

Main.rightOSDUpdateArrow = function () {
    if (this.selectedRightOSD >= 3 && this.selectedRightOSD <= 6) {
        $("#rightOSDBottomLR").show();
        insertText("rightOSDTableRightTD" + this.selectedRightOSD + "0", "<img src='Images/osd/osdArrowUpFO.png' />");
    }
    else
        $("#rightOSDBottomLR").hide();

    if (this.selectedRightOSD === 8) {
        $("#rightOSDBottom09").show();
        if ($("#rightOSDJumpToData").text() !== "00h 00min 00sec")
            insertText("rightOSDBottomReturnText", text.rightOSDBottomReset);
    }
    else
        $("#rightOSDBottom09").hide();
};

Main.rightOSDResetArrow = function () {
    if (this.selectedRightOSD >= 3 && this.selectedRightOSD <= 6) {
        insertText("rightOSDTableRightTD" + this.selectedRightOSD + "0", "<img src='Images/osd/osdArrowUpUF.png' />");
        insertText("rightOSDTableRightTD" + this.selectedRightOSD + "1", "<img src='Images/osd/osdArrowDownUF.png' />");
        this.selectedRightOSDArrow = Main.DOWN;
    }
    if (this.selectedRightOSD >= 4 && this.selectedRightOSD <= 6) {
        if ($("#srtSubtitle").text() === "<br><br>" + text.rightOSDSubtitleTest)
            insertText("srtSubtitle", "");
    }
    else if (this.selectedRightOSD === 8) {
        if (Player.jumpTo() > Player.totalTime || Player.jumpTo() >= Player.wrongTotalTime && Player.wrongTotalTime !== 0) {
            Player.jumpToStr = "";
            insertText("rightOSDJumpToData", "00h 00min 00sec");
            insertText("rightOSDBottomReturnText", text.hide);
        }
        else
            insertText("rightOSDBottomReturnText", text.hide);
    }
};

Main.resetRightOSD = function () {
    this.selectedRightOSD = 0;
    this.selectedRightOSDTop = 95;
    $("#selectedRightOSD").css("top", 95);
    Player.jumpToStr = "";
    insertText("rightOSDJumpToData", "00h 00min 00sec");
    $("#rightOSDBottom09").hide();
    insertText("rightOSDBottomReturnText", text.hide);
    Subtitle.refreshRightOSD();
    for (var i = 0; i < $("#rightOSDTable").find("tr").length; i++) {
        $("#rightOSDTable").find("tr:nth-child(" + (i + 1) + ") td").css("color", "grey");

        if (i >= 3 || i <= 6) {
            insertText("rightOSDTableRightTD" + i + "0", "<img src='Images/osd/osdArrowUpUF.png' />");
            insertText("rightOSDTableRightTD" + i + "1", "<img src='Images/osd/osdArrowDownUF.png' />");
        }
    }
    $("#rightOSDBottomLR").hide();
};

Main.handleRightOSD = function (direction) {
    if (this.selectedRightOSD === 0) // Audio
    {
        if (Metadata.getAudioCount() > 1) {
            if (Player.plugin.sef === true && Player.transcoding === 0) {
                var oldSelectAudio = Audio.audioIndex;

                if (direction === Main.LEFT) {
                    Audio.audioIndex--;
                    if (Audio.audioIndex < 0) {
                        Audio.audioIndex = Metadata.getAudioCount() - 1;
                    }
                } else {
                    Audio.audioIndex++;
                    if (Audio.audioIndex > Metadata.getAudioCount() - 1) {
                        Audio.audioIndex = 0;
                    }
                }

                var result = Player.plugin.SetStreamID(1, Audio.audioIndex); // change the Audio

                if (result === 1) {
                    Metadata.setSelectedAudio(Audio.audioIndex); // send the selected Audio to PMS
                    Audio.setAudioOutput(AudioStreams[Audio.audioIndex].codec); // change the output to receiver
                    insertText("rightOSDAudioStreamData", (Audio.audioIndex + 1) + "/" + Metadata.getAudioCount() + " " + Metadata.getAudioLanguage(Audio.audioIndex) + " - " + Metadata.getAudioCodec(Audio.audioIndex) + " " + Metadata.getAudioChannels(Audio.audioIndex));
                } else {
                    Audio.audioIndex = oldSelectAudio;
                    Main.debug("[Main.js] - Change audio didn't work - result [" + result + "]");
                }

            } else if (Player.transcoding === 1) {

                if (direction === Main.LEFT) {
                    Audio.audioIndex--;
                    if (Audio.audioIndex < 0) {
                        Audio.audioIndex = Metadata.getAudioCount() - 1;
                    }
                } else {
                    Audio.audioIndex++;
                    if (Audio.audioIndex > Metadata.getAudioCount() - 1) {
                        Audio.audioIndex = 0;
                    }
                }

                Metadata.setSelectedAudio(Audio.audioIndex); // send the selected Audio to PMS
                insertText("rightOSDAudioStreamData", (Audio.audioIndex + 1) + "/" + Metadata.getAudioCount() + " " + Metadata.getAudioLanguage(Audio.audioIndex) + " - " + Metadata.getAudioCodec(Audio.audioIndex) + " " + Metadata.getAudioChannels(Audio.audioIndex));

                Main.rightOSDChanged = 1;

            } else {
                Main.showInfo(text.errorUnsupported, "info");
                Main.debug("[Main.js] - Can't change audio because this function is not supported on 2010 devices");
            }
        } else
            Main.debug("[Main.js] - Can't change audio because the file has only one");
    } else if (this.selectedRightOSD === 1) { // Subtitle change

        if (Metadata.getSubtitleCount() > 1) {

            if (direction === Main.LEFT) {
                Subtitle.subtitleIndex--;
                if (Subtitle.subtitleIndex < 0) {
                    Subtitle.subtitleIndex = Metadata.getSubtitleCount() - 1;
                }
            } else {
                Subtitle.subtitleIndex++;
                if (Subtitle.subtitleIndex > (Metadata.getSubtitleCount() - 1)) {
                    Subtitle.subtitleIndex = 0;
                }
            }

            Subtitle.enabled = Subtitle.checkEnable(Subtitle.subtitleIndex, true);

            try {
                keyLock.status = keyLock.BLOCKALL;
                Metadata.setSelectedSubtitle(Subtitle.subtitleIndex); //will also call Subtitle.init
                keyLock.status = keyLock.NONE;
            } catch (e) {
                keyLock.status = keyLock.NONE;
            }

            if (Main.getPlaybackMode() > 2 && (prefs.subtitles.preferOverlay || "") == "off") {
                Main.rightOSDChanged = 1;
            }


        } else {
            Main.debug("[Main.js] - Can't change subs because the file has less then 2 or subs are disabled");
        }
    } else if (this.selectedRightOSD === 2) {// Subtitle Enable

        Main.debug("[Main.js] - Toggle Subtitle enabled");
        Subtitle.toggleEnabled();
    } else if (this.selectedRightOSD === 3) {// Subtitle Offset

        if (!Player.subOffset) {
            Player.subOffset = Number(prefs.subtitles.offset || 0);
        }

        if (this.selectedRightOSDArrow === Main.UP) {
            Player.subOffset += 100;
            if (Player.subOffset > 10000)
                Player.subOffset = 10000;
        } else if (this.selectedRightOSDArrow === Main.DOWN) {
            Player.subOffset -= 100;
            if (Player.subOffset < -10000)
                Player.subOffset = -10000;
        }

        if (Player.subOffset === 0) {
            insertText("rightOSDSubtitleOffsetData", Player.subOffset + "ms");
        }
        if (Player.subOffset > 0) {
            insertText("rightOSDSubtitleOffsetData", text.rightOSDSubAhead + " " + Player.subOffset + "ms");
        } else if (Player.subOffset < 0) {
            var resultO = Player.subOffset + "";
            resultO = resultO.replace(/-/g, "");
            insertText("rightOSDSubtitleOffsetData", text.rightOSDSubDelayed + " " + resultO + "ms");
        }

        Subtitle.subSyncOffset = (Player.subOffset / 1000);
    } else if (this.selectedRightOSD === 4) {// subtitle size

        if (!$("#srtSubtitle").text())
            insertText("srtSubtitle", "<br><br>" + text.rightOSDSubtitleTest);

        var size = parseInt(Player.subSize, 10);
        var offsetPos = 0;

        if (size > 15 && size < 51) {
            if (this.selectedRightOSDArrow === Main.UP) {
                size--; // lower value
                offsetPos = -3.14;
            } else if (this.selectedRightOSDArrow === Main.DOWN) {
                size++; // higher value
                offsetPos = 2.74;
            }
            if (size >= 51)
                size = 50;
            if (size <= 15)
                size = 16;
            $("#srtSubtitle").css("font-size", size); // write value to CSS
            Player.subSize = parseInt($("#srtSubtitle").css("font-size"), 10);
            Main.debug("[Main.js] - Player Subtitles set Font Size to: [" + size + "]");
            insertText("rightOSDSubtitleSizeData", $("#srtSubtitle").css("font-size"));

            if (size > 16 && size < 50) {
                // check the position
                var positionC = Player.subPos;
                var newPos = positionC - offsetPos;
                $("#srtSubtitle").css("top", newPos); // write value to CSS
                Player.subPos = parseInt($("#srtSubtitle").css("top"), 10);
                $("#srtSubtitle").css("height", (540 - newPos));
                Main.debug("[Main.js] - Player Subtitles set Position to: [" + newPos + "]");
            }
        } else
            Main.debug("[Main.js] - Player Subtitles Font Size must be higher than 15 and musn't be higher than 50");
    } else if (this.selectedRightOSD === 5) {// subtitle color

        if (!$("#srtSubtitle").text())
            insertText("srtSubtitle", "<br><br>" + text.rightOSDSubtitleTest);
        if (this.selectedRightOSDArrow === Main.UP) {
            Player.selectedSubColor--;
            if (Player.selectedSubColor < 0)
                Player.selectedSubColor = 6;
        } else if (this.selectedRightOSDArrow === Main.DOWN) {
            Player.selectedSubColor++;
            if (Player.selectedSubColor > 6)
                Player.selectedSubColor = 0;
        }

        var newColor = Player.subColorArray[Player.selectedSubColor];
        $("#rightOSDSubtitleColorData").css("background-color", newColor);
        Player.subColor = newColor;
        $("#srtSubtitle, #srtSubtitle i, #srtSubtitle b").css("color", Player.subColor);
        Main.debug("[Main.js] - Player Subtitles new Color: [" + Player.subColorArray[Player.selectedSubColor] + "] [" + Player.selectedSubColor + "]");
    } else if (this.selectedRightOSD === 6) {// subtitle position

        if (!$("#srtSubtitle").text())
            insertText("srtSubtitle", "<br><br>" + text.rightOSDSubtitleTest);

        var position = parseInt(Player.subPos, 10);
        var sizeN = parseInt(Player.subSize, 10);

        if (position > 0 && position < (540 - sizeN)) {

            if (this.selectedRightOSDArrow === Main.UP) {
                position += 2; // higher value because we want to move it down
            } else if (this.selectedRightOSDArrow === Main.DOWN) {
                position -= 2; // lower value because we want to move it up
            }
            if (position <= 0)
                position = 1;
            if (position >= (540 - sizeN))
                position = (540 - sizeN) - 1;

            $("#srtSubtitle").css("top", position); // write value to CSS
            Player.subPos = parseInt($("#srtSubtitle").css("top"), 10);

            Main.debug("[Main.js] - Player Subtitles set Position to: [" + position + "]");
            $("#srtSubtitle").css("height", (540 - position)); // setting the correct heigt so we have no problems when pushing ARROW DOWN
        } else if (position >= (540 - sizeN)) {

            if (position >= (540 - sizeN))
                position = (540 - sizeN) - 1;

            $("#srtSubtitle").css("top", position); // write value to CSS
            Player.subPos = parseInt($("#srtSubtitle").css("top"), 10);

            Main.debug("[Main.js] - Player Subtitles set Position to: [" + position + "]");
            insertText("rightOSDSubtitlePositionData", $('#srtSubtitle').css("top"));
            $("#srtSubtitle").css("height", (540 - position)); // setting the correct heigt so we have no problems when pushing ARROW DOWN
        }
    } else if (this.selectedRightOSD === 7) // save values as deafult
    {
        if (Metadata.getSubtitleCount() > 0) {
            try {

                var subsize = (Player.subSize || 22).toString();
                if (subsize.contains("px")) {
                    subsize = subsize.replace("px", "");
                }

                prefs.subtitles.offset = Player.subOffset || "0";
                prefs.subtitles.color = Player.subColorArray[Player.selectedSubColor] || "white";
                prefs.subtitles.size = subsize || "22";
                prefs.subtitles.position = Player.subPos || "450";
                Main.showInfo(text.rightOSDSaveDefaultDone, "info");
            } catch (err) {
                Main.showInfo(text.rightOSDSaveDefaultFail);
            }
        }
    } else if (this.selectedRightOSD === 8) // jumpTo
    {
        if ($("#rightOSDJumpToData").css("color") === "red") {
            Main.debug("[Main.js] - Player Jump To won't work because target time is further than total time");
        } else {
            var targetTimeInMS = Player.jumpTo();

            if (targetTimeInMS <= Player.curTime)
                Player.skipBackwardVideo((Player.curTime - targetTimeInMS) / 1000);
            else if (targetTimeInMS >= Player.curTime)
                Player.skipForwardVideo((targetTimeInMS - Player.curTime) / 1000);

            Player.jumpToStr = "";
            $("#rightOSDJumpToData").text("00h 00min 00sec");
        }
    } else if (this.selectedRightOSD === 9) // stretch video
    {
        if ((Player.state === Player.PLAYING || Player.state === Player.PAUSED)) {

            if (direction === Main.LEFT) {
                Player.aspectMode--;
                if (Player.aspectMode < Player.ASPECT_DEFAULT) {
                    Player.aspectMode = Player.ASPECT_STRETCH;
                }
            } else {
                Player.aspectMode++;
                if (Player.aspectMode > Player.ASPECT_STRETCH) {
                    Player.aspectMode = Player.ASPECT_DEFAULT;
                }
            }
            Player.setAspectRatio();
        }
    }
};

/*
 ###############################
 #
 #       ALPHABET CHOICE
 #
 ###############################
 */

Main.resetAlphabet = function () {
    $('#alphabet').text('A');
    Main.alphabet = 0;
    Main.alphabetChars = [];
    Main.alphabetSelected = 0;
};

Main.showAlphabet = function () {
    if (Main.view === Main.SECTIONS) {
        keyLock.status = keyLock.LEFTRIGHTLOCK;
    } else {
        keyLock.status = keyLock.CHOICELOCK;
    }

    if (Main.alphabetChars.length === 0) {
        var url = Main.server.resolveUrl("/library/sections/" + Main.categoryNumber + "/firstCharacter", false, true);
        Main.debug("[buttonMovie.js] - alphabet url: " + url);
        AjaxManager.parseHTTP(url, Main.loadAlphabet, null, 0, Content.id);
    }
    else {
        $('#alphabet').show();
        Main.alphabet = 1;
    }
};

Main.loadAlphabet = function (tree, xhrObj) {
    Main.alphabetChars = [];
    if (tree) {
        var abc = "";
        $.each(tree.MediaContainer.Directory, function () {
            abc = { "character": this["-title"], "key": this["-key"] };
            Main.alphabetChars.push(abc);
        });
        abc = { "character": "*", "key": "all" };
        Main.alphabetChars.push(abc);
        $('#alphabet').text(Main.alphabetChars[0].character);
        Main.alphabetSelected = 0;
        $('#alphabet').show();
        Main.alphabet = 1;
    }
};

Main.closeAlphabet = function () {
    $('#alphabet').hide();
    Content.cat = Main.categoryNumber;

    Main.debug("[Main.js] - alphabet key selected: " + Main.alphabetChars[Main.alphabetSelected].key);
    Main.debug("[Main.js] - Main.mediaContent: " + Main.mediaContent);
    Main.debug("[Main.js] - Main.view: " + Main.view);

    if (Main.alphabetChars[Main.alphabetSelected].key === "all") {
        Content.section = "all";
    } else {
        Content.section = "firstCharacter/" + Main.alphabetChars[Main.alphabetSelected].key;
    }

    Main.nextPageUrl = Content.cat + "/" + Content.section;

    switch (Main.view) {
        case Main.MOVIE:
            Main.loadPage("movie", "forward");
            break;
        case Main.EPISODE:
        case Main.SEASON:
        case Main.SHOW:
            Main.loadPage("show", "forward");
            break;
        case Main.SECTIONS:
            Main.loadPage("catSection", "forward");
            break;
        default:
            Main.debug("[Main.js] - Unhandled Main.view: " + Main.view);
    }

    setTimeout(function () {
        Main.alphabet = 0;
        keyLock.status = keyLock.NONE;
    }, 250);
};

Main.setAlphabet = function (direction) {
    var i;
    if (direction === "up") {
        i = Main.alphabetSelected + 1;
    }
    else {
        i = Main.alphabetSelected - 1;
    }

    Main.alphabetSelected = i.mod(Main.alphabetChars.length);

    $('#alphabet').text(Main.alphabetChars[Main.alphabetSelected].character);
    //Main.alphabetTimer = setTimeout(Main.closeAlphabet, 1000);
};

/*
 ###############################
 #
 #       GET SOMETHING
 #
 ###############################
 */

Main.getPhoto = function (url, imgWidth, imgHeight, section, format) {

    Main.debug("[Main.js] - getPhoto input: [" + url + "]");

    if (isEmpty(url)) {
        Main.debug("[Main.js] - No image url found, using default image for section: " + section);
        switch (section) {
            case "preferences":
                url = "Images/categorie/settings.png";
                break;
            case "quit":
                url = "Images/categorie/exit.png";
                break;
            case "movie":
                url = (imgWidth === Display.FSX) ? "Images/categorie/movie-fanart.png" : "Images/categorie/coverMovie.png";
                break;
            case "show":
            case "episode":
                url = (imgWidth === Display.FSX) ? "Images/categorie/show-fanart.png" : "Images/categorie/coverMovie.png";
                break;
            case "artist":
            case "track":
                url = (imgWidth === Display.FSX) ? "Images/categorie/artist-fanart.png" : "Images/categorie/artist.png";
                break;
            case "photo":
                url = "Images/categorie/photo-fanart.png";
                break;
            case "poster":
                url = "Images/categorie/coverMovie.png";
                break;
            case "posterBig":
                url = "Images/categorie/coverMovieBig.png";
                break;
            case "blank":
                url = "Images/blank.png";
                break;
            default:
                url = (imgWidth === Display.FSX) ? "Images/categorie/art-default.png" : "Images/categorie/plexlogo.png";
                break;
        }
    }

    if (url.startsWith("Images/")) {
        return url;
    }

    var srcUrl;
    var imgUrl;
    var transcoder;
    var fmt = (format) ? format : "";

    if (Main.server.transcodeImage()) {
        transcoder = Main.server;
        //Main.debug("[Main.js] - Main server " + transcoder.name + " can transcode Image: [" + transcoder.transcodeImage().toString() + "]");
    } else {
        var mach = Main.server.getTranscodeServer("image", true);
        if (mach) {
            transcoder = new Server(mach);
        } else {
            transcoder = Main.server;
        }
        //Main.debug("[Main.js] - Alternative server " + transcoder.name + " can transcode Image: [" + transcoder.transcodeImage().toString() + "]");
    }

    var part = ('/:/|/library/|/channels/|/music/|/video/|/photos/|/system/|/resources/');

    if (Main.server.name === "Cloud Sync") {
        imgUrl = Main.server.resolveUrl(url, false, true);
    } else if (url.match(part) !== null) {
        //Main.debug("[Main.js] - getPhoto MATCH url: " + url);
        imgUrl = transcoder.resolveUrl(url, true, false);
    } else {
        //Main.debug("[Main.js] - getPhoto NO MATCH");
        imgUrl = transcoder.resolveUrl(url, false, false);
    }

    imgUrl = Main.server.appendToken(imgUrl);

    if (!transcoder.transcodeImage()) {
        //Main.debug("[Main.js] - No Image transcoder available");
        return imgUrl;
    }


    //Main.debug("[Main.js] - getPhoto requested: [" + imgUrl + "] , server: " + Main.server.name);


    if (fmt !== "") {
        srcUrl = transcoder.resolveUrl("/photo/:/transcode?width=" + imgWidth + "&height=" + imgHeight + "&upscale=1&format=" + fmt + "&url=" + encodeURIComponent(imgUrl), false, true);
    } else {
        srcUrl = transcoder.resolveUrl("/photo/:/transcode?width=" + imgWidth + "&height=" + imgHeight + "&upscale=1&url=" + encodeURIComponent(imgUrl), false, true);
    }

    //Main.debug("[Main.js] - getPhoto transcoded output: [" + srcUrl + "]");
    return srcUrl;
};

Main.updateBackGroundArt = function (nextArtUrl, id) {

    var imgUrl = nextArtUrl;
    var type;

    if (isEmpty(nextArtUrl)) {
        if (!isEmpty(Data.contentArts[id])) {
            if (Main.mediaContent === Main.MOVIE) {
                type = "movie";
            } else if (Main.mediaContent === Main.EPISODE || Main.mediaContent === Main.SHOW) {
                type = "show";
            } else if (Main.mediaContent === Main.ARTIST) {
                type = "artist";
            } else if (Main.mediaContent === Main.PHOTO) {
                type = "photo";
            } else {
                type = (Data.contentTypes[id]) ? Data.contentTypes[id].type : "default";
            }

            imgUrl = Main.getPhoto(Data.contentArts[id], Display.FSX, Display.FSY, type);
        }
    }

    var $active = $('#background').find('img.active');
    var $below = ($active.next().length > 0) ? $active.next() : $('#background').find('img:first');

    //Main.debug("[buttonCategorie.js] - $active BG: " + $active.attr('src'));
    //Main.debug("[buttonCategorie.js] - $below BG: " + $below.attr('src'));
    //Main.debug("[buttonCategorie.js] - new BG: " + imgUrl);

    if (isEmpty(imgUrl) || imgUrl === $active.attr('src')) { //no switch is needed
        //Main.debug("[buttonCategorie.js] - skipping BG load");
    } else {
        $below.attr('src', imgUrl);// this will trigger the bgImage1onLoad or bgImage2onLoad event below
    }

};

Main.bgImage1onLoad = function () {
    //Main.debug("[Main.js] - loading background 1");
    var fadetime = 500;
    if (getProductType() !== "TV")
        fadetime = 50; //kill the fading effect on the slower devices

    var $bgImage1 = $('#bgImage1');
    var $bgImage2 = $('#bgImage2');

    if ($bgImage1.attr('src') !== 'Images/blank.png') {
        //Main.debug("[Main.js] - loading bgImage1: " + $bgImage1.attr('src'));
        $bgImage2.fadeOut(fadetime, function () { //fade out the top image
            $bgImage2.css({ 'z-index': 0 }).removeClass('active'); //reset the z-index and unhide the image
            $bgImage1.css({ 'z-index': 1 }).addClass('active'); //make the next image the top one
            $bgImage2.css({ 'display': 'block' });
            $bgImage2.attr('src', 'Images/blank.png');
        });
    }
};

Main.bgImage2onLoad = function () {
    //Main.debug("[Main.js] - loading background 2");
    var fadetime = 500;
    if (getProductType() !== "TV")
        fadetime = 50; //kill the fading effect on the slower devices

    var $bgImage1 = $('#bgImage1');
    var $bgImage2 = $('#bgImage2');

    if ($bgImage2.attr('src') !== 'Images/blank.png') {
        //Main.debug("[Main.js] - loading bgImage2: " + $bgImage2.attr('src'));
        $bgImage1.fadeOut(fadetime, function () { //fade out the top image
            $bgImage1.css({ 'z-index': 0 }).removeClass('active'); //reset the z-index and unhide the image
            $bgImage2.css({ 'z-index': 1 }).addClass('active'); //make the next image the top one
            $bgImage1.css({ 'display': 'block' });
            $bgImage1.attr('src', 'Images/blank.png');
        });
    }
};

Main.getTheme = function () {
    var result = (prefs.player.playTheme || "on");
    Main.debug("[Main.js] - Theme: [" + result + "]");
    return result;
};

Main.getPlaybackMode = function () {
    return Number(prefs.player.playbackmode || 0);
};

Main.newTranscoderEnabled = function () {
    var result = (prefs.player.universalTranscoder || "off");
    //Main.debug("[Main.js] - UniversalTranscoder: [" + result + "]");
    if (result == "off")
        return false;
    else
        return true;
};

Main.getTranscodingQuality = function (url) {
    var local = false;
    var result;
    var ip = url.between("://", ":");

    if (ip.isValidIPV4()) {
        local = isPrivate(ip);
    }

    if (local) {
        result = (prefs.player.localQuality || "12");
    } else {
        result = (prefs.player.remoteQuality || "7");
    }

    Main.debug("[Main.js] - Transcoding Quality: [" + result + "], Local: [" + local.toString() + "]");
    return result;
};

Main.getTimeOut = function () {
    return (prefs.general.timeout || "15");
};
/*
 ###############################
 #
 #       DEBUG
 #
 ###############################
 */

Main.debug = function (message, loglevel) {

    if (Application.devMode) {
        alert(Main.getTime("debug") + " - " + message);
    }
    /*
     log level:
     1 = WARNING
     2 = INFO
     3 = DEBUG
     */
    if (Main.debugging === "on") {
        message = message.replace(/#################/g, "---------------------------");

        //hide tokens from the log
        message = message.replaceQueryVariable("X-Plex-Token", "XXXXXXX");

        if (!loglevel)
            loglevel = 3;

        message = encodeURIComponent(message);

        var url = Main.server.resolveUrl("/log?level=" + loglevel + "&message=" + message + "&source=PlexforSamsung");

        $.ajax(
            {
                url: url,
                methode: "get"
            });
    }
};

Main.setDebugging = function () {
    if (prefs.general.debug === "off") { // of debug is OFF then create the file debugOn so its enabled
        Main.debugging = Main.ON;
        prefs.general.debug = "on";
    }
    else {
        Main.debugging = Main.OFF;
        prefs.general.debug = "off";
    }
};

/*
 ###############################
 #
 #       TIME / CLOCK
 #
 ###############################
 */

Main.setClock = function () {
    widgetAPI.putInnerHTML(document.getElementById("topTime"), "<span style='color:#FD9800;'>• </span>" + Main.getTime());
};

Main.getLocalTime = function () {
    var pluginTime = document.getElementById("pluginTime");
    var time = 0;
    var epochtime = 0;
    var dt = null;
    var offsetHrs = 0;
    var offsetMS = 0;

    if (pluginTime.GetEpochTime) {
        epochtime = pluginTime.GetEpochTime();
        time = epochtime * 1000;
    }
    else {
        time = new Date().getTime();
    }

    if (epochtime <= 0) {
        time = new Date().getTime();
    }

    if (prefs.general) {
        if ((prefs.general.clockoffset || 0) !== 0) {
            offsetHrs = parseInt(prefs.general.clockoffset, 10);
            offsetMS = offsetHrs * 3600000;
        }
    }

    if (pluginTime.ConvertEpochToLocalTime) {
        var t = pluginTime.ConvertEpochToLocalTime(epochtime);
        var x = t.split("/");
        dt = new Date(x[0], x[1] - 1, x[2], x[3], x[4], x[5]);
        dt = dt.add("h", offsetHrs);
    }
    else {
        time += new Date().getTimezoneOffset();
        dt = new Date(time + offsetMS);
    }

    if (!isFinite(dt)) {
        time += new Date().getTimezoneOffset();
        dt = new Date(time + offsetMS);
    }
    return dt;
};

Main.getTime = function (formattype) {
    var dt = Main.getLocalTime();
    var newTime = "";
    if (formattype === "debug") {
        if (Main.getTimeType() === "12")
            newTime = dt.format("NNN dd, yyyy hh:mm:ss a");
        else
            newTime = dt.format("NNN dd, yyyy HH:mm:ss");
    }
    else {
        if (Main.getTimeType() === "12")
            newTime = dt.format("hh:mm a");
        else
            newTime = dt.format("HH:mm");
    }

    return newTime;
};

Main.getTimeType = function () {
    if (prefs.general) {
        if (prefs.general.timeformat !== 'undefined') {
            return prefs.general.timeformat || "12";
        }
        else {
            return "12";
        }
    }
    else
        return "12";

};

Main.setTime = function () {
    if ((prefs.general.timeformat || "12") === "24") {
        prefs.general.timeformat = "12";
    }
    else {
        prefs.general.timeformat = "24";
    }
    Main.setClock();
};

Main.timeConvert = function (time) {

    if (isNaN(time)) {
        return "00:00:00";
    }

    var timeHour = Math.floor(time / 3600000);
    var timeMinute = Math.floor((time % 3600000) / 60000);
    var timeSecond = Math.floor((time % 60000) / 1000);
    var timeHTML = timeHour + ":";

    if (timeMinute === 0)
        timeHTML += "00:";
    else if (timeMinute < 10)
        timeHTML += "0" + timeMinute + ":";
    else
        timeHTML += timeMinute + ":";

    if (timeSecond === 0)
        timeHTML += "00";
    else if (timeSecond < 10)
        timeHTML += "0" + timeSecond;
    else
        timeHTML += timeSecond;

    return timeHTML;
};


/*
 ###############################
 #
 #       LANGUAGE
 #
 ###############################
 */

Main.getLanguage = function () {
    if (prefs.general)
        Main.language = prefs.general.language || "en";
    else
        Main.language = "en";
};

Main.setLanguage = function () {
    if (Main.view === Main.SETTINGS)
        prefs.general.language = Main.language || "en";

    $.ajax({
        url: 'language/' + Main.language + '.json',
        async: false,
        cache: true,
        success: function (data) {
            text = $.parseJSON(data);
        }
    });
};

/*
 ###############################
 #
 #       LOAD/SAVE PREFS
 #
 ###############################
 */

Main.loadPrefs = function () {
    var strPrefs = "";
    try {
        var fileSystemObj = new FileSystem();
        var bValid = fileSystemObj.isValidCommonPath(curWidget.id);
        if (!bValid) {
            Main.debug("[Main.js] - no folder");
            // no folder, create folder
            var result = fileSystemObj.createCommonDir(curWidget.id);
            Main.debug("[Main.js] - created folder: [" + result + "]");
        }

        var path = curWidget.id + '/prefs.json';
        var fileObj = fileSystemObj.openCommonFile(path, 'r');
        if (fileObj) {
            strPrefs = fileObj.readAll();
            fileSystemObj.closeCommonFile(fileObj);
            var jsPrefs = JSON.parse(strPrefs);
            $.extend(prefs, jsPrefs);
        }

        if (!prefs.general) {
            Main.debug("[Main.js] - Loading User Preferences failed: " + strPrefs);
        }
        else {
            Main.debug("[Main.js] - User Preferences loaded");
        }
    }
    catch (err) {
        Main.debug("[Main.js] - Loading User Preferences failed: " + strPrefs);
    }
};

Main.savePrefs = function () {
    if (prefs.general) //don't save if the object was destroyed somehow, by exiting the app unusual
    {
        var strPrefs = JSON.stringify(prefs, null, 4);
        Main.writeFile("prefs.json", strPrefs);
    }
};

Main.loadProfile = function () {
    try {
        $.get("profiles/Samsung.xml", {}, function (xml) {
            profile = ObjTree.parseXML(xml); //build the object from the xml
            Main.debug("[Main.js] - Profile loaded: " + (profile.Client["-name"] || ""));
            //        var strprofile = JSON.stringify(profile, null, 4);
            //        Main.writeFile("profile.json", strprofile);
        });
    } catch (e) {
        Main.debug("[Main.js] - Profile could not be loaded, error: " + e.message);
    }
};

/*
 ###############################
 #
 #       INSERT TEXT
 #
 ###############################
 */

Main.insertTextAll = function () {
    if (getProductType() === "BD-Player") {
        if ($("#bottomToolsText").length !== 0) {
            $("#bottomToolsText").hide();
            $("#bottomToolsPic").hide();
        }
        else if ($("#bottomToolsText2").length !== 0) {
            $("#bottomToolsText2").hide();
            $("#bottomToolsPic2").hide();
        }
    }
    if ($("#bottomReturnText").length !== 0)
        widgetAPI.putInnerHTML(document.getElementById("bottomReturnText"), text.back);
    if ($("#bottomToolsText").length !== 0)
        widgetAPI.putInnerHTML(document.getElementById("bottomToolsText"), text.tools);
    widgetAPI.putInnerHTML(document.getElementById("resumeBottom"), text.back); // popup for Tools, setwatched
    widgetAPI.putInnerHTML(document.getElementById("infoBottom"), text.back);  // popup for error messages
};

Main.insertTextListview = function () {
    widgetAPI.putInnerHTML(document.getElementById("bottomEnterText"), text.categoryBottomEnterCat);
    widgetAPI.putInnerHTML(document.getElementById("bottomAllDircText"), text.rightOSDBottomNavi);
};

Main.insertTextIndex = function () {
    widgetAPI.putInnerHTML(document.getElementById("singleBgContentFilter"), text.categoryRA);
    widgetAPI.putInnerHTML(document.getElementById("doubleBgODContentFilter"), text.categoryOD);
    widgetAPI.putInnerHTML(document.getElementById("doubleBgRAContentFilter"), text.categoryRA);
    widgetAPI.putInnerHTML(document.getElementById("bottomInfoText"), text.info);
    widgetAPI.putInnerHTML(document.getElementById("bottomEnterText"), text.categoryBottomEnterCat);
    widgetAPI.putInnerHTML(document.getElementById("bottomEnterPlayText"), text.categoryBottomPlaySel);
    widgetAPI.putInnerHTML(document.getElementById("bottomReturnText"), text.categoryBottomExitApp);
};

Main.insertTextMovie = function () {
    widgetAPI.putInnerHTML(document.getElementById("movieDirector"), text.movieDirector);
    widgetAPI.putInnerHTML(document.getElementById("movieWriter"), text.movieWriter);
    widgetAPI.putInnerHTML(document.getElementById("movieCast"), text.movieCast);
    widgetAPI.putInnerHTML(document.getElementById("bottomInfoText"), text.info);
    widgetAPI.putInnerHTML(document.getElementById("bottomMovieDeleteText"), text.buttonDelete);
    widgetAPI.putInnerHTML(document.getElementById("bottomAllDircText"), text.rightOSDBottomNavi);
};

Main.insertTextShow = function () {
    widgetAPI.putInnerHTML(document.getElementById("showAired"), text.showAired);
    widgetAPI.putInnerHTML(document.getElementById("showGenre"), text.showGenre);
    widgetAPI.putInnerHTML(document.getElementById("showDuration"), text.duration);
    widgetAPI.putInnerHTML(document.getElementById("showEpisodes"), text.showEpisodes);
    widgetAPI.putInnerHTML(document.getElementById("showWatched"), text.showWatched);
    widgetAPI.putInnerHTML(document.getElementById("showUnwatched"), text.showUnwatched);
    widgetAPI.putInnerHTML(document.getElementById("bottomInfoText"), text.info);
    widgetAPI.putInnerHTML(document.getElementById("bottomAllDircText"), text.rightOSDBottomNavi);
};

Main.insertTextSeason = function () {
    widgetAPI.putInnerHTML(document.getElementById("bottomInfoText"), text.info);
};

Main.insertTextEpisode = function () {
    widgetAPI.putInnerHTML(document.getElementById("bottomReturnText2"), text.back);
    widgetAPI.putInnerHTML(document.getElementById("bottomToolsText2"), text.tools);
    widgetAPI.putInnerHTML(document.getElementById("bottomInfoText"), text.info);
    widgetAPI.putInnerHTML(document.getElementById("bottomEpisodeDeleteText"), text.buttonDelete);
};

Main.insertTextPlayer = function () {
    widgetAPI.putInnerHTML(document.getElementById("bottomAutoplayText"), text.playerAutoplayOff);
    widgetAPI.putInnerHTML(document.getElementById("osdAutoplayText"), text.OSDAutoplayOff);
    widgetAPI.putInnerHTML(document.getElementById("osdAdSubtText"), text.OSDAdSubt);
    widgetAPI.putInnerHTML(document.getElementById("bottomEnterText"), text.categoryBottomPlaySel);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDHead"), text.rightOSDHead);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDAudioStream"), text.rightOSDAudioStream);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDSubtitleEnable"), text.rightOSDSubtitleEnable);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDSubtitleStream"), text.rightOSDSubtitleStream);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDSubtitleOffset"), text.rightOSDSubtitleOffset);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDSubtitleSize"), text.rightOSDSubtitleSize);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDSubtitleColor"), text.rightOSDSubtitleColor);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDSubtitlePosition"), text.rightOSDSubtitlePosition);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDSaveDefaultTitle"), text.rightOSDSubtitleStream);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDSaveDefault"), text.rightOSDSaveDefault);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDJumpTo"), text.rightOSDJumpTo);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDAspectTitle"), text.OSDAspectTitle);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDAspectRatio"), text.OSDAspectDefault);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDBottomReturnText"), text.hide);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDBottomEnterText"), text.preferencesEnter);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDBottomLRText"), text.rightOSDBottomNavi);
    widgetAPI.putInnerHTML(document.getElementById("rightOSDBottom09Text"), text.rightOSDBottom09);
};

Main.insertTextPreferences = function () {
    widgetAPI.putInnerHTML(document.getElementById("leftName"), text.preferences);
    widgetAPI.putInnerHTML(document.getElementById("set0"), text.preferencesSetGS);
    widgetAPI.putInnerHTML(document.getElementById("set1"), text.preferencesSetPLA);
    widgetAPI.putInnerHTML(document.getElementById("set2"), text.preferencesSetPMS);
    widgetAPI.putInnerHTML(document.getElementById("set3"), text.preferencesSetSUBS);
    widgetAPI.putInnerHTML(document.getElementById("set4"), text.preferencesSetSYSTEM);
    widgetAPI.putInnerHTML(document.getElementById("set5"), text.preferencesSetADVANCED);
    widgetAPI.putInnerHTML(document.getElementById("set6"), text.preferencesSetABOUT);
    //PLA
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Top"), text.preferencesSetPLA);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.THEME), text.preferencesPLAThemeMusic);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.FF), text.preferencesPLAFF);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.RW), text.preferencesPLARW);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.IB), text.preferencesPLAInitBuffer);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.PB), text.preferencesPLAPendingBuffer);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.TB), text.preferencesPLATotalBuffer);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.TC), text.playbackMode);
    //PMS
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PMS + "Top"), text.preferencesSetPMS);
    //GS
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Top"), text.preferencesSetGS);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.DB), text.preferencesGSDebug);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.TIME), text.preferencesGSTime);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.CLOCK), text.preferencesGSClock);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.FX), text.preferencesGSFX);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.TIMEOUT), text.preferencesGSTimeOut);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.SCREENSAVER), text.preferencesGSScreenSaver);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.LANG), text.preferencesGSLanguage);
    // SUBS
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Top"), text.preferencesSetSUBS);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.AUDIO), text.preferencesAudio);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.BOOST), text.preferencesAudioBoost);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.SS), text.preferencesSubSize);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.SC), text.preferencesSubColor);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.SAE), text.preferencesSubAlwaysEnabled);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.USEOVERLAY), text.preferencesSUBSUSEOVERLAY);
    // SYSTEM
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Top"), text.preferencesSetSYSTEM);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right" + buttonSetting.LOGIN), text.preferencesLOGIN);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right" + buttonSetting.USERNAME), text.preferencesUSERNAME);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right" + buttonSetting.EMAIL), text.preferencesEMAIL);
    // ADVANCED
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Top"), text.preferencesSetADVANCED);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.UNIVERSAL), text.preferencesUNIVERSAL);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.DIRECTSTREAM), text.preferencesDIRECTSTREAM);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.DIRECTPLAY), text.preferencesDIRECTPLAY);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.LOCALQUALITY), text.preferencesLOCALQUALITY);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.REMOTEQUALITY), text.preferencesREMOTEQUALITY);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.PICKHIGHRES), text.preferencesPICKHIGHRES);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.PICKFIRSTPART), text.preferencesPICKFIRSTPART);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.AUTOSERVERLIST), text.preferencesAUTOSERVERLIST);
    // ABOUT
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ABOUT + "Top"), text.preferencesSetABOUT);
    widgetAPI.putInnerHTML(document.getElementById("aboutInfo"), text.preferencesABOUTText);
    // NAVIGATION HELP BAR
    widgetAPI.putInnerHTML(document.getElementById("bottomPreferencesAddPMSText"), text.preferencesAddPMS);
    widgetAPI.putInnerHTML(document.getElementById("bottompreferencesFindPMSText"), text.preferencesFindPMS);
    widgetAPI.putInnerHTML(document.getElementById("bottompreferencesCopyPMSText"), text.preferencesCopyPMS);
    widgetAPI.putInnerHTML(document.getElementById("bottomPreferencesDeletePMSText"), text.preferencesDeletePMS);
    widgetAPI.putInnerHTML(document.getElementById("bottomPreferencesPLAEnterText"), text.preferencesEnter);
    widgetAPI.putInnerHTML(document.getElementById("bottomPreferencesPMSEnterText"), text.preferencesRefresh);
    widgetAPI.putInnerHTML(document.getElementById("bottomPreferencesPLAResetBufferText"), text.preferencesPLAResetBuffer);
    widgetAPI.putInnerHTML(document.getElementById("bottomPreferencesEnterText"), text.preferencesEnter);
    // POPUPS
    widgetAPI.putInnerHTML(document.getElementById("clock"), text.preferencesGSPopupClock);
    widgetAPI.putInnerHTML(document.getElementById("serverAdd"), text.preferencesPMSPopupAdd);
    widgetAPI.putInnerHTML(document.getElementById("fastForward"), text.preferencesPLAPopupFF);
    widgetAPI.putInnerHTML(document.getElementById("rewind"), text.preferencesPLAPopupRW);
    widgetAPI.putInnerHTML(document.getElementById("initBuffer"), text.preferencesPLAPopupInitBuffer);
    widgetAPI.putInnerHTML(document.getElementById("pendingBuffer"), text.preferencesPLAPopupPendingBuffer);
    widgetAPI.putInnerHTML(document.getElementById("totalBuffer"), text.preferencesPLAPopupTotalBuffer);
    widgetAPI.putInnerHTML(document.getElementById("localQuality"), text.preferencesPopupLocalQuality);
    widgetAPI.putInnerHTML(document.getElementById("subSize"), text.preferencesSUBSPopupSubSize);
    widgetAPI.putInnerHTML(document.getElementById("subColor"), text.preferencesSUBSPopupSubColor);
    widgetAPI.putInnerHTML(document.getElementById("subPos"), text.preferencesSUBSPopupSubPos);
    widgetAPI.putInnerHTML(document.getElementById("remoteQuality"), text.preferencesPopupLocalQuality);
    widgetAPI.putInnerHTML(document.getElementById("popupBottom"), text.back);
};

/*
 ###############################
 #
 #       INFO POPUP
 #
 ###############################
 */

Main.showInfo = function (infotext, subject, buttontext, callback) {

    var txt = text.close;
    if (buttontext) {
        txt = buttontext;
    }

    if (subject === "info") {
        Popup.showMessage(Popup.INFO, text.info, infotext, txt, callback);
        return false;
    } else if (subject === "warning") {
        Popup.showMessage(Popup.WARNING, text.warning, infotext, txt, callback);
        return false;
    } else if (subject === "error") {
        Popup.showMessage(Popup.WARNING, text.errorOccured, infotext, txt, callback);
        return false;
    } else if (subject === "autoplay") {
        Main.info = 30;  //we need an exception for autplay, so we can do something else when RED is pushed
        Popup.showMessage(Popup.ERROR, text.errorOccured, infotext, txt, callback);
        return false;
    } else if (!isEmpty(subject)) {
        Popup.showMessage(Popup.INFO, subject, infotext, txt, callback);
        return false;
    } else {
        Popup.showMessage(Popup.INFO, text.errorOccured, infotext, txt, callback);
        return false;
    }
};


Main.showMediaInfo = function (id, callback, nocheck) {
    var checkversions = (nocheck) ? false : true;
    if (checkversions && Data.contentMedias[id].length > 1 && (prefs.player.pickHighestResolution || "off") === "off") {
        Popup.showChoice(Data.contentMedias[id], "Media", text.multipleVersions, function (val) {
            if (val !== null) {
                Main.selectedMedia = val;
                MediaInfo.show(id, callback);
            }
        });
    } else {
        Main.selectedMedia = 0;
        MediaInfo.show(id, callback);
    }
};

/*
 ###############################
 #
 #       FILE FUNCTIONS
 #
 ###############################
 */

Main.readFile = function (filename) {
    var path = curWidget.id + '/' + filename;
    var fileSystemObj = new FileSystem();
    var fileObj = fileSystemObj.openCommonFile(path, 'r');
    var strResult = "";
    if (fileObj) {
        strResult = fileObj.readAll();
        strResult = strResult.replace(/(\r\n|\n|\r)/gm, "");
        fileSystemObj.closeCommonFile(fileObj);
    }
    else {
        Main.debug("[Main.js] - File: [" + path.replace(curWidget.id, "Plex") + "] doesn't exist");
        strResult = "";
    }
    return strResult;
};

Main.writeFile = function (filename, input) {
    input += ''; //convert int to string
    var path = curWidget.id + '/' + filename;
    var fileSystemObj = new FileSystem();
    var fileObj = fileSystemObj.openCommonFile(path, 'w'); // open file for writing
    var result;
    if (fileObj) {
        result = fileObj.writeAll(input); // writing into file
        fileSystemObj.closeCommonFile(fileObj); // closing file
        //Main.debug("[Main.js] - Wrote: [" + input +"] into File: [" + path.replace(curWidget.id,"Plex") + "] - Result: [" + result + "]");
    }
    else {
        Main.debug("[Main.js] - Error couldn't write: [" + input + "] into File: [" + path.replace(curWidget.id, "Plex") + "] - Result: [" + fileObj + "]");
        result = false;
    }
    return result;
};

Main.deleteFile = function (filename) {
    var fileSystemObj = new FileSystem();
    var path = curWidget.id + '/' + filename;
    var fileObj = fileSystemObj.deleteCommonFile(path);
    Main.debug("[Main.js] - Deleted File - Path: [" + path.replace(curWidget.id, "Plex") + "] - Result: [" + fileObj + "]");
};

Main.validPath = function (filename) {
    var path = curWidget.id + '/' + filename;
    var fileSystemObj = new FileSystem();
    return fileSystemObj.isValidCommonPath(path);
};

/*
 ###############################
 #
 #       HELPER FUNCTIONS
 #
 ###############################
 */

function fireEvent(evt, param) {
    try {
        if (evt !== "") {
            var part = evt.split(".");
            var fn = window[part[0]][part[1]];
            if (!isEmpty(param)) {
                fn(param);
            } else {
                fn();
            }
        }
    }
    catch (e) {
        Main.debug("[Main.js] - fireEvent error: " + evt);
    }
}

insertText = function (divID, inputText) {
    widgetAPI.putInnerHTML(document.getElementById(divID), inputText);
};

Main.getFirstChild = function (tmpnode) {
    var tmpChild = tmpnode.firstChild;
    while (tmpChild) {
        if ((tmpChild.nodeType === 8) || ((tmpChild.nodeType === 3) && !(/[^\t\n\r\ ]/.test(tmpChild.data))))
            tmpChild = tmpChild.nextSibling;
        else
            return tmpChild;
    }
    return null;
};

Main.getSelectedID = function () {
    if (Main.mediaContent === Main.MOVIE) {
        return Main.selectedContent;
    }
    else if (Main.mediaContent === Main.EPISODE) {
        return Main.selectedEpisode;
    }
    return Main.selectedID;
};

Main.getChildLength = function (divName) {
    try {
        var result = document.getElementById(divName).childNodes.length;

        if (divName.match(/settingSide/))
            result = 7;
        if (divName.match(/settingMain0/)) //GENERAL
            result = 6;
        if (divName.match(/settingMain1/)) //PLAYER
            result = 7;
        //skip settingMain2 = PMS
        if (divName.match(/settingMain3/)) //SUBS
            result = 6;
        if (divName.match(/settingMain4/)) //SYSTEM
            result = 1;
        if (divName.match(/settingMain5/)) //ADVANCED
            result = 6;
        if (divName.match(/settingMai65/)) //ABOUT
            result = 1;

        //Main.debug("[Main.js] - found [" + result + "] childNodes in div [" + divName + "]");
        return result;

    } catch (e) {
        Main.debug("[Main.js] - Main.getChildLength error: " + e.message);
    }
};

Main.getIME = function () {
    var head = document.getElementsByTagName("body")[0];
    var imeObj = document.createElement('script');
    imeObj.type = "text/javascript";
    if (getModel(2010)) {
        imeObj.src = "$MANAGER_WIDGET/Common/IME/ime2.js";
        Main.debug("[Main.js] - IME Loaded for Model 2010");
    }
    else {
        imeObj.src = "$MANAGER_WIDGET/Common/IME_XT9/ime.js";
        Main.debug("[Main.js] - IME Loaded for Model 2011 and later");
    }
    head.appendChild(imeObj);
};

getServerPrefValue = function (prefname) {
    var prefurl = Main.server.resolveUrl("/:/prefs");
    var value;
    $.ajax(
        {
            url: prefurl,
            async: false,
            success: function (data) {
                $(data).find("Setting").each(function () {
                    if ($(this).attr("id") === prefname) {
                        value = ($(this).attr("value") || "false");
                        if (value === "true")
                            Main.serverPref = true;
                        else if (value === "false")
                            Main.serverPref = null;
                    }
                });
            }
        });
    return Main.serverPref;
};

setServerPrefValue = function (prefname) {
    var url = Main.server.resolveUrl("/:/prefs/set?" + prefname + "=1");
    var req = $.ajax(
        {
            url: url,
            methode: "GET",
            async: false
        });

    if (req.status !== 200) {
        Main.debug("[Main.js] - Couldn't enable media deletion, error: [" + req.status + "]");
        return false;
    }
    else {
        Main.debug("[Main.js] - Enabled media deletion");
        return true;
    }
};

Main.getModelName = function () {
    var model;
    var pluginObjectDEVICE = document.getElementById("pluginObjectDEVICE");
    model = pluginObjectDEVICE.GetRealModel();
    return model;
};

Main.getUniqueID = function () {
    var netplugin = document.getElementById('pluginObjectNetwork');
    var naviplugin = document.getElementById('pluginObjectNNavi');
    var MAC = netplugin.GetMAC();
    var DUID = naviplugin.GetDUID(MAC);
    return DUID.toString().toLowerCase();
};

getModel = function (model) {
    var pluginNNavi = document.getElementById("pluginObjectNNavi");
    var firmwareVersion = pluginNNavi.GetFirmware();

    // for use with emulator
    if (Main.getModelName() === "VALENCIA") {
        firmwareVersion = Application.firmwareVersion;
    }

    //Main.debug("[Main.js] - firmwareVersion: " + firmwareVersion);
    if (firmwareVersion.contains(model)) {
        return true;
    } else {
        return false;
    }
};

getModelYear = function () {
    var pluginNNavi = document.getElementById("pluginObjectNNavi");
    var firmwareVersion = pluginNNavi.GetFirmware();

    if (firmwareVersion === "") {  // for emulator only
        firmwareVersion = Application.firmwareVersion;
    }

    //Main.debug("[Main.js] - firmwareVersion: " + firmwareVersion);

    return Number(firmwareVersion.substr(10, 4));
};

check3DSupport = function () {
    var pluginScreen = document.getElementById("pluginScreen");
    var pluginTV = document.getElementById("pluginObjectTV");
    var TV = 0;
    var MONITOR = 1;
    var BD = 2;

    if (pluginTV.GetProductType() === TV) {// PRODUCT_TYPE_TV
        if (pluginScreen.Flag3DEffectSupport() === 1) { // can the TV do 3D
            return text.preferencesTV3DSupport + ": <span style='color:green;'>" + text.yes + "</span>";
        } else {
            return text.preferencesTV3DSupport + ": <span style='color:red;'>" + text.no + "</span>";
        }
    } else if (pluginTV.GetProductType() === BD) { // PRODUCT_TYPE_BD
        if (pluginScreen.Flag3DEffectSupport() === 1) { // does the device support 3D
            return text.preferencesBD3DSupport + ": <span style='color:green;'>" + text.yes + "</span>";
        } else {
            return text.preferencesBD3DSupport + ": <span style='color:red;'>" + text.no + "</span>";
        }
    } else if (pluginTV.GetProductType() === MONITOR) { // PRODUCT_TYPE_MONITOR
        if (pluginScreen.Flag3DEffectSupport() === 1) { // can the MONITOR do 3D
            return text.preferencesMON3DSupport + ": <span style='color:green;'>" + text.yes + "</span>";
        } else {
            return text.preferencesMON3DSupport + ": <span style='color:red;'>" + text.no + "</span>";
        }
    } else {
        return text.error3DUnknown;
    }
};

getProductType = function () {
    var pluginTV = document.getElementById("pluginObjectTV");
    var TV = 0;
    var MONITOR = 1;
    var BD = 2;

    if (pluginTV.GetProductType() === TV) // PRODUCT_TYPE_TV
        return "TV";
    else if (pluginTV.GetProductType() === BD) // PRODUCT_TYPE_BD
        return "BD-Player";
    else if (pluginTV.GetProductType() === MONITOR) // PRODUCT_TYPE_MONITOR
        return "Monitor";
    else // PRODUCT_TYPE_UNKNOWN
        return "device";
};

Main.handleError = function () {
    var result = prefs.servers.length;
    if (result > 0 && Main.error !== Main.NETWORKERROR)
        Main.showInfo(text.errorPMS);
    else if (result <= 0 && Main.error === 0)
        Main.showInfo(text.errorAddPMS, "info", text.close);

    Main.debug("[Channel.js] - Couldn't connect to PMS");

    Main.error = 0;
};

Main.disableScreenSaver = function () {
    pluginAPI.setOffScreenSaver();
    Main.debug("[Main.js] - screensaver disabled");
};

Main.enableScreenSaver = function () {
    var mins = Number(prefs.general.screensaver || "5");
    var secs = mins * 60;
    pluginAPI.setOnScreenSaver(secs);
    Main.debug("[Main.js] - screensaver reset to " + secs + " seconds");
};