﻿var MediaInfo = {
    playmode: 0,
    audio: 0,
    subtitle: 0,
    subtitleMode: 0,
    status: 0,
    position: null,
    controls: [],
    curCtrl: 0,
    maxCtrl: 5,
    minVal: 0,
    maxVal: 1,
    input: null,
    callback: null,
    returnValue: null,
    selectedContent: 0,
    keyDown: function () {
        var keyCode = event.keyCode;
        Main.debug("[MediaInfo.js] - Key pressed: [" + keyCode + "]");
        if (keyLock.checkKey(keyCode)) {
            switch (keyCode) {
                case tvKey.KEY_RETURN:
                case tvKey.KEY_PANEL_RETURN:
                    Main.debug("[MediaInfo.js] - RETURN");
                    widgetAPI.blockNavigation(event);
                    MediaInfo.returnValue = null;
                    MediaInfo.hide();
                    break;
                case tvKey.KEY_EXIT:
                    Main.debug("[MediaInfo.js] - EXIT");
                    widgetAPI.blockNavigation(event);
                    Player.deinit();
                    widgetAPI.sendExitEvent();
                    break;
                case tvKey.KEY_ENTER:
                case tvKey.KEY_PANEL_ENTER:
                case tvKey.KEY_JOYSTICK_DOWN:
                    Main.debug("[MediaInfo.js] - ENTER");
                    MediaInfo.handleEnter();
                    break;
                case tvKey.KEY_RIGHT:
                    Main.debug("[MediaInfo.js] - RIGHT");
                    MediaInfo.moveFocus("right");
                    break;
                case tvKey.KEY_LEFT:
                    Main.debug("[MediaInfo.js] - LEFT");
                    MediaInfo.moveFocus("left");
                    break;
                case tvKey.KEY_UP:
                    Main.debug("[MediaInfo.js] - UP");
                    MediaInfo.moveFocus("previous");
                    break;
                case tvKey.KEY_DOWN:
                    Main.debug("[MediaInfo.js] - DOWN");
                    MediaInfo.moveFocus("next");
                    break;
                case 259:
                case tvKey.KEY_BLUE:
                    Main.debug("[MediaInfo.js] - BLUE/DELETE");
                    //MediaInfo.handleDKey();
                    break;
                default:
                    Main.debug("[MediaInfo.js] - Unhandled key");
                    break;
            }
        } else {
            Main.debug("[MediaInfo.js] - key blocked:" + keyLock.status);
        }
    },
    loadStreams: function () {

        Main.debug("[MediaInfo.js] - loadstreams for item: " + MediaInfo.selectedContent);
        loadbar.show();
        var url = Data.contentMetadataUrls[MediaInfo.selectedContent];
        var key = Data.contentRatingKeys[MediaInfo.selectedContent];

        if (url !== "") {
            Metadata.fetchList(url, key, MediaInfo.load);
        }
        else {
            MediaInfo.load();
        }

    },
    load: function () {

        Main.debug("[MediaInfo.js] - load item: " + MediaInfo.selectedContent);

        MediaInfo.curCtrl = 5;
        MediaInfo.maxCtrl = 5;

        //playmode
        var pic = (!isEmpty(Data.contentGrandParentThumbs[MediaInfo.selectedContent])) ? Data.contentGrandParentThumbs[MediaInfo.selectedContent] : Data.contentThumbs[MediaInfo.selectedContent];
        $("#optPoster").attr('src', Main.getPhoto(pic, 92 * 2, 134 * 2, "poster"));
        $("#optHeader").text(Data.contentTitles[MediaInfo.selectedContent]);
        $("#lblPlayMode").text(text.playback);
        $("#optPlay").text(text.resume2);
        $("#lblAudio").text(text.audio);
        $("#lblSubtitle").text(text.subtitle);
        $("#lblSubtitleMode").text(text.subtitleMode);

        //Watched/unwatched
        var resume = Data.contentOffsets[MediaInfo.selectedContent] > 0;

        if (resume) {
            $("#optResume").text(text.resume1 + Data.contentOffsets[MediaInfo.selectedContent].toTimeString()).show();
            $("#optPlay").removeClass("opt7").addClass("opt6");
            $("#mediaInfo").css("height", 345);
            $("#optHelpbar").css("top", 309);
            MediaInfo.curCtrl = 5;
            MediaInfo.maxCtrl = 6;
        } else {
            $("#optResume").hide();
            $("#optPlay").removeClass("opt6").addClass("opt7");
            $("#mediaInfo").css("height", 300);
            $("#optHelpbar").css("top", 263);
        }

        //Playmode
        MediaInfo.playmode = Main.getPlaybackMode();
        MediaInfo.setPlaymode();

        //audio
        MediaInfo.audio = Metadata.getSelectedAudio();
        MediaInfo.setAudio();

        //subtitles
        MediaInfo.subtitle = Metadata.getSelectedSubtitle();
        MediaInfo.setSubtitle();

        //subtitle pref
        MediaInfo.subtitleMode = ((prefs.subtitles.preferOverlay || "on") === "off") ? 1 : 2;
        MediaInfo.setSubtitleMode();

        loadbar.hide();
        loading.hide();

        MediaInfo.slideBigSelection(0);

        var top = (540 - $("#mediaInfo").outerHeight()) / 2;
        $("#mediaInfo").css({"top": top});

        $("#mediaInfo").css({"visibility": "visible"});
        $("#mediaAnchor").focus();
        Main.keylock = keyLock.NONE;
    },
    show: function (selected, callback) {
        $("#popup-overlay").show();
        $("#mediaAnchor").focus();
        Main.keylock = keyLock.BLOCKALL;
        if (callback) {
            MediaInfo.callback = callback;
        } else {
            MediaInfo.callback = null;
        }
        MediaInfo.selectedContent = selected;
        MediaInfo.loadStreams();
    },
    hide: function () {
        $("#mediaInfo").css({"visibility": "hidden"});
        $("#popup-overlay").hide();
        $("#optPoster").attr('src', "Images/categorie/coverMovie.png");

        MediaInfo.status = 0;
        MediaInfo.curCtrl = 0;

        if (MediaInfo.callback) {
            Main.debug("[MediaInfo.js] - returnValue: " + MediaInfo.returnValue);
            MediaInfo.callback(MediaInfo.returnValue);
            MediaInfo.callback = null;
        }
        //return focus to the main page
        $("#anchor").focus();
    },
    moveFocus: function (direction) {
        var t = 150;

        if (direction === "next") {
            MediaInfo.curCtrl++;
            if (MediaInfo.curCtrl > MediaInfo.maxCtrl) {
                MediaInfo.curCtrl = 1;
            }

            if (MediaInfo.curCtrl === 1 || MediaInfo.curCtrl === 5) {
                t = 0;
            }

            if (MediaInfo.curCtrl > 4) {
                MediaInfo.slideBigSelection(t);
            } else {
                MediaInfo.slideSelection(t);
            }
        } else if (direction === "previous") {
            MediaInfo.curCtrl--;
            if (MediaInfo.curCtrl < 1) {
                MediaInfo.curCtrl = MediaInfo.maxCtrl;
            }

            if (MediaInfo.curCtrl === MediaInfo.maxCtrl || MediaInfo.curCtrl === 4) {
                t = 0;
            }

            if (MediaInfo.curCtrl > 4) {
                MediaInfo.slideBigSelection(t);
            } else {
                MediaInfo.slideSelection(t);
            }
        } else if (direction === "left") {
            MediaInfo.changeOption("left");
        } else if (direction === "right") {
            MediaInfo.changeOption("right");
        }
    },
    slideSelection: function (time) {
        $("#optHelpbar").putInnerHTML('<div class="bottomTextRight bottomTextFlow">' + text.back + '</div><div class="bottomTexture"><img src="Images/navi/back.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.navigate + '</div><div class="bottomTexture"><img src="Images/navi/ud.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.changeSelection + '</div><div class="bottomTexture"><img src="Images/navi/lr.png"/></div>');

        var ctrl = "#optPlaymode";

        if (MediaInfo.curCtrl === 1) {
            ctrl = "#optPlaymode";
        } else if (MediaInfo.curCtrl === 2) {
            ctrl = "#optAudio";
        } else if (MediaInfo.curCtrl === 3) {
            ctrl = "#optSubtitle";
        } else if (MediaInfo.curCtrl === 4) {
            ctrl = "#optSubtitleMode";
        }

        var pos = $(ctrl).position();

        $("#optSelected").text("");
        $("#optSelected").stop(true, true).animate(
            {
                "top": pos.top,
                "width": $(ctrl).width(),
                "left": pos.left,
                "height": $(ctrl).height()
            }, time, "linear", function () {
                $(this).css({
                    fontSize: '16px',
                    paddingLeft: '5px',
                    paddingTop: '7px'
                });
                $("#optSelected").css({ "text-align": "left" });
                $("#optSelected").putInnerHTML($(ctrl).html());
            });
    },
    slideBigSelection: function (time) {
        $("#optHelpbar").putInnerHTML('<div class="bottomTextRight bottomTextFlow">' + text.continue1 + '</div><div class="bottomTexture"><img src="Images/navi/enter.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.navigate + '</div><div class="bottomTexture"><img src="Images/navi/ud.png"/></div>');

        var ctrl = "#optResume";

        if (MediaInfo.maxCtrl === 6) {
            if (MediaInfo.curCtrl === 5) {
                ctrl = "#optResume";
            } else if (MediaInfo.curCtrl === 6) {
                ctrl = "#optPlay";
            }
        }
        else {
            ctrl = "#optPlay";
        }

        var pos = $(ctrl).position();

        $("#optSelected").text("");
        $("#optSelected").stop(true, true).animate(
            {
                "top": pos.top,
                "width": $(ctrl).width(),
                "left": pos.left,
                "height": $(ctrl).height()
            }, time, "linear", function () {
                $(this).css({
                    fontSize: '20px',
                    paddingLeft: '0px',
                    paddingTop: '11px'
                });
                $("#optSelected").css({ "text-align": "center" });
                $("#optSelected").putInnerHTML($(ctrl).html());
            });
    },
    changeOption: function (direction) {
        if (MediaInfo.curCtrl == 1) { //playmode
            if (direction === "left") {
                MediaInfo.playmode--;
            } else {
                MediaInfo.playmode++;
            }
            MediaInfo.setPlaymode(true);
        } else if (MediaInfo.curCtrl == 2) { //audio
            if (direction === "left") {
                MediaInfo.audio--;
            } else {
                MediaInfo.audio++;
            }
            MediaInfo.setAudio(true);
        } else if (MediaInfo.curCtrl == 3) { //subtitle
            if (direction === "left") {
                MediaInfo.subtitle--;
            } else {
                MediaInfo.subtitle++;
            }
            MediaInfo.setSubtitle(true);
        } else if (MediaInfo.curCtrl == 4) { //subtitleMode
            if (direction === "left") {
                MediaInfo.subtitleMode--;
            } else {
                MediaInfo.subtitleMode++;
            }
            MediaInfo.setSubtitleMode(true);
        }
    },
    handleEnter: function () {

        Main.debug("[MediaInfo.js] - MediaInfo.handleEnter: " + MediaInfo.curCtrl);
        if (MediaInfo.curCtrl == 1) { //playmode
            MediaInfo.playmode++;
            MediaInfo.setPlaymode(true);
        } else if (MediaInfo.curCtrl == 2) { //audio
            MediaInfo.audio++;
            MediaInfo.setAudio(true);
        } else if (MediaInfo.curCtrl == 3) { //subtitle
            MediaInfo.subtitle++;
            MediaInfo.setSubtitle(true);
        } else if (MediaInfo.curCtrl == 4) { //resume
            MediaInfo.subtitleMode++;
            MediaInfo.setSubtitleMode(true);
        } else if (MediaInfo.curCtrl == 5) { //resume
            MediaInfo.returnValue = Data.contentOffsets[MediaInfo.selectedContent];
            MediaInfo.hide();
        } else if (MediaInfo.curCtrl == 6) { //resume
            MediaInfo.returnValue = 0;
            MediaInfo.hide();
        }
    },
    setPlaymode: function (isSelected) {
        if (MediaInfo.playmode > 4)
            MediaInfo.playmode = 1;

        if (MediaInfo.playmode < 1)
            MediaInfo.playmode = 4;

        if (MediaInfo.playmode === 1) {
            $("#optPlaymode").putInnerHTML("<span>(1/4)&nbsp;" + text.OSDAutoMode + "</span>");
            prefs.player.playbackmode = 1;
        } else if (MediaInfo.playmode === 2) {
            $("#optPlaymode").putInnerHTML("<span>(2/4)&nbsp;" + text.OSDDirectPlay + "</span>");
            prefs.player.playbackmode = 2;
        } else if (MediaInfo.playmode === 3) {
            $("#optPlaymode").putInnerHTML("<span>(3/4)&nbsp;" + text.OSDDirectStream + "</span>");
            prefs.player.playbackmode = 3;
        } else {
            $("#optPlaymode").putInnerHTML("<span>(4/4)&nbsp;" + text.OSDTranscoding + "</span>");
            prefs.player.playbackmode = 4;
        }

        if (isSelected) {
            $("#optSelected").putInnerHTML($("#optPlaymode").html());
            MediaInfo.setSubtitle();
        }
    },
    setAudio: function (isSelected) {
        var lang = text.unknown;
        var codec = text.unknown;
        var count;

        Main.debug("[MediaInfo.js] - MediaInfo.audio: " + MediaInfo.audio);

        count = AudioStreams.length;

        if (MediaInfo.audio > count - 1)
            MediaInfo.audio = 0;

        if (MediaInfo.audio < 0)
            MediaInfo.audio = count - 1;

        if (count > 0) {
            if (AudioStreams[MediaInfo.audio]) {
                lang = (AudioStreams[MediaInfo.audio].language != "") ? AudioStreams[MediaInfo.audio].language : text.unknown;
                if (lang === text.unknown) {
                    lang = (AudioStreams[MediaInfo.audio].languageCode != "") ? AudioStreams[MediaInfo.audio].languageCode : text.unknown;
                }

                //codec = Audio.codecToString(AudioStreams[MediaInfo.audio].codec, AudioStreams[MediaInfo.audio].channels);
                codec = Metadata.getAudioCodec(MediaInfo.audio) + " " + Metadata.getAudioChannels(MediaInfo.audio);
                $("#optAudio").putInnerHTML("<span>(" + (MediaInfo.audio + 1) + "/" + AudioStreams.length + ")&nbsp;" + lang + "&nbsp;(" + codec + ")</span>");
            }
        } else {
            $("#optAudio").putInnerHTML("<span style='color:#2f2f2f;'>(" + (MediaInfo.audio + 1) + "/" + count + ")&nbsp;" + text.none + "</span>");
        }

        if (isSelected) {
            $("#optSelected").putInnerHTML($("#optAudio").text());
            Metadata.setSelectedAudio(MediaInfo.audio);
        }
    },
    setSubtitle: function (isSelected) {
        var count;
        var langsub = text.unknown;
        var embedded = 0;
        var color = "white";

        Main.debug("[MediaInfo.js] - MediaInfo.subtitle: " + MediaInfo.subtitle);

        count = SubtitleStreams.length;

        if (MediaInfo.subtitle > count - 1) {
            MediaInfo.subtitle = -1;
        }

        if (MediaInfo.subtitle < -1) {
            MediaInfo.subtitle = count - 1;
        }

        if (count > 0 && MediaInfo.subtitle > -1) {
            embedded = (SubtitleStreams[MediaInfo.subtitle].embedded == 1) ? text.internal : text.external;
            langsub = (SubtitleStreams[MediaInfo.subtitle].language != "") ? SubtitleStreams[MediaInfo.subtitle].language : text.unknown;
            if (langsub === text.unknown) {
                langsub = (SubtitleStreams[MediaInfo.subtitle].languageCode != "") ? SubtitleStreams[MediaInfo.subtitle].languageCode : text.unknown;
            }

            if (!Subtitle.isSupported(MediaInfo.subtitle)) {
                Main.debug("[MediaInfo.js] - subtitle unsupported in current mode");
                color = "#2f2f2f";
            }

            $("#optSubtitle").putInnerHTML("<span style='color:" + color + ";'>(" + (MediaInfo.subtitle + 1) + "/" + count + ")&nbsp;" + langsub + "&nbsp;(" + SubtitleStreams[MediaInfo.subtitle].format.toUpperCase() + "&nbsp;" + embedded + ")</span>");
        } else {
            $("#optSubtitle").putInnerHTML("<span style='color:#2f2f2f;'>(" + (MediaInfo.subtitle + 1) + "/" + count + ")&nbsp;" + text.none + "</span>");
        }

        if (isSelected) {
            $("#optSelected").putInnerHTML($("#optSubtitle").html());
            Metadata.setSelectedSubtitle(MediaInfo.subtitle);
        }

        MediaInfo.setSubtitleMode(false);
    },
    setSubtitleMode: function (isSelected) {
        var color = "white";

        if (MediaInfo.subtitleMode > 2) {
            MediaInfo.subtitleMode = 1;
        }

        if (MediaInfo.subtitleMode < 1) {
            MediaInfo.subtitleMode = 2;
        }

        if (!Subtitle.isSupported(MediaInfo.subtitle)) {
            color = "#2f2f2f";
        }

        if (SubtitleStreams[MediaInfo.subtitle]) {

            if ((Main.getPlaybackMode() <= 2) && (SubtitleStreams[MediaInfo.subtitle].format === "srt" || SubtitleStreams[MediaInfo.subtitle].format === "smi") && SubtitleStreams[MediaInfo.subtitle].embedded === 0) {
                $("#optSubtitleMode").putInnerHTML("<span style='color:" + color + ";'>(1/1)&nbsp;" + text.subOverlay + "</span>");
                MediaInfo.subtitleMode = 2;
                prefs.subtitles.preferOverlay = "on";
            } else if ((Main.getPlaybackMode() > 2) && (SubtitleStreams[MediaInfo.subtitle].format === "srt" || SubtitleStreams[MediaInfo.subtitle].format === "smi") && SubtitleStreams[MediaInfo.subtitle].embedded === 0) {
                if (MediaInfo.subtitleMode === 1) {
                    $("#optSubtitleMode").putInnerHTML("<span style='color:" + color + ";'>(1/2)&nbsp;" + text.subEmbedded + "</span>");
                    prefs.subtitles.preferOverlay = "off";
                } else if (MediaInfo.subtitleMode === 2) {
                    $("#optSubtitleMode").putInnerHTML("<span style='color:" + color + ";'>(2/2)&nbsp;" + text.subOverlay + "</span>");
                    prefs.subtitles.preferOverlay = "on";
                }
            } else if ((Main.getPlaybackMode() > 2) && SubtitleStreams[MediaInfo.subtitle].embedded === 1) {
                $("#optSubtitleMode").putInnerHTML("<span style='color:" + color + ";'>(1/1)&nbsp;" + text.subEmbedded + "</span>");
                MediaInfo.subtitleMode = 1;
                prefs.subtitles.preferOverlay = "off";
            } else {
                $("#optSubtitleMode").putInnerHTML("<span style='color:#2f2f2f;'>(" + "0/0" + ")&nbsp;" + text.none + "</span>");
                MediaInfo.subtitleMode = 1;
                prefs.subtitles.preferOverlay = "off";
            }
        } else {
            $("#optSubtitleMode").putInnerHTML("<span style='color:#2f2f2f;'>(" + "0/0" + ")&nbsp;" + text.none + "</span>");
            MediaInfo.subtitleMode = 1;
            prefs.subtitles.preferOverlay = "off";
        }

        Main.debug("[MediaInfo.js] - MediaInfo.subtitleMode: " + MediaInfo.subtitleMode);

        if (isSelected) {
            $("#optSelected").putInnerHTML($("#optSubtitleMode").html());
        }
    }

};