var myPlexXhr = null;
var MyPlex = {
    userName: "",
    userPassword: "",
    userEmail: "",
    userJoinedAt: "",
    authToken: "",
    autoLogin: 0,
    remoteQuality: 7,
    pinUrl: "",
    pinCode: "",
    pinExpires: "",
    plexPass: "",
    loggedIn: false,
    isValidAccount: 0
};

MyPlex.init = function () {
    if (myPlexXhr !== null) {
        if (myPlexXhr.destroy) {
            myPlexXhr.destroy(); // Save memory
        }
        myPlexXhr = null;
    }
    return true;
};

MyPlex.logout = function () {
    MyPlex.loggedIn = false;
    prefs.myplex.autoLogin = "off";
    prefs.myplex.username = "";
    prefs.myplex.password = "";
    prefs.myplex.userEmail = "";
    prefs.myplex.userJoinedAt = "";
    prefs.myplex.authToken = "";
    Main.savePrefs();
};

MyPlex.loginPIN = function (fnCallback) {
    var pUrl = "https://plex.tv/pins.xml";
    var uid = Main.getUniqueID();
    var type = getProductType();
    var model = type + " " + Main.getModelName();

    if (myPlexXhr !== null) {
        if (myPlexXhr.destroy) {
            myPlexXhr.destroy(); // Save memory
        }
        myPlexXhr = null;
    }

    if (myPlexXhr === null) {
        myPlexXhr = new XMLHttpRequest();
        if (myPlexXhr.overrideMimeType) { // needed for 2012
            myPlexXhr.overrideMimeType('text/xml');
        }
    }

    if (myPlexXhr !== null) {
        myPlexXhr.onreadystatechange = function () {
            //Main.debug("[MyPlex.js] - MyPlex.xmlObj.readyState: " + myPlexXhr.readyState);
            //Main.debug("[MyPlex.js] - MyPlex.xmlObj.status: " + myPlexXhr.status);
            if (myPlexXhr.readyState === 4) {
                if (myPlexXhr.status === 200 || myPlexXhr.status === 201) {
                    MyPlex.handlePIN(fnCallback);
                } else {
                    MyPlex.isValidAccount = 0;
                    MyPlex.getResponse(fnCallback);
                }
            }
        };

        myPlexXhr.open("POST", pUrl, true);
        myPlexXhr.setRequestHeader("X-Plex-Product", "Plex for Samsung");
        myPlexXhr.setRequestHeader("X-Plex-Platform", "Samsung");
        myPlexXhr.setRequestHeader("X-Plex-Platform-Version", Application.platformVersion);
        myPlexXhr.setRequestHeader("X-Plex-Version", Application.appVersion);
        myPlexXhr.setRequestHeader("X-Plex-Provides", "client");
        myPlexXhr.setRequestHeader("X-Plex-Client-Identifier", uid);
        myPlexXhr.setRequestHeader("X-Plex-Device", model);
        myPlexXhr.send();
    }
};

MyPlex.handlePIN = function (fnCallback) {
    //analyse the pin response and show the user what to do
    var xmlElement = myPlexXhr.responseXML.documentElement;

    //get the location header

    MyPlex.pinUrl = myPlexXhr.getResponseHeader("Location");

    if (!xmlElement) {
        Main.debug("[MyPlex.js] - Failed to get valid XML");
        MyPlex.isValidAccount = 0;
        this.enabled = false;
        pinUrl
    } else {
        MyPlex.pinCode = $(xmlElement).find('code').text();
        MyPlex.pinExpires = $(xmlElement).find('expires-at ').text();
        MyPlex.authToken = $(xmlElement).find('auth_token').text();
        MyPlex.plexPass = $(xmlElement).find("subscription").attr("active");
    }

//    Main.debug("[MyPlex.js] - pinUrl: " + MyPlex.pinUrl);
//    Main.debug("[MyPlex.js] - pinCode: " + MyPlex.pinCode);
//    Main.debug("[MyPlex.js] - pinExpires: " + MyPlex.pinExpires);
//    Main.debug("[MyPlex.js] - authToken: " + MyPlex.authToken);
//    Main.debug("[MyPlex.js] - plexPass: " + MyPlex.plexPass);

    fnCallback("TRUE");
};

MyPlex.pollPIN = function (fnCallback) {
    var uid = Main.getUniqueID();

    if (myPlexXhr !== null) {
        if (myPlexXhr.destroy) {
            myPlexXhr.destroy(); // Save memory
        }
        myPlexXhr = null;
    }

    if (myPlexXhr === null) {
        myPlexXhr = new XMLHttpRequest();
        if (myPlexXhr.overrideMimeType) // needed for 2012
        {
            myPlexXhr.overrideMimeType('text/xml');
        }
    }

    if (myPlexXhr !== null) {
        myPlexXhr.onreadystatechange = function () {
            //Main.debug("[MyPlex.js] - MyPlex.xmlObj.readyState: " + myPlexXhr.readyState);
            //Main.debug("[MyPlex.js] - MyPlex.xmlObj.status: " + myPlexXhr.status);
            if (myPlexXhr.readyState === 4) {
                if (myPlexXhr.status === 200 || myPlexXhr.status === 201) {
                    MyPlex.handlePollPIN(fnCallback);
                } else {
                    fnCallback("FALSE");
                }
            }
        };

        myPlexXhr.open("GET", MyPlex.pinUrl + ".xml", true);
        myPlexXhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
        myPlexXhr.setRequestHeader("X-Plex-Client-Identifier", uid);
        myPlexXhr.send();
    }
};

MyPlex.handlePollPIN = function (fnCallback) {
    //analyse the pin response and show the user what to do
    var xmlElement = myPlexXhr.responseXML.documentElement;

    if (!xmlElement) {
        Main.debug("[MyPlex.js] - Failed to get valid XML");
        fnCallback("FALSE");
    } else {
        MyPlex.authToken = $(xmlElement).find('auth_token').text();
    }

    if (MyPlex.authToken.length > 0) {
        fnCallback("TRUE");
    } else {
        fnCallback("FALSE");
    }

};

MyPlex.login = function (id, pw, fnCallback)  //only needed for manual login with name and password
{
    MyPlex.userName = id;
    MyPlex.userPassword = pw;

    Main.debug("[MyPlex.js] - Attempting SSO Plex Account login");
    var bURL = "https://plex.tv/users/sign_in.xml";
    var uid = Main.getUniqueID();
    var xhrTimeout = null;
    //var type = getProductType();
    //var model = type + " " + Main.getModelName();

    var auth = window.btoa(id + ":" + pw);

    if (myPlexXhr !== null) {
        if (myPlexXhr.destroy) {
            myPlexXhr.destroy(); // Save memory
        }
        myPlexXhr = null;
    }

    if (myPlexXhr === null) {
        myPlexXhr = new XMLHttpRequest();
    }

    if (myPlexXhr !== null) {
        myPlexXhr.onreadystatechange = function () {
            //Main.debug("[MyPlex.js] - MyPlex.xmlObj.readyState: " + myPlexXhr.readyState);
            if (myPlexXhr.readyState === 4) {
                clearTimeout(xhrTimeout);
                //Main.debug("[MyPlex.js] - myPlexXhr.status: " + myPlexXhr.status);
                if (myPlexXhr.status === 200 || myPlexXhr.status === 201) {
                    MyPlex.receivebrowserXHRResponse(fnCallback);
                } else if (myPlexXhr.status === 404 || myPlexXhr.status >= 500) {
                    //myPlex is offline, keep the token
                    fnCallback("OFFLINE");
                    MyPlex.loggedIn = false;
                } else {
                    MyPlex.logout();
                    MyPlex.isValidAccount = 0;
                    MyPlex.getResponse(fnCallback);
                }
            }
        };

        myPlexXhr.open("POST", bURL, true);

        if (myPlexXhr.overrideMimeType) { // needed for 2012
            myPlexXhr.overrideMimeType('text/xml');
        }

        myPlexXhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
        myPlexXhr.setRequestHeader("Authorization", "Basic " + auth);
        myPlexXhr.setRequestHeader("X-Plex-Product", "Plex for Samsung");
        myPlexXhr.setRequestHeader("X-Plex-Platform", "Samsung");
        myPlexXhr.setRequestHeader("X-Plex-Client-Platform", "Samsung");
        myPlexXhr.setRequestHeader("X-Plex-Platform-Version", Application.platformVersion);
        myPlexXhr.setRequestHeader("X-Plex-Version", Application.appVersion);
        myPlexXhr.setRequestHeader("X-Plex-Provides", "client");
        myPlexXhr.setRequestHeader("X-Plex-Client-Identifier", uid);

        myPlexXhr.send();

        // Timeout to abort in 10 seconds
        xhrTimeout = setTimeout(function () {
            if (myPlexXhr.abort) {
                myPlexXhr.abort();
            }
            if (myPlexXhr.destroy) {
                myPlexXhr.destroy();
            }
            Main.debug("[MyPlex.js] - login attempt timed out");
            fnCallback("OFFLINE");
        }, 10000);
    }
};

MyPlex.loginWithToken = function (fnCallback) {
    Main.debug("[MyPlex.js] - Attempting MyPlex login with Token");
    var bURL = "https://plex.tv/users/sign_in.xml?auth_token=" + MyPlex.authToken;
    var uid = Main.getUniqueID();
    var type = getProductType();
    var model = type + " " + Main.getModelName();
    var xhrTimeout = null;

    if (myPlexXhr !== null) {
        if (myPlexXhr.destroy) {
            myPlexXhr.destroy(); // Save memory
        }
        myPlexXhr = null;
    }

    if (myPlexXhr === null) {
        myPlexXhr = new XMLHttpRequest();
        if (myPlexXhr.overrideMimeType) // needed for 2012
        {
            myPlexXhr.overrideMimeType('text/xml');
        }
    }

    if (myPlexXhr !== null) {
        myPlexXhr.onreadystatechange = function () {
            //Main.debug("[MyPlex.js] - MyPlex.xmlObj.readyState: " + myPlexXhr.readyState);
            if (myPlexXhr.readyState === 4) {
                //Main.debug("[MyPlex.js] - myPlexXhr.status: " + myPlexXhr.status);
                clearTimeout(xhrTimeout);
                if (myPlexXhr.status === 200 || myPlexXhr.status === 201) {
                    MyPlex.receivebrowserXHRResponse(fnCallback);
                } else if (myPlexXhr.status === 404 || myPlexXhr.status >= 500) {
                    //myPlex is offline, keep the token
                    fnCallback("OFFLINE");
                    MyPlex.loggedIn = false;
                } else {
                    MyPlex.logout();
                    MyPlex.isValidAccount = 0;
                    MyPlex.getResponse(fnCallback);
                }
            }
        };

        myPlexXhr.open("POST", bURL, true);
        myPlexXhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
        myPlexXhr.setRequestHeader("X-Plex-Product", "Plex for Samsung");
        myPlexXhr.setRequestHeader("X-Plex-Platform", "Samsung");
        myPlexXhr.setRequestHeader("X-Plex-Platform-Version", Application.platformVersion);
        myPlexXhr.setRequestHeader("X-Plex-Version", Application.appVersion);
        myPlexXhr.setRequestHeader("X-Plex-Provides", "client");
        myPlexXhr.setRequestHeader("X-Plex-Client-Identifier", uid);
        myPlexXhr.setRequestHeader("X-Plex-Device", model);

        myPlexXhr.send();

        // Timeout to abort in 10 seconds
        xhrTimeout = setTimeout(function () {
            if (myPlexXhr.abort) {
                myPlexXhr.abort();
            }
            if (myPlexXhr.destroy) {
                myPlexXhr.destroy();
            }
            Main.debug("[MyPlex.js] - login attempt timed out");
            fnCallback("OFFLINE");
        }, 10000);
    }
};

MyPlex.receivebrowserXHRResponse = function (fnCallback) {

    //Main.debug("[MyPlex.js] - responseText: " + myPlexXhr.responseText);

    var xmlElement = myPlexXhr.responseXML.documentElement;

    if (!xmlElement) {
        Main.debug("[MyPlex.js] - Failed to get valid XML");
        MyPlex.isValidAccount = 0;
        this.enabled = false;
    } else {
        MyPlex.userName = $(xmlElement).find('username').text();
        MyPlex.userEmail = $(xmlElement).find('email').text();
        MyPlex.userJoinedAt = $(xmlElement).find('joined-at').text();
        MyPlex.authToken = $(xmlElement).find('authentication-token').text();
        MyPlex.plexPass = $(xmlElement).find("subscription").attr("active");
        MyPlex.enabled = true;

        prefs.myplex.username = MyPlex.userName;
        prefs.myplex.userEmail = MyPlex.userEmail;
        prefs.myplex.userJoinedAt = MyPlex.userJoinedAt;
        prefs.myplex.password = MyPlex.userPassword;
        prefs.myplex.authToken = MyPlex.authToken;
        prefs.myplex.plexPass = MyPlex.plexPass;
        prefs.myplex.autoLogin = "on";

        Main.savePrefs();

        //Main.debug("[MyPlex.js] - user_name: " + MyPlex.userName);
        //Main.debug("[MyPlex.js] - user_email: " + MyPlex.userEmail);
        //Main.debug("[MyPlex.js] - user_joinedat: " + MyPlex.userJoinedAt);
        //Main.debug("[MyPlex.js] - user_token: " + MyPlex.authToken);
        //Main.debug("[MyPlex.js] - plexPass: " + MyPlex.plexPass);
        MyPlex.isValidAccount = 1;
    }

    MyPlex.getResponse(fnCallback);
};

MyPlex.getResponse = function (fnCallback) {
    if (MyPlex.isValidAccount === 1) {
        fnCallback("TRUE");
        MyPlex.loggedIn = true;
    } else {
        fnCallback("FALSE");
        MyPlex.loggedIn = false;
    }
};

MyPlex.getServerList = function (callback, updatelist) {
    if ((prefs.myplex.authToken || "") !== "") {
        var url = "https://plex.tv/pms/servers/?X-Plex-Token=" + prefs.myplex.authToken;

        Main.debug("[MyPlex.js] - getServerList: " + url);

        AjaxManager.parseHTTP(url, function (tree, xhr, id) {

            if (xhr === null) {
                Main.debug("[MyPlex.js] - getServerList failed");
                if (callback)
                    callback();
                return false;
            }

            if (xhr.status !== 200) {
                Main.debug("[MyPlex.js] - getServerList Error: " + xhr.status);
                if (callback)
                    callback();
                return false;
            } else {
                if (tree) {

                    if (updatelist) {
                        prefs.servers = [];
                    }

                    $.each(tree.MediaContainer.Server, function () {
                        Main.debug("[MyPlex.js] - found server: " + this["-name"]);
                        var ips = (this["-localAddresses"] || "");
                        var locAddr = [];
                        if (ips.contains(',')) {
                            locAddr = ips.split(','); //make an array of ip adresses
                        } else if (ips == "") {
                            locAddr = [];
                        } else {
                            locAddr.push(ips);
                        }
                        var server =
                        {
                            accessToken: (this["-accessToken"] || ""),
                            name: (this["-name"] || ""),
                            address: (this["-address"] || ""),
                            port: (this["-port"] || ""),
                            version: (this["-version"] || ""),
                            scheme: (this["-scheme"] || "http"),
                            host: (this["-host"] || ""),
                            localAddresses: locAddr,
                            machineIdentifier: (this["-machineIdentifier"] || ""),
                            createdAt: (this["-createdAt"] || ""),
                            updatedAt: (this["-updatedAt"] || ""),
                            owned: (this["-owned"] || "0"),
                            synced: (this["-synced"] || "0"),
                            url: "",
                            ip: "",
                            reachable: "no"
                        };

                        if (locAddr.length > 0) {
                            server.url = server.scheme + "://" + locAddr[0] + ":32400";
                            server.ip = locAddr[0];
                        } else {
                            server.url = server.scheme + "://" + server.address + ":" + server.port;
                            server.ip = server.address;
                        }

                        //Main.debug("[MyPlex.js] - server.synced: " + server.synced);
                        Main.debug("[MyPlex.js] - server.ip: " + server.ip);

                        if (updatelist) {
                            var found = false;
                            for (var i = 0; i < prefs.servers.length; i++) {
                                if (prefs.servers[i].machineIdentifier == server.machineIdentifier) {
                                    $.extend(true, prefs.servers[i], server);
                                    found = true;
                                    break;
                                }
                            }

                            if (!found) {
                                prefs.servers.push(server);
                            }
                        }
                    });

                    Main.savePrefs();
                    Main.debug("[MyPlex.js] - Server count: " + prefs.servers.length);

                }
                if (callback)
                    callback();
            }
        }, null, 0, "myPlexServerlist", null);
    } else {
        if (callback)
            callback();
    }
};

MyPlex.checkAccount = function (id, pw, fnCallback) {
    MyPlex.login(id, pw, fnCallback);
};



