var Network =
{
    plugin: null
};

Network.init = function () {
    var success = true;
    Network.plugin = document.getElementById("pluginObjectNetwork");

    if (!Network.plugin) {
        success = false;
    }
    Main.debug("[Network.js] - Network Plugin initialized success vale:  [" + success + "]");
    return success;
};

Network.GetIP = function () {
    var ip = "";
    try //noinspection JSConstructorReturnsPrimitive,JSConstructorReturnsPrimitive
    {
        var conn = Network.plugin.GetActiveType();
        if (conn > -1) {
            ip = Network.plugin.GetIP(conn);
        } else {
            ip = Network.plugin.GetIP();
        }
        return ip;
    }
    catch (err) {
        Main.debug("Network.GetIP error : " + err);
    }
    return ip;
};
Network.getConnectionType = function() {
    if (Network.plugin.CheckPhysicalConnection(1) == 1) {
        return "lan";
    } else if (Network.plugin.CheckPhysicalConnection(0) == 1) {
        return "wlan";
    } else {
        return "error";
    }
};

Network.checkHTTP = function() {
    if (Network.plugin.CheckPhysicalConnection(1) == 1) {
        Main.debug("[Network.js] - Wired connection is OK");
        return true;
    } else if (Network.plugin.CheckPhysicalConnection(0) == 1) {
        Main.debug("[Network.js] - Wireless connection is OK");
        return true;
    } else {
        Main.debug("[Network.js] - Network connection failed");
        return false;
    }
};

Network.CheckGateway = function() {
    if (Network.plugin.CheckGateway(1) == 1) {
        Main.debug("[Network.js] - Gateway is reachable");
        return true;
    } else if (Network.plugin.CheckGateway(0) == 1) {
        Main.debug("[Network.js] - Gateway unreachable");
        return false;
    } else { //noinspection JSConstructorReturnsPrimitive
        {
                Main.debug("[Network.js] - Gateway connection failed");
                return false;
            }
    }
};

Network.validIP = function() {
    var mac = Network.plugin.GetIP();
    if (Network.plugin.IsValidMAC(1) == 1 && Network.plugin.IsValidIP(1) == 1
        && Network.plugin.IsValidSubnetMask(1) == 1
        && Network.plugin.IsValidGateway(1) == 1
        && Network.plugin.IsValidDNS(1) == 1) {
        Main.debug("[Network.js] - TV IP: " + mac);
        return true;
    } else {
        Main.debug("[Network.js] - Error retrieving TV IP Address");
        return false;
    }
};