var PlexRequest = {
    callback: null,
    tree: null,

    containerType: "",
    viewGroup: "",
    popup: false,
    message: "",
    header: ""
};

PlexRequest.fetchUrl = function (url, callback, start, size) {

    PlexRequest.callback = null;
    PlexRequest.tree = null;
    PlexRequest.viewGroup = "";
    PlexRequest.containerType = "";
    PlexRequest.popup = "";
    PlexRequest.header = "";
    PlexRequest.message = "";

    var timeout = 0;
    var plexurl = url; //don't change the original url!

    if (callback)
        PlexRequest.callback = callback;

    if (!isEmpty(start)) {
        this.start = start;
        if (url.contains("?"))
            url += "&X-Plex-Container-Start=" + start + "&X-Plex-Container-Size=" + size;
        else
            url += "?X-Plex-Container-Start=" + start + "&X-Plex-Container-Size=" + size;
    }

    var pUrl = Main.server.resolveUrl(plexurl, false, true);
    Main.debug("[PlexRequest.js] - url: " + pUrl);

    AjaxManager.parseHTTP(pUrl, PlexRequest.handleFetchUrl, null, timeout, "plexRequest");
};

PlexRequest.handleFetchUrl = function (tree, xhrObj) {
    if (xhrObj === null) {
        PlexRequest.handleError(); //timeout occured
        return false;
    }

    if (xhrObj.status !== 200) {
        PlexRequest.handleError(xhrObj); //timeout occured
        return false;
    }

    if (tree) {

        //lets see what we have
        //var strTree = JSON.stringify(tree, null ,4);
        var name = "";
        if (tree.MediaContainer) {
            PlexRequest.viewGroup = (tree.MediaContainer["-viewGroup"] || "");
            PlexRequest.header = (tree.MediaContainer["-header"] || "");
            PlexRequest.message = (tree.MediaContainer["-message"] || "");

            if (tree.MediaContainer.Directory) {
                PlexRequest.containerType = "Directory";

                name = (tree.MediaContainer.Directory[0]["-title"] || tree.MediaContainer.Directory[0]["-name"] || "").toLowerCase();
                var cmd = ('update|restart|reset|install|uninstall');
                PlexRequest.popup  = (name.match(cmd) === null) ? false : true;
                
            } else {
                
                if (tree.MediaContainer.Video) {
                    PlexRequest.containerType = "Video";
                }

                if (tree.MediaContainer.Track) {
                    PlexRequest.containerType = "Track";
                }

                if (tree.MediaContainer.Photo) {
                    PlexRequest.containerType = "Photo";
                }

                if (tree.MediaContainer.Artist) {
                    PlexRequest.containerType = "Artist";
                }

                if (tree.MediaContainer.Album) {
                    PlexRequest.containerType = "Album";
                }

                if (tree.MediaContainer.Playlist) {
                    PlexRequest.containerType = "Playlist";
                }

                if (tree.MediaContainer.Genre) {
                    PlexRequest.containerType = "Genre";
                }

                if (tree.MediaContainer.Podcast) {
                    PlexRequest.containerType = "Podcast";
                }

                if (tree.MediaContainer.Server) {
                    PlexRequest.containerType = "Server";
                }
            }
        }

        if (tree.ASContainer) {
            if (tree.ASContainer.Directory)
                PlexRequest.containerType = "Directory";
            name = (tree.ASContainer.Directory[0]["-title"] || tree.ASContainer.Directory[0]["-name"] || "").toLowerCase();
            if (name === "update" ||
                name === "restart" ||
                name === "reset" ||
                name === "install" ||
                name === "uninstall") {
                PlexRequest.popup = true;
            } else {
                PlexRequest.popup = false;
            }
        }

        if (PlexRequest.callback) {
            PlexRequest.callback();
        }
    }
};

PlexRequest.handleError = function (xhrObj) {
    if (xhrObj) {
        if (xhrObj.status === 401) {
            //Main.showInfo(text.errorPMS401);
            Main.debug("[PlexRequest.js] - Couldn't connect to PMS, Status: Unauthorized");
        }
        else {
            //Main.showInfo(text.errorPMS);
            Main.debug("[PlexRequest.js] - Couldn't connect to server, status" + xhrObj.status);
        }
    }
    else {
        //Main.showInfo(text.errorTimeout);
        Main.debug("[PlexRequest.js] - Couldn't connect to PMS, a timeout occurred");
    }

    if (PlexRequest.callback) {
        PlexRequest.callback();
    }
};