var Popup = {
    INFO: 1,
    WARNING: 2,
    ERROR: 3,
    QUESTION: 4,
    ADDIP: 4,
    NUMBER: 5,
    SPINNER: 6,
    COLOR: 7,
    CHOICE: 8,
    MSGBOX: 9,
    WIZARD: 10,
    status: 0,
    controls: [],
    curCtrl: 0,
    minVal: 0,
    maxVal: 1,
    input: null,
    callback: null,
    returnValue: null,
    keyDown: function () {
        var keyCode = event.keyCode;

        if (keyLock.checkKey(keyCode)) {
            Main.debug("[Popup.js] - Key pressed: [" + keyCode + "]");
            switch (keyCode) {
                case tvKey.KEY_RETURN:
                case tvKey.KEY_PANEL_RETURN:
                    Main.debug("[Popup.js] - RETURN");
                    widgetAPI.blockNavigation(event);
                    Popup.returnValue = null;
                    Popup.hide();
                    break;
                case tvKey.KEY_EXIT:
                    Main.debug("[Popup.js] - EXIT");
                    widgetAPI.blockNavigation(event);
                    Player.deinit();
                    widgetAPI.sendExitEvent();
                    break;
                case tvKey.KEY_ENTER:
                case tvKey.KEY_PANEL_ENTER:
                case tvKey.KEY_JOYSTICK_DOWN:
                    Main.debug("[Popup.js] - ENTER");
                    Popup.handleEnter();
                    event.preventDefault();
                    break;
                case tvKey.KEY_RIGHT:
                    Main.debug("[Popup.js] - RIGHT");
                    if (Popup.status === Popup.SPINNER) {
                        Popup.setSpinner("up");
                    } else {
                        Popup.moveFocus("next");
                    }
                    break;
                case tvKey.KEY_LEFT:
                    Main.debug("[Popup.js] - LEFT");
                    if (Popup.status === Popup.SPINNER) {
                        Popup.setSpinner("down");
                    } else {
                        Popup.moveFocus("previous");
                    }
                    break;
                case tvKey.KEY_UP:
                    Main.debug("[Popup.js] - UP");
                    Popup.moveFocus("previous");
                    break;
                case tvKey.KEY_DOWN:
                    Main.debug("[Popup.js] - DOWN");
                    Popup.moveFocus("next");
                    break;
                case tvKey.KEY_0:
                    Main.debug("[Popup.js] - NUM0");
                    Popup.handleNumkey('0');
                    event.preventDefault();
                    break;
                case tvKey.KEY_1:
                    Main.debug("[Popup.js] - NUM1");
                    Popup.handleNumkey('1');
                    event.preventDefault();
                    break;
                case tvKey.KEY_2:
                    Main.debug("[Popup.js] - NUM2");
                    Popup.handleNumkey('2');
                    event.preventDefault();
                    break;
                case tvKey.KEY_3:
                    Main.debug("[Popup.js] - NUM3");
                    Popup.handleNumkey('3');
                    event.preventDefault();
                    break;
                case tvKey.KEY_4:
                    Main.debug("[Popup.js] - NUM4");
                    Popup.handleNumkey('4');
                    event.preventDefault();
                    break;
                case tvKey.KEY_5:
                    Main.debug("[Popup.js] - NUM5");
                    Popup.handleNumkey('5');
                    event.preventDefault();
                    break;
                case tvKey.KEY_6:
                    Main.debug("[Popup.js] - NUM6");
                    Popup.handleNumkey('6');
                    event.preventDefault();
                    break;
                case tvKey.KEY_7:
                    Main.debug("[Popup.js] - NUM7");
                    Popup.handleNumkey('7');
                    event.preventDefault();
                    break;
                case tvKey.KEY_8:
                    Main.debug("[Popup.js] - NUM8");
                    Popup.handleNumkey('8');
                    event.preventDefault();
                    break;
                case tvKey.KEY_9:
                    Main.debug("[Popup.js] - NUM9");
                    Popup.handleNumkey('9');
                    event.preventDefault();
                    break;
                case 259:
                case tvKey.KEY_BLUE:
                    Main.debug("[Popup.js] - BLUE/DELETE");
                    Popup.handleDKey();
                    break;
                default:
                    Main.debug("[Popup.js] - Unhandled key");
                    break;
            }
        }
    },
    init: function (callback) {
        keyLock.status = keyLock.BLOCKALL;
        if (callback) {
            Popup.callback = callback;
        } else {
            Popup.callback = null;
        }
        Popup.controls = [];
        $("#popupStatus").putInnerHTML('');
        $("#popup-overlay").show();
    },
    show: function () {
        var top = (540 - $("#popup").outerHeight()) / 2;
        $("#popup").css({"top": top, "left": 155});
        loadbar.hide();
        Popup.moveFocus();
        $("#popup").css({"visibility": "visible"});
        $("#popupAnchor").focus();
        keyLock.status = keyLock.NONE;
    },
    hide: function () {
        keyLock.status = keyLock.BLOCKALL;
        $("#popup").css({"visibility": "hidden"});
        $("#popup-overlay").hide();
        $("#popupLabel").text("").css('color', 'white');
        $("#popupContent").putInnerHTML("");
        $("#popupButtons").putInnerHTML("");
        $("#popupHelp").putInnerHTML("");

        Popup.status = 0;
        Popup.curCtrl = 0;

        if (Popup.callback) {
            Main.debug("[Popup.js] - returnValue: " + Popup.returnValue);
            Popup.callback(Popup.returnValue);
        }

        $("#anchor").focus(); //return focus to the main page
        keyLock.status = keyLock.NONE;
    },
    showWizard: function (labeltext, contenttext, buttons, callback) {
        Popup.init(callback);
        var bnt = "";

        $("#popupLabel").putInnerHTML('<img id="popupIcon" src="Images/button/info-white-32.png" style="padding-bottom: 12px; vertical-align: middle;"/>&nbsp;' + labeltext);
        $("#popupLabel").css('color', 'white');
        $("#popupContent").putInnerHTML(contenttext);

        for (var i = 0; i < buttons.length; i++) {
            bnt += '<input type="button" id="button' + i + '" name="button' + i + '" class="popupButton" value="' + buttons[i] + '" onkeydown="Popup.keyDown();"/>';
            Popup.controls.push("button" + i);
        }

        $("#popupButtons").putInnerHTML(bnt);

        $("#popupHelp").putInnerHTML('<div class="bottomTextRight bottomTextFlow">' + text.back + '</div><div class="bottomTexture"><img src="Images/navi/return.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.enter + '</div><div class="bottomTexture"><img src="Images/navi/enter.png"/></div>');
        Popup.curCtrl = 0;
        Popup.status = Popup.WIZARD;
        Popup.show();
    },
    showMessage: function (popuptype, labeltext, contenttext, buttontext, callback) {
        Popup.init(callback);

        if (popuptype === Popup.WARNING) {
            $("#popupLabel").css('color', '#FD9800').putInnerHTML('<img id="popupIcon" src="Images/button/warning-32.png" style="padding-bottom: 12px; vertical-align: middle;"/>&nbsp;' + labeltext);
        } else if (popuptype === Popup.ERROR) {
            $("#popupLabel").css('color', 'red').putInnerHTML('<img id="popupIcon" src="Images/button/error-32.png" style="padding-bottom: 12px; vertical-align: middle;"/>&nbsp;' + labeltext);
        } else {
            $("#popupLabel").css('color', 'white').putInnerHTML('<img id="popupIcon" src="Images/button/info-white-32.png" style="padding-bottom: 12px; vertical-align: middle;"/>&nbsp;' + labeltext);
        }

        $("#popupContent").putInnerHTML(contenttext);
        $("#popupButtons").putInnerHTML('<input type="button" id="buttonOK" name="buttonOK" class="popupButton" value=" ' + buttontext + ' " onkeydown="Popup.keyDown();"/>');
        $("#popupHelp").putInnerHTML('<div class="bottomTextRight bottomTextFlow">' + text.back + '</div><div class="bottomTexture"><img src="Images/navi/return.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.enter + '</div><div class="bottomTexture"><img src="Images/navi/enter.png"/></div>');

        Popup.controls.push("buttonOK");
        Popup.status = Popup.MSGBOX;
        Popup.show();
    },
    showNumberInput: function (labeltext, contenttext, buttontext, min, max, value, callback) {
        Popup.init(callback);
        Popup.returnValue = value;
        Popup.minVal = min;
        Popup.maxVal = max;

        $("#popupLabel").putInnerHTML(labeltext);
        $("#popupContent").putInnerHTML(contenttext + '<br><br>');
        $("#popupContent").append('<input type="text" id="textbox0" name="textbox0" class="popupTextBox" maxlength="4" size="5" onkeydown="Popup.keyDown();" value="' + value + '"/>');
        $("#popupHelp").putInnerHTML('<div class="bottomTextRight bottomTextFlow">' + text.back + '</div><div class="bottomTexture"><img src="Images/navi/return.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.enter + '</div><div class="bottomTexture"><img src="Images/navi/enter.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.backspace + '</div><div class="bottomTexture"><img src="Images/navi/D.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.input + '</div><div class="bottomTexture"><img src="Images/navi/09.png"/></div>');

        Popup.controls.push("textbox0");
        Popup.status = Popup.NUMBER;
        Popup.show();
    },
    showSpinner: function (labeltext, contenttext, buttontext, min, max, value, callback) {
        Popup.init(callback);
        Popup.returnValue = value;
        Popup.minVal = min;
        Popup.maxVal = max;

        $("#popupLabel").putInnerHTML(labeltext);
        $("#popupContent").putInnerHTML(contenttext + '<br><br>');
        $("#popupContent").append('<input type="button" id="dummy0" name="dummy0" class="dummyButton" value="<" />' +
            '<input type="button" id="spinner0" name="spinner0" class="popupTextBox"  width="35px" onkeydown="Popup.keyDown();" value="' + value + '" readonly/>' +
            '<input type="button" id="dummy1" name="dummy1" class="dummyButton" value=">" />');

        $("#popupButtons").putInnerHTML('');
        $("#popupHelp").putInnerHTML('<div class="bottomTextRight bottomTextFlow">' + text.back + '</div><div class="bottomTexture"><img src="Images/navi/return.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.enter + '</div><div class="bottomTexture"><img src="Images/navi/enter.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.changeValue + '</div><div class="bottomTexture"><img src="Images/navi/lr.png"/></div>');

        Popup.controls.push("spinner0");
        Popup.status = Popup.SPINNER;
        Popup.show();
    },
    setSpinner: function (direction) {
        var ctrl = document.getElementById(Popup.controls[Popup.curCtrl]);
        if ($(ctrl).attr('id').startsWith("spinner")) {
            var val = $('#' + Popup.controls[Popup.curCtrl]).val();
            if (direction === "up") {
                val++;
                if (val >= Popup.maxVal) {
                    val = Popup.maxVal;
                }
            } else if (direction === "down") {
                val--;
                if (val < Popup.minVal) {
                    val = Popup.minVal;
                }
            }
            Popup.returnValue = val;
            $('#' + Popup.controls[Popup.curCtrl]).val(val);
        }
    },
    showColorPicker: function (labeltext, contenttext, value, callback) {
        Popup.init(callback);
        Popup.returnValue = value;

        $("#popupLabel").putInnerHTML(labeltext);
        $("#popupContent").putInnerHTML(contenttext + '<br><br>');
        $("#popupButtons").putInnerHTML('<input type="button" id="button0" name="button0" class="popupButton" value="white" style="background-color: white; color: black;" onkeydown="Popup.keyDown();"/>' +
            '<input type="button" id="button1" name="button1" class="popupButton" value="black" style="background-color: black; color: white;" onkeydown="Popup.keyDown();"/>' +
            '<input type="button" id="button2" name="button2" class="popupButton" value="red" style="background-color: red; color: white;" onkeydown="Popup.keyDown();"/>' +
            '<input type="button" id="button3" name="button3" class="popupButton" value="green" style="background-color: green; color: white;" onkeydown="Popup.keyDown();"/>' +
            '<input type="button" id="button4" name="button4" class="popupButton" value="yellow" style="background-color: yellow; color: black;" onkeydown="Popup.keyDown();"/>' +
            '<input type="button" id="button5" name="button5" class="popupButton" value="orange" style="background-color: orange; color: black;" onkeydown="Popup.keyDown();"/>' +
            '<input type="button" id="button6" name="button6" class="popupButton" value="grey" style="background-color: grey; color: white;" onkeydown="Popup.keyDown();"/>');

        $("#popupHelp").putInnerHTML('<div class="bottomTextRight bottomTextFlow">' + text.back + '</div><div class="bottomTexture"><img src="Images/navi/return.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.enter + '</div><div class="bottomTexture"><img src="Images/navi/enter.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.navigate + '</div><div class="bottomTexture"><img src="Images/navi/lr.png"/></div>');

        Popup.controls.push("button0");
        Popup.controls.push("button1");
        Popup.controls.push("button2");
        Popup.controls.push("button3");
        Popup.controls.push("button4");
        Popup.controls.push("button5");
        Popup.controls.push("button6");

        Popup.curCtrl = 0;
        for (var i = 0; i < Popup.controls.length; i++) {
            if ($('#' + Popup.controls[i]).val() === Popup.returnValue) {
                Popup.curCtrl = i;
            }
        }

        Popup.status = Popup.COLOR;
        Popup.show();
    },
    showIPAddress: function (labeltext, contenttext, ip, callback) {
        Popup.init(callback);
        Popup.minVal = 0;
        Popup.maxVal = 255;

        var ipParts;
        var val0 = "";
        var val1 = "";
        var val2 = "";
        var val3 = "";
        var val4 = "32400";

        if (ip.contains(':')) {
            ipParts = ip.split(':');
            val4 = (ipParts[1]) ? ipParts[1] : "32400";
            ipParts = ipParts[0];
        }

        if (ip.contains('.')) {
            ipParts = ip.split('.');
            val0 = ipParts[0];
            val1 = ipParts[1];
            val2 = ipParts[2];
            val3 = ipParts[3];
        }

        $("#popupLabel").putInnerHTML(text.connectToLocalServer);
        $("#popupContent").putInnerHTML(text.enterIPAddress + '<br><br>');
        $("#popupContent").append('<input type="text" id="ipTextbox0" name="ipTextbox0" class="popupTextBox" maxlength="3" size="4" onkeydown="Popup.keyDown();" value="' + val0 + '"/>' +
            ' . <input type="text" id="ipTextbox1" name="ipTextbox1" class="popupTextBox" maxlength="3" size="4" onkeydown="Popup.keyDown();" value="' + val1 + '"/>' +
            ' . <input type="text" id="ipTextbox2" name="ipTextbox2" class="popupTextBox" maxlength="3" size="4" onkeydown="Popup.keyDown();" value="' + val2 + '"/>' +
            ' . <input type="text" id="ipTextbox3" name="ipTextbox3" class="popupTextBox" maxlength="3" size="4" onkeydown="Popup.keyDown();" value="' + val3 + '"/>' +
            ' : <input type="text" id="ipTextbox4" name="ipTextbox4" class="popupTextBox" maxlength="5" size="6" onkeydown="Popup.keyDown();" value="' + val4 + '"/>');

        $("#popupButtons").putInnerHTML('<input type="button" id="buttonOK" name="buttonOK" class="popupButton" value="Add Server" onkeydown="Popup.keyDown();"/>');
        $("#popupHelp").putInnerHTML('<div class="bottomTextRight bottomTextFlow">' + text.back + '</div><div class="bottomTexture"><img src="Images/navi/return.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.enter + '</div><div class="bottomTexture"><img src="Images/navi/enter.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.navigate + '</div><div class="bottomTexture"><img src="Images/navi/allDirections.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.backspace + '</div><div class="bottomTexture"><img src="Images/navi/D.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.input + '</div><div class="bottomTexture"><img src="Images/navi/09.png"/></div>');

        Popup.controls.push("ipTextbox0");
        Popup.controls.push("ipTextbox1");
        Popup.controls.push("ipTextbox2");
        Popup.controls.push("ipTextbox3");
        Popup.controls.push("ipTextbox4");
        Popup.controls.push("buttonOK");
        Popup.status = Popup.ADDIP;
        Popup.curCtrl = 0;
        Popup.show();
    },
    showChoice: function (json, choicetype, labeltext, callback) {
        //Main.debug("[Popup.js] - showChoice " + choicetype);
        var label;
        var html = "";
        var i;
        var count = 0;

        Popup.init(callback);

        if (choicetype === "Media") {
            count = json.length;
            for (i = 0; i < count; i++) {
                label = ((json[i]["-videoResolution"] || json[i]["-bitrate"] || "") + " " + (json[i]["-videoCodec"] || json[i]["-protocol"] || "") + " " + (json[i]["-container"] || "")).toUpperCase();
                html += '<input type="button" id="button' + i + '" name="button' + i + '" class="popupButton" value="' + label + '" data="' + i + '" onkeydown="Popup.keyDown();"/>';
                Popup.controls.push("button" + i);
            }
        } else if (choicetype === "Part") {
            count = json.length;
            for (i = 0; i < count; i++) {
                label = ("Part " + (i + 1));
                html += '<input type="button" id="button' + i + '" name="button' + i + '" class="popupButton" value="' + label + '" data="' + i + '" onkeydown="Popup.keyDown();"/>';
                Popup.controls.push("button" + i);
            }
        } else if (choicetype === "PLEXONLINE") {
            count = json.length;
            for (i = 0; i < count; i++) {
                html += '<input type="button" id="button' + i + '" name="button' + i + '" class="popupButton" value="' + json[i]["-title"] + '" data="' + json[i]["-key"] + '" onkeydown="Popup.keyDown();"/>';
                Popup.controls.push("button" + i);
            }
        }

        $("#popupLabel").putInnerHTML('<img id="popupIcon" src="Images/button/info-white-32.png" style="padding-bottom: 12px; vertical-align: middle;"/>&nbsp;' + labeltext);
        $("#popupContent").putInnerHTML("");
        $("#popupButtons").putInnerHTML(html);
        $("#popupHelp").putInnerHTML('<div class="bottomTextRight bottomTextFlow">' + text.back + '</div><div class="bottomTexture"><img src="Images/navi/return.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.enter + '</div><div class="bottomTexture"><img src="Images/navi/enter.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.navigate + '</div><div class="bottomTexture"><img src="Images/navi/allDirections.png"/></div>');

        Popup.curCtrl = 0;
        Popup.status = Popup.CHOICE;
        Popup.show();
    },
    showMessageBox: function (popuptype, labeltext, buttons, callback) {
        var html = "";
        var i;
        Popup.init(callback);

        if (popuptype === Popup.INFO) {
            $("#popupLabel").putInnerHTML('<img id="popupIcon" src="Images/button/info-white-32.png" style="padding-bottom: 12px; vertical-align: middle;"/>&nbsp;' + labeltext);
            $("#popupLabel").css('color', 'white');
        } else if (popuptype === Popup.QUESTION) {
            $("#popupLabel").putInnerHTML('<img id="popupIcon" src="Images/button/question-32.png" style="padding-bottom: 12px; vertical-align: middle;"/>&nbsp;' + labeltext);
            $("#popupLabel").css('color', 'white');
        } else if (popuptype === Popup.WARNING) {
            $("#popupLabel").putInnerHTML('<img id="popupIcon" src="Images/button/warning-32.png" style="padding-bottom: 12px; vertical-align: middle;"/>&nbsp;' + labeltext);
            $("#popupLabel").css('color', '#FD9800');
        } else if (popuptype === Popup.ERROR) {
            $("#popupLabel").putInnerHTML('<img id="popupIcon" src="Images/button/error-32.png" style="padding-bottom: 12px; vertical-align: middle;"/>&nbsp;' + labeltext);
            $("#popupLabel").css('color', 'red');
        }

        var count = buttons.length;
        for (i = 0; i < count; i++) {
            html += '<input type="button" id="button' + i + '" name="button' + i + '" class="popupButton" value="' + buttons[i] + '" data="' + buttons[i] + '" onkeydown="Popup.keyDown();"/>';
            Popup.controls.push("button" + i);
        }

        $("#popupContent").putInnerHTML("");
        $("#popupButtons").putInnerHTML(html);
        $("#popupHelp").putInnerHTML('<div class="bottomTextRight bottomTextFlow">' + text.back + '</div><div class="bottomTexture"><img src="Images/navi/return.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.enter + '</div><div class="bottomTexture"><img src="Images/navi/enter.png"/></div>' +
            '<div class="bottomTextRight bottomTextFlow">' + text.navigate + '</div><div class="bottomTexture"><img src="Images/navi/allDirections.png"/></div>');

        Popup.curCtrl = 0;
        Popup.status = Popup.MSGBOX;
        Popup.show();
    },
    setInputFocus: function (id) {
        event.preventDefault();
        Popup.input = null;
        Popup.input = new IME_Input(id, Popup.handleEnter, true);
    },
    getInputValue: function (id) {
        Main.debug("[Popup.js] - getInputValue: " + id);
        Popup.returnValue = $('#' + id).val();
    },
    moveFocus: function (direction) {
        try {
            document.getElementById(Popup.controls[Popup.curCtrl]).style.border = "2px solid #404040";

            if (direction === "next") {
                Popup.curCtrl++;
                if (Popup.curCtrl >= Popup.controls.length) {
                    Popup.curCtrl = 0;
                }
            }
            else if (direction === "previous") {
                Popup.curCtrl--;
                if (Popup.curCtrl < 0) {
                    Popup.curCtrl = Popup.controls.length - 1;
                }
            }
            document.getElementById(Popup.controls[Popup.curCtrl]).focus();
            document.getElementById(Popup.controls[Popup.curCtrl]).style.border = "2px solid #FD9800";

        } catch (e) {

        }
    },
    handleNumkey: function (num) {
        var ctrl = document.getElementById(Popup.controls[Popup.curCtrl]);
        if ($(ctrl).attr('type') === "text") {
            var val = ctrl.value;
            val = val.replace(/[^0-9]/g, '');

            // Main.debug("[Popup.js] - num: " + num);
            // Main.debug("[Popup.js] - textbox val before: " + val);

            if (!isNumber(val)) {
                val = num.toString();
            } else {
                val += num.toString();
            }

            val = val.toString().replace(/\D/g, '');

            if (Popup.status === Popup.NUMBER || Popup.status === Popup.ADDIP) {
                var max = Popup.maxVal;

                if (Popup.controls[Popup.curCtrl] == "ipTextbox4") { //port number
                    max = 65535;
                }

                if (parseInt(val, 10) > max) {
                    $(ctrl).val(max.toString());
                } else if (parseInt(val, 10) < Popup.minVal && val.toString().length === Popup.minVal.toString().length) {
                    $(ctrl).val(Popup.minVal.toString());
                } else {
                    $(ctrl).val(parseInt(val, 10).toString()); // removes any prefix zero's
                }
                // Main.debug("[Popup.js] - textbox val after: " + $(ctrl).val());
                Popup.returnValue = $(ctrl).val();
            }
        }
    },
    handleDKey: function () {
        var ctrl = document.getElementById(Popup.controls[Popup.curCtrl]);
        if ($(ctrl).attr('type') === "text") {
            var s = ctrl.value;
            if (s.length > 0) {
                ctrl.value = s.substring(0, ctrl.value.length - 1);
            }
        }
        Popup.returnValue = ctrl.value;
    },
    handleEnter: function () {

        //Main.debug("[Popup.js] - Current control id: " + Popup.controls[Popup.curCtrl]);

        if (Popup.status === Popup.ADDIP) {
            if (Popup.controls[Popup.curCtrl] === "buttonOK") {
                var ip = $('#ipTextbox0').val().trim() + "." + $('#ipTextbox1').val().trim() + "." + $('#ipTextbox2').val().trim() + "." + $('#ipTextbox3').val().trim();
                var port = $('#ipTextbox4').val().trim();
                if (ip.isValidIPV4()) {
                    if (port == "")
                        port = "32400";

                    var base = "http://" + ip + ":" + port;
                    var url;

                    if (MyPlex.loggedIn) {
                        url = base + "/?X-Plex-Token=" + prefs.myplex.authToken;
                    } else {
                        url = base + "/";
                    }

                    Main.debug("[Popup.js] - Try url: " + url);
                    $("#popupStatus").text("Trying to contact server, please wait...");

                    AjaxManager.parseHTTP(url, Popup.handleIPAddress, null, 5000, url);
                    return false;
                } else {
                    $("#popupStatus").text(ip + " is not a valid IPV4 address");
                    return false;
                }
            } else {
                Popup.moveFocus("next");
                return false;
            }
        }
        else if (Popup.status === Popup.NUMBER) {
            var val = $("#textbox0").val();
            if (isEmpty(val) || val > Popup.maxVal || val < Popup.minVal) {
                $("#popupStatus").text(val + " is not within the expected range");
                return false;
            } else {
                Popup.returnValue = val;
            }
        }
        else if (Popup.status === Popup.COLOR) {
            Popup.returnValue = $("#" + Popup.controls[Popup.curCtrl]).val();
        } else if (Popup.status === Popup.CHOICE || Popup.status === Popup.MSGBOX) {
            Popup.returnValue = $("#" + Popup.controls[Popup.curCtrl]).attr("data");
        } else {
            if ($('#' + Popup.controls[Popup.curCtrl]).attr('type') === "button") {
                Popup.returnValue = $("#" + Popup.controls[Popup.curCtrl]).val();
            }
        }

        Popup.hide();
    },
    handleIPAddress: function (tree, xhrObj, id) {
        if (xhrObj !== null) {
            if (xhrObj.status === 200) {
                if (tree) {

                    var url = (id.contains('?')) ? id.leftFromLast("?") : id;
                    var ip = url.between("http://", ":");
                    var port = url.rightFromLast(":");

                    if (port.endsWith("/")) {
                        port = port.leftFromLast("/");
                    }

                    Main.debug("[Popup.js] - Adding new server with url: " + url);
                    Main.debug("[Popup.js] - Adding new server with ip: " + ip);
                    Main.debug("[Popup.js] - Adding new server with port: " + port);

                    var newserver = {};
                    newserver.accessToken = (prefs.myplex.authToken || "");
                    newserver.name = (tree.MediaContainer["-friendlyName"] || tree.MediaContainer["-serverName"] || "").replaceHtml();
                    newserver.address = ip;
                    newserver.port = port;
                    newserver.version = (tree.MediaContainer["-version"] || "");
                    newserver.scheme = "http";
                    newserver.localAddresses = [];
                    newserver.machineIdentifier = (tree.MediaContainer["-machineIdentifier"] || "");
                    newserver.createdAt = "0";
                    newserver.updatedAt = "0";
                    newserver.owned = "1";
                    newserver.synced = "0";
                    newserver.ip = ip;
                    newserver.reachable = "yes";
                    newserver.url = url;

                    newserver.localAddresses.push(ip);

                    var duplicated = false;
                    var owned = true;

                    $.each(prefs.servers, function (i, item) {
                        if (prefs.servers[i].machineIdentifier === newserver.machineIdentifier) {
                            duplicated = true;
                            owned = (prefs.servers[i].owned == "1");
                        }
                    });

                    if (duplicated === false) {
                        var idx = prefs.servers.push(newserver) - 1;

                        if (Main.view === Main.SETTINGS) {
                            widgetAPI.putInnerHTML(document.getElementById("settingMain2Right" + idx), prefs.servers[idx].ip + " - " + prefs.servers[idx].name);
                            widgetAPI.putInnerHTML(document.getElementById("settingMain2Right" + idx + "Image"), "<img src='Images/setting/search.png' />");
                            buttonSetting.updatePMS();
                        }
                        setTimeout(function () {
                            $("#popupStatus").text('Server was successfully added!');
                        }, 2000);
                    } else {
                        if (owned) {
                            $("#popupStatus").text("Server: [" + newserver.name + "]  is already in the list with IP: " + newserver.ip);
                        } else {
                            $("#popupStatus").text("Server: [" + newserver.name + "]  is already known with IP: " + newserver.ip + " , but you are not the owner");
                        }
                    }
                } else {
                    $("#popupStatus").text('Test Failed, Please make sure your server is on, and the IP address is reachable');
                    Main.debug('[Popup.js] - Try IP Address failed, tree is null');
                }
            } else {
                $("#popupStatus").text('Test Failed, Please make sure your server is on, and the IP address is reachable');
                Main.debug('[Popup.js] - Try IP Address failed, status: ' + xhrObj.status);
            }
        } else {
            $("#popupStatus").text('Test Failed, Please make sure your server is on, and the IP address is reachable');
            Main.debug('[Popup.js] - Try IP Address failed, xhrObj is null');
        }
    }
};

