function Protoplayer() { }  // the main object to use

//add some properties
Protoplayer.prototype.plugin = null;
Protoplayer.prototype.sef = false;
Protoplayer.prototype.url = "";

//add eventhandlers name properties
Protoplayer.prototype.OnConnectionFailedHandler = "";
Protoplayer.prototype.OnAuthenticationFailedHandler = "";
Protoplayer.prototype.OnStreamNotFoundHandler = "";
Protoplayer.prototype.OnNetworkDisconnectedHandler = "";
Protoplayer.prototype.OnNetworkSlowEventHandler = "";
Protoplayer.prototype.OnRenderErrorHandler = "";
Protoplayer.prototype.OnRenderingStartHandler = "";
Protoplayer.prototype.OnRenderingCompleteHandler = "";
Protoplayer.prototype.OnStreamInfoReadyHandler = "";
Protoplayer.prototype.OnBufferingStartHandler = "";
Protoplayer.prototype.OnBufferingCompleteHandler = "";
Protoplayer.prototype.OnBufferingProgressHandler = "";
Protoplayer.prototype.OnCurrentPlayTimeHandler = "";

//############# METHODS ###############

Protoplayer.prototype.Open = function (forceold) {

    var force = false;
    if (forceold)
        force = forceold;

    Main.debug("[Protoplayer.js] - force: " + force.toString());

    if ((getModel(2010) === false) && (force === false)) // Protoplayer is a 2011+ model
    {
        this.plugin = document.getElementById("pluginSef"); //use SEF Player
        this.sef = true;
        //sef player needs to be activated
        this.plugin.Open('Player', '1.000', 'Player');
        //register events
        this.plugin.OnEvent = OnEvent;
    } else {
        this.plugin = document.getElementById("pluginPlayer"); //use Normal Player
        this.sef = false;
        //register events
        this.plugin.OnConnectionFailed = 'OnConnectionFailedEvent'; //1
        this.plugin.OnAuthenticationFailed = 'OnAuthenticationFailedEvent'; //2
        this.plugin.OnStreamNotFound = 'OnStreamNotFoundEvent'; //3
        this.plugin.OnNetworkDisconnected = 'OnNetworkDisconnectedEvent'; //4
        this.plugin.OnNetworkSlow = 'OnNetworkSlowEvent'; //5
        this.plugin.OnRenderError = 'OnRenderErrorEvent'; //6
        this.plugin.OnRenderingStart = 'OnRenderingStartEvent'; //7
        this.plugin.OnRenderingComplete = 'OnRenderingCompleteEvent'; //8
        this.plugin.OnStreamInfoReady = 'OnStreamInfoReadyEvent'; //9
        this.plugin.OnBufferingStart = 'OnBufferingStartEvent'; //11
        this.plugin.OnBufferingComplete = 'OnBufferingCompleteEvent'; //12
        this.plugin.OnBufferingProgress = 'OnBufferingProgressEvent'; //13
        this.plugin.OnCurrentPlayTime = 'OnCurrentPlayTimeEvent'; //14
    }
};

Protoplayer.prototype.InitPlayer = function (url) {
    url = url.replace(/&amp;/g, '&');
    if (this.sef) {
        return this.plugin.Execute("InitPlayer", url);
    } else {
        this.url = url; //no equivalent, store the url for later use
        return true;
    }
};

Protoplayer.prototype.SetInitialTimeOut = function (sec) {
    if (this.sef) {
        return this.plugin.Execute("SetInitialTimeOut", sec);
    } else {
        return this.plugin.SetInitialTimeOut(sec);
    }
};

Protoplayer.prototype.StartPlayback = function (time) {
    if (this.sef) {
        if (time) {
            return this.plugin.Execute("StartPlayback", time);
        } else {
            return this.plugin.Execute("StartPlayback");
        }
    }
    else {
        if (time) {
            return this.plugin.ResumePlay(this.url, time); //no equivalent, use the stored the url
        } else {
            return this.plugin.Play(this.url);
        }
    }
};

Protoplayer.prototype.Play = function (url) {
    if (this.sef) {
        return this.plugin.Execute("Play", url);
    } else {
        return this.plugin.Play(url);
    }
};

Protoplayer.prototype.Pause = function () {
    if (this.sef) {
        return this.plugin.Execute("Pause");
    } else {
        return this.plugin.Pause();
    }
};

Protoplayer.prototype.Resume = function () {
    if (this.sef) {
        return this.plugin.Execute("Resume");
    } else {
        return this.plugin.Resume();
    }
};

Protoplayer.prototype.Stop = function () {
    if (this.sef) {
        return this.plugin.Execute("Stop");
    } else {
        return this.plugin.Stop();
    }
};

Protoplayer.prototype.SetDisplayArea = function (x, y, w, h) {
    if (this.sef) {
        if (curWidget.height == '540')
            return this.plugin.Execute("SetDisplayArea", x, y, w, h, 540, 1);
        else if (curWidget.height == '720')
            return this.plugin.Execute("SetDisplayArea", x, y, w, h, 720, 1);
    } else {
        return this.plugin.SetDisplayArea(x, y, w, h);
    }
};

Protoplayer.prototype.SetCropArea = function (x, y, w, h) {
    if (this.sef) {
        return this.plugin.Execute("SetCropArea", x, y, w, h);
    } else {
        return this.plugin.SetCropArea(x, y, w, h);
    }
};

Protoplayer.prototype.SetInitialTimeOut = function (seconds) {
    if (this.sef) {
        return this.plugin.Execute("SetInitialTimeOut", seconds);
    } else {
        return this.plugin.SetInitialTimeOut(seconds);
    }
};

Protoplayer.prototype.SetInitialBuffer = function (size) {
    if (this.sef) {
        return this.plugin.Execute("SetInitialBufferSize", size);
    } else {
        if (typeof this.plugin.SetInitialBuffer == 'function') {
            return this.plugin.SetInitialBuffer(size);
        }
        else {
            Main.debug("[Protoplayer.js] - Player does not support SetInitialBuffer");
        }
    }
};

Protoplayer.prototype.SetPendingBuffer = function (size) {
    if (this.sef) {
        return this.plugin.Execute("SetPendingBufferSize", size);
    } else {
        if (typeof this.plugin.SetPendingBuffer == 'function') {
            return this.plugin.SetPendingBuffer(size);
        }
        else {
            Main.debug("[Protoplayer.js] - Player does not support SetPendingBuffer");
        }
    }
};

Protoplayer.prototype.SetTotalBufferSize = function (size) {
    if (this.sef) {
        return this.plugin.Execute("SetTotalBufferSize", size);
    } else {
        if (typeof this.plugin.SetTotalBufferSize == 'function') {
            return this.plugin.SetTotalBufferSize(size);
        }
        else {
            Main.debug("[Protoplayer.js] - Player does not support SetTotalBufferSize");
        }
    }
};

Protoplayer.prototype.GetVideoWidth = function () {
    var r;
    if (this.sef) {
        var res = this.plugin.Execute("GetVideoResolution");
        if (res !== -1) {
            r = res.toString().split("|");
            return Number(r[0]); //width
        } else
            return 0;
    } else {
        r = this.plugin.GetVideoWidth();
        return Number(r);
    }
};

Protoplayer.prototype.GetVideoHeight = function () {
    var r;
    if (this.sef) {
        var res = this.plugin.Execute("GetVideoResolution");
        if (res !== -1) {
            r = res.toString().split("|");
            return Number(r[1]); //height
        } else
            return 0;
    } else {
        r = this.plugin.GetVideoHeight();
        return Number(r);
    }
};

Protoplayer.prototype.GetCurrentBitrates = function () {
    if (this.sef) {
        return this.plugin.Execute("GetCurrentBitrates");
    } else {
        if (typeof this.plugin.GetCurrentBitrates == 'function') {
            return this.plugin.GetCurrentBitrates();
        } else {
            return 0;
        }
    }
};

Protoplayer.prototype.setICT = function(bICTOn) {
    //bICTOn :Specifies the ICT output level.
    // 		0 - ICT off, 1 - ICT On
    if (this.sef) {
        return this.plugin.Execute("SetICT", bICTOn);
    }
};


Protoplayer.prototype.JumpForward = function (secs) {
    if (this.sef) {
        return this.plugin.Execute("JumpForward", Math.abs(secs));
    } else {
        return this.plugin.JumpForward(Math.abs(secs));
    }
};

Protoplayer.prototype.JumpBackward = function (secs) {
    if (this.sef) {
        return this.plugin.Execute("JumpBackward", Math.abs(secs));
    } else {
        return this.plugin.JumpBackward(Math.abs(secs));
    }
};

Protoplayer.prototype.SetPlaybackSpeed = function (speed) {
    if (this.sef) {
        return this.plugin.Execute("SetPlaybackSpeed", speed);
    } else {
        return this.plugin.SetPlaybackSpeed(speed);
    }
};

Protoplayer.prototype.GetDuration = function () {
    if (this.sef) {
        return this.plugin.Execute("GetDuration");
    } else {
        return this.plugin.GetDuration();
    }
};

Protoplayer.prototype.Set3DEffectMode = function (mode) {
    if (this.sef) {
        return this.plugin.Execute("SetPlayerProperty", 2, '3', mode);
        // arg1 - 2: No need to know
        // arg2 - '3': No need to know
        // arg3 - 1 : Side by Side (2 : Top and Bottom)
    } else {
        //this.url = url; //no equivalent, use screen plugin for older models
        return -1;
    }
};

Protoplayer.prototype.SetStreamID = function (type, value) {
    if (this.sef) {
        var result = this.plugin.Execute("SetStreamID", type, value);
        Main.debug("[Protoplayer.js] - SetStreamID Result: [" + result + "] - Type: [" + type + "] - Value: [" + value + "]");
        return result;
    } else {
        return false;
    }
};

//############# EVENTS ##################

//Helper functions for the 2010 player
function OnConnectionFailedEvent() { OnEvent(1); }
function OnAuthenticationFailedEvent() { OnEvent(2); }
function OnStreamNotFoundEvent() { OnEvent(3); }
function OnNetworkDisconnectedEvent() { OnEvent(4); }
function OnNetworkSlowEvent() { OnEvent(5); }
function OnRenderErrorEvent(num) { OnEvent(6, num); }
function OnRenderingStartEvent() { OnEvent(7); }
function OnRenderingCompleteEvent() { OnEvent(8); }
function OnStreamInfoReadyEvent() { OnEvent(9); }
function OnBufferingStartEvent() { OnEvent(11); }
function OnBufferingCompleteEvent() { OnEvent(12); }
function OnBufferingProgressEvent(percent) { OnEvent(13, percent); }
function OnCurrentPlayTimeEvent(time) { OnEvent(14, time); }

function OnEvent(EventType, param1, param2) {
    var evt = "";
    switch (EventType) {
        case 1: //Player.onConnectionFailed();
            evt = Protoplayer.prototype.OnConnectionFailedHandler;
            fireEvent(evt);
            break;
        case 2: //Player.OnAuthenticationFailed();
            evt = Protoplayer.prototype.OnAuthenticationFailedHandler;
            fireEvent(evt);
            break;
        case 3: //Player.onStreamNotFound();
            evt = Protoplayer.prototype.OnStreamNotFoundHandler;
            fireEvent(evt);
            break;
        case 4: //Player.onNetworkDisconnected();
            evt = Protoplayer.prototype.OnNetworkDisconnectedHandler;
            fireEvent(evt);
            break;
        case 5: //Player.onNetworkSlow();
            evt = Protoplayer.prototype.OnNetworkSlowEventHandler;
            fireEvent(evt);
            break;
        case 6: //Player.onRenderError();
            evt = Protoplayer.prototype.OnRenderErrorHandler;
            fireEvent(evt, param1);
            break;
        case 7: //Player.onRenderingStart();
            evt = Protoplayer.prototype.OnRenderingStartHandler;
            fireEvent(evt);
            break;
        case 8: //Player.onRenderingComplete();
            evt = Protoplayer.prototype.OnRenderingCompleteHandler;
            fireEvent(evt);
            break;
        case 9: //Player.onStreamInfoReady();
            evt = Protoplayer.prototype.OnStreamInfoReadyHandler;
            fireEvent(evt);
            break;
            //'10' : 'DECODING_COMPLETE',
        case 11: //Player.onBufferingStart();
            evt = Protoplayer.prototype.OnBufferingStartHandler;
            fireEvent(evt);
            break;
        case 12: //Player.onBufferingComplete();
            evt = Protoplayer.prototype.OnBufferingCompleteHandler;
            fireEvent(evt);
            break;
        case 13: //Player.onBufferingProgress(param1);
            evt = Protoplayer.prototype.OnBufferingProgressHandler;
            fireEvent(evt, param1);
            break;
        case 14: //Player.onCurrentPlaybackTime(param1);
            evt = Protoplayer.prototype.OnCurrentPlayTimeHandler;
            fireEvent(evt, param1);
            break;
            //'15' : 'AD_START',
            //'16' : 'AD_END',
            //'17' : 'RESOLUTION_CHANGED',
            //'18' : 'BITRATE_CHANGED',
            //'19' : 'SUBTITLE',
            //'20' : 'CUSTOM'
        default:
            //alert("Player event " + EventType + " | " + param1 + " | " + param2);
            break;
    }
    //alert("Player event "+ EventType + " | " + param1 + " | " + param2);
}