var SlideShow =
{
    plugin: null,
    images: [],
    state: 0,
    selected: 0,
    visible: false,
    slideId: 1,
    direction: 2,

    timer: 0,
    displayTime: 5000,
    loaderTimer: 0,

    STOPPED: 0,
    PLAYING: 1,
    PAUSED: 2,
    FORWARD: 3,
    REWIND: 4,
    INPROGRESS: 5,
    ERROR: 6,
    BUFFER: 99
};

var PhotoPlayList = {};

SlideShow.setPhotoPlayList = function (id) {
    if (SlideShow.state === SlideShow.STOPPED) {
        //create a copy of the contentlist for autoplay
        keyLock.status = keyLock.BLOCKALL;
        var playList = JSON.stringify(Data, null, 4);
        SlideShow.selected = parseInt(id, 10);
        PhotoPlayList = {};
        PhotoPlayList = JSON.parse(playList);
        //Main.writeFile("PhotoPlayList.txt", playList); //for debugging
        keyLock.status = keyLock.NONE;

        SlideShow.images = [];

        for (var i = 0; i < PhotoPlayList.contentKeys.length; i++) {

            //Main.debug("[Display.js] - Photolist: " + i);

            var img = { "url": "", "width": "", "height": "" };
            var w, h, ar;

            w = Number((PhotoPlayList.contentWidths[i] || 960));
            h = Number((PhotoPlayList.contentHeights[i] || 540));

            var hasPart = false;
            if (PhotoPlayList.contentMedias) {
                if (PhotoPlayList.contentMedias[i]) {
                    hasPart = true;
                }
            }

            if (PhotoPlayList.contentKeys[i].toLowerCase().contains("/library/parts/") ||
                PhotoPlayList.contentKeys[i].toLowerCase().contains(".jpg") ||
                PhotoPlayList.contentKeys[i].toLowerCase().contains(".png") ||
                PhotoPlayList.contentKeys[i].toLowerCase().contains(".gif") ||
                hasPart === true) {

                // Check if the current width is larger than the max
                if (w >= 960) {
                    ar = 960 / w;  // get ratio for scaling image
                    h = Math.floor(h * ar);    // Reset height to match scaled image
                    w = Math.floor(w * ar);    // Reset width to match scaled image
                }

                if (h >= 540) {
                    ar = 540 / h;  // get ratio for scaling image
                    h = Math.floor(h * ar);    // Reset height to match scaled image
                    w = Math.floor(w * ar);    // Reset width to match scaled image
                }

                img.url = PhotoPlayList.contentKeys[i];
                img.src = "";
                img.width = w;
                img.height = h;

                //Main.debug("[SlideShow.js] - Adding Image to slidehsow: " + img.url + " w: " + w + " h: " + h + " ar: " + ar);

                SlideShow.images.push(img);
            }
            else {
                SlideShow.images.push(null);
            }
        }

    }
    else {
        Main.debug("[SlideShow.js] - SlideShow.setPhotoPlayList canceled, player not in correct state");
    }
};

SlideShow.Show = function () {
    SlideShow.visible = true;
    $("#slide1").attr('src', '');
    $("#slide2").attr('src', '');
    $("#slideshow").show();
    SlideShow.selected--; //reduce with one, this will get updated to the real number
    SlideShow.Next();
};

SlideShow.Play = function () {
    if (SlideShow.status !== SlideShow.PLAYING) {
        SlideShow.status = SlideShow.PLAYING;
        Main.disableScreenSaver();
        SlideShow.Next(Main.RIGHT); //move to the next slide first
        window.clearInterval(SlideShow.timer);
        SlideShow.timer = window.setInterval("SlideShow.Next(Main.RIGHT)", SlideShow.displayTime);
        var label = document.getElementById("loadingProgress");
        $(label).putInnerHTML(text.displayTime + ": " + SlideShow.displayTime / 1000 + " sec<br>" + text.displayChange).show();
        fadeOut(label, 30);
    } else {
        Main.debug("[SlideShow.js] - Ignoring play request, show is already playing");
    }
};

SlideShow.Faster = function () {
    if (SlideShow.status === SlideShow.PLAYING) {
        SlideShow.displayTime += 500;
        var label = document.getElementById("loadingProgress");
        $(label).text(text.displayTime + ": " + SlideShow.displayTime / 1000 + " sec").show();
        fadeOut(label, 30);
        window.clearInterval(SlideShow.timer);
        SlideShow.timer = window.setInterval("SlideShow.Next(Main.RIGHT)", SlideShow.displayTime);
    }
};

SlideShow.Slower = function () {
    if (SlideShow.status === SlideShow.PLAYING) {
        if ((SlideShow.displayTime - 500) > 1000) {
            SlideShow.displayTime -= 500;
        }
        var label = document.getElementById("loadingProgress");
        if (SlideShow.displayTime < 2000) {
            $(label).text(text.displayTime + ": " + SlideShow.displayTime / 1000 + " sec (" + text.lowest + ")").show();
        }
        else {
            $(label).text(text.displayTime + ": " + SlideShow.displayTime / 1000 + " sec").show();
        }
        fadeOut(label, 30);

        window.clearInterval(SlideShow.timer);
        SlideShow.timer = window.setInterval("SlideShow.Next(Main.RIGHT)", SlideShow.displayTime);
    }
};

SlideShow.Next = function (direction) {
    if (direction)
        SlideShow.direction = direction;

    if (SlideShow.direction === Main.LEFT) {
        if ((SlideShow.selected - 1) < 0) {
            SlideShow.selected = PhotoPlayList.contentMedias.length - 1;
        }
        else {
            SlideShow.selected--;
        }
    }
    else if (SlideShow.direction === Main.RIGHT) {
        if ((SlideShow.selected + 1) > PhotoPlayList.contentMedias.length - 1) {
            SlideShow.selected = 0;
        }
        else {
            SlideShow.selected++;
        }
    }

    var img = SlideShow.images[SlideShow.selected];
    if (!img) {
        if ((SlideShow.selected + 1) < PhotoPlayList.contentMedias.length - 1) {
            SlideShow.Next(direction);
        }
        return false;
    }

    var slide = document.getElementById("slide1");

    SlideShow.PreloadImage(img, function (prepImg) {
        if (prepImg) {
            var l = Math.ceil((960 - prepImg.width) / 2);
            var t = Math.ceil((540 - prepImg.height) / 2);

            Main.screenlock = 1;

            if ($(slide).is(':visible')) {
                $(slide).fadeOut(500, function () {
                    $(slide).attr('src', ''); //workaround to trigger the load again
                    $(slide).css({ 'width': prepImg.width + 'px', 'height': prepImg.height + 'px', 'top': t + 'px', 'left': l + 'px' });
                    $(slide).attr('src', prepImg.src);
                    $(slide).fadeIn(1000, function () {
                        Main.screenlock = 0;
                    });
                });
            } else {
                slide.src = prepImg.src;
                $(slide).css({ 'width': prepImg.width + 'px', 'height': prepImg.height + 'px', 'top': t + 'px', 'left': l + 'px' });
                $(slide).fadeIn(1000, function () {
                    Main.screenlock = 0;
                });
            }
            Main.debug("[SlideShow.js] - Showing Image: " + (SlideShow.selected + 1).toString() + "/" + PhotoPlayList.contentMedias.length.toString() + ", w: " + prepImg.width + " h: " + prepImg.height + " t: " + t + " l: " + l);
        } else {
            SlideShow.Next(direction);
        }
    });
};

SlideShow.PreloadImage = function (img, callback) {
    //Main.debug("[SlideShow.js] - Preloading: " + img.url);
    SlideShow.loaderTimer = window.setTimeout(function () {
        loadbar.show();
    }, 1000);

    var sprite = document.createElement("img");
    sprite.onload = function () {
        img.src = this.src;
        img.width = this.width;
        img.height = this.height;
        window.clearTimeout(SlideShow.loaderTimer);
        loadbar.hide();
        sprite = null;
        if (callback) {
            Main.debug("[SlideShow.js] - Preload image: " + img.src);
            callback(img);
        }
    };
    sprite.onerror = function () {
        if (callback) {
            sprite = null;
            window.clearTimeout(SlideShow.loaderTimer);
            loadbar.hide();
            Main.debug("[SlideShow.js] - Preload image failed: " + img.url);
            callback(img);
        }
    };

    sprite.src = Main.getPhoto(img.url, img.width, img.height, "photo", "jpg"); //always set src after the eventhandlers
};

SlideShow.PrepareNext = function () {
    //get the next image so it will be cached before displaying it
    var next = SlideShow.selected;
    if (SlideShow.direction === Main.LEFT) {
        if ((next - 1) < 0) {
            next = PhotoPlayList.contentMedias.length - 1;
        }
        else {
            next--;
        }
    }
    else if (SlideShow.direction === Main.RIGHT) {
        if ((next + 1) > PhotoPlayList.contentMedias.length - 1) {
            next = 0;
        }
        else {
            next++;
        }
    }

    var img = SlideShow.images[next];
    if (!img) {
        return false;
    }

    SlideShow.PreloadImage(img);
};

SlideShow.Stop = function () {
    window.clearInterval(SlideShow.timer);
    window.clearInterval(SlideShow.loaderTimer);
    window.setTimeout(function () { //wait for timers to end
        SlideShow.status = SlideShow.STOPPED;
        Main.enableScreenSaver();
        Main.screenlock = 0;
        window.clearTimeout(SlideShow.loaderTimer);
        loadbar.hide();
        $("#slideshow").hide();
        SlideShow.visible = false;
    }, 500);

};

SlideShow.Pause = function () {
    if (SlideShow.status === SlideShow.PLAYING) {
        SlideShow.status = SlideShow.PAUSED;
        Main.enableScreenSaver();
        window.clearInterval(SlideShow.timer);
        var label = document.getElementById("loadingProgress");
        $(label).putInnerHTML(text.playerPaused).show();
        fadeOut(label, 30);
    } else {
        SlideShow.Play();
    }
};

SlideShow.OnNetworkError = function () {
    Main.debug("[SlideShow.js] - Couldn't connect to PMS ");
    SlideShow.Stop();
};