var TranscodeParameters = {
    identifier: "",
    url: "",
    path: "",
    headers: null,
    mediaIndex: 0,
    partIndex: 0,
    ratingKey: ""
};

function Transcoder() {
    'use strict';

    var publicKey = 'KQMIY6GATPC63AIMC4R2';
    var privateKey = decode64('k3U6GLkZOoNIoSgjDshPErvqMIFdE0xMTx8kgsrhnC0=');
    var capabilities = "protocols=" +
        "http-live-streaming," +
        "http-mp4-streaming," +
        "http-streaming-video," +
        "http-streaming-video-240p," +
        "http-streaming-video-320p," +
        "http-streaming-video-480p," +
        "http-streaming-video-720p," +
        "http-streaming-video-1080p," +
        "http-mp4-video," +
        "http-mp4-video-240p," +
        "http-mp4-video-320p," +
        "http-mp4-video-480p," +
        "http-mp4-video-720p," +
        "http-mp4-video-1080p," +
        "webkit;" +
        "videoDecoders=" +
        "h264{profile:high&resolution:1080&level:41}," +
        "h264{profile:high&resolution:720&level:41}," +
        "h264{profile:high&resolution:480&level:41};" +
        "audioDecoders=" +
        "mp3," +
        "aac," +
        "ac3," +
        "dts";

    var resolutions = ['220x180', '220x128', '284x160', '420x240', '576x320', '720x480', '1024x768', '1280x720', '1280x720', '1920x1080', '1920x1080', '1920x1080', '1920x1080'];
    var qualities = ['10', '20', '30', '30', '40', '60', '60', '75', '100', '60', '75', '90', '100'];
    var bitrates = ['64', '96', '208', '320', '720', '1500', '2000', '3000', '4000', '8000', '10000', '12000', '20000'];
    var uid = Main.getUniqueID();
    return {
        image: function (path, width, height) {
            if (!path)
                return '';

            var params = {
                url: Player.server.resolveUrl(path, false, false),
                width: parseInt(width, 10),
                height: parseInt(height, 10)
            };

            var url = '/photo/:/transcode?' + $.param(params, true);

            return Player.server.resolveUrl(url, false, true);
        },
        music: function (identifier, path, key) {

            Player.transcoding = 1;

            var baseUrl;
            var params;
            var url;

            if (Player.server.supports(Player.server.features.universalMusicTranscoder) && (prefs.player.universalTranscoder || "off") === "on") {
                Main.debug("[Transcode.js] -  Server supports new transcoder, using new version");
                params = {
                    path: Player.server.resolveUrl(key, true, true),
                    mediaIndex: 0,
                    partIndex: 0
                };
                baseUrl = '/music/:/transcode/universal/start.mp3';
            } else {

                if (!Player.server.supports(Player.server.features.universalMusicTranscoder)) {
                    Main.debug("[Transcode.js] - Server does not supports new transcoder, falling back to old version");
                } else {
                    Main.debug("[Transcode.js] - Universal transcoder is disabled, falling back to old version");
                }

                params = {
                    identifier: identifier,
                    session: encodeURIComponent(uid),
                    url: Player.server.resolveUrl(path, true, true),
                    format: 'mp3',
                    audioCodec: 'libmp3lame',
                    audioBitrate: 320,
                    audioSamples: 44100
                };
                baseUrl = '/music/:/transcode/generic.mp3';
            }

            params = $.extend(params, Player.server.getHeaders());
            url = baseUrl + '?' + $.param(params, true);

            return Player.server.resolveUrl(url, false, true);
        },
        video: function (identifier, url, path, headers, mediaIndex, partIndex, ratingKey, callback) {

            TranscodeParameters.identifier = identifier;
            TranscodeParameters.url = url;
            TranscodeParameters.path = path;
            TranscodeParameters.headers = headers;
            TranscodeParameters.mediaIndex = mediaIndex;
            TranscodeParameters.partIndex = partIndex;
            TranscodeParameters.ratingKey = ratingKey;

            // If the server is recent enough to support the universal transcoder,
            // use that endpoint instead of the old transcoder.
            var loopbackPath = Player.server.resolveUrl(path, true, true);
            var loopbackUrl = Player.server.resolveUrl(url, true, true);

            if (Main.getPlaybackMode() == 1) { //auto adjust to get the lowest possible value
                var q = Main.getTranscodingQuality(url);
                Main.debug("[Transcode.js] - Max Transcode quality: " + q);
                var w = Number(Player.media[mediaIndex]["-width"] || resolutions[q].split('x')[0]);
                var h = Number(Player.media[mediaIndex]["-height"] | resolutions[q].split('x')[1]);
                var b = Number(Player.media[mediaIndex]["-bitrate"] || bitrates[q]);
                var quality = this.adjustQuality(w, h, b, q);
            } else {
                quality = Main.getTranscodingQuality(url); //just use what the user has set
            }

            Player.transcoding = 1;

            if (Player.server.supports(Player.server.features.universalTranscoder) && (prefs.player.universalTranscoder || "off") === "on") {
                Main.debug("[Transcode.js] -  Server supports new transcoder, using new version");
                var universalUrl = Player.server.resolveUrl(this.getUniversalTranscoderUrl(loopbackPath, headers, mediaIndex, partIndex, quality), false, true);
                //We don't need to wait to build the m3u8 url with the universal transcoder.
                callback(null, null, universalUrl);
                return false;
            } else {

                if (!Player.server.supports(Player.server.features.universalTranscoder)) {
                    Main.debug("[Transcode.js] - Server does not supports new transcoder, falling back to old version");
                } else {
                    Main.debug("[Transcode.js] - Universal transcoder is disabled, falling back to old version");
                }

                var transurl = this.getTranscoderUrl(identifier, loopbackUrl, path, headers, ratingKey, quality);
                var playurl = Player.server.resolveUrl("/video/:/transcode/segmented/start.m3u8?session=" + encodeURIComponent(uid), false, true);
                AjaxManager.getHTTP(transurl, callback, null, 0, playurl);
            }
        },
        getTranscoderUrl: function (identifier, url, path, headers, ratingKey, quality) {
            var time = Math.round(new Date().getTime() / 1000);
            //noinspection JSPotentiallyInvalidUsageOfThis
            var params = {
                session: encodeURIComponent(uid),
                identifier: identifier,
                offset: 0,
                url: url,
                audioBoost: (prefs.audio.audioboost || "100"),
                subtitleSize: this.getSubtitleSize(),
                ratingKey: ratingKey,
                key: path,
                quality: quality
            };

            if (headers) {
                $.extend(params, headers);
            }

            var transcodeUrl = "/video/:/transcode/segmented/start.m3u8?" + $.param(params, true);

            HMAC_SHA256_init(privateKey);
            HMAC_SHA256_write(transcodeUrl + '@' + time);

            var mac = HMAC_SHA256_finalize();
            var code = encode64(array_to_string(mac));
            var videoCapabilities = capabilities;

            if (Main.getPlaybackMode() === 2) { //Direct Stream
                videoCapabilities = capabilities.replace(/videoDecoders=[^;]+;audioDecoders=[^;]+/, '');
            }

            var transheaders = {
                'X-Plex-Access-Key': publicKey,
                'X-Plex-Access-Time': time,
                'X-Plex-Access-Code': code,
                'X-Plex-Client-Capabilities': videoCapabilities
            };

            $.extend(transheaders, Player.server.getHeaders());

            Main.debug('[Transcode.js] - transcoding with old transcoder');
            Main.debug('[Transcode.js] - capabilities: ' + videoCapabilities);
            Main.debug('[Transcode.js] - quality: ' + params.quality);
            Main.debug('[Transcode.js] - subtitleSize: ' + params.subtitleSize);
            Main.debug('[Transcode.js] - audioBoost: ' + params.audioBoost);

            var returnUrl = Player.server.resolveUrl(transcodeUrl + '&' + $.param(transheaders), false, true);

            Main.debug("[Transcode.js] - video transcodeUrl: " + returnUrl);

            return returnUrl;

        },
        getUniversalTranscoderUrl: function (path, headers, mediaIndex, partIndex, quality) {
            //noinspection JSPotentiallyInvalidUsageOfThis
            var params = {
                path: path,
                mediaIndex: mediaIndex,
                partIndex: partIndex,
                session: encodeURIComponent(uid),
                protocol: 'hls',
                offset: 0,
                fastSeek: 0,
                directPlay: ((prefs.player.directPlay || "off") === "on") ? 1 : 0,
                directStream: ((prefs.player.directStream || "off") === "on") ? 1 : 0,
                videoQuality: qualities[quality],
                videoResolution: resolutions[quality],
                maxVideoBitrate: bitrates[quality],
                subtitleSize: this.getSubtitleSize(),
                audioBoost: Number(prefs.audio.audioboost || "100")
            };

            if (headers) {
                $.extend(params, headers);
            }

            $.extend(params, Player.server.getHeaders());

            Main.debug('[Transcode.js] - transcoding with universal transcoder');
            Main.debug('[Transcode.js] - mediaIndex: ' + params.mediaIndex);
            Main.debug('[Transcode.js] - partIndex: ' + params.partIndex);
            Main.debug('[Transcode.js] - directPlay: ' + params.directPlay);
            Main.debug('[Transcode.js] - directStream: ' + params.directStream);
            Main.debug('[Transcode.js] - videoQuality: ' + params.videoQuality);
            Main.debug('[Transcode.js] - videoResolution: ' + params.videoResolution);
            Main.debug('[Transcode.js] - maxVideoBitrate: ' + params.maxVideoBitrate);
            Main.debug('[Transcode.js] - subtitleSize: ' + params.subtitleSize);
            Main.debug('[Transcode.js] - audioBoost: ' + params.audioBoost);

            var returnUrl = Player.server.resolveUrl('/video/:/transcode/universal/start.m3u8?' + $.param(params, true), false, true);

            Main.debug("[Transcode.js] - video transcodeUrl: " + returnUrl);
            Main.debug("[Transcode.js] - getSubtitleSize: " + this.getSubtitleSize());

            return returnUrl;
        },
        adjustQuality: function (w, h, b, maxQ) {
            var bit = 7;
            var res = 7;

            for (var x = 0; x < bitrates.length; x++) {
                if (bitrates[x] >= b || x >= maxQ) {
                    bit = x;
                    break;
                }
            }

            for (var y = 0; y < resolutions.length; y++) {
                if (((resolutions[y].split('x')[0] >= w) && (resolutions[y].split('x')[0] >= h)) || y >= maxQ) {
                    res = y;
                    break;
                }
            }

            var newQ = Math.max(bit, res);

            Main.debug("[Transcode.js] - Adjusted Transcode quality: " + newQ);
            return newQ;
        },
        getSubtitleSize: function () {
            var subsize = (Player.subSize || 22).toString();
            if (subsize.contains("px")) {
                subsize = subsize.replace("px", "");
            }
            return Math.floor(Number(subsize) * 3);
        },
        kill: function (callback) {
            var url;
            if (Player.server.supports(Player.server.features.universalTranscoder)) {
                url = "/video/:/transcode/universal/stop?session=";
            } else {
                url = "/video/:/transcode/segmented/stop?session=";
            }
            url = Player.server.resolveUrl(url + encodeURIComponent(uid), false, true);

            AjaxManager.getHTTP(url, function (tree, xhr, id) {
                if (xhr.readyState === 4) {
                    if (xhr) {
                        if (xhr.status === 200) {
                            Player.transcoding = 0;
                            Main.debug("[Transcode.js] - Transcode kill command send succesfull");
                        } else {
                            Main.debug("[Transcode.js] - Transcode kill command send failed");
                        }
                    } else {
                        Main.debug("[Transcode.js] - Transcode kill command send failed");
                    }
                    if (callback)
                        callback();
                }
            }, null, 0, "transcode_stop");
        },
        ping: function () {
            var url = "";
            if (Player.server.supports(Player.server.features.universalTranscoder)) {
                url = "/video/:/transcode/universal/ping?session=";
            } else {
                url = "/video/:/transcode/segmented/ping?session=";
            }

            url = Player.server.resolveUrl(url + encodeURIComponent(uid), false, true);
            AjaxManager.getHTTP(url, function (tree, xhr, id) {
                if (xhr.readyState === 4) {
                    if (xhr.status !== 200) {
                        Main.debug("[Transcode.js] - Transcode ping command send succesfull");
                    } else {
                        Main.debug("[Transcode.js] - Transcode ping command send failed");
                    }
                }
            }, null, 0, "transcode_stop");
        },
        restart: function (callback) {
            var self = this;
            self.kill(function () {
                self.video(TranscodeParameters.identifier, TranscodeParameters.url, TranscodeParameters.path, TranscodeParameters.headers,
                    TranscodeParameters.mediaIndex, TranscodeParameters.partIndex, TranscodeParameters.ratingKey, Player.transcodeResponse);
            });
        }
    };
}