// functions for buttons which are on (almost) all sites the same
var buttonAll =
{
    timeoutID: 0
};

buttonAll.getKeyEvent = function (keyCode) {
    if (keyLock.checkKey(keyCode)) {
        Main.debug("[buttonAll.js] - Key pressed: [" + keyCode + "]");
        switch (keyCode) {
            case tvKey.KEY_PLAY:
                Main.debug("[buttonAll.js] - PLAY");

                if (SlideShow.visible) {
                    SlideShow.Play();
                    return false;
                }

                if (Main.screenlock === 0 && Player.state !== Player.STOPPED && Player.state !== Player.BUFFER) {
                    Player.playVideo();
                }
                break;

            case tvKey.KEY_STOP:
                Main.debug("[buttonAll.js] - STOP");
                loading.hide(); // always do this player could be buffering
                loadbar.hide();
                if (SlideShow.visible) {
                    SlideShow.Stop();
                    return false;
                }

                if (Main.screenlock === 0 && Player.state !== Player.STOPPED) {
                    Player.autoplay = Player.OFF;
                    Player.stopVideo(Player.INPROGRESS);
                } else if (Player.transcoding === 1) {
                    var objTrans = new Transcoder();
                    objTrans.kill();
                } else {
                    Main.debug("[buttonAll.js] - Player Ignoring stop request, not in correct state");
                }
                break;

            case tvKey.KEY_PAUSE:
                Main.debug("[buttonAll.js] - PAUSE");

                if (SlideShow.visible) {
                    SlideShow.Pause();
                } else {
                    Player.pauseVideo();
                }
                break;

            case tvKey.KEY_FF:
            case tvKey.KEY_FF_: // >>|
                Main.debug("[buttonAll.js] - FF");
                if ((Player.state === Player.PLAYING || Player.state === Player.FORWARD || Player.state === Player.REWIND) && (Player.mode !== Player.MODE_MUSIC)) {
                    if (Player.transcoding === 0) {
                        if (Main.osd === 0) {
                            Main.slideOSD("up");
                        }
                        Player.fastForwardVideo();
                    } else {
                        Main.showInfo(text.errorFF, "info", text.continue1);
                    }
                } else if ((Player.state === Player.PLAYING || Player.state === Player.PAUSED) && (Player.mode === Player.MODE_MUSIC)) {
                    Main.debug("[Player.js] - Player Next", 1);
                    if (AutoPlayList.contentMedias.length > 1) { //we have more media to play
                        Player.setAutoPlayNext(Main.NEXT, true);
                    }
                } else {
                    Main.debug("[buttonAll.js] - Not in correct state [" + Player.state + "]");
                }
                break;

            case tvKey.KEY_RW:
            case tvKey.KEY_REWIND_: // |<<
                Main.debug("[buttonAll.js] - RW");
                if ((Player.state === Player.PLAYING || Player.state === Player.REWIND || Player.state === Player.FORWARD) && (Player.mode !== Player.MODE_MUSIC)) {
                    if (Player.transcoding === 0) {
                        if (Main.osd === 0) {
                            Main.slideOSD("up");
                        }
                        Player.fastBackwardVideo();
                    } else {
                        Main.showInfo(text.errorFR, "info", text.continue1);
                    }
                } else if ((Player.state === Player.PLAYING || Player.state === Player.PAUSED) && (Player.mode === Player.MODE_MUSIC)) {
                    Main.debug("[Player.js] - Player Previous", 1);
                    if (AutoPlayList.contentMedias.length > 1) { //we have more media to play
                        Player.setAutoPlayNext(Main.PREV, true);
                    }
                } else {
                    Main.debug("[buttonAll.js] - Not in correct state [" + Player.state + "]");
                }
                break;
            case tvKey.KEY_TOOLS:
                Main.debug("[buttonAll.js] - TOOLS");
                if (getProductType() !== "BD-Player") {
                    buttonAll.tools();
                }
                break;

            case tvKey.KEY_INFO:
                Main.debug("[buttonAll.js] - INFO NOT HANDELED!");
                break;

            case tvKey.KEY_RED:
                Main.debug("[buttonAll.js] - RED");
                buttonAll.red();
                break;

            case tvKey.KEY_GREEN:
                Main.debug("[buttonAll.js] - GREEN");
                buttonAll.green();
                break;

            case tvKey.KEY_YELLOW:
                Main.debug("[buttonAll.js] - YELLOW");
                buttonAll.yellow();
                break;
            case tvKey.KEY_BLUE:
                Main.debug("[buttonAll.js] - BLUE NOT HANDELED!");
                break;
            case tvKey.KEY_SUBTITLE: // on TVs
            case tvKey.KEY_SUB_TITLE: //mostly on BD-Player remotes
                Main.debug("[buttonAll.js] - AD/SUBT. - SUBTITLE - Keycode: [" + keyCode + "]");
                if (Metadata.getSubtitleCount() > 0) {
                    if (Main.rightOSD === 0) {
                        $("#playerStatus").show();
                        window.clearTimeout(buttonAll.timeoutID);
                    }

                    Subtitle.toggleEnabled();

                    if (Main.getPlaybackMode() > 2 && Subtitle.enabled === false) {
                        Main.showInfo(text.rightOSDAudioRestart, "info"); // show warning
                    }

                    if (Main.rightOSD === 0) {
                        buttonAll.timeoutID = window.setTimeout(function () {
                            $('#playerStatus').hide();
                        }, 3000);
                    }
                }
                else
                    Main.debug("[buttonAll.js] - Can't change subs because the file has none or subs are disabled");
                break;

            case tvKey.KEY_D_AUDIO:
            case tvKey.KEY_MTS:
                Main.debug("[buttonAll.js] - AUDIO"); //mostly on BD-Player remotes
                if (Metadata.getAudioCount() > 1) {
                    if (getModel(2010)) {
                        if (Player.state !== Player.PAUSED) {
                            Player.pauseVideo();
                        }
                        Main.showInfo(text.errorSupport);
                    }
                    else {
                        var result = 0;
                        var oldSelectAudio = Audio.audioIndex;
                        if (Main.rightOSD === 0) {
                            $("#playerStatus").show();
                            window.clearTimeout(buttonAll.timeoutID);
                        }
                        if (Audio.audioIndex >= Metadata.getAudioCount() - 1) {
                            Audio.audioIndex = 0;
                        }
                        else {
                            Audio.audioIndex++;
                        }
                        result = Player.plugin.SetStreamID(1, Audio.audioIndex); // change the Audio
                        if (result === 1) {
                            Metadata.setSelectedAudio(Audio.audioIndex); // send the selected Audio to PMS
                            Audio.setAudioOutput(AudioStreams[Audio.audioIndex].codec, AudioStreams[Audio.audioIndex].channels);
                            $("#rightOSDAudioStreamData").putInnerHTML((Audio.audioIndex + 1) + "/" + Metadata.getAudioCount() + " " + Metadata.getAudioLanguage(Audio.audioIndex) + " - " + Metadata.getAudioCodec(Audio.audioIndex) + " " + Metadata.getAudioChannels(Audio.audioIndex));
                            $("#playerStatus").putInnerHTML(text.audio + (Audio.audioIndex + 1) + "/" + Metadata.getAudioCount() + " " + Metadata.getAudioLanguage(Audio.audioIndex) + " - " + Metadata.getAudioCodec(Audio.audioIndex) + " " + Metadata.getAudioChannels(Audio.audioIndex));
                        }
                        else {
                            Audio.audioIndex = oldSelectAudio;
                            Main.debug("[buttonAll.js] - Change audio didn't work - result [" + result + "]");
                        }
                        if (Main.rightOSD === 0) {
                            buttonAll.timeoutID = window.setTimeout("$('#playerStatus').hide()", 3000);
                        }
                    }
                }
                else
                    Main.debug("[buttonAll.js] - Can't change audio because the file has only one");
                break;

            case tvKey.KEY_VOL_UP:
            case tvKey.KEY_PANEL_VOL_UP:
                Main.debug("[buttonAll.js] - VOL_UP");
                //Audio.setVolume(0);
                break;

            case tvKey.KEY_VOL_DOWN:
            case tvKey.KEY_PANEL_VOL_DOWN:
                Main.debug("[buttonAll.js] - VOL_DOWN");
                //Audio.setVolume(1);
                break;

            case tvKey.KEY_MUTE:
                Main.debug("[buttonAll.js] - MUTE");
                //Audio.muteMode();
                break;

            case tvKey.KEY_0:
                Main.debug("[buttonAll.js] - NUM0");
                Player.jumpTo("0");
                break;

            case tvKey.KEY_1:
                Main.debug("[buttonAll.js] - NUM1");
                Player.jumpTo(1);
                break;

            case tvKey.KEY_2:
                Main.debug("[buttonAll.js] - NUM2");
                Player.jumpTo(2);
                break;

            case tvKey.KEY_3:
                Main.debug("[buttonAll.js] - NUM3");
                Player.jumpTo(3);
                break;

            case tvKey.KEY_4:
                Main.debug("[buttonAll.js] - NUM4");
                Player.jumpTo(4);
                break;

            case tvKey.KEY_5:
                Main.debug("[buttonAll.js] - NUM5");
                Player.jumpTo(5);
                break;

            case tvKey.KEY_6:
                Main.debug("[buttonAll.js] - NUM6");
                Player.jumpTo(6);
                break;

            case tvKey.KEY_7:
                Main.debug("[buttonAll.js] - NUM7");
                Player.jumpTo(7);
                break;

            case tvKey.KEY_8:
                Main.debug("[buttonAll.js] - NUM8");
                Player.jumpTo(8);
                break;

            case tvKey.KEY_9:
                Main.debug("[buttonAll.js] - NUM9");
                Player.jumpTo(9);
                break;

            case tvKey.KEY_INFOLINK:
            case tvKey.KEY_WLINK:
            case tvKey.KEY_CONTENT:
                Main.debug("[buttonAll.js] - Internet@TV");
                widgetAPI.blockNavigation(event);
                Main.onUnload();
                widgetAPI.sendReturnEvent();
                break;
            case tvKey.KEY_ENTER:
            case tvKey.KEY_PANEL_ENTER:
                Main.debug("[buttonAll.js] - ENTER");
                window.setTimeout(function () {
                    if (Player.status !== Player.STOPPED && Player.status !== Player.BUFFER) {
                        Player.pauseVideo();
                    }
                }, 250);
                break;
			case 246: //history key
            case tvKey.KEY_EXIT:
                Main.debug("[buttonAll.js] - EXIT");
                widgetAPI.blockNavigation(event);
                Main.onUnload();
                widgetAPI.sendExitEvent();
                break;
            default:
                Main.debug("[buttonAll.js] - Unhandled key");
                widgetAPI.blockNavigation(event);
                break;
        }
    }
    else {
        widgetAPI.blockNavigation(event);
        Main.debug("[buttonAll.js] - key blocked, keyLock.status: " + keyLock.status);
    }
};

buttonAll.getKeyEventNonPlayer = function (keyCode) {
    Main.debug("[buttonAll.js] - Key pressed: [" + keyCode + "]");

    switch (keyCode) {
        case tvKey.KEY_VOL_UP:
        case tvKey.KEY_PANEL_VOL_UP:
            Main.debug("[buttonAll.js] - VOL_UP");
            //Audio.setVolume(0);
            break;

        case tvKey.KEY_VOL_DOWN:
        case tvKey.KEY_PANEL_VOL_DOWN:
            Main.debug("[buttonAll.js] - VOL_DOWN");
            //Audio.setVolume(1);
            break;

        case tvKey.KEY_MUTE:
            Main.debug("[buttonAll.js] - MUTE");
            //Audio.muteMode();
            break;

        case tvKey.KEY_TOOLS:
            Main.debug("[buttonAll.js] - TOOLS");
            if (getProductType() !== "BD-Player") {
                buttonAll.tools();
            }
            break;

        case tvKey.KEY_INFOLINK:
        case tvKey.KEY_WLINK:
        case tvKey.KEY_CONTENT:
            Main.debug("[buttonAll.js] - Internet@TV");
            widgetAPI.blockNavigation(event);
            Main.onUnload();
            widgetAPI.sendReturnEvent();
            break;
        case tvKey.KEY_EXIT:
            Main.debug("[buttonAll.js] - EXIT");
            widgetAPI.blockNavigation(event);
            Main.onUnload();
            widgetAPI.sendExitEvent();
            break;

        default:
            Main.debug("[buttonAll.js] - Unhandled key");
            widgetAPI.blockNavigation(event);
            break;
    }
};

buttonAll.tools = function () {
    var state = null;
    var bufferState = null;

    if (Main.view === 0 || Main.view === Main.SETTINGS) {
        state = 0;
        bufferState = 1;
    }
    else {
        state = Player.state;
        bufferState = Player.BUFFER;
    }

    if (Main.screenlock === 0 && state !== bufferState) {

        Popup.showMessageBox(Popup.INFO, text.tools, [text.toolsA, text.toolsP], function (val) {
            if (val !== null) {
                curWidget.onWidgetEvent = buttonAll.widgetEvent();
                if (val === text.toolsA) {
                    pluginAPI.ShowTools(0);
                } else if (val === text.toolsP) {
                    pluginAPI.ShowTools(1);
                }
            }
        });
    }
    else {
        Main.debug("[buttonAll.js] - Can't open TOOLS because another popup is already open");
    }
};

buttonAll.widgetEvent = function () {
    Main.debug("[buttonAll.js] - Widget popup closed");
    //return focus to the main page
    $("#anchor").focus();
    keyLock.status = keyLock.NONE;
};

buttonAll.red = function () {
    if (Player.autoplay === Player.ON) {
        Player.setAutoPlay(Player.OFF);

        if (Main.osd === 0 && Player.state !== Player.STOPPED && Player.state !== Player.BUFFER && Player.mode !== Player.MODE_MUSIC) {
            Main.slideOSD("up");
            window.setTimeout("Main.slideOSD('down')", 2500);
        }
        Main.debug("[buttonAll.js] - Autoplay: OFF");
    } else if (Player.autoplay === Player.OFF) {
        Player.setAutoPlay(Player.ON);
        if (Main.osd === 0 && Player.state !== Player.STOPPED && Player.state !== Player.BUFFER && Player.mode !== Player.MODE_MUSIC) {
            Main.slideOSD("up");
            window.setTimeout("Main.slideOSD('down')", 2500);
        }
        Main.debug("[buttonAll.js] - Autoplay: ON");
    }
    else if (Main.screenlock === 1) {
        Main.debug("[buttonAll.js] - Can't change Autoplay because popup is open");
    }
};

buttonAll.green = function () {
    if (Player.state !== Player.STOPPED && Player.state !== Player.BUFFER && Player.mode !== Player.MODE_MUSIC) {
        if ($("#rightOSD").length > 0) {
            if (Main.rightOSD === 0) {
                Main.slideRightOSD("left");
            }
            else {
                Main.slideRightOSD("right");
            }
        }
    }
    else {
        Main.debug("[buttonAll.js] - Player is stopped");
    }
};

buttonAll.yellow = function () {
    //Main.debug("[buttonAll.js] - Main.view: " + Main.view);
    //Main.debug("[buttonAll.js] - Main.mediaContent: " + Main.mediaContent);
    //Main.debug("[buttonAll.js] - Data.contentViewGroup: " + Data.contentViewGroup);

    if (Display.videoPlayerVisible === 1) {
        return false;
    }

    if (Main.view === Main.SECTIONS && Data.contentViewGroup === "movie") {
        if ((prefs.categorie.viewmode || "carousel") === "listview") {
            prefs.categorie.viewmode = "carousel";
            Main.debug("[buttonAll.js] - Viewmode is now: [" + prefs.categorie.viewmode + "]");
            Main.history.pop();
            Main.loadPage("movie", "forward");
        }
    }
    else if (Main.view === Main.SECTIONS && Data.contentViewGroup === "show") {
        if ((prefs.categorie.viewmode || "carousel") === "listview") {
            prefs.categorie.viewmode = "carousel";
            Main.debug("[buttonAll.js] - Viewmode is now: [" + prefs.categorie.viewmode + "]");
            Main.history.pop();
            Main.loadPage("show", "forward");
        }
    }
    else if (Main.view === Main.MOVIE) {
        prefs.categorie.viewmode = "listview";
        Main.debug("[buttonAll.js] - Viewmode is now: [" + prefs.categorie.viewmode + "]");
        Main.history.pop();
        Main.loadPage("catSection", "forward");
    }
    else if (Main.view === Main.SHOW) {
        prefs.categorie.viewmode = "listview";
        Main.debug("[buttonAll.js] - Viewmode is now: [" + prefs.categorie.viewmode + "]");
        Main.history.pop();
        Main.loadPage("catSection", "forward");
    }
};

buttonAll.info = function (id, callback) {

    if (Data.contentTitles[0] === text.noData) {
        Main.showInfo(text.noData, "info");
    } else if (Player.state !== Player.STOPPED && Player.state !== Player.BUFFER && Player.themePlaying === 0) {
        if (Main.osd === 0) {
            Main.slideOSD("up");
        } else {
            Main.slideOSD("down");
        }
    } else if ((Player.state === Player.STOPPED || Player.state === Player.PLAYING && Player.themePlaying === 1) && Main.screenlock === 0) {

        if (Data.contentRatingKeys[id] !== "") {
            Popup.showMessageBox(Popup.INFO, text.mark, [text.watched, text.unwatched], function (val) {
                if (val !== null) {
                    if (val == text.watched) {
                        Main.debug("[buttonAll.js] - Set as watched");
                        Main.setWatched(Data.contentRatingKeys[id], Main.WATCHED, Data.contentIdentifier, Main.server, callback);
                    } else if (val == text.unwatched) {
                        Main.debug("[buttonAll.js] - Set as Unwatched");
                        Main.setWatched(Data.contentRatingKeys[id], Main.UNWATCHED, Data.contentIdentifier, Main.server, callback);
                    }
                }
            });
        }
    }
};

buttonAll.blue = function (tag, callback) {

    if (getModel(2010)) {
        Main.showInfo(text.errorSupport, "info");
        return false;
    }

    if (Main.deleteAllowed === 0) {
        Main.debug("[buttonAll.js] - DELETE not allowed");
        return false;
    }

    if (Main.screenlock === 0 && (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC)) {

        if (Main.mediaContent !== Main.QUEUE && Main.mediaContent !== Main.RECOMMENDED) {
            if (!getServerPrefValue("allowMediaDeletion")) {
                Main.debug("[buttonAll.js] - Pref allowMediaDeletion: [false]");
                Main.showInfo(text.errorMediaDeletionDisabled, "info", text.close);
                return false;
            } else {
                Main.debug("[buttonAll.js] - Pref allowMediaDeletion: [true]");
            }
        }

        var infoText = "Delete";
        if (Main.mediaContent === Main.EPISODE)
            infoText = text.deleteEpisode;
        else if (Main.mediaContent === Main.MOVIE)
            infoText = text.deleteMovie;
        else if (Main.mediaContent === Main.ARTIST)
            infoText = text.deleteTrack;
        else if (Main.mediaContent === Main.PHOTO)
            infoText = text.deletePhoto;
        else if (Main.mediaContent === Main.QUEUE || Main.mediaContent === Main.RECOMMENDED)
            infoText = text.deleteClip;

        Popup.showMessageBox(Popup.WARNING, infoText, [text.cancel, text.yes], function (val) {
            if (val !== null) {
                if (val === text.yes) {
                    Main.deleteContentFile(tag, callback);
                }
            }
        });
    }
    else {
        Main.debug("[buttonAll.js] - Can't open DELETE dialog at this moment");
    }
};
