var buttonCatSection =
{
    listPosition: 0
};

buttonCatSection.enableKeys = function () {
    if (Popup.status > 0) {
        document.getElementById("popupAnchor").focus();
    } else {
        document.getElementById("anchor").focus();
    }
};

buttonCatSection.keyDown = function () {
    var keyCode = event.keyCode;
    Main.debug("[buttonCatSection.js] - Key pressed: [" + keyCode + "]");

    if (keyLock.checkKey(keyCode)) {
        switch (keyCode) {
            case tvKey.KEY_RETURN:
            case tvKey.KEY_PANEL_RETURN:
                Main.debug("[buttonCatSection.js] - RETURN");
                widgetAPI.blockNavigation(event); // blocking that the program get closed
                if (Main.alphabet === 1) {
                    $('#alphabet').hide();
                    Main.alphabet = 0;
                    keyLock.status = keyLock.NONE;
                } else if (Main.rightOSD === 1) {
                    var txtObj = $("#rightOSDBottomReturnText");
                    if (Main.selectedRightOSD === 8 && $(txtObj).text() !== text.hide) {
                        Player.jumpToStr = "";
                        var obj = $("#rightOSDJumpToData");
                        $(obj).putInnerHTML("00h 00min 00sec");
                        $(obj).css("color", "white");
                        $(txtObj).putInnerHTML(text.hide);
                    } else
                        Main.slideRightOSD("right");
                } else if (Player.state !== Player.STOPPED && Player.mode !== Player.MODE_MUSIC) {
                    Player.autoplay = Player.OFF;
                    Player.stopVideo(Player.INPROGRESS);
                } else if (SlideShow.visible) {
                    SlideShow.Stop();
                } else {
                    Display.hideDescription();
                    Main.loadPage("main", "back");
                }
                break;

            case tvKey.KEY_ENTER:
            case tvKey.KEY_PANEL_ENTER:
                Main.debug("[buttonCatSection.js] - ENTER");
                if (Main.alphabet === 1) {
                    Main.closeAlphabet();
                }
                else if (Main.rightOSD === 1) {
                    Main.handleRightOSD(Main.RIGHT);
                }
                else if (Data.contentTitles[0] === "..") {
                    Main.loadPage("main", "back");
                }
                else if ((Player.state === Player.PLAYING || Player.state === Player.PAUSED) && Player.mode !== Player.MODE_MUSIC) {
                    Main.debug("[buttonCatSection.js] - Sending key to buttonAll.getKeyEvent");
                    buttonAll.getKeyEvent(tvKey.KEY_ENTER);
                }
                else {
                    Main.direction = "forward";
                    if (keyLock.status === keyLock.NONE) { //wait for update
                        buttonCatSection.redirect();
                    }
                }

                break;

            case tvKey.KEY_RIGHT:
                Main.debug("[buttonCatSection.js] - RIGHT");
                Main.debug("[buttonCatSection.js] - Main.screenlock: " + Main.screenlock);
                if (Main.screenlock === 0) {
                    if (Main.rightOSD === 1) {
                        Main.selectNextRightOSDArrow(Main.RIGHT);
                    }
                    else if (SlideShow.visible) {
                        SlideShow.Next(Main.RIGHT);
                    }
                    else if (Player.state === Player.PAUSED || Player.state === Player.PLAYING) {
                        Player.skipForwardVideo();
                    }
                    else if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.lock === 0 && Main.alphabet === 0) {
                        if (Data.contentViewGroup === "artist") {
                            Main.showAlphabet();
                        }
                    }
                    else if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.lock === 0 && Main.alphabet === 1) {
                        if (Data.contentViewGroup === "artist") {
                            Main.setAlphabet("up");
                        }
                    }
                }
                else
                    Main.debug("[buttonPlay.js] - Movie can't go RIGHT because a popup is open");
                break;

            case tvKey.KEY_LEFT:
                Main.debug("[buttonCatSection.js] - LEFT");
                if (Main.screenlock === 0) {
                    if (Main.rightOSD === 1) {
                        Main.selectNextRightOSDArrow(Main.LEFT);
                    }
                    else if (SlideShow.visible) {
                        SlideShow.Next(Main.LEFT);
                    }
                    else if (Player.state === Player.PAUSED || Player.state === Player.PLAYING) {
                        Player.skipBackwardVideo();
                    }
                    else if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.lock === 0 && Main.alphabet === 0) {
                        if (Data.contentViewGroup === "artist") {
                            Main.showAlphabet();
                        }
                    }
                    else if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.lock === 0 && Main.alphabet === 1) {
                        if (Data.contentViewGroup === "artist") {
                            Main.setAlphabet("down");
                        }
                    }
                }
                else
                    Main.debug("[buttonPlay.js] - Movie can't go LEFT because a popup is open");
                break;

            case tvKey.KEY_UP:
                Main.debug("[buttonCatSection.js] - UP");
                if (Main.rightOSD === 1 && Main.screenlock === 0) {
                    if (Main.lock === 0)
                        Main.selectPrevRightOSD();
                }
                else if (SlideShow.visible) {
                    SlideShow.Faster();
                }
                else if (Main.lock === 0 && Main.pageLoaded === 1) {
                    Main.lock = 1;
                    buttonCatSection.selectNextSection(Main.UP);
                }
                break;

            case tvKey.KEY_DOWN:
                Main.debug("[buttonCatSection.js] - DOWN");
                if (Main.rightOSD === 1 && Main.screenlock === 0) {
                    if (Main.lock === 0)
                        Main.selectNextRightOSD();
                }
                else if (SlideShow.visible) {
                    SlideShow.Slower();
                }
                else if (Main.lock === 0 && Main.pageLoaded === 1) {
                    Main.lock = 1;
                    buttonCatSection.selectNextSection(Main.DOWN);
                }
                break;
            case tvKey.KEY_FF_: // >>|
                Main.debug("[buttonCatSection.js] - FF_BD");
                if (Main.lock === 0) {
                    Main.lock = 1;
                    buttonCatSection.selectNextPage(Main.PAGE_DOWN);
                }
                break;
            case tvKey.KEY_REWIND_: // |<<
                Main.debug("[buttonCatSection.js] - REWIND_BD");
                if (Main.lock === 0) {
                    Main.lock = 1;
                    buttonCatSection.selectNextPage(Main.PAGE_UP);
                }
                break;
            case tvKey.KEY_CH_UP:
                Main.debug("[buttonCatSection.js] - KEY_CH_UP");
                if (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) {
                    if (Main.lock === 0) {
                        Main.lock = 1;
                        buttonCatSection.selectNextPage(Main.PAGE_UP);
                    }
                }
                break;
            case tvKey.KEY_CH_DOWN:
                Main.debug("[buttonCatSection.js] - KEY_CH_DOWN");
                if (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) {
                    if (Main.lock === 0) {
                        Main.lock = 1;
                        buttonCatSection.selectNextPage(Main.PAGE_DOWN);
                    }
                }
                break;
            case tvKey.KEY_INFO:
                Main.debug("[buttonCatSection.js] - KEY_INFO");
                buttonAll.info(Main.selectedSection, buttonCatSection.refreshList);
                break;
            case tvKey.KEY_BLUE:
                Main.debug("[buttonCatSection.js] - KEY_BLUE");
                buttonAll.blue(Data.contentRatingKeys[Main.selectedSection], buttonCatSection.deleteCallback);
                break;
            default:
                Main.debug("[buttonCatSection.js] - Sending key to buttonAll.getKeyEvent");
                buttonAll.getKeyEvent(keyCode);
                break;
        }
    }
    else {
        widgetAPI.blockNavigation(event);
        Main.debug("[buttonAll.js] - key blocked, keyLock.status: " + keyLock.status);
    }
};

buttonCatSection.redirect = function () {

    Main.debug("[buttonCatSection.js] - Main.mediaContent: " + Main.mediaContent);
    Main.debug("[buttonCatSection.js] - Data.contentKeys[Main.selectedSection]: " + Data.contentKeys[Main.selectedSection]);

    if (Data.contentSettings[Main.selectedSection] === "1") {
        Main.showInfo(text.errorPrefs, "info");
        return false;
    }

    loadbar.show();

    if (Data.contentTitles[0] === text.noData) {
        Main.loadPage("main", "back");
        return false;
    }

    Main.currentUrl = Main.currentUrl.leftFrom("?"); //strip the stuff after the question mark

    Main.debug("[buttonCatSection.js] -  Main.currentUrl: " + Main.currentUrl);

    var section = "catSection";
    switch (Main.mediaContent) {
        case Main.MOVIE:
            if (Main.direction === "forward") {

                if (Data.contentSearch[Main.selectedSection] === 1) {
                    widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), text.search + " " + text.movies + " <img src='Images/navi/B.png' />");
                    document.getElementById("searchBox").style.display = "block";
                    searchBox = new IME_Input("searchText", function (searchString) {
                        document.getElementById("anchor").focus();
                        document.getElementById("searchBox").style.display = "none";
                        Main.debug("[buttonCatSection.js] - searchString: " + searchString);
                        if (searchString !== "") {
                            Main.nextPageUrl = Main.server.resolveUrl(Main.currentUrl + "/" + Data.contentKeys[Main.selectedSection] + "&query=" + searchString, false, false);
                            Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                            if ((prefs.categorie.viewmode || "carousel") === "listview") {
                                Main.loadPage("catSection", "forward");
                            } else {
                                Main.loadPage("movie", "forward");
                            }
                        }
                    });
                    return false;
                }

                if (Data.contentTypes[Main.selectedSection] === "movie") {
                    Player.mode = Player.MODE_VIDEO;
                    Main.showMediaInfo(Main.selectedSection, function (value) {
                        if (value !== null) {
                            buttonCatSection.playMovie(value);
                        }
                    });
                    return false;
                }

                if (Data.contentViewGroup === "secondary") {
                    Main.nextPageUrl = Main.server.resolveUrl(Main.currentUrl + "/" + Data.contentKeys[Main.selectedSection], false, false);
                }
                else {
                    Main.nextPageUrl = Main.server.resolveUrl(Data.contentKeys[Main.selectedSection], false, false);
                }

                Main.debug("[buttonCatSection.js] - Main.nextPageUrl: " + Main.nextPageUrl);

                PlexRequest.fetchUrl(Main.nextPageUrl, function () {
                    if (PlexRequest.viewGroup === "movie" && PlexRequest.containerType === "Video") {
                        Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                        if ((prefs.categorie.viewmode || "carousel") === "listview") {
                            Main.loadPage("catSection", "forward");
                        } else {
                            Main.loadPage("movie", "forward");
                        }
                    }
                    else {
                        Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                        Main.loadPage("catSection", "forward");
                    }
                }, 0, 1);
                break;
            }
            else {
                Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                Main.loadPage("catSection", "forward");
            }
            break;
        case Main.EPISODE:
        case Main.SEASON:
        case Main.SHOW:
            if (Main.direction === "forward") {

                if (Data.contentSearch[Main.selectedSection] === 1) {

                    if (Data.contentTitles[Main.selectedSection].contains("Episode")) {
                        widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), text.search + " " + text.episodes + " <img src='Images/navi/B.png' />");
                        section = "episode";
                    }
                    else if (Data.contentTitles[Main.selectedSection].contains("Show")) {
                        widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), text.search + " " + text.shows + " <img src='Images/navi/B.png' />");
                        section = "show";
                    }
                    else if (Data.contentTitles[Main.selectedSection].contains("Season")) {
                        widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), text.search + " " + text.seasons + " <img src='Images/navi/B.png' />");
                        section = "season";
                    }

                    document.getElementById("searchBox").style.display = "block";
                    searchBox = new IME_Input("searchText", function (searchString) {
                        document.getElementById("anchor").focus();
                        document.getElementById("searchBox").style.display = "none";
                        if (searchString !== "") {
                            Main.nextPageUrl = Main.server.resolveUrl(Main.currentUrl + "/" + Data.contentKeys[Main.selectedSection] + "&query=" + searchString, false, false);
                            Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                            if ((prefs.categorie.viewmode || "carousel") === "listview") {
                                Main.loadPage("catSection", "forward");
                            } else {
                                Main.loadPage("show", "forward");
                            }
                        }
                    });
                    return false;
                }

                Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);

                if (Data.contentTypes[Main.selectedSection] === "episode") {
                    Player.mode = Player.MODE_VIDEO;
                    Main.showMediaInfo(Main.selectedSection, function (value) {
                        if (value !== null) {
                            buttonCatSection.playMovie(value);
                        }
                    });
                    return false;
                }

                if (Data.contentViewGroup === "secondary") {
                    Main.nextPageUrl = Main.server.resolveUrl(Main.currentUrl + "/" + Data.contentKeys[Main.selectedSection], false, false);
                }
                else {
                    Main.nextPageUrl = Main.server.resolveUrl(Data.contentKeys[Main.selectedSection], false, false);
                }

                Main.debug("[buttonCatSection.js] - Main.nextPageUrl: " + Main.nextPageUrl);

                PlexRequest.fetchUrl(Main.nextPageUrl, function () {
                    if (PlexRequest.viewGroup === "show") {
                        if ((prefs.categorie.viewmode || "carousel") === "listview") {
                            Main.loadPage("catSection", "forward");
                        } else {
                            Main.loadPage("show", "forward");
                        }
                    }
                    else if (PlexRequest.viewGroup === "season") {
                        Main.loadPage("season", "forward");
                        return false;
                    }
                    else if (PlexRequest.viewGroup === "episode" && PlexRequest.containerType === "Video") {
                        Display.episodeFilter = 1;
                        Main.loadPage("episode", "forward");
                    }
                    else {
                        Main.loadPage("catSection", "forward");
                    }
                }, 0, 1);
                break;
            }
            else {
                Main.loadPage("catSection", "forward");
            }
            break;
        case Main.ARTIST:
            if (Main.direction === "forward") {

                if (Data.contentSearch[Main.selectedSection] === 1) {
                    if (Data.contentTitles[Main.selectedSection].contains("Artist"))
                        widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), text.search + " " + text.artists + " <img src='Images/navi/B.png' />");
                    else if (Data.contentTitles[Main.selectedSection].contains("Album"))
                        widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), text.search + " " + text.albums + " <img src='Images/navi/B.png' />");
                    else if (Data.contentTitles[Main.selectedSection].contains("Track"))
                        widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), text.search + " " + text.tracks + " <img src='Images/navi/B.png' />");

                    document.getElementById("searchBox").style.display = "block";
                    searchBox = new IME_Input("searchText", function (searchString) {
                        document.getElementById("anchor").focus();
                        document.getElementById("searchBox").style.display = "none";
                        if (searchString !== "") {
                            Main.nextPageUrl = Main.server.resolveUrl(Main.currentUrl + "/" + Data.contentKeys[Main.selectedSection] + "&query=" + searchString, false, false);
                            Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                            Main.loadPage("catSection", "forward");
                        }
                    });
                    return false;
                }

                if (Data.contentViewGroup === "secondary") {
                    Main.nextPageUrl = Main.server.resolveUrl(Main.currentUrl + "/" + Data.contentKeys[Main.selectedSection], false, false);
                }
                else {
                    Main.nextPageUrl = Main.server.resolveUrl(Data.contentKeys[Main.selectedSection], false, false);
                }

                Main.debug("[buttonCatSection.js] - Main.nextPageUrl: " + Main.nextPageUrl);
                Main.debug("[buttonCatSection.js] - Content.contentCount: " + Data.contentCount);

                if (Data.contentMedias[Main.selectedSection] !== "") {
                    buttonCatSection.updatePlayList("buttonCatSection.playTrack", Main.selectedSection); //update the playlist and start playback
                }
                else {
                    Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                    Main.loadPage("catSection", "forward");
                }
                break;
            }
            else {
                Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                Main.loadPage("catSection", "forward");
            }
            break;
        case Main.PHOTO:
            if (Main.direction === "forward") {
                if (Data.contentViewGroup === "secondary") {
                    Main.nextPageUrl = Main.server.resolveUrl(Main.currentUrl + "/" + Data.contentKeys[Main.selectedSection], false, false);
                }
                else {
                    Main.nextPageUrl = Main.server.resolveUrl(Data.contentKeys[Main.selectedSection], false, false);
                }

                if (SlideShow.visible) {
                    SlideShow.Pause();
                } else {
                    Main.debug("[buttonCatSection.js] - Main.nextPageUrl: " + Main.nextPageUrl);

                    if (Data.contentTypes[Main.selectedSection] === "photo" && Data.contentKeys[Main.selectedSection].contains("/library/parts/")) {
                        buttonCatSection.updatePlayList("buttonCatSection.showPhoto", Main.selectedSection); //update the playlist and start playback
                        return false;
                    }
                    else {
                        Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                        Main.loadPage("catSection", "forward");
                    }
                }

                break;
            }
            else {
                Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                Main.loadPage("catSection", "forward");
            }
            break;
        case Main.SHARED:

            if (Main.direction === "forward") {

                if (Data.contentSearch[Main.selectedSection] === 1) {
                    if (Data.contentTitles[Main.selectedSection].contains("Episode")) {
                        widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), text.search + " " + text.episodes + " <img src='Images/navi/B.png' />");
                        section = "episode";
                    }
                    else if (Data.contentTitles[Main.selectedSection].contains("Show")) {
                        widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), text.search + " " + text.shows + " <img src='Images/navi/B.png' />");
                        section = "show";
                    }
                    else if (Data.contentTitles[Main.selectedSection].contains("Season")) {
                        widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), text.search + " " + text.seasons + " <img src='Images/navi/B.png' />");
                        section = "season";
                    }
                    else if (Data.contentTitles[Main.selectedSection].contains("Movie")) {
                        widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), text.search + " " + text.movies + " <img src='Images/navi/B.png' />");
                        section = "movie";
                    }
                    else if (Data.contentTitles[Main.selectedSection].contains("Artist")) {
                        widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), text.search + " " + text.artists + " <img src='Images/navi/B.png' />");
                        section = "catSection";
                    }
                    else if (Data.contentTitles[Main.selectedSection].contains("Album")) {
                        widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), text.search + " " + text.albums + " <img src='Images/navi/B.png' />");
                        section = "catSection";
                    }
                    else if (Data.contentTitles[Main.selectedSection].contains("Track")) {
                        widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), text.search + " " + text.tracks + " <img src='Images/navi/B.png' />");
                        section = "catSection";
                    }

                    document.getElementById("searchBox").style.display = "block";
                    searchBox = new IME_Input("searchText", function (searchString) {
                        document.getElementById("anchor").focus();
                        document.getElementById("searchBox").style.display = "none";
                        if (searchString !== "") {
                            Main.nextPageUrl = Main.server.resolveUrl(Main.currentUrl + "/" + Data.contentKeys[Main.selectedSection] + "&query=" + searchString, false, false);
                            Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                            Main.loadPage(section, "forward");
                        }
                    });
                    return false;
                }

                Main.debug("[buttonCatSection.js] - server ID: " + Data.contentMachineIndentifiers[Main.selectedSection]);

                //swap server if needed
                if (Data.contentMachineIndentifiers[Main.selectedSection] !== "") {
                    Main.server = new Server(Data.contentMachineIndentifiers[Main.selectedSection]);
                }

                if (Data.contentViewGroup === "secondary") {
                    Main.nextPageUrl = Main.server.resolveUrl(Main.currentUrl + "/" + Data.contentKeys[Main.selectedSection], false, false);
                }
                else {
                    Main.nextPageUrl = Main.server.resolveUrl(Data.contentKeys[Main.selectedSection], false, false);
                }

                Main.debug("[buttonCatSection.js] - treeUrl: " + Main.nextPageUrl);

                if (Data.contentTypes[Main.selectedSection] === "photo" && Data.contentKeys[Main.selectedSection].contains("/library/parts/")) {
                    buttonCatSection.updatePlayList("buttonCatSection.showPhoto", Main.selectedSection); //update the playlist and start playback
                    return false;
                }
                if (Data.contentTypes[Main.selectedSection] === "track" && Data.contentMedias[Main.selectedSection] !== "") {
                    buttonCatSection.updatePlayList("buttonCatSection.playTrack", Main.selectedSection); //update the playlist and start playback
                    return false;
                }

                Main.debug("[buttonCatSection.js] - viewGroup: " + PlexRequest.viewGroup + " , containerType: " + PlexRequest.containerType);

                if (Data.contentTypes[Main.selectedSection] === "movie" && PlexRequest.containerType === "Video" && Data.contentMedias[Main.selectedSection] !== "") {
                    Player.mode = Player.MODE_VIDEO;
                    Main.showMediaInfo(Main.selectedSection, function (value) {
                        if (value !== null) {
                            buttonCatSection.playMovie(value);
                        }
                    });
                    return false;
                }

                if (Data.contentTypes[Main.selectedSection] === "episode") {
                    Player.mode = Player.MODE_VIDEO;
                    Main.showMediaInfo(Main.selectedSection, function (value) {
                        if (value !== null) {
                            buttonCatSection.playMovie(value);
                        }
                    });
                    return false;
                }

                PlexRequest.fetchUrl(Main.nextPageUrl, function () {
                    Main.debug("[buttonCatSection.js] - viewGroup: " + PlexRequest.viewGroup + " , containerType: " + PlexRequest.containerType);

                    if (PlexRequest.viewGroup === "movie" && PlexRequest.containerType === "Video") {
                        Main.categoryNumber = Main.nextPageUrl.between("library/sections/", "/");
                        Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                        if ((prefs.categorie.viewmode || "carousel") === "listview") {
                            Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                            Main.loadPage("catSection", "forward");
                        } else {
                            Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                            Main.loadPage("movie", "forward");
                        }
                        return false;
                    }
                    else if (PlexRequest.viewGroup === "show") {
                        Main.categoryNumber = Main.nextPageUrl.between("library/sections/", "/");
                        Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                        if ((prefs.categorie.viewmode || "carousel") === "listview") {
                            Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                            Main.loadPage("catSection", "forward");
                        } else {
                            Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                            Main.loadPage("show", "forward");
                        }
                        return false;
                    }
                    else if (PlexRequest.viewGroup === "season") {
                        Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                        Main.loadPage("season", "forward");
                        return false;
                    }
                    else if (PlexRequest.viewGroup === "episode" && PlexRequest.containerType === "Video") {
                        Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                        Main.loadPage("episode", "forward");
                        return false;
                    }
                    else {
                        Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                        Main.loadPage("catSection", "forward");
                        return false;
                    }
                }, 0, 1);
                break;
            }
            else {
                Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                Main.loadPage("catSection", "forward");
            }
            break;
        case Main.QUEUE:
        case Main.RECOMMENDED:
            if (Main.direction === "forward") {
                Main.nextPageUrl = Main.currentUrl + "/" + Data.contentKeys[Main.selectedSection];

                Main.debug("[buttonCatSection.js] - Data.contentTypes[Main.selectedSection]: " + Data.contentTypes[Main.selectedSection]);

                if ((Data.contentMedias[Main.selectedSection] !== "") || (Data.contentKeys[Main.selectedSection].contains(".mp3")) ||
                    (Data.contentTypes[Main.selectedSection] === "clip") || (Data.contentTypes[Main.selectedSection] === "track")) {

                    if (Player.state !== Player.STOPPED && Player.mode === Player.MODE_MUSIC) {
                        Player.stopMusic();
                    }

                    Player.mode = Player.MODE_CLIP;
                    if (Data.contentMedias[Main.selectedSection]) {
                        Player.setMedia(Data.contentMedias[Main.selectedSection]);
                        Player.setAutoPlayList([Main.selectedSection]);
                        buttonCatSection.playClip();
                        //Player.playMedia(0);
                        return false;
                    }
                    else {
                        Player.setURL(Main.server.resolveUrl(Data.contentKeys[Main.selectedSection]), false, true);
                        Player.setAutoPlayList([Main.selectedSection]);
                        Player.playMedia(0);
                        return false;
                    }
                }

                PlexRequest.fetchUrl(Main.nextPageUrl, function () {
                    if (PlexRequest.viewGroup === "clip") {

                    }
                    else {
                        Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                        Main.loadPage("catSection", "forward");
                    }
                }, 0, 1);
            }
            else {
                Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                Main.loadPage("catSection", "forward");
            }
            break;
        case Main.PLEXONLINE:
            if (Main.direction === "forward") {

                if (Data.contentKeys[Main.selectedSection].startsWith("/system/appstore/updates")) {
                    var url = Main.server.resolveUrl(Data.contentKeys[Main.selectedSection], false, true);
                    Main.showInfo(text.contactingServer, "info", text.close);
                    AjaxManager.parseHTTP(Main.server.resolveUrl(url, false, true), buttonCatSection.plexonlineReturnData, null, 0, "PLEXONLINE");
                    return false;
                }

                if (Data.contentKeys[Main.selectedSection].startsWith("/video") ||
                    Data.contentKeys[Main.selectedSection].startsWith("/music") ||
                    Data.contentKeys[Main.selectedSection].startsWith("/photos") ||
                    Data.contentKeys[Main.selectedSection].startsWith("/system") ||
                    Data.contentKeys[Main.selectedSection].startsWith("/:/")) {

                    Main.nextPageUrl = Main.server.resolveUrl(Data.contentKeys[Main.selectedSection], false, true);
                }
                else {
                    Main.nextPageUrl = Main.server.resolveUrl(Main.currentUrl + "/" + Data.contentKeys[Main.selectedSection], false, true);
                }

                Main.nextPageUrl += (Main.nextPageUrl.contains("?")) ? "&" : "?" + $.param(Main.server.getHeaders(), true);

                //Main.debug("[buttonCatSection.js] - Main.nextPageUrl: " + Main.nextPageUrl);

                PlexRequest.fetchUrl(Main.nextPageUrl, function () {
                    if (PlexRequest.popup === true) {
                        AjaxManager.parseHTTP(Main.server.resolveUrl(Main.nextPageUrl, false, true), buttonCatSection.showStoreChoice, null, 0, "PLEXONLINE", null);
                    } else {
                        Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                        Main.loadPage("catSection", "forward");
                    }
                });
            }
            break;
        case Main.PLUGIN:
            if (Main.direction === "forward") {

                if (Data.contentSearch[Main.selectedSection] === 1) {
                    widgetAPI.putInnerHTML(document.getElementById("searchPrompt"), Data.contentTitles[Main.selectedSection] + " <img src='Images/navi/B.png' />");
                    document.getElementById("searchBox").style.display = "block";
                    searchBox = new IME_Input("searchText", function (searchString) {
                        document.getElementById("anchor").focus();
                        document.getElementById("searchBox").style.display = "none";
                        if (searchString !== "") {
                            Main.nextPageUrl = Main.server.resolveUrl(Data.contentKeys[Main.selectedSection] + "&query=" + searchString, false, false);
                            Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                            Main.loadPage("catSection", "forward");
                        }
                    });
                    return false;
                }

                // Main.debug("[buttonCatSection.js] - Data.contentTypes[Main.selectedSection]: " + Data.contentTypes[Main.selectedSection]);
                if ((Data.contentContainerType[Main.selectedSection] === "Video")) {
                    buttonCatSection.updatePlayList("buttonCatSection.playClip", Main.selectedSection);
                    return false;
                } else if ((Data.contentContainerType[Main.selectedSection] === "Track")) {
                    buttonCatSection.updatePlayList("buttonCatSection.playTrack", Main.selectedSection);
                    return false;
                } else if ((Data.contentContainerType[Main.selectedSection] === "Photo")) {
                    if (SlideShow.visible) {
                        loadbar.hide();
                        SlideShow.Pause();
                        return false;
                    } else {
                        buttonCatSection.updatePlayList("buttonCatSection.showPhoto", Main.selectedSection);
                        return false;
                    }
                } else {


                    if (Main.currentUrl == Data.contentKeys[Main.selectedSection]) { //for refresh buttons in channels, don't store history.
                        Main.loadPage("catSection", "forward");
                        Main.history.pop();
                        return false;
                    }

                    if (Data.contentKeys[Main.selectedSection]) {
                        if (Data.contentKeys[Main.selectedSection].startsWith("/video") ||
                            Data.contentKeys[Main.selectedSection].startsWith("/music") ||
                            Data.contentKeys[Main.selectedSection].startsWith("/photos") ||
                            Data.contentKeys[Main.selectedSection].startsWith("/system") ||
                            Data.contentKeys[Main.selectedSection].startsWith("/applications") ||
                            Data.contentKeys[Main.selectedSection].startsWith("/:/")) {
                            Main.nextPageUrl = Data.contentKeys[Main.selectedSection];
                        }
                        else {
                            Main.nextPageUrl = Main.currentUrl + "/" + Data.contentKeys[Main.selectedSection];
                            Main.nextPageUrl += (Main.nextPageUrl.contains("?")) ? "&" : "?" + $.param(Main.server.getHeaders(), true);
                        }
                    }
                    else {
                        Main.nextPageUrl = Main.currentUrl + "/" + Data.contentKeys[Main.selectedSection];
                        Main.nextPageUrl += (Main.nextPageUrl.contains("?")) ? "&" : "?" + $.param(Main.server.getHeaders(), true);
                    }

                    PlexRequest.fetchUrl(Main.nextPageUrl, function () {
                        //Main.debug("PlexRequest.popup: " + PlexRequest.popup);
                        if (PlexRequest.popup === true) {
                            AjaxManager.parseHTTP(Main.server.resolveUrl(Main.nextPageUrl, false, true), buttonCatSection.showStoreChoice, null, 0, "PLUGIN", null);
                        } else if (PlexRequest.message !== "") {
                            Popup.showMessage(Popup.INFO, PlexRequest.header, PlexRequest.message, text.close);
                            return false;
                        } else {
                            Main.updateHistoryPosition(Main.selectedSection, Display.listPosition);
                            Main.loadPage("catSection", "forward");
                        }
                    });
                }
            }
            break;
        default:
            Main.debug("[buttonCatSection.js] - Unknown Main.mediaContent: " + Main.mediaContent);
    }
};

buttonCatSection.refreshList = function () {
    Data.clearContent();
    Content.callback = "Display.setContentList";
    Content.id = "listUpdate";
    Content.fetchContentList(Content.cat, Content.section, 0, 1, "noUpdate");
};

buttonCatSection.updatePlayList = function (callback, id) {
    Content.callback = callback;
    Content.id = "playlist";
    Content.fetchContentList(Content.cat, Content.section, 0, Data.contentCount, "noUpdate");
};

buttonCatSection.playTrack = function () {

    Main.debug("[buttonCatSection.js] - Playing track: " + Data.contentTitles[Main.selectedSection]);

    Player.albumImage = Main.getPhoto(Data.contentThumbs[Main.selectedSection], 70, 70, "artist");
    Player.aristName = (Data.contentGrandParentTitles[Main.selectedSection] || Data.contentTitle2 || Data.contentTitle1);
    Player.albumName = Data.contentParentTitles[Main.selectedSection];
    Player.songName = Data.contentTitles[Main.selectedSection];
    Display.showAudioPlayer();

    Player.contentTitle = Data.contentTitles[Main.selectedSection];
    Player.contentYear = Player.aristName + ", " + Player.albumName;
    Player.mode = Player.MODE_MUSIC;

    if (Data.contentMedias[Main.selectedSection]) {
        Main.debug("[buttonCatSection.js] - Playing track with setMedia");
        Player.setMedia(Data.contentMedias[Main.selectedSection]);
        Player.setAutoPlayList([Main.selectedSection]);
        Player.playMedia(0);
    }
    else {
        Main.debug("[buttonCatSection.js] - Playing track with setUrl");

        if (Data.contentKeys[Main.selectedSection].startsWith("/")) {
            Player.setURL(Main.server.resolveUrl(Data.contentKeys[Main.selectedSection], false, true));
        } else {
            var prefix = Main.currentUrl.leftFrom("?");
            Player.setURL(Main.server.resolveUrl(prefix + "/" + Data.contentKeys[Main.selectedSection], false, true));
        }

        Player.setAutoPlayList([Main.selectedSection]);
        Player.playMusic();
    }
};

buttonCatSection.playClip = function () {

    Main.debug("[buttonCatSection.js] - Playing Clip: " + Data.contentTitles[Main.selectedSection]);

    if (Player.state !== Player.STOPPED && Player.mode === Player.MODE_MUSIC) {
        Player.stopMusic();
    }

    Player.contentTitle = Data.contentTitles[Main.selectedSection];
    Player.contentYear = Data.contentYears[Main.selectedSection];
    Player.mode = Player.MODE_CLIP;
    if (Data.contentMedias[Main.selectedSection] !== "") {
        Main.debug("[buttonCatSection.js] - Playing clip with setMedia");
        Player.setMedia(Data.contentMedias[Main.selectedSection]);
        Player.setAutoPlayList([Main.selectedSection]);
        Player.playMedia(0);
    }
    else {
        Main.debug("[buttonCatSection.js] - Playing clip with setUrl");

        if (Data.contentKeys[Main.selectedSection].startsWith("/") || Data.contentKeys[Main.selectedSection].substring(0, 10).contains("://")) {
            Player.setURL(Main.server.resolveUrl(Data.contentKeys[Main.selectedSection], false, true));
        } else {
            var prefix = Main.currentUrl.leftFrom("?");
            Player.setURL(Main.server.resolveUrl(prefix + "/" + Data.contentKeys[Main.selectedSection], false, true));
        }

        Player.setAutoPlayList([Main.selectedSection]);
        Player.playMedia(0);
    }
};

buttonCatSection.playMovie = function (time) {

    Main.debug("[buttonCatSection.js] - Playing Movie: " + Data.contentTitles[Main.selectedSection]);

    if (Player.state !== Player.STOPPED && Player.mode === Player.MODE_MUSIC) {
        Player.stopMusic();
    }

    Player.contentTitle = Data.contentTitles[Main.selectedSection];
    Player.contentYear = Data.contentYears[Main.selectedSection];
    Player.mode = Player.MODE_VIDEO;
    if (Data.contentMedias[Main.selectedSection] !== "") {
        Main.debug("[buttonCatSection.js] - Playing movie with setMedia");
        Player.setMedia(Data.contentMedias[Main.selectedSection]);
        Player.setAutoPlayList([Main.selectedSection]);
    }
    else {
        Main.debug("[buttonCatSection.js] - Playing movie with setUrl");
        if (Data.contentKeys[Main.selectedSection].startsWith("/")) {
            Player.setURL(Main.server.resolveUrl(Data.contentKeys[Main.selectedSection], false, true));
        } else {
            var prefix = Main.currentUrl.leftFrom("?");
            Player.setURL(Main.server.resolveUrl(prefix + "/" + Data.contentKeys[Main.selectedSection], false, true));
        }
        Player.setAutoPlayList([Main.selectedSection]);
    }

    if (time) {
        Player.playMedia(time);
    } else {
        Player.playMedia(0);
    }
};

buttonCatSection.showPhoto = function () {
	window.setTimeout(SlideShow.setPhotoPlayList, 200, Main.selectedSection);
	window.setTimeout(SlideShow.Show, 200, Main.selectedSection);
    SlideShow.Show();
    loadbar.hide();
};

buttonCatSection.deleteCallback = function (xhrObj) {
    Main.debug("[buttonCatSection.js] - delete returned : " + xhrObj.status);
    buttonCatSection.refreshList();
};

buttonCatSection.refreshList = function () {
    Data.clearContent();
    Content.callback = "Display.setCategorieSectionList";
    Content.id = "catSectionUpdate";
    Content.fetchContentList(Content.cat, null, null, null, "noUpdate");
};

buttonCatSection.showStoreChoice = function (tree, xhrObj, id) {
    if (tree) {
        if (tree.ASContainer) {
            Popup.showChoice(tree.ASContainer.Directory, "PLEXONLINE", text.manageChannel, function (val) {
                if (val !== null) {
                    var url = Main.server.resolveUrl(val, false, true);
                    Main.debug("[Main.js] - Choice url: " + url);
                    Main.showInfo(text.contactingServer, "info", text.close);
                    AjaxManager.parseHTTP(url, buttonCatSection.plexonlineReturnData, null, 30000, Content.id);
                }
            });
        }
        else if (tree.MediaContainer) {
            Popup.showChoice(tree.MediaContainer.Directory, "PLEXONLINE", text.manageChannel, function (val) {
                if (val !== null) {
                    var url = Main.server.resolveUrl(val, false, true);
                    Main.debug("[Main.js] - Choice url: " + url);
                    Main.showInfo(text.contactingServer, "info", text.close);
                    AjaxManager.parseHTTP(url, buttonCatSection.plexonlineReturnData, null, 30000, Content.id);
                }
            });
        }
    }
    else {
        Content.handleError();
    }
};

buttonCatSection.plexonlineReturnData = function (tree, xhrObj) {
    if (xhrObj === null) {//timeout occured
        Content.handleError(null);
        return false;
    }

    if (xhrObj.status !== 200) {
        Main.debug("[Content.js] - Media XML Server Error " + xhrObj.status);
        if (xhrObj.status !== 0) { //skip 0, this is due to the object being destroyed before it got back, like in fast scrolling.
            Main.showInfo(text.timedOut, "info", text.close);
            Content.handleError(xhrObj);
        }
    }
    else {

        if (tree) {
            if (tree.MediaContainer) {
                Main.showInfo(tree.MediaContainer["-header"] + "<br>" + tree.MediaContainer["-message"], "info", text.close);
                buttonCatSection.refreshList();
            }
            else {
                Main.handleError();
            }
        }
    }
};

buttonCatSection.selectNextSection = function (direction) {

    if (Main.selectedSection === Data.contentCount - 1 && direction === Main.DOWN) {
        Main.selectedSection = 0; //move to top
    } else if (Main.selectedSection === 0 && direction === Main.UP) {
        Main.selectedSection = Data.contentCount - 1;
    } else if (direction === Main.DOWN) {
        Main.selectedSection = Main.selectedSection + 1;
        if (Main.selectedSection > Data.contentCount - 1) {
            Main.selectedSection = Data.contentCount - 1;
        }
    } else if (direction === Main.UP) {
        Main.selectedSection = Main.selectedSection - 1;
        if (Main.selectedSection < 0) {
            Main.selectedSection = 0;
        }
    }

    Main.debug("[buttonCatSection.js] - selectNextSection :" + Main.selectedSection);
    Display.slideList("section", Main.selectedSection, direction);
};

buttonCatSection.selectNextPage = function (direction) {

    if (Main.selectedSection === Data.contentCount - 1 && direction === Main.PAGE_DOWN) {
        Main.selectedSection = 0; //move to top
    } else if (Main.selectedSection === 0 && direction === Main.PAGE_UP) {
        Main.selectedSection = Data.contentCount - 1;
    } else if (direction === Main.PAGE_DOWN) {
        Main.selectedSection = Main.selectedSection + 10;
        if (Main.selectedSection > Data.contentCount - 1) {
            Main.selectedSection = Data.contentCount - 1;
        }
    } else if (direction === Main.PAGE_UP) {
        Main.selectedSection = Main.selectedSection - 10;
        if (Main.selectedSection < 0) {
            Main.selectedSection = 0;
        }
    }

    Main.debug("[buttonCatSection.js] - selectNextSection :" + Main.selectedSection);
    Display.slideList("section", Main.selectedSection, direction);
};