var supported = ["movie", "show", "plugin", "queue", "shared", "recommendations", "artist", "photo", "plexonline", "applications"];
var buttonCategorie =
{
    rightLock: 0,
    selectedRight: 0,
    rightBg: 0,
    rightBgPic: "",
    pict: "",
    nextArt: "",
    prevArt: "",
    displayTimer: 0,
    currentBG: 0,

    OD: 1,
    RA: 2,

    SINGLE: 0,
    DOUBLE: 1
};

buttonCategorie.enableKeys = function () {
    if (Popup.status > 0) {
        document.getElementById("popupAnchor").focus();
    } else {
        document.getElementById("anchor").focus();
    }
};

buttonCategorie.keyDown = function () {
    var keyCode = event.keyCode;

    if (keyLock.checkKey(keyCode)) {
        Main.debug("[buttonCategorie.js] - Key pressed: [" + keyCode + "]");
        switch (keyCode) {
            case tvKey.KEY_RETURN:
            case tvKey.KEY_PANEL_RETURN:
                Main.debug("[buttonCategorie.js] - RETURN");
                widgetAPI.blockNavigation(event);
                if (Main.rightOSD === 1) {
                    var txtObj = $("#rightOSDBottomReturnText");
                    if (Main.selectedRightOSD === 8 && $(txtObj).text() !== text.hide) {
                        Player.jumpToStr = "";
                        var obj = $("#rightOSDJumpToData");
                        $(obj).putInnerHTML("00h 00min 00sec");
                        $(obj).css("color", "white");
                        $(txtObj).putInnerHTML(text.hide);
                    } else {
                        Main.slideRightOSD("right");
                    }
                }
                else if (SlideShow.visible) {
                    SlideShow.Stop();
                }
                else if (Player.state !== Player.STOPPED && Player.mode !== Player.MODE_MUSIC) {
                    Player.autoplay = Player.OFF;
                    Player.stopVideo(Player.INPROGRESS);
                }
                else if (buttonCategorie.rightLock === 1 && Main.lock === 0) {
                    if (buttonCategorie.rightBg === buttonCategorie.DOUBLE) {
                        if (buttonCategorie.rightLock === 1 && buttonCategorie.selectedRight === buttonCategorie.OD && buttonCategorie.rightBg === buttonCategorie.DOUBLE) {
                            buttonCategorie.contentUnfocus("doubleBgODContent", Main.selectedOD, "last");
                        }
                        if (buttonCategorie.rightLock === 1 && buttonCategorie.selectedRight === buttonCategorie.RA && buttonCategorie.rightBg === buttonCategorie.DOUBLE) {
                            buttonCategorie.contentUnfocus("doubleBgRAContent", Main.selectedRA, "last");
                        }
                        document.getElementById("doubleBg").style.backgroundImage = "url(" + buttonCategorie.rightBgPic.src + ")";
                        buttonCategorie.rightBgPic.src = "Images/categorie/doubleFocused.png";
                    }
                    else if (buttonCategorie.rightLock === 1 && buttonCategorie.rightBg === buttonCategorie.SINGLE) {
                        buttonCategorie.contentUnfocus("singleBgContent", Main.selectedRA, "last");
                        document.getElementById("singleBg").style.backgroundImage = "url(" + buttonCategorie.rightBgPic.src + ")";
                        buttonCategorie.rightBgPic.src = "Images/categorie/singleFocused.png";
                    }
                    buttonCategorie.showCategories();
                    buttonCategorie.rightLock = 0;
                    buttonCategorie.highlightPosterRow();
                    Main.debug("[buttonCategorie.js] - Category left rightBG ");
                }
                else if (Main.screenlock === 0 && buttonCategorie.rightLock === 0 && keyLock.status === keyLock.NONE) {

                    Popup.showMessageBox(Popup.QUESTION, text.exitApp, [text.cancel, text.exit], function (val) {
                        if (val !== null) {
                            if (val === text.exit) {
                                widgetAPI.blockNavigation(event);
                                Main.onUnload();
                                widgetAPI.sendReturnEvent();
                            }
                        }
                    });
                    return false;
                }
                break;

            case tvKey.KEY_ENTER:
            case tvKey.KEY_PANEL_ENTER:
                Main.debug("[buttonCategorie.js] - ENTER");
                buttonCategorie.handleEnter();
                break;
            case tvKey.KEY_RIGHT:
                Main.debug("[buttonCategorie.js] - RIGHT");
                if (Main.rightOSD === 1 && Main.screenlock === 0)
                    Main.selectNextRightOSDArrow(Main.RIGHT);
                else if (Main.screenlock === 0) {
                    if (SlideShow.visible) {
                        SlideShow.Next(Main.RIGHT);
                    } else if (Player.state === Player.PAUSED || (Player.state === Player.PLAYING && Player.mode !== Player.MODE_MUSIC)) {
                        Player.skipForwardVideo();
                    } else if (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) {
                        if (supported.indexOf(Data.category[Main.selectedCat].type) === -1) //set sections in top of this page
                        {
                            if (Data.category[Main.selectedCat].type === "preferences") {
                                buttonCategorie.hideCategories();
                                Main.loadPage("setting", "forward");
                            }
                            else
                                Main.debug("[buttonCategorie.js] - Category can't go RIGHT because not correct category type selected");
                        }
                        else if (buttonCategorie.rightLock === 0 && Data.categorieRACount !== 0) {
                            Main.debug("[buttonCategorie.js] - Category entered rightBG ");
                            buttonCategorie.rightLock = 1;
                            buttonCategorie.hideCategories();
                            if (buttonCategorie.rightBg === buttonCategorie.DOUBLE) {
                                document.getElementById("doubleBg").style.backgroundImage = "url(" + buttonCategorie.rightBgPic.src + ")";
                                buttonCategorie.rightBgPic.src = "Images/categorie/doubleUnfocused.png";
                                buttonCategorie.highlightPosterRow();
                                if (buttonCategorie.selectedRight === buttonCategorie.OD) {
                                    buttonCategorie.updateSelected("doubleBgODContent", Main.selectedOD);
                                }
                                else if (buttonCategorie.selectedRight === buttonCategorie.RA) {
                                    buttonCategorie.updateSelected("doubleBgRAContent", Main.selectedRA);
                                }
                            }
                            else if (buttonCategorie.selectedRight === buttonCategorie.RA && buttonCategorie.rightBg === buttonCategorie.SINGLE) {
                                buttonCategorie.rightBgPic.src = "Images/categorie/singleUnfocused.png";
                                buttonCategorie.updateSelected("singleBgContent", Main.selectedRA);
                            }
                        }
                        else if (buttonCategorie.rightLock === 1 && Main.lock === 0) {
                            Main.lock = 1;
                            buttonCategorie.slideBg("right");
                        }
                        else if (buttonCategorie.rightLock === 0 && Data.categorieRACount === 0) {
                            Main.debug("[buttonCategorie.js] - Category can't go RIGHT because there is no content in this Category");
                        }
                        else
                            Main.debug("[buttonCategorie.js] - Category can't go RIGHT because popup is open");
                    }
                }
                break;

            case tvKey.KEY_LEFT:
                Main.debug("[buttonCategorie.js] - LEFT");
                if (Main.rightOSD === 1 && Main.screenlock === 0)
                    Main.selectNextRightOSDArrow(Main.LEFT);
                else if (Main.screenlock === 0) {
                    if (SlideShow.visible) {
                        SlideShow.Next(Main.LEFT);
                    }
                    else if (Player.state === Player.PAUSED || (Player.state === Player.PLAYING && Player.mode !== Player.MODE_MUSIC))
                        Player.skipBackwardVideo();
                    else if (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) {
                        if (buttonCategorie.rightLock === 1) {
                            if (Main.lock === 0 && ((buttonCategorie.selectedRight === buttonCategorie.RA && Main.selectedRA > 0 && buttonCategorie.rightBg === buttonCategorie.SINGLE) || (buttonCategorie.selectedRight === buttonCategorie.RA && Main.selectedRA > Data.categorieODCount && buttonCategorie.rightBg === buttonCategorie.DOUBLE) || (buttonCategorie.selectedRight === buttonCategorie.OD && Main.selectedOD > 0 && buttonCategorie.rightBg === buttonCategorie.DOUBLE))) {
                                Main.lock = 1;
                                buttonCategorie.slideBg("left");
                            }
                            else if (Main.lock === 0) {
                                if (buttonCategorie.rightBg === buttonCategorie.DOUBLE) {
                                    if (Main.selectedOD === 0 && buttonCategorie.selectedRight === buttonCategorie.OD) {
                                        buttonCategorie.contentUnfocus("doubleBgODContent", Main.selectedOD, "last");
                                        Main.updateBackGroundArt(null, Main.selectedOD);
                                    }
                                    else if (Main.selectedRA === Data.categorieODCount && buttonCategorie.selectedRight === buttonCategorie.RA) {
                                        buttonCategorie.contentUnfocus("doubleBgRAContent", Main.selectedRA, "last");
                                        Main.updateBackGroundArt(null, Main.selectedRA);
                                    }
                                    document.getElementById("doubleBg").style.backgroundImage = "url(" + buttonCategorie.rightBgPic.src + ")";
                                    buttonCategorie.rightBgPic.src = "Images/categorie/doubleFocused.png";
                                }
                                else if (buttonCategorie.rightBg === buttonCategorie.SINGLE) {
                                    buttonCategorie.contentUnfocus("singleBgContent", Main.selectedRA, "last");
                                    document.getElementById("singleBg").style.backgroundImage = "url(" + buttonCategorie.rightBgPic.src + ")";
                                    buttonCategorie.rightBgPic.src = "Images/categorie/singleFocused.png";
                                }
                                buttonCategorie.showCategories();
                                buttonCategorie.rightLock = 0;
                                buttonCategorie.highlightPosterRow();
                                Main.debug("[buttonCategorie.js] - Category left rightBG ");
                            }
                        }
                        else
                            Main.debug("[buttonCategorie.js] - Category can't go LEFT because popup is open");
                    }
                }
                break;

            case tvKey.KEY_UP:
                Main.debug("[buttonCategorie.js] - UP");

                if (Main.screenlock === 1) {
                    Main.debug("[buttonCategorie.js] - Category can't go UP because popup is open");
                }
                else if (Main.rightOSD === 1) {
                    if (Main.lock === 0)
                        Main.selectPrevRightOSD();
                }
                else if (SlideShow.visible) {
                    SlideShow.Faster();
                }
                else if (buttonCategorie.rightLock === 0) {
                    if (Main.lock === 0 && Main.pageLoaded === 1) {
                        Main.lock = 1;
                        buttonCategorie.slideCat('up');
                    }
                }
                else if (Main.lock === 0 && buttonCategorie.rightLock === 1 && buttonCategorie.selectedRight === buttonCategorie.RA && buttonCategorie.rightBg === buttonCategorie.DOUBLE && (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC)) {
                    buttonCategorie.selectedRight = buttonCategorie.OD;
                    buttonCategorie.highlightPosterRow();
                    buttonCategorie.contentUnfocus("doubleBgRAContent", Main.selectedRA, "last");
                    buttonCategorie.updateSelected("doubleBgODContent", Main.selectedOD);
                }
                break;

            case tvKey.KEY_DOWN:
                Main.debug("[buttonCategorie.js] - DOWN");
                if (Main.screenlock === 1) {
                    Main.debug("[buttonCategorie.js] - Category can't go DOWN because popup is open");
                }
                else if (Main.rightOSD === 1) {
                    if (Main.lock === 0)
                        Main.selectNextRightOSD();
                }
                else if (SlideShow.visible) {
                    SlideShow.Slower();
                }
                else if (buttonCategorie.rightLock === 0) {
                    if (Main.lock === 0 && Main.pageLoaded === 1) {
                        Main.lock = 1;
                        buttonCategorie.slideCat('down');
                    }
                }
                else if (Main.lock === 0 && buttonCategorie.rightLock === 1 && buttonCategorie.selectedRight === buttonCategorie.OD && buttonCategorie.rightBg === buttonCategorie.DOUBLE && (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC)) {
                    buttonCategorie.selectedRight = buttonCategorie.RA;
                    buttonCategorie.highlightPosterRow();
                    buttonCategorie.contentUnfocus("doubleBgODContent", Main.selectedOD, "last");
                    buttonCategorie.updateSelected("doubleBgRAContent", Main.selectedRA);
                }
                break;

            case tvKey.KEY_INFO:
                if (buttonCategorie.selectedRight === buttonCategorie.RA) {
                    buttonAll.info(Main.selectedRA, buttonCategorie.setwatchedCallback);
                } else if (buttonCategorie.selectedRight === buttonCategorie.OD) {
                    buttonAll.info(Main.selectedOD, buttonCategorie.setwatchedCallback);
                }
                break;
            case tvKey.KEY_YELLOW:
                Main.debug("[buttonCategorie.js] - YELLOW");
                break;
            case tvKey.KEY_BLUE:
                Main.debug("[buttonCatSection.js] - KEY_BLUE");

                if (buttonCategorie.selectedRight === buttonCategorie.RA) {
                    if (Main.mediaContent === Main.QUEUE || Main.mediaContent === Main.RECOMMENDED) {
                        buttonAll.blue(Data.contentIds[Main.selectedRA], buttonCategorie.setwatchedCallback);
                    }
                    else {
                        buttonAll.blue(Data.contentRatingKeys[Main.selectedRA], buttonCategorie.setwatchedCallback);
                    }
                }
                else if (buttonCategorie.selectedRight === buttonCategorie.OD) {
                    if (Main.mediaContent === Main.QUEUE || Main.mediaContent === Main.RECOMMENDED) {
                        buttonAll.blue(Data.contentIds[Main.selectedOD], buttonCategorie.setwatchedCallback);
                    }
                    else {
                        buttonAll.blue(Data.contentRatingKeys[Main.selectedOD], buttonCategorie.setwatchedCallback);
                    }
                }
                break;
            default:
                Main.debug("[buttonCategorie.js] - Sending key to buttonAll.getKeyEvent");
                buttonAll.getKeyEvent(keyCode);
                break;
        }
    }
    else {
        widgetAPI.blockNavigation(event);
        Main.debug("[buttonCategorie.js] - key blocked, keyLock.status: " + keyLock.status);
    }
};

/*
 ####################
 #
 #       CATEGORIES
 #
 ####################
 */

buttonCategorie.handleEnter = function () {

    if (Main.rightOSD === 1) {
        Main.handleRightOSD();
    }
    else if (Data.category[Main.selectedCat].type === "preferences") {
        if (getModel(2010))
            loadbar.show();

        //buttonCategorie.hideCategories();

        $('#leftAll').animate({ 'left': -300 }, 300, function () {
            Main.loadPage("setting", "forward");
        });
        return false;
    }
    else if (Data.category[Main.selectedCat].type === "quit") {
        Main.onUnload();
        widgetAPI.sendReturnEvent();
    }
    else if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && buttonCategorie.rightLock === 1) {

        if (buttonCategorie.selectedRight === buttonCategorie.RA) {
            Main.selectedContent = Main.selectedRA;
            Main.selectedEpisode = Main.selectedRA;
        }
        else if (buttonCategorie.selectedRight === buttonCategorie.OD) {
            Main.selectedContent = Main.selectedOD;
            Main.selectedEpisode = Main.selectedOD;
        }

        if (Main.mediaContent === Main.MOVIE) {
            Main.showMediaInfo(Main.selectedContent, function (value) {
                if (value !== null) {
                    buttonCategorie.playContent(value, Player.MODE_VIDEO);
                }
            });
            return false;
        }
        else if (Main.mediaContent === Main.EPISODE) {
            Main.showMediaInfo(Main.selectedEpisode, function (value) {
                if (value !== null) {
                    buttonCategorie.playContent(value, Player.MODE_VIDEO);
                }
            });
            return false;
        }
        else if (Main.mediaContent === Main.PHOTO) {
            if (SlideShow.visible) {
                SlideShow.Pause();
            } else {
                SlideShow.setPhotoPlayList(Main.selectedRA);
                SlideShow.Show();
                loadbar.hide();
            }
            return false;
        }
        else if (Main.mediaContent === Main.ARTIST) {
            Main.nextPageUrl = Main.server.resolveUrl(Data.contentKeys[Main.selectedRA], false, false);
            Main.loadPage("catSection", "forward");
            return false;
        }
        else if (Main.mediaContent === Main.PLUGIN) {
            Main.nextPageUrl = Main.server.resolveUrl(Data.contentKeys[Main.selectedRA] + "?" + $.param(Main.server.getHeaders(), false, false));
            Main.loadPage("catSection", "forward");
            return false;
        }
        else if (Main.mediaContent === Main.QUEUE) {
            Main.showMediaInfo(Main.selectedRA, function (value) {
                if (value !== null) {
                    buttonCategorie.playContent(value, Player.MODE_CLIP);
                }
            }, true); //don't check multiple versions
            return false;
        }
        else if (Main.mediaContent === Main.RECOMMENDED) {
            Main.showMediaInfo(Main.selectedRA, function (value) {
                if (value !== null) {
                    buttonCategorie.playContent(value, Player.MODE_CLIP);
                }
            });
            return false;
        }
        else if (Main.mediaContent === Main.SHARED) {
            if (Data.contentMachineIndentifiers[Main.selectedSection] !== "") {
                Main.server = new Server(Data.contentMachineIndentifiers[Main.selectedSection]);
                Main.nextPageUrl = Main.server.resolveUrl(Data.contentKeys[Main.selectedRA], false, false);
                Main.loadPage("catSection", "forward");
            }
            return false;
        }
    }
    else if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && buttonCategorie.rightLock === 0 && Main.screenlock === 0) {
        keyLock.status = keyLock.BLOCKALL; //block buttons while animating
        document.getElementById("singleBg").style.display = "none";
        document.getElementById("doubleBg").style.display = "none";
        document.getElementById("bottom").style.display = "none";

        var slidetime = 500;
        if (getProductType() !== "TV")
            slidetime = 50; //kill the animation effect on the slower devices, don't set to zero!

        $('#leftAll').animate({ 'left': "-300px" }, slidetime, function () {
            switch (Data.category[Main.selectedCat].type) {
                case "plugin":
                case "queue":
                case "recommendations":
                    Main.nextPageUrl = Main.server.resolveUrl(Data.category[Main.selectedCat].baseUrl, false, true);
                    Main.loadPage("catSection", "forward");
                    break;
                case "shared":
                    Main.nextPageUrl = Main.server.resolveUrl(Data.category[Main.selectedCat].url + Data.category[Main.selectedCat].baseUrl, false, true);
                    Main.loadPage("catSection", "forward");
                    break;
                default:
                    Main.nextPageUrl = Main.server.resolveUrl(Data.category[Main.selectedCat].url, false, true);
                    Main.loadPage("catSection", "forward");
                    break;
            }
        });
    }
    else {
        Main.debug("[buttonCategorie.js] - Sending key to buttonAll.getKeyEvent");
        Main.debug("[buttonCategorie.js] - Player.state: " + Player.state);
        Main.debug("[buttonCategorie.js] - buttonCategorie.rightLock: " + buttonCategorie.rightLock);
        buttonAll.getKeyEvent(tvKey.KEY_ENTER);
    }

};

buttonCategorie.playContent = function (resume, mode) {
    if (Player.state !== Player.STOPPED && Player.mode === Player.MODE_MUSIC) {
        Player.stopMusic();
    }

    if (Player.state !== Player.PLAYING || Player.state !== Player.BUFFER) {

        keyLock.status = keyLock.PLAYERSTART;
        Player.mode = mode;
        Player.resumeTime = resume;

        var selected = Main.selectedContent;

        if (Main.mediaContent === Main.EPISODE) {
            selected = Main.selectedEpisode;
            Player.contentTitle = Data.contentGrandParentTitles[selected];
            Player.contentYear = "Season " + Data.contentParentIndexs[selected] + ", Episode " + Data.contentIndexs[selected] + ": " + Data.contentTitles[selected];
        }
        else {
            Player.contentTitle = Data.contentTitles[selected];
            Player.contentYear = Data.contentYears[selected];
        }

        if (Data.contentMedias[selected] !== "") {
            Main.debug("[Display.js] - Playing Movie with setMedia");
            Player.setMedia(Data.contentMedias[selected]);
            Player.setAutoPlayList(selected);
            Player.playMedia(resume);
        }
        else {
            Main.debug("[Display.js] - Playing Movie with setUrl");
            Player.setURL(Main.server.resolveUrl(Data.contentKeys[selected], false, true));
            Player.setAutoPlayList(selected);
            Player.playMedia(resume);
        }
    }
    else {
        Main.debug("[buttonCategorie.js] - Ignoring play key, not in correct state");
    }
};

buttonCategorie.focusCat = function (id, noanim) {
    var t = (noanim) ? 0 : 150;
    $('#' + id).stop(true, true).animate({
        fontSize: '30px'
    }, t, "linear", function () {
        $(this).css({
            color: '#FD9800',
            fontSize: '30px'
        });
        if (Data.category[id].serverName !== "") {
            $(this).css({
                height: '48px',
                paddingTop: '2px'
            });
            $(this).closest('li').find('span').css('display', 'block');
        } else {
            $(this).css({
                height: '35px',
                paddingTop: '11px'
            });
        }
    });
};

buttonCategorie.unfocusCat = function (id) {
    $('#' + id).stop(true, true).animate({
        fontSize: '22px'
    }, 150, "linear", function () {
        $(this).css({
            color: '#808080',
            fontSize: '22px',
            paddingTop: '15px',
            height: '35px'
        });
        $(this).closest('li').find('span').css('display', 'none');
    });
};

buttonCategorie.setwatchedCallback = function () {
    buttonCategorie.updateCurrentCat();
    buttonCategorie.showCategories();
    buttonCategorie.rightLock = 0;
    buttonCategorie.highlightPosterRow();
};

buttonCategorie.updateCurrentCat = function () {
    //## CLEAN UP
    widgetAPI.putInnerHTML(document.getElementById("singleBgCarousel_ul"), "");
    widgetAPI.putInnerHTML(document.getElementById("doubleBgODCarousel_ul"), "");
    widgetAPI.putInnerHTML(document.getElementById("doubleBgRACarousel_ul"), "");
    widgetAPI.putInnerHTML(document.getElementById("doubleBgRAContentName"), "");
    widgetAPI.putInnerHTML(document.getElementById("doubleBgODContentName"), "");
    widgetAPI.putInnerHTML(document.getElementById("singleBgContentName"), "");

    Main.debug("buttonCategorie.js - Data.category[Main.selectedCat].server: " + Data.category[Main.selectedCat].server);
    Main.server = new Server(Data.category[Main.selectedCat].server);
    Main.debug("buttonCategorie.js - server: " + Main.server.name);

    insertText("serverFriendlyName", Data.category[Main.selectedCat].serverName || "");
    buttonCategorie.rightLock = 0;
    Data.categorieODCount = 0;
    Data.categorieRACount = 0;
    Data.clearContent();
    var doublerow = false;

    if (supported.indexOf(Data.category[Main.selectedCat].type) === -1) {//set supported sections in top of this page
        loadbar.hide();
        $("#singleBg").hide();
        $("#doubleBg").hide();
    }
    else {

        Main.debug("[buttonCategorie.js] - Loading " + Data.category[Main.selectedCat].type);
        loadbar.show();
        Main.categoryNumber = 0;

        if (Data.category[Main.selectedCat].type === "movie") {
            Main.view = Main.MOVIE;
            Main.mediaContent = Main.MOVIE;
            doublerow = true;
            widgetAPI.putInnerHTML(document.getElementById("doubleBgODContentFilter"), text.categoryOD);
            widgetAPI.putInnerHTML(document.getElementById("doubleBgRAContentFilter"), text.categoryRA);
            Main.categoryNumber = Data.category[Main.selectedCat].url.rightFromLast("/");
            //Main.debug("[buttonCategorie.js] - Main.categoryNumber: " + Main.categoryNumber);
            Data.clearContent();
            Content.id = Main.selectedCat;
            Content.fetchContentList(Data.category[Main.selectedCat].url, "onDeck", 0, 20);
        }
        else if (Data.category[Main.selectedCat].type === "show") {
            Main.view = Main.EPISODE;
            Main.mediaContent = Main.EPISODE;
            doublerow = true;
            widgetAPI.putInnerHTML(document.getElementById("doubleBgODContentFilter"), text.categoryOD);
            widgetAPI.putInnerHTML(document.getElementById("doubleBgRAContentFilter"), text.categoryRA);
            Main.categoryNumber = Data.category[Main.selectedCat].url.rightFromLast("/");
            //Main.debug("[buttonCategorie.js] - Main.categoryNumber: " + Main.categoryNumber);
            Data.clearContent();
            Content.id = Main.selectedCat;
            Main.debug("[buttonCategorie.js] - Main.selectedCat: " + Main.selectedCat);
            Content.fetchContentList(Data.category[Main.selectedCat].url, "onDeck", 0, 20);
        }
        else if (Data.category[Main.selectedCat].type === "artist") {
            Main.view = Main.CATEGORIE;
            Main.mediaContent = Main.ARTIST;
            Main.categoryNumber = Data.category[Main.selectedCat].url.rightFromLast("/");
            widgetAPI.putInnerHTML(document.getElementById("singleBgContentFilter"), text.categoryRA);
            Data.clearContent();
            Content.callback = "buttonCategorie.dataReceivedCallback2";
            Content.id = Main.selectedCat;
            Content.fetchContentList(Data.category[Main.selectedCat].url, "recentlyAdded", 0, 20, "noUpdate");
        }
        else if (Data.category[Main.selectedCat].type === "photo") {
            Main.view = Main.CATEGORIE;
            Main.mediaContent = Main.PHOTO;
            Main.categoryNumber = Data.category[Main.selectedCat].url.rightFromLast("/");
            widgetAPI.putInnerHTML(document.getElementById("singleBgContentFilter"), text.categoryRA);
            Data.clearContent();
            Content.callback = "buttonCategorie.dataReceivedCallback2";
            Content.id = Main.selectedCat;
            Content.fetchContentList(Data.category[Main.selectedCat].url, "recentlyAdded", 0, 20, "noUpdate");
        }
        else if (Data.category[Main.selectedCat].type === "plugin") {
            Main.view = Main.CATEGORIE;
            Main.mediaContent = Main.PLUGIN;
            widgetAPI.putInnerHTML(document.getElementById("singleBgContentFilter"), text.categoryRV);
            Data.clearContent();
            Content.callback = "buttonCategorie.dataReceivedCallback2";
            Content.id = Main.selectedCat;
            Content.fetchContentList(Data.category[Main.selectedCat].url, null, null, null, "noUpdate");
        }
        else if (Data.category[Main.selectedCat].type === "plexonline") {
            Main.view = Main.CATEGORIE;
            Main.mediaContent = Main.PLEXONLINE;

            document.getElementById("singleBg").style.display = "none";
            document.getElementById("doubleBg").style.display = "none";
            loadbar.hide();
            Main.lock = 0; // free the lock
        }
        else if (Data.category[Main.selectedCat].type === "queue" && (prefs.myplex.authToken || "") !== "") {
            Main.view = Main.CATEGORIE;
            Main.mediaContent = Main.QUEUE;
            widgetAPI.putInnerHTML(document.getElementById("singleBgContentFilter"), text.categoryUW);
            Data.clearContent();
            Content.callback = "buttonCategorie.dataReceivedCallback2";
            Content.id = Main.selectedCat;
            Content.fetchContentList(Data.category[Main.selectedCat].baseUrl + "/unwatched", null, 0, 20, "noUpdate");
        }
        else if (Data.category[Main.selectedCat].type === "recommendations" && (prefs.myplex.authToken || "") !== "") {
            Main.view = Main.CATEGORIE;
            Main.mediaContent = Main.RECOMMENDED;
            widgetAPI.putInnerHTML(document.getElementById("singleBgContentFilter"), text.categoryUW);
            Data.clearContent();
            Content.callback = "buttonCategorie.dataReceivedCallback2";
            Content.id = Main.selectedCat;
            Content.fetchContentList(Data.category[Main.selectedCat].baseUrl + "/unwatched", null, 0, 20, "noUpdate");
        }
        else if (Data.category[Main.selectedCat].type === "shared" && (prefs.myplex.authToken || "") !== "") {
            Main.view = Main.CATEGORIE;
            Main.mediaContent = Main.SHARED;
            widgetAPI.putInnerHTML(document.getElementById("singleBgContentFilter"), "");
            Data.clearContent();
            Content.callback = "buttonCategorie.dataReceivedCallback2";
            Content.id = Main.selectedCat;
            Content.fetchContentList("https://plex.tv/pms/system" + Data.category[Main.selectedCat].baseUrl, null, 0, 20, "noUpdate");
        }

        var offset = $('#' + Main.selectedCat).offset();
        if (offset) {
            Main.debug("[buttonCategorie.js] - Menu top: " + offset.top);
            if (offset.top > 0) {
                if ((offset.top) > 255) {
                    buttonCategorie.slideCatCorrection("down");
                } else if ((offset.top) < 245) {
                    buttonCategorie.slideCatCorrection("up");
                }
            }
        }

        Content.dataReceivedCallback = function (id) {
            if (id == Main.selectedCat) { //skip second part if we moved to a different category
                if (Data.category[Main.selectedCat].type === "movie" || Data.category[Main.selectedCat].type === "show") { //if you push very fast, a new request may already be fired, then skip this
                    Content.id = id;
                    Main.view = Main.CATEGORIE;
                    Content.fetchContentList(Data.category[Main.selectedCat].url, "recentlyAdded", 0, 20);
                }
            }
        };
    }

    prefs.categorie.selectedContent = Main.mediaContent;

    if (doublerow === false) {
        Main.updateBackGroundArt(Main.getPhoto(Data.category[Main.selectedCat].art, Display.FSX, Display.FSY, Data.category[Main.selectedCat].type));
    }
    keyLock.status = keyLock.NONE;
    Main.debug("[buttonCategorie.js] - Categorie ID: [" + Main.selectedCat + "] - Type: [" + Data.category[Main.selectedCat].type + "]");
    Main.debug("[buttonCategorie.js] - CategorieCount: [" + Data.getCategorieCount() + "]");

};

buttonCategorie.dataReceivedCallback2 = function (id) {

    if (id)  // if we gave it an id it has to match
    {
        if (Main.selectedCat !== id) {
            Main.debug("[buttonCategorie.js] - skipping: " + id + ", Main.selectedCat: " + Main.selectedCat);
            return;
        }
        else {
            Main.debug("[buttonCategorie.js] - using: " + id + ", Main.selectedCat: " + Data.category[Main.selectedCat].type);
        }
    }
    else {
        Main.debug("[buttonCategorie.js] - No ID: Main.selectedCat: " + Data.category[Main.selectedCat].type);
    }

    /* Use video information when it has arrived */
    if (Data.categorieODCount === 0 && Data.categorieRACount > 0) {
        if ($('#singleBg').css('display') === "none") {
            document.getElementById("singleBg").style.display = "block";
            document.getElementById("doubleBg").style.display = "none";
        }
        buttonCategorie.rightBgPic = document.createElement("img");
        buttonCategorie.rightBgPic.src = "Images/categorie/singleFocused.png";

        if (Main.mediaContent === Main.MOVIE)
            Display.setCategorieMovieList("singleBg");
        else if (Main.mediaContent === Main.EPISODE)
            Display.setCategorieEpisodeList("singleBg");
        else
            Display.setCategorieGeneralList("singleBg", id);

        buttonCategorie.selectedRight = buttonCategorie.RA;
        buttonCategorie.rightBg = buttonCategorie.SINGLE;
        Main.selectedRA = 0;
    }
    else if (Data.categorieODCount > 0 && Data.categorieRACount > 0) {
        if ($('#doubleBg').css('display') === "none") {
            document.getElementById("doubleBg").style.display = "block";
            document.getElementById("singleBg").style.display = "none";
        }

        buttonCategorie.rightBgPic = document.createElement("img");
        buttonCategorie.rightBgPic.src = "Images/categorie/doubleFocused.png";

        if (Main.mediaContent === Main.MOVIE) {
            Display.setCategorieMovieList("doubleBgOD");
            Display.setCategorieMovieList("doubleBgRA");
        }
        else if (Main.mediaContent === Main.EPISODE) {
            Display.setCategorieEpisodeList("doubleBgOD");
            Display.setCategorieEpisodeList("doubleBgRA");
        }

        buttonCategorie.rightBg = buttonCategorie.DOUBLE;
        Main.selectedOD = 0;
        Main.selectedRA = Data.categorieODCount;

        if (buttonCategorie.selectedRight === buttonCategorie.RA) {
            buttonCategorie.selectedRight = buttonCategorie.RA;
        }
        else {
            buttonCategorie.selectedRight = buttonCategorie.OD;
        }
    }
    else {
        document.getElementById("doubleBg").style.display = "none";
        document.getElementById("singleBg").style.display = "none";
        $("#loading").hide();
    }
    document.getElementById("singleBgCarousel_ul").style.left = "0px";
    document.getElementById("doubleBgODCarousel_ul").style.left = "0px";
    document.getElementById("doubleBgRACarousel_ul").style.left = "0px";

    loadbar.hide();

    var x = Math.floor((Math.random() * Data.contentArts.length) + 1);
    if (Data.contentArts[x] !== "") {
        Main.updateBackGroundArt(Main.getPhoto(Data.contentArts[x], Display.FSX, Display.FSY, Data.category[Main.selectedCat].type), 0);
    } else {
        Main.updateBackGroundArt(Main.getPhoto(Data.category[Main.selectedCat].art, Display.FSX, Display.FSY, Data.category[Main.selectedCat].type));
    }
};

buttonCategorie.hideCategories = function () {
    for (var i = 0; i < Data.getCategorieCount(); i++) {
        if (i !== Main.selectedCat)
            $('#' + i).fadeTo(400, 0);
    }
    if (Data.category[Main.selectedCat].type !== "preferences") {
        widgetAPI.putInnerHTML(document.getElementById("bottomReturnText"), text.back);
        document.getElementById("bottomEnter").style.display = "none";
        document.getElementById("bottomRighLock").style.display = "block";

        if (Main.mediaContent === Main.MOVIE || Main.mediaContent === Main.EPISODE || Main.mediaContent === Main.QUEUE || Main.mediaContent === Main.RECOMMENDED)
            widgetAPI.putInnerHTML(document.getElementById("bottomDeleteText"), text.buttonDelete);
        else {
            document.getElementById("bottomInfoText").style.display = "none";
            document.getElementById("bottomInfoPic").style.display = "none";
        }
    }
    document.getElementById("leftAll").style.opacity = "0.9";
    document.getElementById("singleBg").style.opacity = "0.9";
    document.getElementById("doubleBg").style.opacity = "0.9";
};

buttonCategorie.showCategories = function () {
    for (var i = 0; i < Data.getCategorieCount(); i++) {
        if (i !== Main.selectedCat)
            $('#' + i).fadeTo(400, 1);
    }
    widgetAPI.putInnerHTML(document.getElementById("bottomReturnText"), text.categoryBottomExitApp);
    document.getElementById("bottomRighLock").style.display = "none";
    document.getElementById("bottomInfoText").style.display = "block";
    document.getElementById("bottomInfoPic").style.display = "block";
    document.getElementById("bottomEnter").style.display = "block";
    document.getElementById("leftAll").style.opacity = "1.0";
    document.getElementById("singleBg").style.opacity = "1.0";
    document.getElementById("doubleBg").style.opacity = "1.0";
};

/*
 ####################
 #       RIGHT BG
 ####################
 */

buttonCategorie.highlightPosterRow = function () {
    var i;
    if (buttonCategorie.rightBg === buttonCategorie.DOUBLE) {
        if (buttonCategorie.selectedRight === buttonCategorie.OD && buttonCategorie.rightLock === 1) {
            for (i = Data.categorieODCount; i < Data.categorieRealRACount; i++) {
                $("#doubleBgRAID" + i + "Black").show();
            }

            for (i = 0; i < Data.categorieODCount; i++) {
                $("#doubleBgODID" + i + "Black").hide();
            }
        }
        else if (buttonCategorie.selectedRight === buttonCategorie.RA && buttonCategorie.rightLock === 1) {
            for (i = 0; i < Data.categorieODCount; i++) {
                $("#doubleBgODID" + i + "Black").show();
            }

            for (i = Data.categorieODCount; i < Data.categorieRealRACount; i++) {
                $("#doubleBgRAID" + i + "Black").hide();
            }
        }
        else if (buttonCategorie.rightLock === 0) {
            if (buttonCategorie.selectedRight === buttonCategorie.RA) {
                for (i = 0; i < Data.categorieODCount; i++) {
                    $("#doubleBgODID" + i + "Black").hide();
                }
            }
            else if (buttonCategorie.selectedRight === buttonCategorie.OD) {
                for (i = Data.categorieODCount; i < Data.categorieRealRACount; i++) {
                    $("#doubleBgRAID" + i + "Black").hide();
                }
            }
        }
    }
};

buttonCategorie.slideBg = function (where) {
    var slide = function (divName, bg, id, whereTo) {
        var left = parseInt($('#' + divName).css('left'), 10);
        var slideTo = 0;
        if (whereTo === "right")
            slideTo = left - 120;
        else if (whereTo === "left")
            slideTo = left + 120;

        var slidetime = 250;
        if (getProductType() !== "TV")
            slidetime = 50; //kill the fading effect on the slower devices, don't set to zero!

        $('#' + divName).animate({ 'left': slideTo }, slidetime, "linear", function () {
            buttonCategorie.updateSelected(bg, id);
            Main.lock = 0;
        });
    };

    var slideOk = 0;

    if (where === "right") {
        if (buttonCategorie.rightBg === buttonCategorie.SINGLE) {
            if (Main.selectedRA + 1 < Data.categorieRealRACount) {
                buttonCategorie.contentUnfocus("singleBgContent", Main.selectedRA);
                Main.selectedRA += 1;
                slide("singleBgCarousel_ul", "singleBgContent", Main.selectedRA, "right");
            }
            else
                slideOk = 1;
        }
        else if (buttonCategorie.rightBg === buttonCategorie.DOUBLE && buttonCategorie.selectedRight === buttonCategorie.OD) {
            if (Main.selectedOD + 1 < Data.categorieODCount) {
                buttonCategorie.contentUnfocus("doubleBgODContent", Main.selectedOD);
                Main.selectedOD += 1;
                slide("doubleBgODCarousel_ul", "doubleBgODContent", Main.selectedOD, "right");
            }
            else
                slideOk = 1;
        }
        else if (buttonCategorie.rightBg === buttonCategorie.DOUBLE && buttonCategorie.selectedRight === buttonCategorie.RA) {
            if (Main.selectedRA + 1 < Data.categorieRealRACount) {
                buttonCategorie.contentUnfocus("doubleBgRAContent", Main.selectedRA);
                Main.selectedRA += 1;
                slide("doubleBgRACarousel_ul", "doubleBgRAContent", Main.selectedRA, "right");
            }
            else
                slideOk = 1;
        }
    }
    else if (where === "left") {
        if (buttonCategorie.rightBg === buttonCategorie.SINGLE) {
            if (Main.selectedRA > 0) {
                buttonCategorie.contentUnfocus("singleBgContent", Main.selectedRA);
                Main.selectedRA -= 1;
                slide("singleBgCarousel_ul", "singleBgContent", Main.selectedRA, "left");
            }
            else
                slideOk = 1;
        }
        else if (buttonCategorie.rightBg === buttonCategorie.DOUBLE && buttonCategorie.selectedRight === buttonCategorie.OD) {
            if (Main.selectedOD > 0) {
                buttonCategorie.contentUnfocus("doubleBgODContent", Main.selectedOD);
                Main.selectedOD -= 1;
                slide("doubleBgODCarousel_ul", "doubleBgODContent", Main.selectedOD, "left");
            }
            else
                slideOk = 1;
        }
        else if (buttonCategorie.rightBg === buttonCategorie.DOUBLE && buttonCategorie.selectedRight === buttonCategorie.RA) {
            if (Main.selectedRA - 1 >= Data.categorieODCount) {
                buttonCategorie.contentUnfocus("doubleBgRAContent", Main.selectedRA);
                Main.selectedRA -= 1;
                slide("doubleBgRACarousel_ul", "doubleBgRAContent", Main.selectedRA, "left");
            }
            else
                slideOk = 1;
        }
    }

    if (slideOk === 1) {
        Main.lock = 0;
        return "end";
    }
};

buttonCategorie.updateSelected = function (bg, id) {
    MediaInfo.selectedContent = id;
    var thumb = document.getElementById(bg + "ID" + id);
    if (!isEmpty(thumb)) {
        thumb.style.outline = "2px solid #FD9800"; // thumb markieren
    }
    Display.setCategorieBottomButtons(id);
    Main.updateBackGroundArt(null, id); //update background
    keyLock.status = keyLock.NONE;
    if (Main.mediaContent === Main.MOVIE) {
        var str = "";
        if (Data.contentTitles[id])
            str = "<span style='color:#FD9800;'>" + Data.contentTitles[id] + "</span>";
        if (Data.contentTitles[id] && Data.contentYears[id])
            str = str + " • " + Data.contentYears[id];
        else if (Data.contentYears[id])
            str = Data.contentYears[id];
        if (Data.contentDurations[id] && (Data.contentTitles[id] || Data.contentYears[id]))
            str = str + " • " + Data.contentDurations[id].toTimeString();
        else if (Data.contentDurations[id])
            str = Data.contentDurations[id].toTimeString();

        widgetAPI.putInnerHTML(document.getElementById(bg + "Name"), str);
        Main.selectedContent = id;
        if (Data.contentMedias[id] !== "") {
            Player.setMedia(Data.contentMedias[id]);
        }
        Main.debug("[buttonCategorie.js] - Movie Name: [" + Data.contentTitles[id] + "]");
    }
    else if (Main.mediaContent === Main.EPISODE) {

        if (isEmpty(Data.contentOriginallyAvailableAt[id]))
            widgetAPI.putInnerHTML(document.getElementById(bg + "Name"), "<span style='color:#FD9800;'>" + Data.contentGrandParentTitles[id] + "</span> • <span style='color:#FD9800;'>" + Data.contentTitles[id] + "</span>  • " + Data.contentDurations[id].toTimeString());
        else
            widgetAPI.putInnerHTML(document.getElementById(bg + "Name"), "<span style='color:#FD9800;'>" + Data.contentGrandParentTitles[id] + "</span> • " + Data.contentOriginallyAvailableAt[id] + "<span style='color:#FD9800;'> • " + Data.contentTitles[id] + "</span>  • " + Data.contentDurations[id].toTimeString());

        Main.selectedEpisode = id;
        if (Data.contentMedias[id] !== "") {
            Player.setMedia(Data.contentMedias[id]);
        }
        Main.debug("[buttonCategorie.js] - TV Show Name: [" + Data.contentGrandParentTitles[id] + " - S" + Data.contentParentIndexs[id] + "E" + Data.contentIndexs[id] + ": " + Data.contentTitles[id] + "]");
    }
    else if (Main.mediaContent === Main.ARTIST) {
        widgetAPI.putInnerHTML(document.getElementById(bg + "Name"), "<span style='color:#FD9800;'>" + Data.contentParentTitles[id] + " • </span><span>" + Data.contentTitles[id] + "</span>");
        Main.debug("[buttonCategorie.js] - Channel Name: " + Data.contentTitles[id]);
    }
    else if (Main.mediaContent === Main.PHOTO) {
        widgetAPI.putInnerHTML(document.getElementById(bg + "Name"), "<span style='color:#FD9800;'>" + Data.contentTitles[id] + "</span>");
        Main.debug("[buttonCategorie.js] - Channel Name: " + Data.contentTitles[id]);
    }
    else if (Main.mediaContent === Main.PLUGIN) {
        widgetAPI.putInnerHTML(document.getElementById(bg + "Name"), "<span style='color:#FD9800;'>" + Data.contentTitles[id] + "</span>");
        Main.debug("[buttonCategorie.js] - Channel Name: " + Data.contentTitles[id]);
    }
    else if (Main.mediaContent === Main.QUEUE) {
        widgetAPI.putInnerHTML(document.getElementById(bg + "Name"), "<span style='color:#FD9800;'>" + Data.contentSourceTitles[id] + " • </span><span>" + Data.contentTitles[id] + "</span>");
        Main.debug("[buttonCategorie.js] - Queue item Name: " + Data.contentTitles[id]);
    }
    else if (Main.mediaContent === Main.RECOMMENDED) {
        widgetAPI.putInnerHTML(document.getElementById(bg + "Name"), "<span style='color:#FD9800;'>" + Data.contentSourceTitles[id] + " • </span><span>" + Data.contentTitles[id] + "</span>");
        Main.debug("[buttonCategorie.js] - Recommended item Name: " + Data.contentTitles[id]);
    }
    else if (Main.mediaContent === Main.SHARED) {
        widgetAPI.putInnerHTML(document.getElementById(bg + "Name"), "<span style='color:#FD9800;'>" + Data.contentSourceTitles[id] + " • </span><span>" + Data.contentTitles[id] + "</span>");
        Main.debug("[buttonCategorie.js] - Shared item Name: " + Data.contentTitles[id]);
    }

};

buttonCategorie.contentUnfocus = function (bg, id, last) {
    try {
        if (last) {
            widgetAPI.putInnerHTML(document.getElementById(bg + "Name"), "");
        }
        var thumb = document.getElementById(bg + "ID" + id);
        if (!isEmpty(thumb)) {
            thumb.style.outline = "0px solid #FD9800"; // thumb markieren
        }
    } catch (e) {

    }
};

/*
 #######################
 #       SLIDE ANIMATION
 #######################
 */
buttonCategorie.slideCat = function (where) {

    //get the item height
    var itemHeight = $("#carousel_ul").find("li").outerHeight();
    var topIndent = 0;

    if (where === "up") {
        topIndent = parseInt($("#carousel_ul").css("top"), 10) + itemHeight;
    }
    else {
        topIndent = parseInt($("#carousel_ul").css("top"), 10) - itemHeight;
    }

    if (where === "up") {
        if ((Main.selectedCat - 1) < 0) {
            Main.selectedCat = Data.getCategorieCount() - 1;
            buttonCategorie.unfocusCat(0);
        }
        else {
            Main.selectedCat = Main.selectedCat - 1;
            buttonCategorie.unfocusCat(Main.selectedCat + 1);
        }
    } else {
        if (Main.selectedCat + 1 === Data.getCategorieCount()) {
            Main.selectedCat = 0;
            buttonCategorie.unfocusCat(Data.getCategorieCount() - 1);
        }
        else {
            Main.selectedCat = Main.selectedCat + 1;
            buttonCategorie.unfocusCat(Main.selectedCat - 1);
        }
    }

    if ((prefs.general.animations || "on") === "off")
        buttonCategorie.focusCat(Main.selectedCat);


    window.clearTimeout(buttonCategorie.displayTimer); //stop updating
    $('#' + Main.selectedCat).stop(true, true);
    buttonCategorie.displayTimer = window.setTimeout(buttonCategorie.updateCurrentCat, 500);

    $("#carousel_ul").stop(true, true).animate({ "top": topIndent }, 250, "linear", function () {
        $(this).css({ "top": -51 });

        buttonCategorie.focusCat(Main.selectedCat);
        Main.selectedCatID = Data.category[Main.selectedCat].id;

        if (where === "up") {
            $("#carousel_ul").find("li:first").before($("#carousel_ul").find("li:last"));
            //Main.debug("[buttonCategorie.js] - buttonCategorie.prevArt.src : " + buttonCategorie.prevArt.src);
        }
        else {
            $("#carousel_ul").find("li:last").after($("#carousel_ul").find("li:first"));
            //Main.debug("[buttonCategorie.js] - buttonCategorie.nextArt.src : " + buttonCategorie.nextArt.src);
        }

        Main.lock = 0;
    });
};

buttonCategorie.slideCatCorrection = function (where) {

    //get the item height
    var itemHeight = $("#carousel_ul").find("li").outerHeight();
    var topIndent = 0;

    if (where === "up") {
        topIndent = parseInt($("#carousel_ul").css("top"), 10) + itemHeight;
    }
    else {
        topIndent = parseInt($("#carousel_ul").css("top"), 10) - itemHeight;
    }

    $("#carousel_ul").stop(true, true).animate({ "top": topIndent }, 250, "linear", function () {
        $(this).css({ "top": -51 });

        if (where === "up") {
            $("#carousel_ul").find("li:first").before($("#carousel_ul").find("li:last"));
            //Main.debug("[buttonCategorie.js] - buttonCategorie.prevArt.src : " + buttonCategorie.prevArt.src);
        }
        else {
            $("#carousel_ul").find("li:last").after($("#carousel_ul").find("li:first"));
            //Main.debug("[buttonCategorie.js] - buttonCategorie.nextArt.src : " + buttonCategorie.nextArt.src);
        }

        Main.lock = 0;
    });
};