var buttonEpisode =
{
    listPosition: 0
};

buttonEpisode.enableKeys = function () {
    if (Popup.status > 0) {
        document.getElementById("popupAnchor").focus();
    } else {
        document.getElementById("anchor").focus();
    }
};

buttonEpisode.keyDown = function () {
    var keyCode = event.keyCode;

    if (keyLock.checkKey(keyCode)) {
        Main.debug("[buttonEpisode.js] - Key pressed: [" + keyCode + "]");

        switch (keyCode) {
            case tvKey.KEY_RETURN:
            case tvKey.KEY_PANEL_RETURN:
                Main.debug("[buttonEpisode.js] - RETURN");
                widgetAPI.blockNavigation(event); // blocking that the program get closed
                if (Main.rightOSD === 1) {
                    var txtObj = $("#rightOSDBottomReturnText");
                    if (Main.selectedRightOSD === 8 && $(txtObj).text() !== text.hide) {
                        Player.jumpToStr = "";
                        var obj = $("#rightOSDJumpToData");
                        $(obj).putInnerHTML("00h 00min 00sec");
                        $(obj).css("color", "white");
                        $(txtObj).putInnerHTML(text.hide);
                    }
                    else
                        Main.slideRightOSD("right");
                }
                else if (Player.state !== Player.STOPPED && Player.mode !== Player.MODE_MUSIC) {
                    Player.autoplay = Player.OFF;
                    Player.stopVideo(Player.INPROGRESS);
                }
                else {
                    Main.loadPage("catSection", "back");  // the backward routine will handle the return to season
                }

                break;

            case tvKey.KEY_ENTER:
            case tvKey.KEY_PANEL_ENTER:
                Main.debug("[buttonEpisode.js] - ENTER");
                buttonEpisode.handleEnter();
                break;

            case tvKey.KEY_RIGHT:
                Main.debug("[buttonEpisode.js] - RIGHT");
                if (Main.rightOSD === 1 && Main.screenlock === 0)
                    Main.selectNextRightOSDArrow(Main.RIGHT);
                else if ((Player.state === Player.PAUSED || Player.state === Player.PLAYING) && Player.themePlaying === 0) {
                    Player.skipForwardVideo();
                }
                break;

            case tvKey.KEY_LEFT:
                Main.debug("[buttonEpisode.js] - LEFT");
                if (Main.rightOSD === 1 && Main.screenlock === 0)
                    Main.selectNextRightOSDArrow(Main.LEFT);
                else if ((Player.state === Player.PAUSED || Player.state === Player.PLAYING) && Player.themePlaying === 0) {
                    Player.skipBackwardVideo();
                }
                break;

            case tvKey.KEY_UP:
                Main.debug("[buttonEpisode.js] - UP");
                if (Main.rightOSD === 1 && Main.screenlock === 0) {
                    if (Main.lock === 0)
                        Main.selectPrevRightOSD();
                }
                else if (Main.lock === 0 && (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.pageLoaded === 1) {
                    Main.lock = 1;
                    buttonEpisode.selectNextEpisode(Main.UP);
                }
                else
                    Main.debug("[buttonEpisode.js] - not in correct state");
                break;

            case tvKey.KEY_DOWN:
                Main.debug("[buttonEpisode.js] - DOWN");
                if (Main.rightOSD === 1 && Main.screenlock === 0) {
                    if (Main.lock === 0)
                        Main.selectNextRightOSD();
                }
                else if (Main.lock === 0 && (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.pageLoaded === 1) {
                    Main.lock = 1;
                    buttonEpisode.selectNextEpisode(Main.DOWN);
                }
                break;
            case tvKey.KEY_FF_: // >>|
                Main.debug("[buttonEpisode.js] - FF_BD");
                if (Main.lock === 0) {
                    Main.lock = 1;
                    buttonEpisode.selectNextPage(Main.PAGE_DOWN);
                }
                break;

            case tvKey.KEY_REWIND_: // |<<
                Main.debug("[buttonEpisode.js] - REWIND_BD");
                if (Main.lock === 0) {
                    Main.lock = 1;
                    buttonEpisode.selectNextPage(Main.PAGE_UP);
                }
                break;
            case tvKey.KEY_CH_UP:
                Main.debug("[buttonEpisode.js] - KEY_CH_UP");
                if (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) {
                    if (Main.lock === 0) {
                        Main.lock = 1;
                        buttonEpisode.selectNextPage(Main.PAGE_UP);
                    }
                }
                break;
            case tvKey.KEY_CH_DOWN:
                Main.debug("[buttonEpisode.js] - KEY_CH_DOWN");
                if (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) {
                    if (Main.lock === 0) {
                        Main.lock = 1;
                        buttonEpisode.selectNextPage(Main.PAGE_DOWN);
                    }
                }
                break;
            case tvKey.KEY_INFO:
                Main.debug("[buttonEpisode.js] - KEY_INFO");
                buttonAll.info(Main.selectedEpisode, buttonEpisode.setwatchedCallback);
                break;
            case tvKey.KEY_BLUE:
                Main.debug("[buttonCatSection.js] - KEY_BLUE");
                buttonAll.blue(Data.contentRatingKeys[Main.selectedEpisode], buttonEpisode.setwatchedCallback);
                break;
            default:
                Main.debug("[buttonEpisode.js] - Sending key to buttonAll.getKeyEvent");
                buttonAll.getKeyEvent(keyCode);
                break;
        }
    }
    else {
        widgetAPI.blockNavigation(event);
        Main.debug("[buttonAll.js] - key blocked, keyLock.status: " + keyLock.status);
    }
};

buttonEpisode.handleEnter = function () {

    buttonEpisode.listPosition = Display.listPosition;

    if (Main.rightOSD === 1) {
        Main.handleRightOSD();
    }
    else if (Player.state === Player.STOPPED || Player.mode !== Player.MODE_VIDEO) {
        Main.showMediaInfo(Main.selectedEpisode, function (value) {
            if (value !== null) {
                buttonEpisode.playContent(value);
            }
        });
        return false;

    } else if ((Player.state === Player.PLAYING || Player.state === Player.PAUSED) && Player.mode !== Player.MODE_MUSIC) {
        Main.debug("[buttonCatSection.js] - Sending key to buttonAll.getKeyEvent");
        buttonAll.getKeyEvent(tvKey.KEY_ENTER);

    } else {
        Main.debug("[buttonEpisode.js] - not in correct state");
    }
};

buttonEpisode.playContent = function (resume) {
    if (Player.state !== Player.STOPPED && Player.mode === Player.MODE_MUSIC) {
        Player.stopMusic();
    }

    if (Player.state !== Player.PLAYING || Player.state !== Player.BUFFER) {

        keyLock.status = keyLock.PLAYERSTART;
        Player.resumeTime = resume;
        Player.mode = Player.MODE_VIDEO;

        Display.stopAnimation("episodeDescription", "top");
        keyLock.status = keyLock.PLAYERSTART;
        Player.contentTitle = Data.contentGrandParentTitles[Main.selectedEpisode];
        Player.contentYear = "Season " + Data.contentParentIndexs[Main.selectedEpisode] + ", Episode " + Data.contentIndexs[Main.selectedEpisode] + ": " + Data.contentTitles[Main.selectedEpisode];

        if (Data.contentMedias[Main.selectedEpisode] !== "") {
            Main.debug("[buttonEpisode.js] - Playing Movie with setMedia, start from [" + resume + "]");
            Player.setMedia(Data.contentMedias[Main.selectedEpisode]);
            Player.setAutoPlayList([Main.selectedEpisode]);
            Player.playMedia(resume);
        }
        else {
            Main.debug("[buttonEpisode.js] - Playing Movie with setUrl, start from [" + resume + "]");
            Player.setURL(Main.server.resolveUrl(Data.contentKeys[Main.selectedEpisode], false, true));
            Player.setAutoPlayList([Main.selectedEpisode]);
            Player.playMedia(resume);
        }
    }
    else {
        Main.debug("[buttonMovie.js] - Movie Ignoring play key, not in correct state");
    }
};

buttonEpisode.setwatchedCallback = function () {
    buttonEpisode.refreshList();
};

buttonEpisode.refreshList = function () {
    Data.clearContent();
    Content.callback = "Display.setEpisodeList";
    Content.id = "episodeUpdate";
    Content.fetchContentList(Content.cat, null, null, null, "noUpdate");
};

buttonEpisode.selectNextEpisode = function (direction) {

    if (Main.selectedEpisode === Data.contentCount - 1 && direction === Main.DOWN) {
        Main.selectedEpisode = 0; //move to top
    } else if (Main.selectedEpisode === 0 && direction === Main.UP) {
        Main.selectedEpisode = Data.contentCount - 1;
    } else if (direction === Main.DOWN) {
        Main.selectedEpisode = Main.selectedEpisode + 1;
        if (Main.selectedEpisode > Data.selectedEpisode - 1) {
            Main.selectedEpisode = Data.selectedEpisode - 1;
        }
    } else if (direction === Main.UP) {
        Main.selectedEpisode = Main.selectedEpisode - 1;
        if (Main.selectedEpisode < 0) {
            Main.selectedEpisode = 0;
        }
    }

    Main.debug("[buttonEpisode.js] - selectedEpisode :" + Main.selectedEpisode);
    Display.slideList("episode", Main.selectedEpisode, direction);
};

buttonEpisode.selectNextPage = function (direction) {

    if (Main.selectedEpisode === Data.contentCount - 1 && direction === Main.PAGE_DOWN) {
        Main.selectedEpisode = 0; //move to top
    } else if (Main.selectedEpisode === 0 && direction === Main.PAGE_UP) {
        Main.selectedEpisode = Data.contentCount - 1;
    } else if (direction === Main.PAGE_DOWN) {
        Main.selectedEpisode = Main.selectedEpisode + 10;
        if (Main.selectedEpisode > Data.contentCount - 1) {
            Main.selectedEpisode = Data.contentCount - 1;
        }
    } else if (direction === Main.PAGE_UP) {
        Main.selectedEpisode = Main.selectedEpisode - 10;
        if (Main.selectedEpisode < 0) {
            Main.selectedEpisode = 0;
        }
    }

    Main.debug("[buttonEpisode.js] - selectNextPage :" + Main.selectedEpisode);
    Display.slideList("episode", Main.selectedEpisode, direction);
};