var buttonMovie =
{
    slideIndex: 0
};

buttonMovie.enableKeys = function () {
    if (Popup.status > 0) {
        document.getElementById("popupAnchor").focus();
    } else {
        document.getElementById("anchor").focus();
    }
};

buttonMovie.keyDown = function () {
    var keyCode = event.keyCode;

    if (keyLock.checkKey(keyCode)) {
        Main.debug("[buttonMovie.js] - Key pressed: [" + keyCode + "]");

        switch (keyCode) {
            case tvKey.KEY_RETURN:
            case tvKey.KEY_PANEL_RETURN:
                Main.debug("[buttonMovie.js] - RETURN");
                widgetAPI.blockNavigation(event); // blocking that the program get closed
                if (Main.alphabet === 1) {
                    $('#alphabet').hide();
                    Main.alphabet = 0;
                    keyLock.status = keyLock.NONE;
                }
                else if (Main.rightOSD === 1) {
                    var txtObj = $("#rightOSDBottomReturnText");
                    if (Main.selectedRightOSD === 8 && $(txtObj).text() !== text.hide) {
                        Player.jumpToStr = "";
                        var obj = $("#rightOSDJumpToData");
                        $(obj).putInnerHTML("00h 00min 00sec");
                        $(obj).css("color", "white");
                        $(txtObj).putInnerHTML(text.hide);
                    }
                    else
                        Main.slideRightOSD("right");
                }
                else if (Player.state !== Player.STOPPED && Player.mode !== Player.MODE_MUSIC) {
                    Player.autoplay = Player.OFF;
                    Player.stopVideo(Player.INPROGRESS);
                }
                else {
                    prefs.categorie.selectedMovie = Main.selectedContent;
                    Main.loadPage("catSection", "back");
                }
                break;

            case tvKey.KEY_ENTER:
            case tvKey.KEY_PANEL_ENTER:
                Main.debug("[buttonMovie.js] - ENTER");
                buttonMovie.handleEnter();
                break;

            case tvKey.KEY_RIGHT:
                Main.debug("[buttonMovie.js] - RIGHT");
                if (Main.screenlock === 0) {
                    if (Main.rightOSD === 1)
                        Main.selectNextRightOSDArrow(Main.RIGHT);
                    else {
                        if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.pageLoaded === 1 && Main.lock === 0 && Main.osd === 0) {
                            Main.lock = 1;
                            buttonMovie.slide(Main.RIGHT);
                        }
                        else if ((Player.state === Player.PAUSED || Player.state === Player.PLAYING) && Player.mode !== Player.MODE_MUSIC) {
                            Player.skipForwardVideo();
                        }
                    }
                }
                else
                    Main.debug("[buttonMovie.js] - Movie can't go RIGHT because a popup is open");
                break;

            case tvKey.KEY_LEFT:
                Main.debug("[buttonMovie.js] - LEFT");
                if (Main.screenlock === 0) {
                    if (Main.rightOSD === 1)
                        Main.selectNextRightOSDArrow(Main.LEFT);
                    else {
                        if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.pageLoaded === 1 && Main.lock === 0 && Main.osd === 0) {
                            Main.lock = 1;
                            buttonMovie.slide(Main.LEFT);
                        }
                        else if ((Player.state === Player.PAUSED || Player.state === Player.PLAYING) && Player.mode !== Player.MODE_MUSIC) {
                            Player.skipBackwardVideo();
                        }
                    }
                }
                else
                    Main.debug("[buttonMovie.js] - Movie can't go LEFT because a popup is open");
                break;

            case tvKey.KEY_UP:
                Main.debug("[buttonMovie.js] - UP");
                if (Main.rightOSD === 1 && Main.screenlock === 0) {
                    if (Main.lock === 0)
                        Main.selectPrevRightOSD();
                }
                else if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.lock === 0 && Main.alphabet === 0) {
                    Main.showAlphabet();
                }
                else if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.lock === 0 && Main.alphabet === 1) {
                    Main.setAlphabet("up");
                }
                break;

            case tvKey.KEY_DOWN:
                Main.debug("[buttonMovie.js] - DOWN");
                if (Main.rightOSD === 1 && Main.screenlock === 0) {
                    if (Main.lock === 0)
                        Main.selectNextRightOSD();
                }
                else if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.lock === 0 && Main.alphabet === 0) {
                    Main.showAlphabet();
                }
                else if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.lock === 0 && Main.alphabet === 1) {
                    Main.setAlphabet("down");
                }
                break;
            case tvKey.KEY_CH_UP:
            case tvKey.KEY_FF_: // >>|
                Main.debug("[buttonMovie.js] - KEY_CH_UP");
                if (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) {
                    if (Display.pageLock === 0) {
                        Main.selectedContent += 7;
                        $("#contentInfoPoster").find("img").attr('src', Main.getPhoto("", 188 * 2, 280 * 2, "posterBig"));
                        $("#contentList").find("img").filter(":first-child").attr('src', Main.getPhoto("", 92 * 2, 134 * 2, "poster"));
                        $("#contentList").find("img").filter(":last-child").attr('src', 'Images/blank.png');
                        Display.pageLock = 1;
                        Display.setContentList();
                    }
                }
                break;
            case tvKey.KEY_CH_DOWN:
            case tvKey.KEY_REWIND_: // |<<
                Main.debug("[buttonMovie.js] - KEY_CH_DOWN");
                if (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) {
                    if (Display.pageLock === 0) {
                        Main.selectedContent -= 7;
                        $("#contentInfoPoster").find("img").attr('src', Main.getPhoto("", 188 * 2, 280 * 2, "posterBig"));
                        $("#contentList").find("img").filter(":first-child").attr('src', Main.getPhoto("", 92 * 2, 134 * 2, "poster"));
                        $("#contentList").find("img").filter(":last-child").attr('src', 'Images/blank.png');
                        Display.pageLock = 1;
                        Display.setContentList();
                    }
                }
                break;
            case tvKey.KEY_INFO:
                buttonAll.info(Main.selectedContent, buttonMovie.setwatchedCallback);
                break;
            case tvKey.KEY_BLUE:
                buttonAll.blue(Data.contentRatingKeys[Main.selectedContent], buttonMovie.setwatchedCallback);
                break;
            default:
                Main.debug("[buttonMovie.js] - Sending key to buttonAll.getKeyEvent");
                prefs.categorie.selectedMovie = Main.selectedContent;
                buttonAll.getKeyEvent(keyCode);
                break;
        }
    }
    else {
        widgetAPI.blockNavigation(event);
        Main.debug("[buttonAll.js] - key blocked, keyLock.status: " + keyLock.status);
    }
};

buttonMovie.handleEnter = function () {
    if (Main.alphabet === 1) {
        Main.closeAlphabet();
    } else if (Main.rightOSD === 1) {
        Main.handleRightOSD();
    } else if (Data.contentTitles[0] === text.noData) {
        Main.loadPage("catSection", "back");
    } else if (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) {
        Main.showMediaInfo(Main.selectedContent, function (value) {
            if (value !== null) {
                buttonMovie.playContent(value);
            }
        });
        return false;

    } else if ((Player.state === Player.PLAYING || Player.state === Player.PAUSED) && Player.mode !== Player.MODE_MUSIC) {
        Main.debug("[buttonCatSection.js] - Sending key to buttonAll.getKeyEvent");
        buttonAll.getKeyEvent(tvKey.KEY_ENTER);
    } else {
        Main.debug("[buttonMovie.js] - not in correct state");
    }
};

buttonMovie.playContent = function (resume) {
    if (Player.state !== Player.STOPPED && Player.mode === Player.MODE_MUSIC) {
        Player.stopMusic();
    }

    if (Player.state !== Player.PLAYING || Player.state !== Player.BUFFER) {
        Display.stopAnimation("contentInfoSummary", "top");

        keyLock.status = keyLock.PLAYERSTART;
        Player.resumeTime = resume;
        Player.mode = Player.MODE_VIDEO;

        Player.contentTitle = Data.contentTitles[Main.selectedContent];
        Player.contentYear = Data.contentYears[Main.selectedContent];

        if (Data.contentMedias[Main.selectedSection] !== "") {
            Main.debug("[buttonMovie.js] - Playing Movie with setMedia, start from [" + resume + "]");
            Player.setMedia(Data.contentMedias[Main.selectedContent]);
            Player.setAutoPlayList([Main.selectedContent]);
            Player.playMedia(resume);
        }
        else {
            Main.debug("[buttonMovie.js] - Playing Movie with setUrl, start from [" + resume + "]");
            Player.setURL(Main.server.resolveUrl(Data.contentKeys[Main.selectedSection], false, true));
            Player.setAutoPlayList([Main.selectedContent]);
            Player.playMedia(resume);
        }
    }
    else {
        Main.debug("[buttonMovie.js] - Movie Ignoring play key, not in correct state");
    }
};

buttonMovie.setwatchedCallback = function () {
    buttonMovie.refreshList();
};

buttonMovie.refreshList = function () {
    Data.clearContent();
    Content.callback = "Display.setContentList";
    Content.id = "movieUpdate";
    Content.fetchContentList(Content.cat, Content.section, 0, 1, "noUpdate");
};

buttonMovie.slide = function (where) {
    var i;
    var v;
    var x;
    if (where === Main.RIGHT) {

        v = Main.selectedContent + 1;
        Main.selectedContent = v.mod(Data.contentCount);

        x = Main.selectedContent + 5;
        i = x.mod(Data.contentCount);
        Display.slideIndex = i;

        Main.debug("[buttonMovie.js] - Movie Content ID: [" + Main.selectedContent + "] - Content Name: [" + Data.contentTitles[Main.selectedContent] + "]");

        if (isEmpty(Data.contentThumbs[i])) {
            loadbar.show();
            Content.callback = "Display.UpdateSlideRight";
            Content.id = "movieSlideUpdate";
            Content.fetchContentList(Content.cat, Content.section, i, 50, "noUpdate");
        }
        else {
            Display.UpdateSlideRight();
        }
    }
    else if (where === Main.LEFT) {

        v = Main.selectedContent - 1;
        Main.selectedContent = v.mod(Data.contentCount);

        x = Main.selectedContent - 4;
        i = x.mod(Data.contentCount);

        Display.slideIndex = i;

        Main.debug("[buttonMovie.js] - Movie Content ID: [" + Main.selectedContent + "] - Content Name: [" + Data.contentTitles[Main.selectedContent] + "]");

        if (isEmpty(Data.contentThumbs[i])) {
            loadbar.show();
            var s;
            if (Math.abs(i - 50) > Data.contentCount) {
                s = 0;
            } else {
                s = i - 50;
            }
            Content.callback = "Display.UpdateSlideLeft";
            Content.id = "movieSlideLeftUpdate";
            Content.fetchContentList(Content.cat, Content.section, s, 51, "noUpdate");
        }
        else {
            Display.UpdateSlideLeft();
        }

    }
};