var buttonSeason =
{
    listPosition: 0
};

buttonSeason.enableKeys = function () {
    if (Popup.status > 0) {
        document.getElementById("popupAnchor").focus();
    } else {
        document.getElementById("anchor").focus();
    }
};

buttonSeason.keyDown = function () {
    var keyCode = event.keyCode;

    if (keyLock.checkKey(keyCode)) {
        Main.debug("[buttonSeason.js] - Key pressed: [" + keyCode + "]");
        switch (keyCode) {
            case tvKey.KEY_RETURN:
            case tvKey.KEY_PANEL_RETURN:
                Main.debug("[buttonSeason.js] - RETURN");
                widgetAPI.blockNavigation(event); // blocking that the program get closed
                if (Main.rightOSD === 1) {
                    var txtObj = $("#rightOSDBottomReturnText");
                    if (Main.selectedRightOSD === 8 && $(txtObj).text() !== text.hide) {
                        Player.jumpToStr = "";
                        var obj = $("#rightOSDJumpToData");
                        $(obj).putInnerHTML("00h 00min 00sec");
                        $(obj).css("color", "white");
                        $(txtObj).putInnerHTML(text.hide);
                    }
                    else
                        Main.slideRightOSD("right");
                }
                else if (Player.state !== Player.STOPPED && Player.mode !== Player.MODE_MUSIC) {
                    Player.autoplay = Player.OFF;
                    Player.stopVideo(Player.INPROGRESS);
                }
                else {
                    if (Player.themePlaying === 1) {
                        Player.stopMusic();
                    }
                    Main.loadPage("show", "back");
                }
                break;
            case tvKey.KEY_ENTER:
            case tvKey.KEY_PANEL_ENTER:
                Main.debug("[buttonSeason.js] - ENTER");

                buttonSeason.listPosition = Display.listPosition;

                if (Main.pageLoaded === 1) {
                    Main.nextPageUrl = Main.server.resolveUrl(Data.contentKeys[Main.selectedSeason], false, false);
                    Display.episodeFilter = 0;
                    Main.updateHistoryPosition(Main.selectedSeason, Display.listPosition);
                    Main.loadPage("episode", "forward");
                }
                break;

            case tvKey.KEY_RIGHT:
                Main.debug("[buttonSeason.js] - RIGHT");
                break;

            case tvKey.KEY_LEFT:
                Main.debug("[buttonSeason.js] - LEFT");
                break;

            case tvKey.KEY_UP:
                Main.debug("[buttonSeason.js] - UP");
                if (Main.lock === 0) {
                    Main.lock = 1;
                    buttonSeason.selectNextSeason(Main.UP);
                }

                break;

            case tvKey.KEY_DOWN:
                Main.debug("[buttonSeason.js] - DOWN");
                if (Main.lock === 0) {
                    Main.lock = 1;
                    buttonSeason.selectNextSeason(Main.DOWN);
                }

                break;
            case tvKey.KEY_STOP:
                Player.stopMusic();
                break;
            case tvKey.KEY_RED:
                Main.debug("[buttonSeason.js] - RED");
                break;
            case tvKey.KEY_FF_: // >>|
                Main.debug("[buttonSeason.js] - FF_BD");
                if (Main.lock === 0) {
                    Main.lock = 1;
                    buttonSeason.selectNextPage(Main.PAGE_DOWN);
                }
                break;
            case tvKey.KEY_REWIND_: // |<<
                Main.debug("[buttonSeason.js] - REWIND_BD");
                if (Main.lock === 0) {
                    Main.lock = 1;
                    buttonSeason.selectNextPage(Main.PAGE_UP);
                }
                break;
            case tvKey.KEY_CH_UP:
                Main.debug("[buttonSeason.js] - KEY_CH_UP");
                if (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) {
                    if (Main.lock === 0) {
                        Main.lock = 1;
                        buttonSeason.selectNextPage(Main.PAGE_UP);
                    }
                }
                break;
            case tvKey.KEY_CH_DOWN:
                Main.debug("[buttonSeason.js] - KEY_CH_DOWN");
                if (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) {
                    if (Main.lock === 0) {
                        Main.lock = 1;
                        buttonSeason.selectNextPage(Main.PAGE_DOWN);
                    }
                }
                break;
            case tvKey.KEY_INFO:
                Main.debug("[buttonSeason.js] - INFO");
                buttonAll.info(Main.selectedSeason, buttonSeason.setwatchedCallback);
                break;
            case tvKey.KEY_BLUE:
                Main.debug("[buttonSeason.js] - KEY_BLUE");
                break;
            default:
                Main.debug("[buttonSeason.js] - Sending key to buttonAll.getKeyEvent");
                buttonAll.getKeyEventNonPlayer(keyCode);
                break;
        }
    }
    else {
        widgetAPI.blockNavigation(event);
        Main.debug("[buttonAll.js] - key blocked, keyLock.status: " + keyLock.status);
    }
};

buttonSeason.setwatchedCallback = function () {
    Data.clearContent();
    Content.callback = "Display.setSeasonList";
    Content.id = "seasonUpdate";
    Content.fetchContentList(Content.cat, null, null, null, "noUpdate");
};

buttonSeason.selectNextSeason = function (direction) {

    if (Main.selectedSeason === Data.contentCount - 1 && direction === Main.DOWN) {
        Main.selectedSeason = 0; //move to top
    } else if (Main.selectedSeason === 0 && direction === Main.UP) {
        Main.selectedSeason = Data.contentCount - 1;
    } else if (direction === Main.DOWN) {
        Main.selectedSeason = Main.selectedSeason + 1;
        if (Main.selectedSeason > Data.selectedSeason - 1) {
            Main.selectedSeason = Data.selectedSeason - 1;
        }
    } else if (direction === Main.UP) {
        Main.selectedSeason = Main.selectedSeason - 1;
        if (Main.selectedSeason < 0) {
            Main.selectedSeason = 0;
        }
    }

    Main.debug("[buttonSeason.js] - selectedSeason :" + Main.selectedSeason);
    Display.slideList("season", Main.selectedSeason, direction);
};

buttonSeason.selectNextPage = function (direction) {

    if (Main.selectedSeason === Data.contentCount - 1 && direction === Main.PAGE_DOWN) {
        Main.selectedSeason = 0; //move to top
    } else if (Main.selectedSeason === 0 && direction === Main.PAGE_UP) {
        Main.selectedSeason = Data.contentCount - 1;
    } else if (direction === Main.PAGE_DOWN) {
        Main.selectedSeason = Main.selectedSeason + 10;
        if (Main.selectedSeason > Data.contentCount - 1) {
            Main.selectedSeason = Data.contentCount - 1;
        }
    } else if (direction === Main.PAGE_UP) {
        Main.selectedSeason = Main.selectedSeason - 10;
        if (Main.selectedSeason < 0) {
            Main.selectedSeason = 0;
        }
    }

    Main.debug("[buttonSeason.js] - selectNextPage :" + Main.selectedSeason);
    Display.slideList("season", Main.selectedSeason, direction);
};
