var buttonShow =
{
    listPosition: 0
};

buttonShow.enableKeys = function () {
    if (Popup.status > 0) {
        document.getElementById("popupAnchor").focus();
    } else {
        document.getElementById("anchor").focus();
    }
};

buttonShow.keyDown = function () {
    var keyCode = event.keyCode;
    if (keyLock.checkKey(keyCode)) {
        Main.debug("[buttonShow.js] - Key pressed: [" + keyCode + "]");
        switch (keyCode) {
            case tvKey.KEY_RETURN:
            case tvKey.KEY_PANEL_RETURN:
                Main.debug("[buttonShow.js] - RETURN");
                widgetAPI.blockNavigation(event); // blocking that the program get closed
                if (Main.alphabet === 1) {
                    $('#alphabet').hide();
                    Main.alphabet = 0;
                    keyLock.status = keyLock.NONE;
                    return false;
                } else if (Player.mode === Player.MODE_MUSIC && Player.themePlaying === 1) {
                    Player.autoplay = Player.OFF;
                    Player.stopMusic();
                }

                prefs.categorie.selectedShow = Main.selectedContent;
                Main.loadPage("catSection", "back");
                break;

            case tvKey.KEY_ENTER:
            case tvKey.KEY_PANEL_ENTER:
                Main.debug("[buttonShow.js] - ENTER");
                if (Main.alphabet === 1) {
                    Main.closeAlphabet();
                } else if (Data.contentTitles[0] === text.noData) {
                    Main.loadPage("catSection", "back");
                } else {
                    Display.stopAnimation("contentInfoSummary", "top");
                    Main.debug("[buttonShow.js] - Show Child key: [" + Data.contentKeys[Main.selectedContent] + "]");
                    Main.nextPageUrl = Data.contentKeys[Main.selectedContent];
                    Main.selectedSeason = 0;
                    Main.updateHistoryPosition(Main.selectedContent, Display.listPosition);
                    prefs.categorie.selectedShow = Main.selectedContent;
                    Main.loadPage("season", "forward");
                }
                break;

            case tvKey.KEY_RIGHT:
                Main.debug("[buttonShow.js] - RIGHT");
                if (Main.screenlock === 0 && Main.pageLoaded === 1 && Main.lock === 0) {
                    Main.lock = 1;
                    buttonShow.slide(Main.RIGHT);
                }
                else
                    Main.debug("[buttonShow.js] - Show can't go RIGHT because a popup is open");
                break;

            case tvKey.KEY_LEFT:
                Main.debug("[buttonShow.js] - LEFT");
                if (Main.screenlock === 0 && Main.pageLoaded === 1 && Main.lock === 0) {
                    Main.lock = 1;
                    buttonShow.slide(Main.LEFT);
                }
                else
                    Main.debug("[buttonShow.js] - Show can't go LEFT because a popup is open");
                break;

            case tvKey.KEY_UP:
                Main.debug("[buttonShow.js] - UP");
                if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.lock === 0 && Main.alphabet === 0) {
                    Main.showAlphabet();
                }
                else if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.lock === 0 && Main.alphabet === 1) {
                    Main.setAlphabet("up");
                }
                break;

            case tvKey.KEY_DOWN:
                Main.debug("[buttonShow.js] - DOWN");
                if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.lock === 0 && Main.alphabet === 0) {
                    Main.showAlphabet();
                }
                else if ((Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) && Main.lock === 0 && Main.alphabet === 1) {
                    Main.setAlphabet("down");
                }
                break;

            case tvKey.KEY_INFO:
                Main.debug("[buttonShow.js] - INFO");
                buttonAll.info(Main.selectedSeason, buttonShow.setwatchedCallback);
                break;
            case tvKey.KEY_CH_UP:
            case tvKey.KEY_FF_: // >>|
                Main.debug("[buttonShow.js] - KEY_CH_UP");
                if (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) {
                    if (Display.pageLock === 0) {
                        Main.selectedContent += 7;
                        $("#contentInfoPoster").find("img").attr('src', Main.getPhoto("", 188 * 2, 280 * 2, "posterBig"));
                        $("#contentList").find("img").filter(":first-child").attr('src', Main.getPhoto("", 92 * 2, 134 * 2, "poster"));
                        $("#contentList").find("img").filter(":last-child").attr('src', 'Images/blank.png');
                        Display.pageLock = 1;
                        Display.setContentList();
                    }
                }
                break;
            case tvKey.KEY_CH_DOWN:
            case tvKey.KEY_REWIND_: // |<<
                Main.debug("[buttonShow.js] - KEY_CH_DOWN");
                if (Player.state === Player.STOPPED || Player.mode === Player.MODE_MUSIC) {
                    if (Display.pageLock === 0) {
                        Main.selectedContent -= 7;
                        $("#contentInfoPoster").find("img").attr('src', Main.getPhoto("", 188 * 2, 280 * 2, "posterBig"));
                        $("#contentList").find("img").filter(":first-child").attr('src', Main.getPhoto("", 92 * 2, 134 * 2, "poster"));
                        $("#contentList").find("img").filter(":last-child").attr('src', 'Images/blank.png');
                        Display.pageLock = 1;
                        Display.setContentList();
                    }
                }
                break;
            default:
                Main.debug("[buttonShow.js] - Sending key to buttonAll.getKeyEvent");
                prefs.categorie.selectedShow = Main.selectedContent;
                buttonAll.getKeyEvent(keyCode);
                break;
        }
    }
    else {
        widgetAPI.blockNavigation(event);
        Main.debug("[buttonAll.js] - key blocked, keyLock.status: " + keyLock.status);
    }
};

buttonShow.setwatchedCallback = function () {
    Data.clearContent();
    Content.callback = "Display.setContentList";
    Content.id = "showUpdate";
    Content.fetchContentList(Content.cat, Content.section, 0, 1, "noUpdate");
};

buttonShow.slide = function (where) {
    var i;
    var v;
    var x;
    if (where === Main.RIGHT) {

        v = Main.selectedContent + 1;
        Main.selectedContent = v.mod(Data.contentCount);

        x = Main.selectedContent + 5;
        i = x.mod(Data.contentCount);
        Display.slideIndex = i;

        Main.debug("[buttonShow.js] - Show Content ID: [" + Main.selectedContent + "] - Content Name: [" + Data.contentTitles[Main.selectedContent] + "]");

        if (isEmpty(Data.contentThumbs[i])) {
            loadbar.show();
            Content.callback = "Display.UpdateSlideRight";
            Content.id = "showSlideRightUpdate";
            Content.fetchContentList(Content.cat, Content.section, i, 50, "noUpdate");
        }
        else {
            Display.UpdateSlideRight();
        }
    }
    else if (where === Main.LEFT) {

        v = Main.selectedContent - 1;
        Main.selectedContent = v.mod(Data.contentCount);

        x = Main.selectedContent - 4;
        i = x.mod(Data.contentCount);

        Display.slideIndex = i;

        Main.debug("[buttonShow.js] - Show Content ID: [" + Main.selectedContent + "] - Content Name: [" + Data.contentTitles[Main.selectedContent] + "]");

        if (isEmpty(Data.contentThumbs[i])) {
            loadbar.show();
            var s;
            if (Math.abs(i - 50) > Data.contentCount) {
                s = 0;
            } else {
                s = i - 50;
            }
            Content.callback = "Display.UpdateSlideLeft";
            Content.id = "showSlideLeftUpdate";
            Content.fetchContentList(Content.cat, Content.section, s, 51, "noUpdate");
        }
        else {
            Display.UpdateSlideLeft();
        }

    }
};